:- module(atr2, 
	[
	    tp/0,
	    test/1, 
	    result/1,
	    spend_time/2
	]).

:- include(tabling_type).

:- dynamic results/1.
:- set_prolog_flag(multi_arity_warnings, off).

:- use_module(library(write)).

:- table /(pdcg,3).

spend_time(NT,T) :-
	abolish_all_tables,
        statistics(runtime,[_,_]),
	tp, abolish_all_tables,
        statistics(runtime,[_,Tt]),
	N is NT / Tt,
        statistics(runtime,[_,_]),
        (
            between(1,N,_),
            tp, abolish_all_tables,
            fail
        ;
            true
        ),
        statistics(runtime,[_,Tfin]),
        (
            between(1,N,_),
            fail
        ;
            true
        ),
        statistics(runtime,[_,Tfin2]),
        T is (Tfin - Tfin2) / N.

tp :- 
     sent(_,S),
     pdcg(S),
     fail.
tp.

test(_) :-
     abolish_all_tables,
     sent(No,S),
     pdcg(S),
     assert(results(succeed(No))),
     fail.
test(L) :- get_list(L).

get_list([R|L]) :-
	retract(results(R)), !,
	get_list(L).

get_list([]).
    
values(n_x_ka_kan,[[n_y_ka,n_suffix_quant_time]]).
values(n_month_day,[[n_n_month,n_n_day]]).
values(n_reservation,[[n_capacity],[n_capacity,n_aux,n_stay_date],[n_capacity,n_stay_date],[n_stay_date],[n_stay_date,n_aux,n_capacity]]).
values(n_adv_degr,[[t_teido_hukusi]]).
values(n_adv,[[t_hukusi],[t_hukusi_desu]]).
values(n_n_adj,[[n_n_adj_2FH_ga],[n_n_adj_2FH_ga_de],[n_n_adj_2FH_ga_to],[n_prefix,n_n_adj]]).
values(n_vstem5_2FH_ga_ni_5EH_e,[[t_vstem_5_k_q_2FH_ga_ni_5EH_e],[t_vstem_5_m_2FH_ga_ni_5EH_e],[t_vstem_5_t_2FH_ga_ni_5EH_e]]).
values(n_n_minute,[[t_meisi_hun]]).
values(n_n_proper,[[n_mod_n,n_n_proper],[n_n_name,n_n_hutu],[n_n_proper,n_n_proper],[n_n_proper,t_suffix_hutu_hutu],[n_n_proper,t_suffix_name],[t_koyuu_meisi]]).
values(n_aux,[[n_auxstem],[n_auxstem,n_infl],[n_auxstem_caus],[n_auxstem_caus,n_infl],[n_auxstem_deac],[n_auxstem_deac,n_infl],[t_aux_da],[t_aux_daq],[t_aux_daro],[t_aux_de],[t_aux_infr],[t_aux_infr_spe],[t_aux_na],[t_aux_negt_n],[t_aux_negt_zu],[t_aux_ni],[t_aux_oblg_masu],[t_aux_past],[t_aux_sfp_ba],[t_aux_sfp_de],[t_aux_sfp_ga],[t_aux_sfp_ka],[t_aux_sfp_kaa],[t_aux_sfp_kara],[t_aux_sfp_kasira],[t_aux_sfp_kedo],[t_aux_sfp_kedomo],[t_aux_sfp_keredo],[t_aux_sfp_keredomo],[t_aux_sfp_mono],[t_aux_sfp_monode],[t_aux_sfp_monodesukara],[t_aux_sfp_na],[t_aux_sfp_naa],[t_aux_sfp_ne],[t_aux_sfp_nee],[t_aux_sfp_no],[t_aux_sfp_node],[t_aux_sfp_qke],[t_aux_sfp_qte],[t_aux_sfp_si],[t_aux_sfp_te],[t_aux_sfp_to],[t_aux_sfp_tomo],[t_aux_sfp_wa],[t_aux_sfp_ya],[t_aux_sfp_yo],[t_aux_suru_sa],[t_aux_suru_se],[t_aux_suru_shi],[t_aux_suru_shiro],[t_aux_suru_sure],[t_aux_suru_suru],[t_aux_te_kahen_syusi],[t_aux_te_masu],[t_aux_te_orimasen],[t_aux_zya],[t_auxstem_nikui],[t_auxstem_rashii],[t_auxstem_yasui]]).
values(n_n_num_keta_man,[[n_n_num_ichi,n_num_suf_man]]).
values(n_p_quote,[[t_p_quote_ka],[t_p_quote_kato],[t_p_quote_noka],[t_p_quote_to],[t_p_quote_toka]]).
values(n_v_sahen_2FH_ga,[[n_mod_v,n_v_sahen_2FH_ga],[n_pp_ni,n_v_sahen_2FH_ga_ni],[n_pp_o,n_v_sahen_2FH_ga_o]]).
values(n_adv_cl,[[n_adv_cl,n_p_conj_advcl],[n_vaux,n_aux_katei],[n_vaux,n_p_conj_advcl],[n_verb,n_aux_katei],[n_verb,n_p_conj_advcl],[t_interj_hesit,n_adv_cl]]).
values(n_aux_katei,[[t_aux_nara],[t_aux_past_katei]]).
values(n_pp_o,[[n_n_cl,t_p_kaku_o],[n_np],[n_np,t_p_kaku_o]]).
values(n_cl_ex,[[n_adv_cl,n_cl_ex],[n_interj,n_cl_ex],[n_renyo_cl,n_cl_ex],[t_interj_hesit,n_cl],[t_interj_hesit,n_cl_ex],[t_interj_hesit,n_vaux],[t_interj_hesit,n_verb]]).
values(n_specific_date,[[n_mod_day,n_n_day],[n_mod_time,n_n_time],[n_mod_week,n_n_week],[n_month_day],[n_month_day,n_n_week],[n_n_day],[n_n_day,n_n_week]]).
values(n_stay_date,[[n_stay_day],[n_stay_day,n_stay_period],[n_stay_period],[n_stay_period,n_p_rentai,n_stay_day],[n_stay_period,n_stay_day]]).
values(n_vstem1_2FH_ga_ni_5EH_to,[[t_vstem_1_2FH_ga_ni_5EH_to]]).
values(n_vstem1_2FH_ga_o,[[t_vstem_1_2FH_ga_o]]).
values(n_p_kaku_optn,[[n_p_kaku_optn,n_p_kaku_optn],[t_p_kaku_de],[t_p_kaku_e],[t_p_kaku_hukugo],[t_p_kaku_kara],[t_p_kaku_made],[t_p_kaku_ni],[t_p_kaku_to],[t_p_kaku_yori]]).
values(n_n_num,[[n_n_num_hyaku],[n_n_num_ichi],[n_n_num_man],[n_n_num_sen],[n_n_num_ten,n_n_num_syosu],[n_n_num_zyuu]]).
values(n_n_date_and_time,[[n_mod_n,n_n_date_and_time],[n_n_date_and_time,n_n_week],[n_n_day],[n_n_hour],[n_n_hour,n_n_minute],[n_n_minute],[n_n_month],[n_n_month,n_n_day],[n_n_week],[n_n_year],[n_n_year,n_n_month],[n_tag_slot],[n_tag_slot,n_n_date_and_time],[n_tag_slot,n_n_hour]]).
values(n_num_suf_zyuu,[[t_num_zyuq],[t_num_zyuu]]).
values(n_period_kara,[[n_period_begin,n_p_kaku_optn]]).
values(n_vstem1_2FH_ga_to,[[t_vstem_1_2FH_ga_to]]).
values(n_vstem5_2FH_ga_ni_o,[[t_vstem_5_b_2FH_ga_ni_o],[t_vstem_5_g_2FH_ga_ni_o],[t_vstem_5_k_2FH_ga_ni_o],[t_vstem_5_m_2FH_ga_ni_o],[t_vstem_5_r_2FH_ga_ni_o],[t_vstem_5_s_2FH_ga_ni_o],[t_vstem_5_t_2FH_ga_ni_o],[t_vstem_5_w_2FH_ga_ni_o]]).
values(n_n_num_bango,[[n_n_num_bango,n_suffix_unit],[n_num_ex_2,n_num_ex_4],[n_num_ex_2,n_num_ex_4,n_num_ex_4],[n_num_ex_3,n_num_ex_3,n_num_ex_4],[n_num_ex_3,n_num_ex_4],[n_num_ex_4,n_num_ex_4],[n_num_ex_4,n_num_ex_4,n_num_ex_4,n_num_ex_4],[n_num_ex_rentai,n_num_ex_4]]).
values(n_tag_slot,[[t_zikantai]]).
values(n_v_sahen_2FH_ga_o,[[n_mod_v,n_v_sahen_2FH_ga_o],[t_sahen_dousi_katei_2FH_ga_o],[t_sahen_dousi_mizen_2FH_ga_o],[t_sahen_dousi_rentai_2FH_ga_o],[t_sahen_dousi_renyo_2FH_ga_o],[t_sahen_dousi_syusi_2FH_ga_o]]).
values(n_mod_n,[[n_mod_n,n_aux],[n_np,n_p_para],[n_np,n_p_rentai],[n_pp,n_p_rentai],[n_vaux],[n_verb],[t_rentai]]).
values(n_p_rentai,[[t_p_rentai_hukugo],[t_p_rentai_no]]).
values(n_verb_2FH_ga_to,[[n_mod_v,n_n_adj_2FH_ga_to],[n_mod_v,n_n_sahen_2FH_ga_to],[n_mod_v,n_verb_2FH_ga_to],[n_vstem1_2FH_ga_to],[n_vstem1_2FH_ga_to,n_infl],[n_vstem5_2FH_ga_to,n_infl]]).
values(n_period_begin,[[n_n_time,n_specific_date],[n_specific_date]]).
values(n_renyo_cl,[[n_vaux],[n_verb]]).
values(n_n_num_ex,[[t_num_bouyomi]]).
values(n_num_suf_sen,[[t_num_sen],[t_num_zen]]).
values(n_v_sahen_2FH_ga_ni,[[n_mod_v,n_v_sahen_2FH_ga_ni],[t_sahen_dousi_katei_2FH_ga_ni],[t_sahen_dousi_mizen_2FH_ga_ni],[t_sahen_dousi_rentai_2FH_ga_ni],[t_sahen_dousi_renyo_2FH_ga_ni],[t_sahen_dousi_syusi_2FH_ga_ni]]).
values(n_stay,[[n_reservation],[n_visitor_name,n_aux,n_reservation],[n_visitor_name,n_reservation]]).
values(n_auxstem_deac,[[t_auxstem_deac_rareru],[t_auxstem_deac_reru]]).
values(n_verb_2FH_ga_o,[[n_mod_v,n_n_sahen_2FH_ga_o],[n_mod_v,n_verb_2FH_ga_o],[n_pp_e,n_verb_2FH_ga_ni_5EH_e_o],[n_pp_ni,n_n_sahen_2FH_ga_ni_o],[n_pp_ni,n_verb_2FH_ga_ni_5EH_e_o],[n_pp_ni,n_verb_2FH_ga_ni_o],[n_vstem1_2FH_ga_o],[n_vstem1_2FH_ga_o,n_infl],[n_vstem5_2FH_ga_o,n_infl]]).
values(n_n_sahen_2FH_ga_ni_5EH_e_o,[[n_prefix,n_verb_2FH_ga_ni_5EH_e_o]]).
values(n_vstem5_2FH_ga,[[t_vstem_5_b_2FH_ga],[t_vstem_5_g_2FH_ga],[t_vstem_5_k_2FH_ga],[t_vstem_5_m_2FH_ga],[t_vstem_5_r_2FH_ga],[t_vstem_5_r_i_2FH_ga],[t_vstem_5_s_2FH_ga],[t_vstem_5_t_2FH_ga],[t_vstem_5_w_2FH_ga]]).
values(n_vstem1_2FH_ga_de,[[t_vstem_1_2FH_ga_de]]).
values(n_n_num_man,[[n_n_num_keta_man],[n_n_num_keta_man,n_n_num_hyaku],[n_n_num_keta_man,n_n_num_ichi],[n_n_num_keta_man,n_n_num_sen],[n_n_num_keta_man,n_n_num_zyuu]]).
values(n_vstem5_2FH_ga_ni,[[t_vstem_5_b_2FH_ga_ni],[t_vstem_5_g_2FH_ga_ni],[t_vstem_5_k_2FH_ga_ni],[t_vstem_5_m_2FH_ga_ni],[t_vstem_5_r_2FH_ga_ni],[t_vstem_5_s_2FH_ga_ni],[t_vstem_5_t_2FH_ga_ni],[t_vstem_5_w_2FH_ga_ni]]).
values(n_period_end,[[n_specific_date]]).
values(n_period_made,[[n_period_end],[n_period_end,n_p_kaku_optn]]).
values(n_p_conj_advp,[[t_p_conj_renyo_te],[t_p_conj_syusi_to]]).
values(n_adv_sent,[[t_bun_hukusi]]).
values(n_vstem_spe_2FH_ga_ni,[[t_vstem_sahen_2FH_ga_ni]]).
values(n_vstem1_2FH_ga_ni_5EH_e,[[t_vstem_1_2FH_ga_ni_5EH_e]]).
values(n_num_suf_hyaku,[[t_num_byaku],[t_num_byaq],[t_num_hyaku],[t_num_hyaq],[t_num_pyaku],[t_num_pyaq]]).
values(n_suffix_unit,[[t_suffix_doru],[t_suffix_en],[t_suffix_num_b],[t_suffix_num_d],[t_suffix_num_g],[t_suffix_num_h],[t_suffix_num_i],[t_suffix_num_k],[t_suffix_num_ka],[t_suffix_num_m],[t_suffix_num_n],[t_suffix_num_p],[t_suffix_num_r],[t_suffix_num_ri],[t_suffix_num_s],[t_suffix_num_t],[t_suffix_num_tsu],[t_suffix_num_w],[t_suffix_num_y],[t_suffix_num_z],[t_suffix_sento]]).
values(n_n_hutu,[[n_mod_n,n_n_hutu],[n_n_adj,n_n_hutu],[n_n_adj_2FH_ga,t_suffix_adj_hutu],[n_n_date_and_time,t_suffix_time_hutu],[n_n_hutu,n_n_hutu],[n_n_hutu,n_n_sahen],[n_n_hutu,t_suffix_hutu_hutu],[n_n_hutu,t_suffix_name],[n_n_num,n_suffix_unit],[n_n_proper,n_n_hutu],[n_n_proper,n_n_sahen],[n_n_quant,n_n_hutu],[n_n_quant,t_suffix_name],[n_n_quant,t_suffix_quant_hutu],[n_n_sahen,n_n_hutu],[n_n_sahen,n_n_sahen],[n_n_sahen,t_suffix_hutu_hutu],[n_n_sahen,t_suffix_sahen_hutu],[n_n_spel,n_n_spel],[n_n_spel,n_n_spel,n_n_spel],[n_num_ex_3,n_suffix_unit],[n_prefix,n_n_hutu],[n_prefix,n_wh_adv],[t_adj_meisi],[t_adjstem_2FH_ga,t_suffix_adj_hutu],[t_hutu_meisi],[t_hutu_meisi_post],[t_n_keisiki]]).
values(n_n_num_keta_hyaku,[[n_n_num_ichi,n_num_suf_hyaku],[n_num_suf_hyaku]]).
values(n_n_cl,[[n_vaux,t_p_jun],[n_verb,t_p_jun]]).
values(n_pp_ni,[[n_np,t_p_kaku_ni],[n_pp,t_p_kaku_ni],[n_pp_ni,n_p_kakari]]).
values(n_verb_2FH_ga_de,[[n_mod_v,n_n_adj_2FH_ga_de],[n_mod_v,n_verb_2FH_ga_de],[n_vstem1_2FH_ga_de,n_infl],[n_vstem5_2FH_ga_de,n_infl],[t_adj_renyo_2FH_ga_de],[t_adjstem_2FH_ga_de,n_infl],[t_adjstem_spe_2FH_ga_de,n_infl]]).
values(n_v_kahen_2FH_,[[n_mod_v,n_v_kahen_2FH_],[n_pp_ga,n_v_kahen_2FH_ga]]).
values(n_verb_2FH_ga_quote,[[n_mod_v,n_n_sahen_2FH_ga_quote],[n_mod_v,n_verb_2FH_ga_quote],[n_vstem1_2FH_ga_quote],[n_vstem1_2FH_ga_quote,n_infl],[n_vstem5_2FH_ga_quote,n_infl]]).
values(n_verb_2FH_,[[n_mod_v,n_verb_2FH_],[n_pp_ga,n_n_adj_2FH_ga],[n_pp_ga,n_n_sahen_2FH_ga],[n_pp_ga,n_verb_2FH_ga],[n_pp_ni,n_verb_2FH_ni]]).
values(n_n_hour,[[t_meisi_zi]]).
values(n_x_haku_y_ka,[[n_x_haku,n_y_ka]]).
values(n_infl,[[t_infl_1_re],[t_infl_1_ro],[t_infl_1_ru],[t_infl_1_yo],[t_infl_5_ba],[t_infl_5_be],[t_infl_5_bi],[t_infl_5_bo],[t_infl_5_bu],[t_infl_5_ga],[t_infl_5_ge],[t_infl_5_gi],[t_infl_5_go],[t_infl_5_gu],[t_infl_5_i],[t_infl_5_ka],[t_infl_5_ke],[t_infl_5_ki],[t_infl_5_ko],[t_infl_5_ku],[t_infl_5_ma],[t_infl_5_me],[t_infl_5_mi],[t_infl_5_mo],[t_infl_5_mu],[t_infl_5_n],[t_infl_5_na],[t_infl_5_ne],[t_infl_5_ni],[t_infl_5_no],[t_infl_5_nu],[t_infl_5_q],[t_infl_5_ra],[t_infl_5_re],[t_infl_5_ri],[t_infl_5_ro],[t_infl_5_ru],[t_infl_5_sa],[t_infl_5_se],[t_infl_5_shi],[t_infl_5_so],[t_infl_5_su],[t_infl_5_ta],[t_infl_5_te],[t_infl_5_ti],[t_infl_5_to],[t_infl_5_tu],[t_infl_5_wa],[t_infl_5_we],[t_infl_5_wi],[t_infl_5_wo],[t_infl_5_wu],[t_infl_adj_i],[t_infl_adj_kaq],[t_infl_adj_karo],[t_infl_adj_kere],[t_infl_adj_ku],[t_infl_adj_kya],[t_infl_adj_u],[t_infl_caus_re],[t_infl_caus_ru],[t_infl_deac_re],[t_infl_deac_ru],[t_infl_sahen_shi],[t_infl_sahen_sure],[t_infl_sahen_suru],[t_infl_spe_i],[t_infl_spe_q],[t_infl_spe_re],[t_infl_spe_ru],[t_infl_spe_se],[t_infl_spe_shi],[t_infl_spe_sho],[t_infl_spe_su]]).
values(n_v_sahen_2FH_o,[[n_mod_v,n_v_sahen_2FH_o],[n_pp_ga,n_v_sahen_2FH_ga_o]]).
values(n_verb_2FH_ga_ni_5EH_e_o,[[n_mod_v,n_verb_2FH_ga_ni_5EH_e_o],[n_vstem1_2FH_ga_ni_5EH_e_o,n_infl],[n_vstem5_2FH_ga_ni_5EH_e_o,n_infl]]).
values(n_n_sahen,[[n_mod_n,n_n_sahen],[n_n_date_and_time,n_n_sahen],[n_n_sahen_2FH_ga],[n_n_sahen_2FH_ga_de],[n_n_sahen_2FH_ga_ni],[n_n_sahen_2FH_ga_ni_5EH_e],[n_n_sahen_2FH_ga_ni_5EH_e_o],[n_n_sahen_2FH_ga_ni_5EH_to],[n_n_sahen_2FH_ga_ni_o],[n_n_sahen_2FH_ga_o],[n_n_sahen_2FH_ga_quote],[n_n_sahen_2FH_ga_to],[n_prefix,n_n_sahen]]).
values(n_p_conj_advcl,[[t_p_conj_katei],[t_p_conj_rentai],[t_p_conj_renyo],[t_p_conj_renyo_te],[t_p_conj_syusi]]).
values(n_interj,[[n_adv,n_interj],[n_adv_cl,n_interj],[t_interj_post],[t_interj_pre]]).
values(n_n_adv,[[t_huku_meisi]]).
values(n_mod_v,[[n_advp],[n_n_adj,n_aux],[n_n_quant],[n_n_time],[n_pp]]).
values(n_period_to,[[n_period_begin,n_p_para]]).
values(n_p_kakari,[[t_p_kakari_mo],[t_p_kakari_qte],[t_p_kakari_te],[t_p_kakari_wa]]).
values(n_n_sahen_2FH_ga,[[n_prefix,n_verb_2FH_ga],[n_prefix,t_sahen_meisi_2FH_ga],[t_sahen_meisi_2FH_ga],[t_sahen_meisi_pol_2FH_ga]]).
values(n_v_kahen_2FH_ga_ni,[[n_mod_v,n_v_kahen_2FH_ga_ni],[t_kahen_dousi_katei_2FH_ga_ni],[t_kahen_dousi_mizen_2FH_ga_ni],[t_kahen_dousi_rentai_2FH_ga_ni],[t_kahen_dousi_renyo_2FH_ga_ni],[t_kahen_dousi_syusi_2FH_ga_ni]]).
values(n_verb,[[n_v_kahen_2FH_],[n_v_kahen_2FH_ga],[n_v_kahen_2FH_ga_ni],[n_v_kahen_2FH_ni],[n_v_sahen_2FH_],[n_v_sahen_2FH_ga],[n_v_sahen_2FH_ga_ni],[n_v_sahen_2FH_ga_o],[n_v_sahen_2FH_o],[n_verb,n_p_kakari],[n_verb_2FH_],[n_verb_2FH_de],[n_verb_2FH_ga],[n_verb_2FH_ga_de],[n_verb_2FH_ga_ni],[n_verb_2FH_ga_ni_5EH_e],[n_verb_2FH_ga_ni_5EH_e_o],[n_verb_2FH_ga_ni_5EH_to],[n_verb_2FH_ga_ni_o],[n_verb_2FH_ga_o],[n_verb_2FH_ga_quote],[n_verb_2FH_ga_to],[n_verb_2FH_ni],[n_verb_2FH_o],[n_verb_2FH_to]]).
values(n_vstem5_2FH_ga_quote,[[t_vstem_5_r_i_2FH_ga_quote],[t_vstem_5_s_2FH_ga_quote],[t_vstem_5_w_2FH_ga_quote]]).
values(n_v_sahen_2FH_,[[n_mod_v,n_v_sahen_2FH_],[n_pp_ga,n_v_sahen_2FH_ga]]).
values(n_auxstem_caus,[[t_auxstem_caus_saseru],[t_auxstem_caus_seru]]).
values(n_verb_2FH_ga_ni_5EH_to,[[n_mod_v,n_verb_2FH_ga_ni_5EH_to],[n_vstem1_2FH_ga_ni_5EH_to,n_infl],[n_vstem5_2FH_ga_ni_5EH_to,n_infl]]).
values(n_n_num_ten,[[n_n_num,t_suffix_ten]]).
values(n_n_adj_2FH_ga,[[t_kdo_2FH_ga]]).
values(n_mod_time,[[n_n_day,n_p_rentai]]).
values(n_vstem5_2FH_ga_ni_5EH_e_o,[[t_vstem_5_r_2FH_ga_ni_5EH_e_o]]).
values(n_n_adj_2FH_ga_to,[[t_kdo_2FH_ga_to]]).
values(n_mod_week,[[n_month_day,n_p_rentai]]).
values(n_addr,[[n_n_hutu,t_suffix_name],[n_n_name_jap_honor],[n_n_name_others_honor],[n_name,t_suffix_name]]).
values(n_n_name,[[t_myoji_first],[t_myoji_last],[t_namae_first],[t_namae_last]]).
values(n_vstem5_2FH_ga_to,[[t_vstem_5_b_2FH_ga_to],[t_vstem_5_k_2FH_ga_to],[t_vstem_5_m_2FH_ga_to],[t_vstem_5_r_2FH_ga_to],[t_vstem_5_s_2FH_ga_to],[t_vstem_5_t_2FH_ga_to],[t_vstem_5_w_2FH_ga_to]]).
values(n_sent,[[n_cl],[n_cl_ex]]).
values(n_n_quant,[[n_adv_degr,n_n_quant],[n_mod_n,n_n_quant],[n_n_hutu,n_n_quant],[n_n_hutu,t_suffix_quant_quant],[n_n_num,n_suffix_unit],[n_n_num,t_hutu_meisi],[n_n_quant,t_suffix_quant_quant],[n_prefix,n_n_quant],[n_wh_pro,n_suffix_unit],[n_wh_pro,t_suffix_quant_quant],[t_suuryousi]]).
values(n_n_sahen_2FH_ga_ni,[[n_mod_v,n_n_sahen_2FH_ga_ni],[n_prefix,n_verb_2FH_ga_ni],[n_prefix,t_sahen_meisi_2FH_ga_ni],[t_sahen_meisi_2FH_ga_ni],[t_sahen_meisi_pol_2FH_ga_ni]]).
values(n_mod_day,[[n_n_month,n_p_rentai]]).
values(n_verb_2FH_ga_ni_o,[[n_mod_v,n_n_sahen_2FH_ga_ni_o],[n_mod_v,n_verb_2FH_ga_ni_o],[n_vstem1_2FH_ga_ni_o],[n_vstem1_2FH_ga_ni_o,n_infl],[n_vstem5_2FH_ga_ni_o,n_infl]]).
values(n_pp_to,[[n_np,t_p_kaku_to],[n_pp,t_p_kaku_to],[n_pp_to,n_p_kakari]]).
values(n_num_suf_man,[[t_num_man]]).
values(n_p_fuku,[[t_p_fuku_bakari],[t_p_fuku_dake],[t_p_fuku_demo],[t_p_fuku_goto],[t_p_fuku_gurai],[t_p_fuku_hodo],[t_p_fuku_ka],[t_p_fuku_kadouka],[t_p_fuku_kato],[t_p_fuku_koso],[t_p_fuku_kurai],[t_p_fuku_made],[t_p_fuku_nado],[t_p_fuku_nanka],[t_p_fuku_nante],[t_p_fuku_nomi],[t_p_fuku_qteiyaa],[t_p_fuku_sae],[t_p_fuku_shika],[t_p_fuku_toka],[t_p_fuku_tou],[t_p_fuku_zutu]]).
values(n_vstem5_2FH_ga_o,[[t_vstem_5_b_2FH_ga_o],[t_vstem_5_g_2FH_ga_o],[t_vstem_5_k_2FH_ga_o],[t_vstem_5_m_2FH_ga_o],[t_vstem_5_r_2FH_ga_o],[t_vstem_5_r_i_2FH_ga_o],[t_vstem_5_s_2FH_ga_o],[t_vstem_5_t_2FH_ga_o],[t_vstem_5_w_2FH_ga_o]]).
values(n_verb_2FH_ni,[[n_mod_v,n_verb_2FH_ni],[n_pp_ga,n_n_sahen_2FH_ga_ni],[n_pp_ga,n_verb_2FH_ga_ni]]).
values(n_verb_2FH_o,[[n_mod_v,n_verb_2FH_o],[n_pp_ga,n_n_sahen_2FH_ga_o],[n_pp_ga,n_verb_2FH_ga_o]]).
values(n_v_kahen_2FH_ni,[[n_pp_ga,n_v_kahen_2FH_ga_ni]]).
values(n_pp_ga,[[n_n_cl,t_p_kaku_ga],[n_np,t_p_kaku_ga]]).
values(n_n_sahen_2FH_ga_ni_5EH_e,[[n_prefix,n_verb_2FH_ga_ni_5EH_e],[n_prefix,t_sahen_meisi_2FH_ga_ni_5EH_e],[t_sahen_meisi_2FH_ga_ni_5EH_e]]).
values(n_n_adj_2FH_ga_de,[[t_kdo_2FH_ga_de]]).
values(n_y_ka,[[n_n_num,n_suffix_unit]]).
values(n_vstem5_2FH_ga_de,[[t_vstem_5_w_2FH_ga_de]]).
values(n_n_time,[[n_mod_n,n_n_time],[n_n_date_and_time,t_suffix_time_time],[n_n_hutu,t_suffix_time_time],[n_wh_pro,t_suffix_time_time],[t_zikan_meisi],[t_zikan_meisi_ippai]]).
values(n_pp_quote,[[n_pp_quote,n_p_kakari],[n_vaux,n_p_quote],[n_verb,n_p_quote]]).
values(n_name,[[n_mod_n,n_name],[n_n_name],[n_n_name,n_n_name]]).
values(n_n_num_zyuu,[[n_n_num_keta_zyuu],[n_n_num_keta_zyuu,n_n_num_ichi]]).
values(n_n_sahen_2FH_ga_quote,[[n_prefix,n_verb_2FH_ga_quote]]).
values(n_pp,[[n_advp,t_p_kaku_ni],[n_n_cl,n_p_kakari],[n_n_cl,n_p_kaku_optn],[n_np,n_p_fuku],[n_np,n_p_kakari],[n_np,n_p_kaku_optn],[n_pp,n_p_kakari],[n_pro_domo],[n_pro_exp]]).
values(n_pp_de,[[n_np,t_p_kaku_de],[n_pp_de,n_p_kakari]]).
values(n_verb_2FH_ga_ni_5EH_e,[[n_mod_v,n_n_sahen_2FH_ga_ni_5EH_e],[n_mod_v,n_verb_2FH_ga_ni_5EH_e],[n_pp_o,n_verb_2FH_ga_ni_5EH_e_o],[n_vstem1_2FH_ga_ni_5EH_e,n_infl],[n_vstem5_2FH_ga_ni_5EH_e,n_infl]]).
values(n_vstem1_2FH_ga_ni_o,[[t_vstem_1_2FH_ga_ni_o]]).
values(n_n_num_syosu,[[n_n_num_ex,n_n_num_ex]]).
values(n_p_para,[[n_p_para,n_p_para],[t_p_para_ka],[t_p_para_matawa],[t_p_para_moshikuwa],[t_p_para_nari],[t_p_para_ni],[t_p_para_tari],[t_p_para_to],[t_p_para_toka],[t_p_para_ya]]).
values(n_pro_domo,[[n_mod_n,n_pro_domo],[t_daimeisi_domo]]).
values(n_n_num_keta_sen,[[n_n_num_ichi,n_num_suf_sen],[n_num_suf_sen]]).
values(n_n_year,[[n_n_num,t_suffix_nen]]).
values(n_num_ex_2,[[n_n_num_ex,n_n_num_ex]]).
values(n_x_haku,[[n_n_num,n_suffix_unit]]).
values(n_vstem1_2FH_ga,[[t_vstem_1_2FH_ga]]).
values(n_advp,[[n_adv],[n_mod_n,n_n_adv],[n_vaux,n_p_conj_advp],[n_vaux,n_p_fuku],[n_verb,n_p_conj_advp],[n_verb,n_p_fuku],[n_verb,n_p_kaku_optn],[n_wh_adv]]).
values(n_num_ex_3,[[n_n_num_ex,n_n_num_ex,n_n_num_ex],[n_num_ex_rentai,n_num_ex_3]]).
values(n_start,[[n_sent]]).
values(n_pro_exp,[[t_daimeisi_exp]]).
values(n_vstem_spe_2FH_ga,[[t_vstem_masu_2FH_ga]]).
values(n_pp_e,[[n_np,t_p_kaku_e]]).
values(n_num_ex_4,[[n_n_num_ex,n_n_num_ex,n_n_num_ex,n_n_num_ex],[n_num_ex_rentai,n_num_ex_4]]).
values(n_n_sahen_2FH_ga_to,[[n_prefix,n_verb_2FH_ga_to],[n_prefix,t_sahen_meisi_2FH_ga_to],[t_sahen_meisi_2FH_ga_to],[t_sahen_meisi_pol_2FH_ga_to]]).
values(n_n_week,[[t_meisi_youbi]]).
values(n_n_sahen_2FH_ga_o,[[n_prefix,n_verb_2FH_ga_o],[n_prefix,t_sahen_meisi_2FH_ga_o],[t_sahen_meisi_2FH_ga_o],[t_sahen_meisi_pol_2FH_ga_o]]).
values(n_auxv,[[n_auxvstem,n_infl]]).
values(n_verb_2FH_to,[[n_pp_ga,n_n_sahen_2FH_ga_to]]).
values(n_wh_pro,[[n_mod_n,n_wh_pro],[n_prefix,n_wh_pro],[t_wh_daimeisi],[t_wh_daimeisi_nan]]).
values(n_pro,[[t_daimeisi]]).
values(n_vstem1_2FH_ga_ni,[[t_vstem_1_2FH_ga_ni]]).
values(n_vstem5_2FH_ga_ni_5EH_to,[[t_vstem_5_r_2FH_ga_ni_5EH_to]]).
values(n_vaux,[[n_n_adj,n_aux],[n_n_cl,n_aux],[n_n_sahen,n_aux],[n_vaux,n_aux],[n_vaux,n_p_kakari],[n_verb,n_aux],[n_verb,n_auxv]]).
values(n_kajo,[[n_stay]]).
values(n_prefix,[[t_prefix_go],[t_prefix_hutu_hutu],[t_prefix_o],[t_prefix_quant_quant]]).
values(n_auxstem,[[t_auxstem_copula_5_r],[t_auxstem_copula_masu],[t_auxstem_de_1],[t_auxstem_de_5_k],[t_auxstem_de_5_r],[t_auxstem_de_5_w],[t_auxstem_de_adj],[t_auxstem_de_kahen_renyo],[t_auxstem_de_masu],[t_auxstem_desu],[t_auxstem_infr_spe],[t_auxstem_intn_u],[t_auxstem_intn_you],[t_auxstem_masu],[t_auxstem_negt],[t_auxstem_oblg_katei],[t_auxstem_oblg_mizen],[t_auxstem_oblg_syusi],[t_auxstem_sahen_1],[t_auxstem_sahen_5_k],[t_auxstem_sahen_5_r],[t_auxstem_sahen_5_s],[t_auxstem_sahen_5_w],[t_auxstem_te_1],[t_auxstem_te_5_k],[t_auxstem_te_5_r],[t_auxstem_te_5_s],[t_auxstem_te_5_w],[t_auxstem_te_adj],[t_auxstem_te_kahen_katei],[t_auxstem_te_kahen_mizen],[t_auxstem_te_kahen_rentai],[t_auxstem_te_kahen_renyo],[t_auxstem_te_kahen_syusi],[t_auxstem_te_kdo],[t_auxstem_te_masu],[t_auxstem_wish]]).
values(n_verb_2FH_ga,[[n_adv,n_aux],[n_mod_v,n_n_adj_2FH_ga],[n_mod_v,n_n_sahen_2FH_ga],[n_mod_v,n_verb_2FH_ga],[n_np,n_aux],[n_num_ex_4,n_aux],[n_pp,n_aux],[n_pp_de,n_n_adj_2FH_ga_de],[n_pp_de,n_verb_2FH_ga_de],[n_pp_e,n_n_sahen_2FH_ga_ni_5EH_e],[n_pp_e,n_verb_2FH_ga_ni_5EH_e],[n_pp_ni,n_n_sahen_2FH_ga_ni],[n_pp_ni,n_n_sahen_2FH_ga_ni_5EH_e],[n_pp_ni,n_verb_2FH_ga_ni],[n_pp_ni,n_verb_2FH_ga_ni_5EH_e],[n_pp_ni,n_verb_2FH_ga_ni_5EH_to],[n_pp_o,n_n_sahen_2FH_ga_o],[n_pp_o,n_verb_2FH_ga_o],[n_pp_quote,n_n_sahen_2FH_ga_quote],[n_pp_quote,n_verb_2FH_ga_quote],[n_pp_to,n_n_adj_2FH_ga_to],[n_pp_to,n_n_sahen_2FH_ga_to],[n_pp_to,n_verb_2FH_ga_ni_5EH_to],[n_pp_to,n_verb_2FH_ga_to],[n_verb_2FH_ga,n_auxv],[n_vstem1_2FH_ga],[n_vstem1_2FH_ga,n_infl],[n_vstem5_2FH_ga,n_infl],[n_vstem_spe_2FH_ga,n_infl],[t_adj_renyo_2FH_ga],[t_adjstem_2FH_ga,n_infl]]).
values(n_n_num_hyaku,[[n_n_num_keta_hyaku],[n_n_num_keta_hyaku,n_n_num_ichi],[n_n_num_keta_hyaku,n_n_num_zyuu]]).
values(n_n_sahen_2FH_ga_ni_5EH_to,[[n_prefix,n_verb_2FH_ga_ni_5EH_to]]).
values(n_n_sahen_2FH_ga_de,[[n_prefix,n_verb_2FH_ga_de]]).
values(n_verb_2FH_ga_ni,[[n_mod_v,n_n_sahen_2FH_ga_ni],[n_mod_v,n_verb_2FH_ga_ni],[n_pp_o,n_n_sahen_2FH_ga_ni_o],[n_pp_o,n_verb_2FH_ga_ni_o],[n_vstem1_2FH_ga_ni],[n_vstem1_2FH_ga_ni,n_infl],[n_vstem5_2FH_ga_ni,n_infl],[n_vstem_spe_2FH_ga_ni,n_infl]]).
values(n_n_num_sen,[[n_n_num_keta_sen],[n_n_num_keta_sen,n_n_num_hyaku],[n_n_num_keta_sen,n_n_num_ichi],[n_n_num_keta_sen,n_n_num_zyuu]]).
values(n_v_kahen_2FH_ga,[[n_mod_v,n_v_kahen_2FH_ga],[n_pp_ni,n_v_kahen_2FH_ga_ni]]).
values(n_num_ex_rentai,[[n_num_ex_2,n_p_rentai],[n_num_ex_3,n_p_rentai],[n_num_ex_4,t_p_rentai_no]]).
values(n_stay_period,[[n_period_begin],[n_period_begin,n_period_end],[n_period_kara],[n_period_kara,n_period_made],[n_period_to,n_period_end]]).
values(n_vstem1_2FH_ga_quote,[[t_vstem_1_2FH_ga_quote]]).
values(n_n_spel,[[t_tsuzuri]]).
values(n_verb_2FH_de,[[n_mod_v,n_verb_2FH_de],[n_pp_ga,n_verb_2FH_ga_de]]).
values(n_np,[[n_kajo],[n_mod_n,n_n_adv],[n_n_date_and_time],[n_n_hutu],[n_n_num],[n_n_num_bango],[n_n_proper],[n_n_quant],[n_n_sahen],[n_n_time],[n_name],[n_name,t_suffix_name],[n_np,n_p_fuku],[n_pro],[n_pro_domo],[n_pro_domo,t_suffix_pro],[n_pro_exp],[n_pro_exp,t_suffix_name],[n_vaux,n_np],[n_wh_pro],[n_wh_pro,t_suffix_name]]).
values(n_n_sahen_2FH_ga_ni_o,[[n_prefix,n_verb_2FH_ga_ni_o],[t_sahen_meisi_2FH_ga_ni_o]]).
values(n_stay_day,[[n_prefix,n_x_haku],[n_x_haku],[n_x_haku_y_ka],[n_x_ka_kan]]).
values(n_auxvstem,[[t_auxvstem_renyo_1],[t_auxvstem_renyo_5_s]]).
values(n_vstem1_2FH_ga_ni_5EH_e_o,[[t_vstem_1_2FH_ga_ni_5EH_e_o]]).
values(n_n_num_keta_zyuu,[[n_n_num_ichi,n_num_suf_zyuu],[n_num_suf_zyuu]]).
values(n_n_month,[[t_meisi_tsuki]]).
values(n_cl,[[n_addr,n_cl],[n_adv_cl,n_cl],[n_adv_sent,n_cl],[n_interj],[n_interj,n_cl],[n_renyo_cl,n_cl],[n_vaux],[n_verb],[t_conj,n_cl]]).
values(n_n_day,[[t_meisi_hi]]).
values(n_wh_adv,[[t_wh_hukusi]]).
values(n_n_num_ichi,[[t_num_go],[t_num_hachi],[t_num_haq],[t_num_hito],[t_num_huta],[t_num_hutsu],[t_num_ichi],[t_num_iq],[t_num_itsu],[t_num_kokono],[t_num_ku],[t_num_kyuu],[t_num_miq],[t_num_mui],[t_num_muq],[t_num_nana],[t_num_nano],[t_num_ni],[t_num_one],[t_num_roku],[t_num_roq],[t_num_san],[t_num_shi],[t_num_shichi],[t_num_ten],[t_num_tou],[t_num_yaq],[t_num_yo],[t_num_yon],[t_num_yoq],[t_num_you]]).

/* sentences */
sent(0,[t_interj_post,t_koyuu_meisi,t_aux_de,t_auxstem_copula_masu,t_infl_spe_su]).
sent(1,[t_interj_hesit,t_interj_pre,t_daimeisi_domo,t_myoji_first,t_namae_last,t_p_kaku_to,t_vstem_5_w_2FH_ga_to,t_infl_5_wi,t_auxstem_masu,t_infl_spe_su,t_p_conj_syusi,t_daimeisi_exp,t_p_rentai_no,t_hutu_meisi,t_p_rentai_no,t_sahen_meisi_2FH_ga_o,t_p_kaku_o,t_sahen_dousi_renyo_2FH_ga_o,t_auxstem_wish,t_infl_adj_i,t_p_jun,t_auxstem_desu,t_infl_spe_su,t_aux_sfp_ga]).
sent(2,[t_prefix_o,t_hutu_meisi_post,t_suffix_name,t_p_rentai_no,t_prefix_o,t_hutu_meisi,t_p_rentai_no,t_hutu_meisi,t_p_kaku_o,t_vstem_1_2FH_ga_o,t_auxstem_masu,t_infl_spe_su,t_auxstem_desu,t_infl_spe_sho,t_auxstem_intn_u,t_aux_sfp_ka]).
sent(3,[t_hutu_meisi,t_tsuzuri,t_tsuzuri,t_tsuzuri,t_tsuzuri,t_tsuzuri,t_auxstem_desu,t_infl_spe_su]).
sent(4,[t_hukusi_desu,t_prefix_go,t_sahen_meisi_2FH_ga_ni,t_p_rentai_no,t_prefix_go,t_sahen_meisi_2FH_ga_o,t_auxstem_desu,t_infl_spe_sho,t_auxstem_intn_u,t_aux_sfp_ka]).
sent(5,[t_interj_pre,t_meisi_tsuki,t_meisi_hi,t_p_kaku_kara,t_meisi_tsuki,t_meisi_hi,t_p_rentai_no,t_num_nano,t_suffix_num_ka,t_suffix_quant_quant,t_auxstem_desu,t_infl_spe_su,t_aux_sfp_kedo]).
sent(6,[t_interj_pre,t_hukusi_desu,t_auxstem_desu,t_infl_spe_su]).
sent(7,[t_interj_hesit,t_rentai,t_sahen_meisi_2FH_ga,t_p_rentai_no,t_prefix_o,t_hutu_meisi,t_p_kaku_o,t_prefix_go,t_sahen_meisi_2FH_ga_o,t_auxstem_desu,t_infl_spe_sho,t_auxstem_intn_u,t_aux_sfp_ka]).
sent(8,[t_interj_hesit,t_interj_hesit,t_daimeisi_exp,t_num_hito,t_suffix_num_ri,t_auxstem_desu,t_infl_spe_su,t_p_conj_syusi,t_interj_hesit,t_hutu_meisi,t_p_kaku_de,t_adjstem_2FH_ga_de,t_infl_adj_i,t_p_jun,t_auxstem_desu,t_infl_spe_su,t_aux_sfp_kedo]).
sent(9,[t_interj_pre,t_hutu_meisi,t_aux_de,t_auxstem_copula_masu,t_infl_spe_su,t_aux_sfp_ne]).

data('ATR_PDCG_10_corpus.pl').
target(pdcg,1).

pdcg(L) :- start_symbol(C),pdcg(C,L,[]).

 %% [t_interj_post,t_koyuu_meisi,t_aux_de,t_auxstem_copula_masu,t_infl_spe_su]

start_symbol(n_sent).

pdcg(n_x_ka_kan,_1728,_1729) :- fstck(n_x_ka_kan,_1728),msw(n_x_ka_kan,[n_y_ka,n_suffix_quant_time]),pdcg(n_y_ka,_1728,_1733),_1733=[n_suffix_quant_time|_1729].
pdcg(n_month_day,_1728,_1729) :- fstck(n_month_day,_1728),msw(n_month_day,[n_n_month,n_n_day]),pdcg(n_n_month,_1728,_1733),pdcg(n_n_day,_1733,_1729).
pdcg(n_reservation,_1728,_1729) :- fstck(n_reservation,_1728),msw(n_reservation,[n_capacity,n_stay_date]),_1728=[n_capacity|_1740],pdcg(n_stay_date,_1740,_1729).
pdcg(n_reservation,_1730,_1731) :- fstck(n_reservation,_1730),msw(n_reservation,[n_stay_date,n_aux,n_capacity]),pdcg(n_stay_date,_1730,_1735),pdcg(n_aux,_1735,_1742),_1742=[n_capacity|_1731].
pdcg(n_reservation,_1730,_1731) :- fstck(n_reservation,_1730),msw(n_reservation,[n_capacity,n_aux,n_stay_date]),_1730=[n_capacity|_1742],pdcg(n_aux,_1742,_1749),pdcg(n_stay_date,_1749,_1731).
pdcg(n_reservation,_1726,_1727) :- fstck(n_reservation,_1726),msw(n_reservation,[n_capacity]),_1726=[n_capacity|_1727].
pdcg(n_reservation,_1726,_1727) :- fstck(n_reservation,_1726),msw(n_reservation,[n_stay_date]),pdcg(n_stay_date,_1726,_1727).
pdcg(n_adv_degr,_1726,_1727) :- fstck(n_adv_degr,_1726),msw(n_adv_degr,[t_teido_hukusi]),_1726=[t_teido_hukusi|_1727].
pdcg(n_adv,_1726,_1727) :- fstck(n_adv,_1726),msw(n_adv,[t_hukusi]),_1726=[t_hukusi|_1727].
pdcg(n_adv,_1726,_1727) :- fstck(n_adv,_1726),msw(n_adv,[t_hukusi_desu]),_1726=[t_hukusi_desu|_1727].
pdcg(n_n_adj,_1726,_1727) :- fstck(n_n_adj,_1726),msw(n_n_adj,[n_n_adj_2FH_ga]),pdcg(n_n_adj_2FH_ga,_1726,_1727).
pdcg(n_n_adj,_1726,_1727) :- fstck(n_n_adj,_1726),msw(n_n_adj,[n_n_adj_2FH_ga_de]),pdcg(n_n_adj_2FH_ga_de,_1726,_1727).
pdcg(n_n_adj,_1726,_1727) :- fstck(n_n_adj,_1726),msw(n_n_adj,[n_n_adj_2FH_ga_to]),pdcg(n_n_adj_2FH_ga_to,_1726,_1727).
pdcg(n_n_adj,_1728,_1729) :- fstck(n_n_adj,_1728),msw(n_n_adj,[n_prefix,n_n_adj]),pdcg(n_prefix,_1728,_1733),pdcg(n_n_adj,_1733,_1729).
pdcg(n_vstem5_2FH_ga_ni_5EH_e,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_5EH_e,_1726),msw(n_vstem5_2FH_ga_ni_5EH_e,[t_vstem_5_k_q_2FH_ga_ni_5EH_e]),_1726=[t_vstem_5_k_q_2FH_ga_ni_5EH_e|_1727].
pdcg(n_vstem5_2FH_ga_ni_5EH_e,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_5EH_e,_1726),msw(n_vstem5_2FH_ga_ni_5EH_e,[t_vstem_5_t_2FH_ga_ni_5EH_e]),_1726=[t_vstem_5_t_2FH_ga_ni_5EH_e|_1727].
pdcg(n_vstem5_2FH_ga_ni_5EH_e,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_5EH_e,_1726),msw(n_vstem5_2FH_ga_ni_5EH_e,[t_vstem_5_m_2FH_ga_ni_5EH_e]),_1726=[t_vstem_5_m_2FH_ga_ni_5EH_e|_1727].
pdcg(n_n_minute,_1726,_1727) :- fstck(n_n_minute,_1726),msw(n_n_minute,[t_meisi_hun]),_1726=[t_meisi_hun|_1727].
pdcg(n_n_proper,_1728,_1729) :- fstck(n_n_proper,_1728),msw(n_n_proper,[n_mod_n,n_n_proper]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_proper,_1733,_1729).
pdcg(n_n_proper,_1728,_1729) :- fstck(n_n_proper,_1728),msw(n_n_proper,[n_n_proper,t_suffix_hutu_hutu]),pdcg(n_n_proper,_1728,_1733),_1733=[t_suffix_hutu_hutu|_1729].
pdcg(n_n_proper,_1728,_1729) :- fstck(n_n_proper,_1728),msw(n_n_proper,[n_n_proper,t_suffix_name]),pdcg(n_n_proper,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_n_proper,_1728,_1729) :- fstck(n_n_proper,_1728),msw(n_n_proper,[n_n_name,n_n_hutu]),pdcg(n_n_name,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_proper,_1728,_1729) :- fstck(n_n_proper,_1728),msw(n_n_proper,[n_n_proper,n_n_proper]),pdcg(n_n_proper,_1728,_1733),pdcg(n_n_proper,_1733,_1729).
pdcg(n_n_proper,_1726,_1727) :- fstck(n_n_proper,_1726),msw(n_n_proper,[t_koyuu_meisi]),_1726=[t_koyuu_meisi|_1727].
pdcg(n_aux,_1728,_1729) :- fstck(n_aux,_1728),msw(n_aux,[n_auxstem,n_infl]),pdcg(n_auxstem,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[n_auxstem]),pdcg(n_auxstem,_1726,_1727).
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[n_auxstem_caus]),pdcg(n_auxstem_caus,_1726,_1727).
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[n_auxstem_deac]),pdcg(n_auxstem_deac,_1726,_1727).
pdcg(n_aux,_1728,_1729) :- fstck(n_aux,_1728),msw(n_aux,[n_auxstem_caus,n_infl]),pdcg(n_auxstem_caus,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_aux,_1728,_1729) :- fstck(n_aux,_1728),msw(n_aux,[n_auxstem_deac,n_infl]),pdcg(n_auxstem_deac,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_te_orimasen]),_1726=[t_aux_te_orimasen|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_oblg_masu]),_1726=[t_aux_oblg_masu|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_past]),_1726=[t_aux_past|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_infr]),_1726=[t_aux_infr|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_daro]),_1726=[t_aux_daro|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_daq]),_1726=[t_aux_daq|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_de]),_1726=[t_aux_de|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_ni]),_1726=[t_aux_ni|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_da]),_1726=[t_aux_da|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_na]),_1726=[t_aux_na|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_zya]),_1726=[t_aux_zya|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_negt_n]),_1726=[t_aux_negt_n|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_negt_zu]),_1726=[t_aux_negt_zu|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_infr_spe]),_1726=[t_aux_infr_spe|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_te_kahen_syusi]),_1726=[t_aux_te_kahen_syusi|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_te_masu]),_1726=[t_aux_te_masu|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_auxstem_yasui]),_1726=[t_auxstem_yasui|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_auxstem_nikui]),_1726=[t_auxstem_nikui|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_auxstem_rashii]),_1726=[t_auxstem_rashii|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_suru_sa]),_1726=[t_aux_suru_sa|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_suru_se]),_1726=[t_aux_suru_se|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_suru_shi]),_1726=[t_aux_suru_shi|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_suru_suru]),_1726=[t_aux_suru_suru|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_suru_sure]),_1726=[t_aux_suru_sure|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_suru_shiro]),_1726=[t_aux_suru_shiro|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_ba]),_1726=[t_aux_sfp_ba|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_de]),_1726=[t_aux_sfp_de|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_ga]),_1726=[t_aux_sfp_ga|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_ka]),_1726=[t_aux_sfp_ka|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_kaa]),_1726=[t_aux_sfp_kaa|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_kara]),_1726=[t_aux_sfp_kara|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_kasira]),_1726=[t_aux_sfp_kasira|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_mono]),_1726=[t_aux_sfp_mono|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_no]),_1726=[t_aux_sfp_no|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_si]),_1726=[t_aux_sfp_si|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_to]),_1726=[t_aux_sfp_to|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_tomo]),_1726=[t_aux_sfp_tomo|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_wa]),_1726=[t_aux_sfp_wa|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_ya]),_1726=[t_aux_sfp_ya|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_qke]),_1726=[t_aux_sfp_qke|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_qte]),_1726=[t_aux_sfp_qte|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_te]),_1726=[t_aux_sfp_te|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_yo]),_1726=[t_aux_sfp_yo|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_ne]),_1726=[t_aux_sfp_ne|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_nee]),_1726=[t_aux_sfp_nee|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_na]),_1726=[t_aux_sfp_na|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_naa]),_1726=[t_aux_sfp_naa|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_node]),_1726=[t_aux_sfp_node|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_kedo]),_1726=[t_aux_sfp_kedo|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_kedomo]),_1726=[t_aux_sfp_kedomo|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_keredo]),_1726=[t_aux_sfp_keredo|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_keredomo]),_1726=[t_aux_sfp_keredomo|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_monode]),_1726=[t_aux_sfp_monode|_1727].
pdcg(n_aux,_1726,_1727) :- fstck(n_aux,_1726),msw(n_aux,[t_aux_sfp_monodesukara]),_1726=[t_aux_sfp_monodesukara|_1727].
pdcg(n_n_num_keta_man,_1728,_1729) :- fstck(n_n_num_keta_man,_1728),msw(n_n_num_keta_man,[n_n_num_ichi,n_num_suf_man]),pdcg(n_n_num_ichi,_1728,_1733),pdcg(n_num_suf_man,_1733,_1729).
pdcg(n_p_quote,_1726,_1727) :- fstck(n_p_quote,_1726),msw(n_p_quote,[t_p_quote_to]),_1726=[t_p_quote_to|_1727].
pdcg(n_p_quote,_1726,_1727) :- fstck(n_p_quote,_1726),msw(n_p_quote,[t_p_quote_ka]),_1726=[t_p_quote_ka|_1727].
pdcg(n_p_quote,_1726,_1727) :- fstck(n_p_quote,_1726),msw(n_p_quote,[t_p_quote_kato]),_1726=[t_p_quote_kato|_1727].
pdcg(n_p_quote,_1726,_1727) :- fstck(n_p_quote,_1726),msw(n_p_quote,[t_p_quote_toka]),_1726=[t_p_quote_toka|_1727].
pdcg(n_p_quote,_1726,_1727) :- fstck(n_p_quote,_1726),msw(n_p_quote,[t_p_quote_noka]),_1726=[t_p_quote_noka|_1727].
pdcg(n_v_sahen_2FH_ga,_1728,_1729) :- fstck(n_v_sahen_2FH_ga,_1728),msw(n_v_sahen_2FH_ga,[n_pp_o,n_v_sahen_2FH_ga_o]),pdcg(n_pp_o,_1728,_1733),pdcg(n_v_sahen_2FH_ga_o,_1733,_1729).
pdcg(n_v_sahen_2FH_ga,_1728,_1729) :- fstck(n_v_sahen_2FH_ga,_1728),msw(n_v_sahen_2FH_ga,[n_pp_ni,n_v_sahen_2FH_ga_ni]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_v_sahen_2FH_ga_ni,_1733,_1729).
pdcg(n_v_sahen_2FH_ga,_1728,_1729) :- fstck(n_v_sahen_2FH_ga,_1728),msw(n_v_sahen_2FH_ga,[n_mod_v,n_v_sahen_2FH_ga]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_sahen_2FH_ga,_1733,_1729).
pdcg(n_adv_cl,_1728,_1729) :- fstck(n_adv_cl,_1728),msw(n_adv_cl,[t_interj_hesit,n_adv_cl]),_1728=[t_interj_hesit|_1740],pdcg(n_adv_cl,_1740,_1729).
pdcg(n_adv_cl,_1728,_1729) :- fstck(n_adv_cl,_1728),msw(n_adv_cl,[n_verb,n_aux_katei]),pdcg(n_verb,_1728,_1733),pdcg(n_aux_katei,_1733,_1729).
pdcg(n_adv_cl,_1728,_1729) :- fstck(n_adv_cl,_1728),msw(n_adv_cl,[n_vaux,n_aux_katei]),pdcg(n_vaux,_1728,_1733),pdcg(n_aux_katei,_1733,_1729).
pdcg(n_adv_cl,_1728,_1729) :- fstck(n_adv_cl,_1728),msw(n_adv_cl,[n_verb,n_p_conj_advcl]),pdcg(n_verb,_1728,_1733),pdcg(n_p_conj_advcl,_1733,_1729).
pdcg(n_adv_cl,_1728,_1729) :- fstck(n_adv_cl,_1728),msw(n_adv_cl,[n_vaux,n_p_conj_advcl]),pdcg(n_vaux,_1728,_1733),pdcg(n_p_conj_advcl,_1733,_1729).
pdcg(n_adv_cl,_1728,_1729) :- fstck(n_adv_cl,_1728),msw(n_adv_cl,[n_adv_cl,n_p_conj_advcl]),pdcg(n_adv_cl,_1728,_1733),pdcg(n_p_conj_advcl,_1733,_1729).
pdcg(n_aux_katei,_1726,_1727) :- fstck(n_aux_katei,_1726),msw(n_aux_katei,[t_aux_past_katei]),_1726=[t_aux_past_katei|_1727].
pdcg(n_aux_katei,_1726,_1727) :- fstck(n_aux_katei,_1726),msw(n_aux_katei,[t_aux_nara]),_1726=[t_aux_nara|_1727].
pdcg(n_pp_o,_1728,_1729) :- fstck(n_pp_o,_1728),msw(n_pp_o,[n_np,t_p_kaku_o]),pdcg(n_np,_1728,_1733),_1733=[t_p_kaku_o|_1729].
pdcg(n_pp_o,_1728,_1729) :- fstck(n_pp_o,_1728),msw(n_pp_o,[n_n_cl,t_p_kaku_o]),pdcg(n_n_cl,_1728,_1733),_1733=[t_p_kaku_o|_1729].
pdcg(n_pp_o,_1726,_1727) :- fstck(n_pp_o,_1726),msw(n_pp_o,[n_np]),pdcg(n_np,_1726,_1727).
pdcg(n_cl_ex,_1728,_1729) :- fstck(n_cl_ex,_1728),msw(n_cl_ex,[n_interj,n_cl_ex]),pdcg(n_interj,_1728,_1733),pdcg(n_cl_ex,_1733,_1729).
pdcg(n_cl_ex,_1728,_1729) :- fstck(n_cl_ex,_1728),msw(n_cl_ex,[n_adv_cl,n_cl_ex]),pdcg(n_adv_cl,_1728,_1733),pdcg(n_cl_ex,_1733,_1729).
pdcg(n_cl_ex,_1728,_1729) :- fstck(n_cl_ex,_1728),msw(n_cl_ex,[n_renyo_cl,n_cl_ex]),pdcg(n_renyo_cl,_1728,_1733),pdcg(n_cl_ex,_1733,_1729).
pdcg(n_cl_ex,_1728,_1729) :- fstck(n_cl_ex,_1728),msw(n_cl_ex,[t_interj_hesit,n_cl_ex]),_1728=[t_interj_hesit|_1740],pdcg(n_cl_ex,_1740,_1729).
pdcg(n_cl_ex,_1728,_1729) :- fstck(n_cl_ex,_1728),msw(n_cl_ex,[t_interj_hesit,n_verb]),_1728=[t_interj_hesit|_1740],pdcg(n_verb,_1740,_1729).
pdcg(n_cl_ex,_1728,_1729) :- fstck(n_cl_ex,_1728),msw(n_cl_ex,[t_interj_hesit,n_vaux]),_1728=[t_interj_hesit|_1740],pdcg(n_vaux,_1740,_1729).
pdcg(n_cl_ex,_1728,_1729) :- fstck(n_cl_ex,_1728),msw(n_cl_ex,[t_interj_hesit,n_cl]),_1728=[t_interj_hesit|_1740],pdcg(n_cl,_1740,_1729).
pdcg(n_specific_date,_1726,_1727) :- fstck(n_specific_date,_1726),msw(n_specific_date,[n_month_day]),pdcg(n_month_day,_1726,_1727).
pdcg(n_specific_date,_1726,_1727) :- fstck(n_specific_date,_1726),msw(n_specific_date,[n_n_day]),pdcg(n_n_day,_1726,_1727).
pdcg(n_specific_date,_1728,_1729) :- fstck(n_specific_date,_1728),msw(n_specific_date,[n_month_day,n_n_week]),pdcg(n_month_day,_1728,_1733),pdcg(n_n_week,_1733,_1729).
pdcg(n_specific_date,_1728,_1729) :- fstck(n_specific_date,_1728),msw(n_specific_date,[n_mod_day,n_n_day]),pdcg(n_mod_day,_1728,_1733),pdcg(n_n_day,_1733,_1729).
pdcg(n_specific_date,_1728,_1729) :- fstck(n_specific_date,_1728),msw(n_specific_date,[n_mod_week,n_n_week]),pdcg(n_mod_week,_1728,_1733),pdcg(n_n_week,_1733,_1729).
pdcg(n_specific_date,_1728,_1729) :- fstck(n_specific_date,_1728),msw(n_specific_date,[n_n_day,n_n_week]),pdcg(n_n_day,_1728,_1733),pdcg(n_n_week,_1733,_1729).
pdcg(n_specific_date,_1728,_1729) :- fstck(n_specific_date,_1728),msw(n_specific_date,[n_mod_time,n_n_time]),pdcg(n_mod_time,_1728,_1733),pdcg(n_n_time,_1733,_1729).
pdcg(n_stay_date,_1728,_1729) :- fstck(n_stay_date,_1728),msw(n_stay_date,[n_stay_period,n_stay_day]),pdcg(n_stay_period,_1728,_1733),pdcg(n_stay_day,_1733,_1729).
pdcg(n_stay_date,_1730,_1731) :- fstck(n_stay_date,_1730),msw(n_stay_date,[n_stay_period,n_p_rentai,n_stay_day]),pdcg(n_stay_period,_1730,_1735),pdcg(n_p_rentai,_1735,_1742),pdcg(n_stay_day,_1742,_1731).
pdcg(n_stay_date,_1728,_1729) :- fstck(n_stay_date,_1728),msw(n_stay_date,[n_stay_day,n_stay_period]),pdcg(n_stay_day,_1728,_1733),pdcg(n_stay_period,_1733,_1729).
pdcg(n_stay_date,_1726,_1727) :- fstck(n_stay_date,_1726),msw(n_stay_date,[n_stay_day]),pdcg(n_stay_day,_1726,_1727).
pdcg(n_stay_date,_1726,_1727) :- fstck(n_stay_date,_1726),msw(n_stay_date,[n_stay_period]),pdcg(n_stay_period,_1726,_1727).
pdcg(n_vstem1_2FH_ga_ni_5EH_to,_1726,_1727) :- fstck(n_vstem1_2FH_ga_ni_5EH_to,_1726),msw(n_vstem1_2FH_ga_ni_5EH_to,[t_vstem_1_2FH_ga_ni_5EH_to]),_1726=[t_vstem_1_2FH_ga_ni_5EH_to|_1727].
pdcg(n_vstem1_2FH_ga_o,_1726,_1727) :- fstck(n_vstem1_2FH_ga_o,_1726),msw(n_vstem1_2FH_ga_o,[t_vstem_1_2FH_ga_o]),_1726=[t_vstem_1_2FH_ga_o|_1727].
pdcg(n_p_kaku_optn,_1728,_1729) :- fstck(n_p_kaku_optn,_1728),msw(n_p_kaku_optn,[n_p_kaku_optn,n_p_kaku_optn]),pdcg(n_p_kaku_optn,_1728,_1733),pdcg(n_p_kaku_optn,_1733,_1729).
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_ni]),_1726=[t_p_kaku_ni|_1727].
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_e]),_1726=[t_p_kaku_e|_1727].
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_de]),_1726=[t_p_kaku_de|_1727].
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_to]),_1726=[t_p_kaku_to|_1727].
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_kara]),_1726=[t_p_kaku_kara|_1727].
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_yori]),_1726=[t_p_kaku_yori|_1727].
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_made]),_1726=[t_p_kaku_made|_1727].
pdcg(n_p_kaku_optn,_1726,_1727) :- fstck(n_p_kaku_optn,_1726),msw(n_p_kaku_optn,[t_p_kaku_hukugo]),_1726=[t_p_kaku_hukugo|_1727].
pdcg(n_n_num,_1726,_1727) :- fstck(n_n_num,_1726),msw(n_n_num,[n_n_num_ichi]),pdcg(n_n_num_ichi,_1726,_1727).
pdcg(n_n_num,_1726,_1727) :- fstck(n_n_num,_1726),msw(n_n_num,[n_n_num_zyuu]),pdcg(n_n_num_zyuu,_1726,_1727).
pdcg(n_n_num,_1726,_1727) :- fstck(n_n_num,_1726),msw(n_n_num,[n_n_num_hyaku]),pdcg(n_n_num_hyaku,_1726,_1727).
pdcg(n_n_num,_1726,_1727) :- fstck(n_n_num,_1726),msw(n_n_num,[n_n_num_sen]),pdcg(n_n_num_sen,_1726,_1727).
pdcg(n_n_num,_1726,_1727) :- fstck(n_n_num,_1726),msw(n_n_num,[n_n_num_man]),pdcg(n_n_num_man,_1726,_1727).
pdcg(n_n_num,_1728,_1729) :- fstck(n_n_num,_1728),msw(n_n_num,[n_n_num_ten,n_n_num_syosu]),pdcg(n_n_num_ten,_1728,_1733),pdcg(n_n_num_syosu,_1733,_1729).
pdcg(n_n_date_and_time,_1728,_1729) :- fstck(n_n_date_and_time,_1728),msw(n_n_date_and_time,[n_mod_n,n_n_date_and_time]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_date_and_time,_1733,_1729).
pdcg(n_n_date_and_time,_1726,_1727) :- fstck(n_n_date_and_time,_1726),msw(n_n_date_and_time,[n_n_year]),pdcg(n_n_year,_1726,_1727).
pdcg(n_n_date_and_time,_1726,_1727) :- fstck(n_n_date_and_time,_1726),msw(n_n_date_and_time,[n_n_month]),pdcg(n_n_month,_1726,_1727).
pdcg(n_n_date_and_time,_1726,_1727) :- fstck(n_n_date_and_time,_1726),msw(n_n_date_and_time,[n_n_week]),pdcg(n_n_week,_1726,_1727).
pdcg(n_n_date_and_time,_1726,_1727) :- fstck(n_n_date_and_time,_1726),msw(n_n_date_and_time,[n_n_day]),pdcg(n_n_day,_1726,_1727).
pdcg(n_n_date_and_time,_1726,_1727) :- fstck(n_n_date_and_time,_1726),msw(n_n_date_and_time,[n_tag_slot]),pdcg(n_tag_slot,_1726,_1727).
pdcg(n_n_date_and_time,_1726,_1727) :- fstck(n_n_date_and_time,_1726),msw(n_n_date_and_time,[n_n_hour]),pdcg(n_n_hour,_1726,_1727).
pdcg(n_n_date_and_time,_1726,_1727) :- fstck(n_n_date_and_time,_1726),msw(n_n_date_and_time,[n_n_minute]),pdcg(n_n_minute,_1726,_1727).
pdcg(n_n_date_and_time,_1728,_1729) :- fstck(n_n_date_and_time,_1728),msw(n_n_date_and_time,[n_tag_slot,n_n_hour]),pdcg(n_tag_slot,_1728,_1733),pdcg(n_n_hour,_1733,_1729).
pdcg(n_n_date_and_time,_1728,_1729) :- fstck(n_n_date_and_time,_1728),msw(n_n_date_and_time,[n_n_year,n_n_month]),pdcg(n_n_year,_1728,_1733),pdcg(n_n_month,_1733,_1729).
pdcg(n_n_date_and_time,_1728,_1729) :- fstck(n_n_date_and_time,_1728),msw(n_n_date_and_time,[n_n_month,n_n_day]),pdcg(n_n_month,_1728,_1733),pdcg(n_n_day,_1733,_1729).
pdcg(n_n_date_and_time,_1728,_1729) :- fstck(n_n_date_and_time,_1728),msw(n_n_date_and_time,[n_n_hour,n_n_minute]),pdcg(n_n_hour,_1728,_1733),pdcg(n_n_minute,_1733,_1729).
pdcg(n_n_date_and_time,_1728,_1729) :- fstck(n_n_date_and_time,_1728),msw(n_n_date_and_time,[n_n_date_and_time,n_n_week]),pdcg(n_n_date_and_time,_1728,_1733),pdcg(n_n_week,_1733,_1729).
pdcg(n_n_date_and_time,_1728,_1729) :- fstck(n_n_date_and_time,_1728),msw(n_n_date_and_time,[n_tag_slot,n_n_date_and_time]),pdcg(n_tag_slot,_1728,_1733),pdcg(n_n_date_and_time,_1733,_1729).
pdcg(n_num_suf_zyuu,_1726,_1727) :- fstck(n_num_suf_zyuu,_1726),msw(n_num_suf_zyuu,[t_num_zyuu]),_1726=[t_num_zyuu|_1727].
pdcg(n_num_suf_zyuu,_1726,_1727) :- fstck(n_num_suf_zyuu,_1726),msw(n_num_suf_zyuu,[t_num_zyuq]),_1726=[t_num_zyuq|_1727].
pdcg(n_period_kara,_1728,_1729) :- fstck(n_period_kara,_1728),msw(n_period_kara,[n_period_begin,n_p_kaku_optn]),pdcg(n_period_begin,_1728,_1733),pdcg(n_p_kaku_optn,_1733,_1729).
pdcg(n_vstem1_2FH_ga_to,_1726,_1727) :- fstck(n_vstem1_2FH_ga_to,_1726),msw(n_vstem1_2FH_ga_to,[t_vstem_1_2FH_ga_to]),_1726=[t_vstem_1_2FH_ga_to|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_k_2FH_ga_ni_o]),_1726=[t_vstem_5_k_2FH_ga_ni_o|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_g_2FH_ga_ni_o]),_1726=[t_vstem_5_g_2FH_ga_ni_o|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_s_2FH_ga_ni_o]),_1726=[t_vstem_5_s_2FH_ga_ni_o|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_t_2FH_ga_ni_o]),_1726=[t_vstem_5_t_2FH_ga_ni_o|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_b_2FH_ga_ni_o]),_1726=[t_vstem_5_b_2FH_ga_ni_o|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_m_2FH_ga_ni_o]),_1726=[t_vstem_5_m_2FH_ga_ni_o|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_r_2FH_ga_ni_o]),_1726=[t_vstem_5_r_2FH_ga_ni_o|_1727].
pdcg(n_vstem5_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_o,_1726),msw(n_vstem5_2FH_ga_ni_o,[t_vstem_5_w_2FH_ga_ni_o]),_1726=[t_vstem_5_w_2FH_ga_ni_o|_1727].
pdcg(n_n_num_bango,_1728,_1729) :- fstck(n_n_num_bango,_1728),msw(n_n_num_bango,[n_num_ex_rentai,n_num_ex_4]),pdcg(n_num_ex_rentai,_1728,_1733),pdcg(n_num_ex_4,_1733,_1729).
pdcg(n_n_num_bango,_1728,_1729) :- fstck(n_n_num_bango,_1728),msw(n_n_num_bango,[n_n_num_bango,n_suffix_unit]),pdcg(n_n_num_bango,_1728,_1733),pdcg(n_suffix_unit,_1733,_1729).
pdcg(n_n_num_bango,_1728,_1729) :- fstck(n_n_num_bango,_1728),msw(n_n_num_bango,[n_num_ex_3,n_num_ex_4]),pdcg(n_num_ex_3,_1728,_1733),pdcg(n_num_ex_4,_1733,_1729).
pdcg(n_n_num_bango,_1730,_1731) :- fstck(n_n_num_bango,_1730),msw(n_n_num_bango,[n_num_ex_3,n_num_ex_3,n_num_ex_4]),pdcg(n_num_ex_3,_1730,_1735),pdcg(n_num_ex_3,_1735,_1742),pdcg(n_num_ex_4,_1742,_1731).
pdcg(n_n_num_bango,_1732,_1733) :- fstck(n_n_num_bango,_1732),msw(n_n_num_bango,[n_num_ex_4,n_num_ex_4,n_num_ex_4,n_num_ex_4]),pdcg(n_num_ex_4,_1732,_1737),pdcg(n_num_ex_4,_1737,_1744),pdcg(n_num_ex_4,_1744,_1751),pdcg(n_num_ex_4,_1751,_1733).
pdcg(n_n_num_bango,_1730,_1731) :- fstck(n_n_num_bango,_1730),msw(n_n_num_bango,[n_num_ex_2,n_num_ex_4,n_num_ex_4]),pdcg(n_num_ex_2,_1730,_1735),pdcg(n_num_ex_4,_1735,_1742),pdcg(n_num_ex_4,_1742,_1731).
pdcg(n_n_num_bango,_1728,_1729) :- fstck(n_n_num_bango,_1728),msw(n_n_num_bango,[n_num_ex_4,n_num_ex_4]),pdcg(n_num_ex_4,_1728,_1733),pdcg(n_num_ex_4,_1733,_1729).
pdcg(n_n_num_bango,_1728,_1729) :- fstck(n_n_num_bango,_1728),msw(n_n_num_bango,[n_num_ex_2,n_num_ex_4]),pdcg(n_num_ex_2,_1728,_1733),pdcg(n_num_ex_4,_1733,_1729).
pdcg(n_tag_slot,_1726,_1727) :- fstck(n_tag_slot,_1726),msw(n_tag_slot,[t_zikantai]),_1726=[t_zikantai|_1727].
pdcg(n_v_sahen_2FH_ga_o,_1728,_1729) :- fstck(n_v_sahen_2FH_ga_o,_1728),msw(n_v_sahen_2FH_ga_o,[n_mod_v,n_v_sahen_2FH_ga_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_sahen_2FH_ga_o,_1733,_1729).
pdcg(n_v_sahen_2FH_ga_o,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_o,_1726),msw(n_v_sahen_2FH_ga_o,[t_sahen_dousi_mizen_2FH_ga_o]),_1726=[t_sahen_dousi_mizen_2FH_ga_o|_1727].
pdcg(n_v_sahen_2FH_ga_o,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_o,_1726),msw(n_v_sahen_2FH_ga_o,[t_sahen_dousi_renyo_2FH_ga_o]),_1726=[t_sahen_dousi_renyo_2FH_ga_o|_1727].
pdcg(n_v_sahen_2FH_ga_o,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_o,_1726),msw(n_v_sahen_2FH_ga_o,[t_sahen_dousi_syusi_2FH_ga_o]),_1726=[t_sahen_dousi_syusi_2FH_ga_o|_1727].
pdcg(n_v_sahen_2FH_ga_o,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_o,_1726),msw(n_v_sahen_2FH_ga_o,[t_sahen_dousi_rentai_2FH_ga_o]),_1726=[t_sahen_dousi_rentai_2FH_ga_o|_1727].
pdcg(n_v_sahen_2FH_ga_o,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_o,_1726),msw(n_v_sahen_2FH_ga_o,[t_sahen_dousi_katei_2FH_ga_o]),_1726=[t_sahen_dousi_katei_2FH_ga_o|_1727].
pdcg(n_mod_n,_1726,_1727) :- fstck(n_mod_n,_1726),msw(n_mod_n,[n_verb]),pdcg(n_verb,_1726,_1727).
pdcg(n_mod_n,_1726,_1727) :- fstck(n_mod_n,_1726),msw(n_mod_n,[n_vaux]),pdcg(n_vaux,_1726,_1727).
pdcg(n_mod_n,_1728,_1729) :- fstck(n_mod_n,_1728),msw(n_mod_n,[n_mod_n,n_aux]),pdcg(n_mod_n,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_mod_n,_1726,_1727) :- fstck(n_mod_n,_1726),msw(n_mod_n,[t_rentai]),_1726=[t_rentai|_1727].
pdcg(n_mod_n,_1728,_1729) :- fstck(n_mod_n,_1728),msw(n_mod_n,[n_np,n_p_rentai]),pdcg(n_np,_1728,_1733),pdcg(n_p_rentai,_1733,_1729).
pdcg(n_mod_n,_1728,_1729) :- fstck(n_mod_n,_1728),msw(n_mod_n,[n_pp,n_p_rentai]),pdcg(n_pp,_1728,_1733),pdcg(n_p_rentai,_1733,_1729).
pdcg(n_mod_n,_1728,_1729) :- fstck(n_mod_n,_1728),msw(n_mod_n,[n_np,n_p_para]),pdcg(n_np,_1728,_1733),pdcg(n_p_para,_1733,_1729).
pdcg(n_p_rentai,_1726,_1727) :- fstck(n_p_rentai,_1726),msw(n_p_rentai,[t_p_rentai_no]),_1726=[t_p_rentai_no|_1727].
pdcg(n_p_rentai,_1726,_1727) :- fstck(n_p_rentai,_1726),msw(n_p_rentai,[t_p_rentai_hukugo]),_1726=[t_p_rentai_hukugo|_1727].
pdcg(n_verb_2FH_ga_to,_1728,_1729) :- fstck(n_verb_2FH_ga_to,_1728),msw(n_verb_2FH_ga_to,[n_vstem5_2FH_ga_to,n_infl]),pdcg(n_vstem5_2FH_ga_to,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_to,_1728,_1729) :- fstck(n_verb_2FH_ga_to,_1728),msw(n_verb_2FH_ga_to,[n_vstem1_2FH_ga_to,n_infl]),pdcg(n_vstem1_2FH_ga_to,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_to,_1726,_1727) :- fstck(n_verb_2FH_ga_to,_1726),msw(n_verb_2FH_ga_to,[n_vstem1_2FH_ga_to]),pdcg(n_vstem1_2FH_ga_to,_1726,_1727).
pdcg(n_verb_2FH_ga_to,_1728,_1729) :- fstck(n_verb_2FH_ga_to,_1728),msw(n_verb_2FH_ga_to,[n_mod_v,n_verb_2FH_ga_to]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_to,_1733,_1729).
pdcg(n_verb_2FH_ga_to,_1728,_1729) :- fstck(n_verb_2FH_ga_to,_1728),msw(n_verb_2FH_ga_to,[n_mod_v,n_n_sahen_2FH_ga_to]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga_to,_1733,_1729).
pdcg(n_verb_2FH_ga_to,_1728,_1729) :- fstck(n_verb_2FH_ga_to,_1728),msw(n_verb_2FH_ga_to,[n_mod_v,n_n_adj_2FH_ga_to]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_adj_2FH_ga_to,_1733,_1729).
pdcg(n_period_begin,_1728,_1729) :- fstck(n_period_begin,_1728),msw(n_period_begin,[n_n_time,n_specific_date]),pdcg(n_n_time,_1728,_1733),pdcg(n_specific_date,_1733,_1729).
pdcg(n_period_begin,_1726,_1727) :- fstck(n_period_begin,_1726),msw(n_period_begin,[n_specific_date]),pdcg(n_specific_date,_1726,_1727).
pdcg(n_renyo_cl,_1726,_1727) :- fstck(n_renyo_cl,_1726),msw(n_renyo_cl,[n_verb]),pdcg(n_verb,_1726,_1727).
pdcg(n_renyo_cl,_1726,_1727) :- fstck(n_renyo_cl,_1726),msw(n_renyo_cl,[n_vaux]),pdcg(n_vaux,_1726,_1727).
pdcg(n_n_num_ex,_1726,_1727) :- fstck(n_n_num_ex,_1726),msw(n_n_num_ex,[t_num_bouyomi]),_1726=[t_num_bouyomi|_1727].
pdcg(n_num_suf_sen,_1726,_1727) :- fstck(n_num_suf_sen,_1726),msw(n_num_suf_sen,[t_num_sen]),_1726=[t_num_sen|_1727].
pdcg(n_num_suf_sen,_1726,_1727) :- fstck(n_num_suf_sen,_1726),msw(n_num_suf_sen,[t_num_zen]),_1726=[t_num_zen|_1727].
pdcg(n_v_sahen_2FH_ga_ni,_1728,_1729) :- fstck(n_v_sahen_2FH_ga_ni,_1728),msw(n_v_sahen_2FH_ga_ni,[n_mod_v,n_v_sahen_2FH_ga_ni]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_sahen_2FH_ga_ni,_1733,_1729).
pdcg(n_v_sahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_ni,_1726),msw(n_v_sahen_2FH_ga_ni,[t_sahen_dousi_mizen_2FH_ga_ni]),_1726=[t_sahen_dousi_mizen_2FH_ga_ni|_1727].
pdcg(n_v_sahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_ni,_1726),msw(n_v_sahen_2FH_ga_ni,[t_sahen_dousi_renyo_2FH_ga_ni]),_1726=[t_sahen_dousi_renyo_2FH_ga_ni|_1727].
pdcg(n_v_sahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_ni,_1726),msw(n_v_sahen_2FH_ga_ni,[t_sahen_dousi_syusi_2FH_ga_ni]),_1726=[t_sahen_dousi_syusi_2FH_ga_ni|_1727].
pdcg(n_v_sahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_ni,_1726),msw(n_v_sahen_2FH_ga_ni,[t_sahen_dousi_rentai_2FH_ga_ni]),_1726=[t_sahen_dousi_rentai_2FH_ga_ni|_1727].
pdcg(n_v_sahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_sahen_2FH_ga_ni,_1726),msw(n_v_sahen_2FH_ga_ni,[t_sahen_dousi_katei_2FH_ga_ni]),_1726=[t_sahen_dousi_katei_2FH_ga_ni|_1727].
pdcg(n_stay,_1726,_1727) :- fstck(n_stay,_1726),msw(n_stay,[n_reservation]),pdcg(n_reservation,_1726,_1727).
pdcg(n_stay,_1728,_1729) :- fstck(n_stay,_1728),msw(n_stay,[n_visitor_name,n_reservation]),_1728=[n_visitor_name|_1740],pdcg(n_reservation,_1740,_1729).
pdcg(n_stay,_1730,_1731) :- fstck(n_stay,_1730),msw(n_stay,[n_visitor_name,n_aux,n_reservation]),_1730=[n_visitor_name|_1742],pdcg(n_aux,_1742,_1749),pdcg(n_reservation,_1749,_1731).
pdcg(n_auxstem_deac,_1726,_1727) :- fstck(n_auxstem_deac,_1726),msw(n_auxstem_deac,[t_auxstem_deac_reru]),_1726=[t_auxstem_deac_reru|_1727].
pdcg(n_auxstem_deac,_1726,_1727) :- fstck(n_auxstem_deac,_1726),msw(n_auxstem_deac,[t_auxstem_deac_rareru]),_1726=[t_auxstem_deac_rareru|_1727].
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_vstem5_2FH_ga_o,n_infl]),pdcg(n_vstem5_2FH_ga_o,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_vstem1_2FH_ga_o,n_infl]),pdcg(n_vstem1_2FH_ga_o,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_o,_1726,_1727) :- fstck(n_verb_2FH_ga_o,_1726),msw(n_verb_2FH_ga_o,[n_vstem1_2FH_ga_o]),pdcg(n_vstem1_2FH_ga_o,_1726,_1727).
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_pp_ni,n_verb_2FH_ga_ni_5EH_e_o]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1733,_1729).
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_pp_e,n_verb_2FH_ga_ni_5EH_e_o]),pdcg(n_pp_e,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1733,_1729).
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_pp_ni,n_verb_2FH_ga_ni_o]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_verb_2FH_ga_ni_o,_1733,_1729).
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_mod_v,n_verb_2FH_ga_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_o,_1733,_1729).
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_pp_ni,n_n_sahen_2FH_ga_ni_o]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni_o,_1733,_1729).
pdcg(n_verb_2FH_ga_o,_1728,_1729) :- fstck(n_verb_2FH_ga_o,_1728),msw(n_verb_2FH_ga_o,[n_mod_v,n_n_sahen_2FH_ga_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga_o,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_ni_5EH_e_o,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni_5EH_e_o,_1728),msw(n_n_sahen_2FH_ga_ni_5EH_e_o,[n_prefix,n_verb_2FH_ga_ni_5EH_e_o]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1733,_1729).
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_k_2FH_ga]),_1726=[t_vstem_5_k_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_g_2FH_ga]),_1726=[t_vstem_5_g_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_s_2FH_ga]),_1726=[t_vstem_5_s_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_t_2FH_ga]),_1726=[t_vstem_5_t_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_b_2FH_ga]),_1726=[t_vstem_5_b_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_m_2FH_ga]),_1726=[t_vstem_5_m_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_r_2FH_ga]),_1726=[t_vstem_5_r_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_r_i_2FH_ga]),_1726=[t_vstem_5_r_i_2FH_ga|_1727].
pdcg(n_vstem5_2FH_ga,_1726,_1727) :- fstck(n_vstem5_2FH_ga,_1726),msw(n_vstem5_2FH_ga,[t_vstem_5_w_2FH_ga]),_1726=[t_vstem_5_w_2FH_ga|_1727].
pdcg(n_vstem1_2FH_ga_de,_1726,_1727) :- fstck(n_vstem1_2FH_ga_de,_1726),msw(n_vstem1_2FH_ga_de,[t_vstem_1_2FH_ga_de]),_1726=[t_vstem_1_2FH_ga_de|_1727].
pdcg(n_n_num_man,_1726,_1727) :- fstck(n_n_num_man,_1726),msw(n_n_num_man,[n_n_num_keta_man]),pdcg(n_n_num_keta_man,_1726,_1727).
pdcg(n_n_num_man,_1728,_1729) :- fstck(n_n_num_man,_1728),msw(n_n_num_man,[n_n_num_keta_man,n_n_num_ichi]),pdcg(n_n_num_keta_man,_1728,_1733),pdcg(n_n_num_ichi,_1733,_1729).
pdcg(n_n_num_man,_1728,_1729) :- fstck(n_n_num_man,_1728),msw(n_n_num_man,[n_n_num_keta_man,n_n_num_zyuu]),pdcg(n_n_num_keta_man,_1728,_1733),pdcg(n_n_num_zyuu,_1733,_1729).
pdcg(n_n_num_man,_1728,_1729) :- fstck(n_n_num_man,_1728),msw(n_n_num_man,[n_n_num_keta_man,n_n_num_hyaku]),pdcg(n_n_num_keta_man,_1728,_1733),pdcg(n_n_num_hyaku,_1733,_1729).
pdcg(n_n_num_man,_1728,_1729) :- fstck(n_n_num_man,_1728),msw(n_n_num_man,[n_n_num_keta_man,n_n_num_sen]),pdcg(n_n_num_keta_man,_1728,_1733),pdcg(n_n_num_sen,_1733,_1729).
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_k_2FH_ga_ni]),_1726=[t_vstem_5_k_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_g_2FH_ga_ni]),_1726=[t_vstem_5_g_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_s_2FH_ga_ni]),_1726=[t_vstem_5_s_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_t_2FH_ga_ni]),_1726=[t_vstem_5_t_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_b_2FH_ga_ni]),_1726=[t_vstem_5_b_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_m_2FH_ga_ni]),_1726=[t_vstem_5_m_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_r_2FH_ga_ni]),_1726=[t_vstem_5_r_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni,_1726),msw(n_vstem5_2FH_ga_ni,[t_vstem_5_w_2FH_ga_ni]),_1726=[t_vstem_5_w_2FH_ga_ni|_1727].
pdcg(n_period_end,_1726,_1727) :- fstck(n_period_end,_1726),msw(n_period_end,[n_specific_date]),pdcg(n_specific_date,_1726,_1727).
pdcg(n_period_made,_1728,_1729) :- fstck(n_period_made,_1728),msw(n_period_made,[n_period_end,n_p_kaku_optn]),pdcg(n_period_end,_1728,_1733),pdcg(n_p_kaku_optn,_1733,_1729).
pdcg(n_period_made,_1726,_1727) :- fstck(n_period_made,_1726),msw(n_period_made,[n_period_end]),pdcg(n_period_end,_1726,_1727).
pdcg(n_p_conj_advp,_1726,_1727) :- fstck(n_p_conj_advp,_1726),msw(n_p_conj_advp,[t_p_conj_renyo_te]),_1726=[t_p_conj_renyo_te|_1727].
pdcg(n_p_conj_advp,_1726,_1727) :- fstck(n_p_conj_advp,_1726),msw(n_p_conj_advp,[t_p_conj_syusi_to]),_1726=[t_p_conj_syusi_to|_1727].
pdcg(n_adv_sent,_1726,_1727) :- fstck(n_adv_sent,_1726),msw(n_adv_sent,[t_bun_hukusi]),_1726=[t_bun_hukusi|_1727].
pdcg(n_vstem_spe_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem_spe_2FH_ga_ni,_1726),msw(n_vstem_spe_2FH_ga_ni,[t_vstem_sahen_2FH_ga_ni]),_1726=[t_vstem_sahen_2FH_ga_ni|_1727].
pdcg(n_vstem1_2FH_ga_ni_5EH_e,_1726,_1727) :- fstck(n_vstem1_2FH_ga_ni_5EH_e,_1726),msw(n_vstem1_2FH_ga_ni_5EH_e,[t_vstem_1_2FH_ga_ni_5EH_e]),_1726=[t_vstem_1_2FH_ga_ni_5EH_e|_1727].
pdcg(n_num_suf_hyaku,_1726,_1727) :- fstck(n_num_suf_hyaku,_1726),msw(n_num_suf_hyaku,[t_num_hyaku]),_1726=[t_num_hyaku|_1727].
pdcg(n_num_suf_hyaku,_1726,_1727) :- fstck(n_num_suf_hyaku,_1726),msw(n_num_suf_hyaku,[t_num_hyaq]),_1726=[t_num_hyaq|_1727].
pdcg(n_num_suf_hyaku,_1726,_1727) :- fstck(n_num_suf_hyaku,_1726),msw(n_num_suf_hyaku,[t_num_byaku]),_1726=[t_num_byaku|_1727].
pdcg(n_num_suf_hyaku,_1726,_1727) :- fstck(n_num_suf_hyaku,_1726),msw(n_num_suf_hyaku,[t_num_byaq]),_1726=[t_num_byaq|_1727].
pdcg(n_num_suf_hyaku,_1726,_1727) :- fstck(n_num_suf_hyaku,_1726),msw(n_num_suf_hyaku,[t_num_pyaku]),_1726=[t_num_pyaku|_1727].
pdcg(n_num_suf_hyaku,_1726,_1727) :- fstck(n_num_suf_hyaku,_1726),msw(n_num_suf_hyaku,[t_num_pyaq]),_1726=[t_num_pyaq|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_en]),_1726=[t_suffix_en|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_doru]),_1726=[t_suffix_doru|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_sento]),_1726=[t_suffix_sento|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_b]),_1726=[t_suffix_num_b|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_g]),_1726=[t_suffix_num_g|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_h]),_1726=[t_suffix_num_h|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_k]),_1726=[t_suffix_num_k|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_m]),_1726=[t_suffix_num_m|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_n]),_1726=[t_suffix_num_n|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_p]),_1726=[t_suffix_num_p|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_s]),_1726=[t_suffix_num_s|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_z]),_1726=[t_suffix_num_z|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_ri]),_1726=[t_suffix_num_ri|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_tsu]),_1726=[t_suffix_num_tsu|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_ka]),_1726=[t_suffix_num_ka|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_d]),_1726=[t_suffix_num_d|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_r]),_1726=[t_suffix_num_r|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_t]),_1726=[t_suffix_num_t|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_i]),_1726=[t_suffix_num_i|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_w]),_1726=[t_suffix_num_w|_1727].
pdcg(n_suffix_unit,_1726,_1727) :- fstck(n_suffix_unit,_1726),msw(n_suffix_unit,[t_suffix_num_y]),_1726=[t_suffix_num_y|_1727].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_spel,n_n_spel]),pdcg(n_n_spel,_1728,_1733),pdcg(n_n_spel,_1733,_1729).
pdcg(n_n_hutu,_1730,_1731) :- fstck(n_n_hutu,_1730),msw(n_n_hutu,[n_n_spel,n_n_spel,n_n_spel]),pdcg(n_n_spel,_1730,_1735),pdcg(n_n_spel,_1735,_1742),pdcg(n_n_spel,_1742,_1731).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_mod_n,n_n_hutu]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_num,n_suffix_unit]),pdcg(n_n_num,_1728,_1733),pdcg(n_suffix_unit,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_num_ex_3,n_suffix_unit]),pdcg(n_num_ex_3,_1728,_1733),pdcg(n_suffix_unit,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_prefix,n_n_hutu]),pdcg(n_prefix,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_hutu,t_suffix_hutu_hutu]),pdcg(n_n_hutu,_1728,_1733),_1733=[t_suffix_hutu_hutu|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_quant,t_suffix_quant_hutu]),pdcg(n_n_quant,_1728,_1733),_1733=[t_suffix_quant_hutu|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_hutu,t_suffix_name]),pdcg(n_n_hutu,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_quant,t_suffix_name]),pdcg(n_n_quant,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_sahen,t_suffix_hutu_hutu]),pdcg(n_n_sahen,_1728,_1733),_1733=[t_suffix_hutu_hutu|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_sahen,t_suffix_sahen_hutu]),pdcg(n_n_sahen,_1728,_1733),_1733=[t_suffix_sahen_hutu|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_date_and_time,t_suffix_time_hutu]),pdcg(n_n_date_and_time,_1728,_1733),_1733=[t_suffix_time_hutu|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[t_adjstem_2FH_ga,t_suffix_adj_hutu]),_1728=[t_adjstem_2FH_ga|_1740],_1740=[t_suffix_adj_hutu|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_adj_2FH_ga,t_suffix_adj_hutu]),pdcg(n_n_adj_2FH_ga,_1728,_1733),_1733=[t_suffix_adj_hutu|_1729].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_hutu,n_n_hutu]),pdcg(n_n_hutu,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_quant,n_n_hutu]),pdcg(n_n_quant,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_sahen,n_n_hutu]),pdcg(n_n_sahen,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_hutu,n_n_sahen]),pdcg(n_n_hutu,_1728,_1733),pdcg(n_n_sahen,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_sahen,n_n_sahen]),pdcg(n_n_sahen,_1728,_1733),pdcg(n_n_sahen,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_proper,n_n_hutu]),pdcg(n_n_proper,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_proper,n_n_sahen]),pdcg(n_n_proper,_1728,_1733),pdcg(n_n_sahen,_1733,_1729).
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_n_adj,n_n_hutu]),pdcg(n_n_adj,_1728,_1733),pdcg(n_n_hutu,_1733,_1729).
pdcg(n_n_hutu,_1726,_1727) :- fstck(n_n_hutu,_1726),msw(n_n_hutu,[t_hutu_meisi]),_1726=[t_hutu_meisi|_1727].
pdcg(n_n_hutu,_1726,_1727) :- fstck(n_n_hutu,_1726),msw(n_n_hutu,[t_hutu_meisi_post]),_1726=[t_hutu_meisi_post|_1727].
pdcg(n_n_hutu,_1726,_1727) :- fstck(n_n_hutu,_1726),msw(n_n_hutu,[t_n_keisiki]),_1726=[t_n_keisiki|_1727].
pdcg(n_n_hutu,_1728,_1729) :- fstck(n_n_hutu,_1728),msw(n_n_hutu,[n_prefix,n_wh_adv]),pdcg(n_prefix,_1728,_1733),pdcg(n_wh_adv,_1733,_1729).
pdcg(n_n_hutu,_1726,_1727) :- fstck(n_n_hutu,_1726),msw(n_n_hutu,[t_adj_meisi]),_1726=[t_adj_meisi|_1727].
pdcg(n_n_num_keta_hyaku,_1726,_1727) :- fstck(n_n_num_keta_hyaku,_1726),msw(n_n_num_keta_hyaku,[n_num_suf_hyaku]),pdcg(n_num_suf_hyaku,_1726,_1727).
pdcg(n_n_num_keta_hyaku,_1728,_1729) :- fstck(n_n_num_keta_hyaku,_1728),msw(n_n_num_keta_hyaku,[n_n_num_ichi,n_num_suf_hyaku]),pdcg(n_n_num_ichi,_1728,_1733),pdcg(n_num_suf_hyaku,_1733,_1729).
pdcg(n_n_cl,_1728,_1729) :- fstck(n_n_cl,_1728),msw(n_n_cl,[n_verb,t_p_jun]),pdcg(n_verb,_1728,_1733),_1733=[t_p_jun|_1729].
pdcg(n_n_cl,_1728,_1729) :- fstck(n_n_cl,_1728),msw(n_n_cl,[n_vaux,t_p_jun]),pdcg(n_vaux,_1728,_1733),_1733=[t_p_jun|_1729].
pdcg(n_pp_ni,_1728,_1729) :- fstck(n_pp_ni,_1728),msw(n_pp_ni,[n_np,t_p_kaku_ni]),pdcg(n_np,_1728,_1733),_1733=[t_p_kaku_ni|_1729].
pdcg(n_pp_ni,_1728,_1729) :- fstck(n_pp_ni,_1728),msw(n_pp_ni,[n_pp_ni,n_p_kakari]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_pp_ni,_1728,_1729) :- fstck(n_pp_ni,_1728),msw(n_pp_ni,[n_pp,t_p_kaku_ni]),pdcg(n_pp,_1728,_1733),_1733=[t_p_kaku_ni|_1729].
pdcg(n_verb_2FH_ga_de,_1728,_1729) :- fstck(n_verb_2FH_ga_de,_1728),msw(n_verb_2FH_ga_de,[n_vstem5_2FH_ga_de,n_infl]),pdcg(n_vstem5_2FH_ga_de,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_de,_1728,_1729) :- fstck(n_verb_2FH_ga_de,_1728),msw(n_verb_2FH_ga_de,[n_vstem1_2FH_ga_de,n_infl]),pdcg(n_vstem1_2FH_ga_de,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_de,_1728,_1729) :- fstck(n_verb_2FH_ga_de,_1728),msw(n_verb_2FH_ga_de,[t_adjstem_2FH_ga_de,n_infl]),_1728=[t_adjstem_2FH_ga_de|_1740],pdcg(n_infl,_1740,_1729).
pdcg(n_verb_2FH_ga_de,_1728,_1729) :- fstck(n_verb_2FH_ga_de,_1728),msw(n_verb_2FH_ga_de,[t_adjstem_spe_2FH_ga_de,n_infl]),_1728=[t_adjstem_spe_2FH_ga_de|_1740],pdcg(n_infl,_1740,_1729).
pdcg(n_verb_2FH_ga_de,_1726,_1727) :- fstck(n_verb_2FH_ga_de,_1726),msw(n_verb_2FH_ga_de,[t_adj_renyo_2FH_ga_de]),_1726=[t_adj_renyo_2FH_ga_de|_1727].
pdcg(n_verb_2FH_ga_de,_1728,_1729) :- fstck(n_verb_2FH_ga_de,_1728),msw(n_verb_2FH_ga_de,[n_mod_v,n_verb_2FH_ga_de]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_de,_1733,_1729).
pdcg(n_verb_2FH_ga_de,_1728,_1729) :- fstck(n_verb_2FH_ga_de,_1728),msw(n_verb_2FH_ga_de,[n_mod_v,n_n_adj_2FH_ga_de]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_adj_2FH_ga_de,_1733,_1729).
pdcg(n_v_kahen_2FH_,_1728,_1729) :- fstck(n_v_kahen_2FH_,_1728),msw(n_v_kahen_2FH_,[n_pp_ga,n_v_kahen_2FH_ga]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_v_kahen_2FH_ga,_1733,_1729).
pdcg(n_v_kahen_2FH_,_1728,_1729) :- fstck(n_v_kahen_2FH_,_1728),msw(n_v_kahen_2FH_,[n_mod_v,n_v_kahen_2FH_]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_kahen_2FH_,_1733,_1729).
pdcg(n_verb_2FH_ga_quote,_1728,_1729) :- fstck(n_verb_2FH_ga_quote,_1728),msw(n_verb_2FH_ga_quote,[n_vstem5_2FH_ga_quote,n_infl]),pdcg(n_vstem5_2FH_ga_quote,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_quote,_1728,_1729) :- fstck(n_verb_2FH_ga_quote,_1728),msw(n_verb_2FH_ga_quote,[n_vstem1_2FH_ga_quote,n_infl]),pdcg(n_vstem1_2FH_ga_quote,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_quote,_1726,_1727) :- fstck(n_verb_2FH_ga_quote,_1726),msw(n_verb_2FH_ga_quote,[n_vstem1_2FH_ga_quote]),pdcg(n_vstem1_2FH_ga_quote,_1726,_1727).
pdcg(n_verb_2FH_ga_quote,_1728,_1729) :- fstck(n_verb_2FH_ga_quote,_1728),msw(n_verb_2FH_ga_quote,[n_mod_v,n_verb_2FH_ga_quote]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_quote,_1733,_1729).
pdcg(n_verb_2FH_ga_quote,_1728,_1729) :- fstck(n_verb_2FH_ga_quote,_1728),msw(n_verb_2FH_ga_quote,[n_mod_v,n_n_sahen_2FH_ga_quote]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga_quote,_1733,_1729).
pdcg(n_verb_2FH_,_1728,_1729) :- fstck(n_verb_2FH_,_1728),msw(n_verb_2FH_,[n_pp_ga,n_verb_2FH_ga]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_verb_2FH_ga,_1733,_1729).
pdcg(n_verb_2FH_,_1728,_1729) :- fstck(n_verb_2FH_,_1728),msw(n_verb_2FH_,[n_pp_ni,n_verb_2FH_ni]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_verb_2FH_ni,_1733,_1729).
pdcg(n_verb_2FH_,_1728,_1729) :- fstck(n_verb_2FH_,_1728),msw(n_verb_2FH_,[n_mod_v,n_verb_2FH_]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_,_1733,_1729).
pdcg(n_verb_2FH_,_1728,_1729) :- fstck(n_verb_2FH_,_1728),msw(n_verb_2FH_,[n_pp_ga,n_n_sahen_2FH_ga]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_n_sahen_2FH_ga,_1733,_1729).
pdcg(n_verb_2FH_,_1728,_1729) :- fstck(n_verb_2FH_,_1728),msw(n_verb_2FH_,[n_pp_ga,n_n_adj_2FH_ga]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_n_adj_2FH_ga,_1733,_1729).
pdcg(n_n_hour,_1726,_1727) :- fstck(n_n_hour,_1726),msw(n_n_hour,[t_meisi_zi]),_1726=[t_meisi_zi|_1727].
pdcg(n_x_haku_y_ka,_1728,_1729) :- fstck(n_x_haku_y_ka,_1728),msw(n_x_haku_y_ka,[n_x_haku,n_y_ka]),pdcg(n_x_haku,_1728,_1733),pdcg(n_y_ka,_1733,_1729).
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ka]),_1726=[t_infl_5_ka|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ko]),_1726=[t_infl_5_ko|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ki]),_1726=[t_infl_5_ki|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ku]),_1726=[t_infl_5_ku|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ke]),_1726=[t_infl_5_ke|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ga]),_1726=[t_infl_5_ga|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_go]),_1726=[t_infl_5_go|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_gi]),_1726=[t_infl_5_gi|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_gu]),_1726=[t_infl_5_gu|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ge]),_1726=[t_infl_5_ge|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_sa]),_1726=[t_infl_5_sa|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_so]),_1726=[t_infl_5_so|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_shi]),_1726=[t_infl_5_shi|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_su]),_1726=[t_infl_5_su|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_se]),_1726=[t_infl_5_se|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ta]),_1726=[t_infl_5_ta|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_to]),_1726=[t_infl_5_to|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ti]),_1726=[t_infl_5_ti|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_tu]),_1726=[t_infl_5_tu|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_te]),_1726=[t_infl_5_te|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_na]),_1726=[t_infl_5_na|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_no]),_1726=[t_infl_5_no|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ni]),_1726=[t_infl_5_ni|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_nu]),_1726=[t_infl_5_nu|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ne]),_1726=[t_infl_5_ne|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ba]),_1726=[t_infl_5_ba|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_bo]),_1726=[t_infl_5_bo|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_bi]),_1726=[t_infl_5_bi|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_bu]),_1726=[t_infl_5_bu|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_be]),_1726=[t_infl_5_be|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ma]),_1726=[t_infl_5_ma|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_mo]),_1726=[t_infl_5_mo|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_mi]),_1726=[t_infl_5_mi|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_mu]),_1726=[t_infl_5_mu|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_me]),_1726=[t_infl_5_me|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ra]),_1726=[t_infl_5_ra|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ro]),_1726=[t_infl_5_ro|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ri]),_1726=[t_infl_5_ri|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_ru]),_1726=[t_infl_5_ru|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_re]),_1726=[t_infl_5_re|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_wa]),_1726=[t_infl_5_wa|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_wo]),_1726=[t_infl_5_wo|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_wi]),_1726=[t_infl_5_wi|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_wu]),_1726=[t_infl_5_wu|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_we]),_1726=[t_infl_5_we|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_i]),_1726=[t_infl_5_i|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_q]),_1726=[t_infl_5_q|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_5_n]),_1726=[t_infl_5_n|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_1_yo]),_1726=[t_infl_1_yo|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_1_ru]),_1726=[t_infl_1_ru|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_1_re]),_1726=[t_infl_1_re|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_1_ro]),_1726=[t_infl_1_ro|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_sahen_shi]),_1726=[t_infl_sahen_shi|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_sahen_suru]),_1726=[t_infl_sahen_suru|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_sahen_sure]),_1726=[t_infl_sahen_sure|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_se]),_1726=[t_infl_spe_se|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_sho]),_1726=[t_infl_spe_sho|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_shi]),_1726=[t_infl_spe_shi|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_su]),_1726=[t_infl_spe_su|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_adj_ku]),_1726=[t_infl_adj_ku|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_adj_karo]),_1726=[t_infl_adj_karo|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_adj_kya]),_1726=[t_infl_adj_kya|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_adj_kaq]),_1726=[t_infl_adj_kaq|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_adj_i]),_1726=[t_infl_adj_i|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_adj_kere]),_1726=[t_infl_adj_kere|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_adj_u]),_1726=[t_infl_adj_u|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_caus_ru]),_1726=[t_infl_caus_ru|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_caus_re]),_1726=[t_infl_caus_re|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_deac_ru]),_1726=[t_infl_deac_ru|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_deac_re]),_1726=[t_infl_deac_re|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_ru]),_1726=[t_infl_spe_ru|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_re]),_1726=[t_infl_spe_re|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_i]),_1726=[t_infl_spe_i|_1727].
pdcg(n_infl,_1726,_1727) :- fstck(n_infl,_1726),msw(n_infl,[t_infl_spe_q]),_1726=[t_infl_spe_q|_1727].
pdcg(n_v_sahen_2FH_o,_1728,_1729) :- fstck(n_v_sahen_2FH_o,_1728),msw(n_v_sahen_2FH_o,[n_pp_ga,n_v_sahen_2FH_ga_o]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_v_sahen_2FH_ga_o,_1733,_1729).
pdcg(n_v_sahen_2FH_o,_1728,_1729) :- fstck(n_v_sahen_2FH_o,_1728),msw(n_v_sahen_2FH_o,[n_mod_v,n_v_sahen_2FH_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_sahen_2FH_o,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e_o,_1728),msw(n_verb_2FH_ga_ni_5EH_e_o,[n_vstem5_2FH_ga_ni_5EH_e_o,n_infl]),pdcg(n_vstem5_2FH_ga_ni_5EH_e_o,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e_o,_1728),msw(n_verb_2FH_ga_ni_5EH_e_o,[n_vstem1_2FH_ga_ni_5EH_e_o,n_infl]),pdcg(n_vstem1_2FH_ga_ni_5EH_e_o,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e_o,_1728),msw(n_verb_2FH_ga_ni_5EH_e_o,[n_mod_v,n_verb_2FH_ga_ni_5EH_e_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1733,_1729).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga]),pdcg(n_n_sahen_2FH_ga,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_o]),pdcg(n_n_sahen_2FH_ga_o,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_ni]),pdcg(n_n_sahen_2FH_ga_ni,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_de]),pdcg(n_n_sahen_2FH_ga_de,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_to]),pdcg(n_n_sahen_2FH_ga_to,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_ni_o]),pdcg(n_n_sahen_2FH_ga_ni_o,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_ni_5EH_e]),pdcg(n_n_sahen_2FH_ga_ni_5EH_e,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_ni_5EH_e_o]),pdcg(n_n_sahen_2FH_ga_ni_5EH_e_o,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_ni_5EH_to]),pdcg(n_n_sahen_2FH_ga_ni_5EH_to,_1726,_1727).
pdcg(n_n_sahen,_1726,_1727) :- fstck(n_n_sahen,_1726),msw(n_n_sahen,[n_n_sahen_2FH_ga_quote]),pdcg(n_n_sahen_2FH_ga_quote,_1726,_1727).
pdcg(n_n_sahen,_1728,_1729) :- fstck(n_n_sahen,_1728),msw(n_n_sahen,[n_mod_n,n_n_sahen]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_sahen,_1733,_1729).
pdcg(n_n_sahen,_1728,_1729) :- fstck(n_n_sahen,_1728),msw(n_n_sahen,[n_prefix,n_n_sahen]),pdcg(n_prefix,_1728,_1733),pdcg(n_n_sahen,_1733,_1729).
pdcg(n_n_sahen,_1728,_1729) :- fstck(n_n_sahen,_1728),msw(n_n_sahen,[n_n_date_and_time,n_n_sahen]),pdcg(n_n_date_and_time,_1728,_1733),pdcg(n_n_sahen,_1733,_1729).
pdcg(n_p_conj_advcl,_1726,_1727) :- fstck(n_p_conj_advcl,_1726),msw(n_p_conj_advcl,[t_p_conj_renyo]),_1726=[t_p_conj_renyo|_1727].
pdcg(n_p_conj_advcl,_1726,_1727) :- fstck(n_p_conj_advcl,_1726),msw(n_p_conj_advcl,[t_p_conj_syusi]),_1726=[t_p_conj_syusi|_1727].
pdcg(n_p_conj_advcl,_1726,_1727) :- fstck(n_p_conj_advcl,_1726),msw(n_p_conj_advcl,[t_p_conj_rentai]),_1726=[t_p_conj_rentai|_1727].
pdcg(n_p_conj_advcl,_1726,_1727) :- fstck(n_p_conj_advcl,_1726),msw(n_p_conj_advcl,[t_p_conj_katei]),_1726=[t_p_conj_katei|_1727].
pdcg(n_p_conj_advcl,_1726,_1727) :- fstck(n_p_conj_advcl,_1726),msw(n_p_conj_advcl,[t_p_conj_renyo_te]),_1726=[t_p_conj_renyo_te|_1727].
pdcg(n_interj,_1728,_1729) :- fstck(n_interj,_1728),msw(n_interj,[n_adv,n_interj]),pdcg(n_adv,_1728,_1733),pdcg(n_interj,_1733,_1729).
pdcg(n_interj,_1728,_1729) :- fstck(n_interj,_1728),msw(n_interj,[n_adv_cl,n_interj]),pdcg(n_adv_cl,_1728,_1733),pdcg(n_interj,_1733,_1729).
pdcg(n_interj,_1726,_1727) :- fstck(n_interj,_1726),msw(n_interj,[t_interj_pre]),_1726=[t_interj_pre|_1727].
pdcg(n_interj,_1726,_1727) :- fstck(n_interj,_1726),msw(n_interj,[t_interj_post]),_1726=[t_interj_post|_1727].
pdcg(n_n_adv,_1726,_1727) :- fstck(n_n_adv,_1726),msw(n_n_adv,[t_huku_meisi]),_1726=[t_huku_meisi|_1727].
pdcg(n_mod_v,_1726,_1727) :- fstck(n_mod_v,_1726),msw(n_mod_v,[n_pp]),pdcg(n_pp,_1726,_1727).
pdcg(n_mod_v,_1726,_1727) :- fstck(n_mod_v,_1726),msw(n_mod_v,[n_advp]),pdcg(n_advp,_1726,_1727).
pdcg(n_mod_v,_1726,_1727) :- fstck(n_mod_v,_1726),msw(n_mod_v,[n_n_time]),pdcg(n_n_time,_1726,_1727).
pdcg(n_mod_v,_1726,_1727) :- fstck(n_mod_v,_1726),msw(n_mod_v,[n_n_quant]),pdcg(n_n_quant,_1726,_1727).
pdcg(n_mod_v,_1728,_1729) :- fstck(n_mod_v,_1728),msw(n_mod_v,[n_n_adj,n_aux]),pdcg(n_n_adj,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_period_to,_1728,_1729) :- fstck(n_period_to,_1728),msw(n_period_to,[n_period_begin,n_p_para]),pdcg(n_period_begin,_1728,_1733),pdcg(n_p_para,_1733,_1729).
pdcg(n_p_kakari,_1726,_1727) :- fstck(n_p_kakari,_1726),msw(n_p_kakari,[t_p_kakari_wa]),_1726=[t_p_kakari_wa|_1727].
pdcg(n_p_kakari,_1726,_1727) :- fstck(n_p_kakari,_1726),msw(n_p_kakari,[t_p_kakari_mo]),_1726=[t_p_kakari_mo|_1727].
pdcg(n_p_kakari,_1726,_1727) :- fstck(n_p_kakari,_1726),msw(n_p_kakari,[t_p_kakari_te]),_1726=[t_p_kakari_te|_1727].
pdcg(n_p_kakari,_1726,_1727) :- fstck(n_p_kakari,_1726),msw(n_p_kakari,[t_p_kakari_qte]),_1726=[t_p_kakari_qte|_1727].
pdcg(n_n_sahen_2FH_ga,_1728,_1729) :- fstck(n_n_sahen_2FH_ga,_1728),msw(n_n_sahen_2FH_ga,[n_prefix,n_verb_2FH_ga]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga,_1733,_1729).
pdcg(n_n_sahen_2FH_ga,_1728,_1729) :- fstck(n_n_sahen_2FH_ga,_1728),msw(n_n_sahen_2FH_ga,[n_prefix,t_sahen_meisi_2FH_ga]),pdcg(n_prefix,_1728,_1733),_1733=[t_sahen_meisi_2FH_ga|_1729].
pdcg(n_n_sahen_2FH_ga,_1726,_1727) :- fstck(n_n_sahen_2FH_ga,_1726),msw(n_n_sahen_2FH_ga,[t_sahen_meisi_2FH_ga]),_1726=[t_sahen_meisi_2FH_ga|_1727].
pdcg(n_n_sahen_2FH_ga,_1726,_1727) :- fstck(n_n_sahen_2FH_ga,_1726),msw(n_n_sahen_2FH_ga,[t_sahen_meisi_pol_2FH_ga]),_1726=[t_sahen_meisi_pol_2FH_ga|_1727].
pdcg(n_v_kahen_2FH_ga_ni,_1728,_1729) :- fstck(n_v_kahen_2FH_ga_ni,_1728),msw(n_v_kahen_2FH_ga_ni,[n_mod_v,n_v_kahen_2FH_ga_ni]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_kahen_2FH_ga_ni,_1733,_1729).
pdcg(n_v_kahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_kahen_2FH_ga_ni,_1726),msw(n_v_kahen_2FH_ga_ni,[t_kahen_dousi_mizen_2FH_ga_ni]),_1726=[t_kahen_dousi_mizen_2FH_ga_ni|_1727].
pdcg(n_v_kahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_kahen_2FH_ga_ni,_1726),msw(n_v_kahen_2FH_ga_ni,[t_kahen_dousi_renyo_2FH_ga_ni]),_1726=[t_kahen_dousi_renyo_2FH_ga_ni|_1727].
pdcg(n_v_kahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_kahen_2FH_ga_ni,_1726),msw(n_v_kahen_2FH_ga_ni,[t_kahen_dousi_syusi_2FH_ga_ni]),_1726=[t_kahen_dousi_syusi_2FH_ga_ni|_1727].
pdcg(n_v_kahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_kahen_2FH_ga_ni,_1726),msw(n_v_kahen_2FH_ga_ni,[t_kahen_dousi_rentai_2FH_ga_ni]),_1726=[t_kahen_dousi_rentai_2FH_ga_ni|_1727].
pdcg(n_v_kahen_2FH_ga_ni,_1726,_1727) :- fstck(n_v_kahen_2FH_ga_ni,_1726),msw(n_v_kahen_2FH_ga_ni,[t_kahen_dousi_katei_2FH_ga_ni]),_1726=[t_kahen_dousi_katei_2FH_ga_ni|_1727].
pdcg(n_verb,_1728,_1729) :- fstck(n_verb,_1728),msw(n_verb,[n_verb,n_p_kakari]),pdcg(n_verb,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_]),pdcg(n_verb_2FH_,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga]),pdcg(n_verb_2FH_ga,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_o]),pdcg(n_verb_2FH_o,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ni]),pdcg(n_verb_2FH_ni,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_de]),pdcg(n_verb_2FH_de,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_to]),pdcg(n_verb_2FH_to,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_o]),pdcg(n_verb_2FH_ga_o,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_ni]),pdcg(n_verb_2FH_ga_ni,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_ni_o]),pdcg(n_verb_2FH_ga_ni_o,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_de]),pdcg(n_verb_2FH_ga_de,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_to]),pdcg(n_verb_2FH_ga_to,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_ni_5EH_to]),pdcg(n_verb_2FH_ga_ni_5EH_to,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_ni_5EH_e]),pdcg(n_verb_2FH_ga_ni_5EH_e,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_ni_5EH_e_o]),pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_verb_2FH_ga_quote]),pdcg(n_verb_2FH_ga_quote,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_sahen_2FH_]),pdcg(n_v_sahen_2FH_,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_sahen_2FH_ga]),pdcg(n_v_sahen_2FH_ga,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_sahen_2FH_o]),pdcg(n_v_sahen_2FH_o,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_sahen_2FH_ga_o]),pdcg(n_v_sahen_2FH_ga_o,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_sahen_2FH_ga_ni]),pdcg(n_v_sahen_2FH_ga_ni,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_kahen_2FH_]),pdcg(n_v_kahen_2FH_,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_kahen_2FH_ga]),pdcg(n_v_kahen_2FH_ga,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_kahen_2FH_ni]),pdcg(n_v_kahen_2FH_ni,_1726,_1727).
pdcg(n_verb,_1726,_1727) :- fstck(n_verb,_1726),msw(n_verb,[n_v_kahen_2FH_ga_ni]),pdcg(n_v_kahen_2FH_ga_ni,_1726,_1727).
pdcg(n_vstem5_2FH_ga_quote,_1726,_1727) :- fstck(n_vstem5_2FH_ga_quote,_1726),msw(n_vstem5_2FH_ga_quote,[t_vstem_5_s_2FH_ga_quote]),_1726=[t_vstem_5_s_2FH_ga_quote|_1727].
pdcg(n_vstem5_2FH_ga_quote,_1726,_1727) :- fstck(n_vstem5_2FH_ga_quote,_1726),msw(n_vstem5_2FH_ga_quote,[t_vstem_5_r_i_2FH_ga_quote]),_1726=[t_vstem_5_r_i_2FH_ga_quote|_1727].
pdcg(n_vstem5_2FH_ga_quote,_1726,_1727) :- fstck(n_vstem5_2FH_ga_quote,_1726),msw(n_vstem5_2FH_ga_quote,[t_vstem_5_w_2FH_ga_quote]),_1726=[t_vstem_5_w_2FH_ga_quote|_1727].
pdcg(n_v_sahen_2FH_,_1728,_1729) :- fstck(n_v_sahen_2FH_,_1728),msw(n_v_sahen_2FH_,[n_pp_ga,n_v_sahen_2FH_ga]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_v_sahen_2FH_ga,_1733,_1729).
pdcg(n_v_sahen_2FH_,_1728,_1729) :- fstck(n_v_sahen_2FH_,_1728),msw(n_v_sahen_2FH_,[n_mod_v,n_v_sahen_2FH_]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_sahen_2FH_,_1733,_1729).
pdcg(n_auxstem_caus,_1726,_1727) :- fstck(n_auxstem_caus,_1726),msw(n_auxstem_caus,[t_auxstem_caus_seru]),_1726=[t_auxstem_caus_seru|_1727].
pdcg(n_auxstem_caus,_1726,_1727) :- fstck(n_auxstem_caus,_1726),msw(n_auxstem_caus,[t_auxstem_caus_saseru]),_1726=[t_auxstem_caus_saseru|_1727].
pdcg(n_verb_2FH_ga_ni_5EH_to,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_to,_1728),msw(n_verb_2FH_ga_ni_5EH_to,[n_vstem5_2FH_ga_ni_5EH_to,n_infl]),pdcg(n_vstem5_2FH_ga_ni_5EH_to,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_to,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_to,_1728),msw(n_verb_2FH_ga_ni_5EH_to,[n_vstem1_2FH_ga_ni_5EH_to,n_infl]),pdcg(n_vstem1_2FH_ga_ni_5EH_to,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_to,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_to,_1728),msw(n_verb_2FH_ga_ni_5EH_to,[n_mod_v,n_verb_2FH_ga_ni_5EH_to]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_to,_1733,_1729).
pdcg(n_n_num_ten,_1728,_1729) :- fstck(n_n_num_ten,_1728),msw(n_n_num_ten,[n_n_num,t_suffix_ten]),pdcg(n_n_num,_1728,_1733),_1733=[t_suffix_ten|_1729].
pdcg(n_n_adj_2FH_ga,_1726,_1727) :- fstck(n_n_adj_2FH_ga,_1726),msw(n_n_adj_2FH_ga,[t_kdo_2FH_ga]),_1726=[t_kdo_2FH_ga|_1727].
pdcg(n_mod_time,_1728,_1729) :- fstck(n_mod_time,_1728),msw(n_mod_time,[n_n_day,n_p_rentai]),pdcg(n_n_day,_1728,_1733),pdcg(n_p_rentai,_1733,_1729).
pdcg(n_vstem5_2FH_ga_ni_5EH_e_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_5EH_e_o,_1726),msw(n_vstem5_2FH_ga_ni_5EH_e_o,[t_vstem_5_r_2FH_ga_ni_5EH_e_o]),_1726=[t_vstem_5_r_2FH_ga_ni_5EH_e_o|_1727].
pdcg(n_n_adj_2FH_ga_to,_1726,_1727) :- fstck(n_n_adj_2FH_ga_to,_1726),msw(n_n_adj_2FH_ga_to,[t_kdo_2FH_ga_to]),_1726=[t_kdo_2FH_ga_to|_1727].
pdcg(n_mod_week,_1728,_1729) :- fstck(n_mod_week,_1728),msw(n_mod_week,[n_month_day,n_p_rentai]),pdcg(n_month_day,_1728,_1733),pdcg(n_p_rentai,_1733,_1729).
pdcg(n_addr,_1726,_1727) :- fstck(n_addr,_1726),msw(n_addr,[n_n_name_jap_honor]),_1726=[n_n_name_jap_honor|_1727].
pdcg(n_addr,_1726,_1727) :- fstck(n_addr,_1726),msw(n_addr,[n_n_name_others_honor]),_1726=[n_n_name_others_honor|_1727].
pdcg(n_addr,_1728,_1729) :- fstck(n_addr,_1728),msw(n_addr,[n_n_hutu,t_suffix_name]),pdcg(n_n_hutu,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_addr,_1728,_1729) :- fstck(n_addr,_1728),msw(n_addr,[n_name,t_suffix_name]),pdcg(n_name,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_n_name,_1726,_1727) :- fstck(n_n_name,_1726),msw(n_n_name,[t_myoji_first]),_1726=[t_myoji_first|_1727].
pdcg(n_n_name,_1726,_1727) :- fstck(n_n_name,_1726),msw(n_n_name,[t_namae_last]),_1726=[t_namae_last|_1727].
pdcg(n_n_name,_1726,_1727) :- fstck(n_n_name,_1726),msw(n_n_name,[t_myoji_last]),_1726=[t_myoji_last|_1727].
pdcg(n_n_name,_1726,_1727) :- fstck(n_n_name,_1726),msw(n_n_name,[t_namae_first]),_1726=[t_namae_first|_1727].
pdcg(n_vstem5_2FH_ga_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_to,_1726),msw(n_vstem5_2FH_ga_to,[t_vstem_5_k_2FH_ga_to]),_1726=[t_vstem_5_k_2FH_ga_to|_1727].
pdcg(n_vstem5_2FH_ga_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_to,_1726),msw(n_vstem5_2FH_ga_to,[t_vstem_5_s_2FH_ga_to]),_1726=[t_vstem_5_s_2FH_ga_to|_1727].
pdcg(n_vstem5_2FH_ga_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_to,_1726),msw(n_vstem5_2FH_ga_to,[t_vstem_5_t_2FH_ga_to]),_1726=[t_vstem_5_t_2FH_ga_to|_1727].
pdcg(n_vstem5_2FH_ga_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_to,_1726),msw(n_vstem5_2FH_ga_to,[t_vstem_5_b_2FH_ga_to]),_1726=[t_vstem_5_b_2FH_ga_to|_1727].
pdcg(n_vstem5_2FH_ga_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_to,_1726),msw(n_vstem5_2FH_ga_to,[t_vstem_5_m_2FH_ga_to]),_1726=[t_vstem_5_m_2FH_ga_to|_1727].
pdcg(n_vstem5_2FH_ga_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_to,_1726),msw(n_vstem5_2FH_ga_to,[t_vstem_5_r_2FH_ga_to]),_1726=[t_vstem_5_r_2FH_ga_to|_1727].
pdcg(n_vstem5_2FH_ga_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_to,_1726),msw(n_vstem5_2FH_ga_to,[t_vstem_5_w_2FH_ga_to]),_1726=[t_vstem_5_w_2FH_ga_to|_1727].
pdcg(n_sent,_1726,_1727) :- fstck(n_sent,_1726),msw(n_sent,[n_cl]),pdcg(n_cl,_1726,_1727).
pdcg(n_sent,_1726,_1727) :- fstck(n_sent,_1726),msw(n_sent,[n_cl_ex]),pdcg(n_cl_ex,_1726,_1727).
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_mod_n,n_n_quant]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_quant,_1733,_1729).
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_n_num,n_suffix_unit]),pdcg(n_n_num,_1728,_1733),pdcg(n_suffix_unit,_1733,_1729).
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_wh_pro,n_suffix_unit]),pdcg(n_wh_pro,_1728,_1733),pdcg(n_suffix_unit,_1733,_1729).
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_n_num,t_hutu_meisi]),pdcg(n_n_num,_1728,_1733),_1733=[t_hutu_meisi|_1729].
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_adv_degr,n_n_quant]),pdcg(n_adv_degr,_1728,_1733),pdcg(n_n_quant,_1733,_1729).
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_prefix,n_n_quant]),pdcg(n_prefix,_1728,_1733),pdcg(n_n_quant,_1733,_1729).
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_n_quant,t_suffix_quant_quant]),pdcg(n_n_quant,_1728,_1733),_1733=[t_suffix_quant_quant|_1729].
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_wh_pro,t_suffix_quant_quant]),pdcg(n_wh_pro,_1728,_1733),_1733=[t_suffix_quant_quant|_1729].
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_n_hutu,t_suffix_quant_quant]),pdcg(n_n_hutu,_1728,_1733),_1733=[t_suffix_quant_quant|_1729].
pdcg(n_n_quant,_1728,_1729) :- fstck(n_n_quant,_1728),msw(n_n_quant,[n_n_hutu,n_n_quant]),pdcg(n_n_hutu,_1728,_1733),pdcg(n_n_quant,_1733,_1729).
pdcg(n_n_quant,_1726,_1727) :- fstck(n_n_quant,_1726),msw(n_n_quant,[t_suuryousi]),_1726=[t_suuryousi|_1727].
pdcg(n_n_sahen_2FH_ga_ni,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni,_1728),msw(n_n_sahen_2FH_ga_ni,[n_prefix,n_verb_2FH_ga_ni]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_ni,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_ni,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni,_1728),msw(n_n_sahen_2FH_ga_ni,[n_prefix,t_sahen_meisi_2FH_ga_ni]),pdcg(n_prefix,_1728,_1733),_1733=[t_sahen_meisi_2FH_ga_ni|_1729].
pdcg(n_n_sahen_2FH_ga_ni,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni,_1728),msw(n_n_sahen_2FH_ga_ni,[n_mod_v,n_n_sahen_2FH_ga_ni]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_ni,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_ni,_1726),msw(n_n_sahen_2FH_ga_ni,[t_sahen_meisi_2FH_ga_ni]),_1726=[t_sahen_meisi_2FH_ga_ni|_1727].
pdcg(n_n_sahen_2FH_ga_ni,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_ni,_1726),msw(n_n_sahen_2FH_ga_ni,[t_sahen_meisi_pol_2FH_ga_ni]),_1726=[t_sahen_meisi_pol_2FH_ga_ni|_1727].
pdcg(n_mod_day,_1728,_1729) :- fstck(n_mod_day,_1728),msw(n_mod_day,[n_n_month,n_p_rentai]),pdcg(n_n_month,_1728,_1733),pdcg(n_p_rentai,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_o,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_o,_1728),msw(n_verb_2FH_ga_ni_o,[n_vstem5_2FH_ga_ni_o,n_infl]),pdcg(n_vstem5_2FH_ga_ni_o,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_o,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_o,_1728),msw(n_verb_2FH_ga_ni_o,[n_vstem1_2FH_ga_ni_o,n_infl]),pdcg(n_vstem1_2FH_ga_ni_o,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_o,_1726,_1727) :- fstck(n_verb_2FH_ga_ni_o,_1726),msw(n_verb_2FH_ga_ni_o,[n_vstem1_2FH_ga_ni_o]),pdcg(n_vstem1_2FH_ga_ni_o,_1726,_1727).
pdcg(n_verb_2FH_ga_ni_o,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_o,_1728),msw(n_verb_2FH_ga_ni_o,[n_mod_v,n_verb_2FH_ga_ni_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_ni_o,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_o,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_o,_1728),msw(n_verb_2FH_ga_ni_o,[n_mod_v,n_n_sahen_2FH_ga_ni_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni_o,_1733,_1729).
pdcg(n_pp_to,_1728,_1729) :- fstck(n_pp_to,_1728),msw(n_pp_to,[n_np,t_p_kaku_to]),pdcg(n_np,_1728,_1733),_1733=[t_p_kaku_to|_1729].
pdcg(n_pp_to,_1728,_1729) :- fstck(n_pp_to,_1728),msw(n_pp_to,[n_pp_to,n_p_kakari]),pdcg(n_pp_to,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_pp_to,_1728,_1729) :- fstck(n_pp_to,_1728),msw(n_pp_to,[n_pp,t_p_kaku_to]),pdcg(n_pp,_1728,_1733),_1733=[t_p_kaku_to|_1729].
pdcg(n_num_suf_man,_1726,_1727) :- fstck(n_num_suf_man,_1726),msw(n_num_suf_man,[t_num_man]),_1726=[t_num_man|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_ka]),_1726=[t_p_fuku_ka|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_kurai]),_1726=[t_p_fuku_kurai|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_gurai]),_1726=[t_p_fuku_gurai|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_koso]),_1726=[t_p_fuku_koso|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_sae]),_1726=[t_p_fuku_sae|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_shika]),_1726=[t_p_fuku_shika|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_dake]),_1726=[t_p_fuku_dake|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_demo]),_1726=[t_p_fuku_demo|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_tou]),_1726=[t_p_fuku_tou|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_nado]),_1726=[t_p_fuku_nado|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_nanka]),_1726=[t_p_fuku_nanka|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_nomi]),_1726=[t_p_fuku_nomi|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_bakari]),_1726=[t_p_fuku_bakari|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_hodo]),_1726=[t_p_fuku_hodo|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_kadouka]),_1726=[t_p_fuku_kadouka|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_goto]),_1726=[t_p_fuku_goto|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_kato]),_1726=[t_p_fuku_kato|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_made]),_1726=[t_p_fuku_made|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_nante]),_1726=[t_p_fuku_nante|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_qteiyaa]),_1726=[t_p_fuku_qteiyaa|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_toka]),_1726=[t_p_fuku_toka|_1727].
pdcg(n_p_fuku,_1726,_1727) :- fstck(n_p_fuku,_1726),msw(n_p_fuku,[t_p_fuku_zutu]),_1726=[t_p_fuku_zutu|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_k_2FH_ga_o]),_1726=[t_vstem_5_k_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_g_2FH_ga_o]),_1726=[t_vstem_5_g_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_s_2FH_ga_o]),_1726=[t_vstem_5_s_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_t_2FH_ga_o]),_1726=[t_vstem_5_t_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_b_2FH_ga_o]),_1726=[t_vstem_5_b_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_m_2FH_ga_o]),_1726=[t_vstem_5_m_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_r_2FH_ga_o]),_1726=[t_vstem_5_r_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_r_i_2FH_ga_o]),_1726=[t_vstem_5_r_i_2FH_ga_o|_1727].
pdcg(n_vstem5_2FH_ga_o,_1726,_1727) :- fstck(n_vstem5_2FH_ga_o,_1726),msw(n_vstem5_2FH_ga_o,[t_vstem_5_w_2FH_ga_o]),_1726=[t_vstem_5_w_2FH_ga_o|_1727].
pdcg(n_verb_2FH_ni,_1728,_1729) :- fstck(n_verb_2FH_ni,_1728),msw(n_verb_2FH_ni,[n_pp_ga,n_verb_2FH_ga_ni]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_verb_2FH_ga_ni,_1733,_1729).
pdcg(n_verb_2FH_ni,_1728,_1729) :- fstck(n_verb_2FH_ni,_1728),msw(n_verb_2FH_ni,[n_mod_v,n_verb_2FH_ni]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ni,_1733,_1729).
pdcg(n_verb_2FH_ni,_1728,_1729) :- fstck(n_verb_2FH_ni,_1728),msw(n_verb_2FH_ni,[n_pp_ga,n_n_sahen_2FH_ga_ni]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni,_1733,_1729).
pdcg(n_verb_2FH_o,_1728,_1729) :- fstck(n_verb_2FH_o,_1728),msw(n_verb_2FH_o,[n_pp_ga,n_verb_2FH_ga_o]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_verb_2FH_ga_o,_1733,_1729).
pdcg(n_verb_2FH_o,_1728,_1729) :- fstck(n_verb_2FH_o,_1728),msw(n_verb_2FH_o,[n_mod_v,n_verb_2FH_o]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_o,_1733,_1729).
pdcg(n_verb_2FH_o,_1728,_1729) :- fstck(n_verb_2FH_o,_1728),msw(n_verb_2FH_o,[n_pp_ga,n_n_sahen_2FH_ga_o]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_n_sahen_2FH_ga_o,_1733,_1729).
pdcg(n_v_kahen_2FH_ni,_1728,_1729) :- fstck(n_v_kahen_2FH_ni,_1728),msw(n_v_kahen_2FH_ni,[n_pp_ga,n_v_kahen_2FH_ga_ni]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_v_kahen_2FH_ga_ni,_1733,_1729).
pdcg(n_pp_ga,_1728,_1729) :- fstck(n_pp_ga,_1728),msw(n_pp_ga,[n_np,t_p_kaku_ga]),pdcg(n_np,_1728,_1733),_1733=[t_p_kaku_ga|_1729].
pdcg(n_pp_ga,_1728,_1729) :- fstck(n_pp_ga,_1728),msw(n_pp_ga,[n_n_cl,t_p_kaku_ga]),pdcg(n_n_cl,_1728,_1733),_1733=[t_p_kaku_ga|_1729].
pdcg(n_n_sahen_2FH_ga_ni_5EH_e,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni_5EH_e,_1728),msw(n_n_sahen_2FH_ga_ni_5EH_e,[n_prefix,n_verb_2FH_ga_ni_5EH_e]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_ni_5EH_e,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni_5EH_e,_1728),msw(n_n_sahen_2FH_ga_ni_5EH_e,[n_prefix,t_sahen_meisi_2FH_ga_ni_5EH_e]),pdcg(n_prefix,_1728,_1733),_1733=[t_sahen_meisi_2FH_ga_ni_5EH_e|_1729].
pdcg(n_n_sahen_2FH_ga_ni_5EH_e,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_ni_5EH_e,_1726),msw(n_n_sahen_2FH_ga_ni_5EH_e,[t_sahen_meisi_2FH_ga_ni_5EH_e]),_1726=[t_sahen_meisi_2FH_ga_ni_5EH_e|_1727].
pdcg(n_n_adj_2FH_ga_de,_1726,_1727) :- fstck(n_n_adj_2FH_ga_de,_1726),msw(n_n_adj_2FH_ga_de,[t_kdo_2FH_ga_de]),_1726=[t_kdo_2FH_ga_de|_1727].
pdcg(n_y_ka,_1728,_1729) :- fstck(n_y_ka,_1728),msw(n_y_ka,[n_n_num,n_suffix_unit]),pdcg(n_n_num,_1728,_1733),pdcg(n_suffix_unit,_1733,_1729).
pdcg(n_vstem5_2FH_ga_de,_1726,_1727) :- fstck(n_vstem5_2FH_ga_de,_1726),msw(n_vstem5_2FH_ga_de,[t_vstem_5_w_2FH_ga_de]),_1726=[t_vstem_5_w_2FH_ga_de|_1727].
pdcg(n_n_time,_1728,_1729) :- fstck(n_n_time,_1728),msw(n_n_time,[n_mod_n,n_n_time]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_time,_1733,_1729).
pdcg(n_n_time,_1728,_1729) :- fstck(n_n_time,_1728),msw(n_n_time,[n_n_hutu,t_suffix_time_time]),pdcg(n_n_hutu,_1728,_1733),_1733=[t_suffix_time_time|_1729].
pdcg(n_n_time,_1728,_1729) :- fstck(n_n_time,_1728),msw(n_n_time,[n_wh_pro,t_suffix_time_time]),pdcg(n_wh_pro,_1728,_1733),_1733=[t_suffix_time_time|_1729].
pdcg(n_n_time,_1728,_1729) :- fstck(n_n_time,_1728),msw(n_n_time,[n_n_date_and_time,t_suffix_time_time]),pdcg(n_n_date_and_time,_1728,_1733),_1733=[t_suffix_time_time|_1729].
pdcg(n_n_time,_1726,_1727) :- fstck(n_n_time,_1726),msw(n_n_time,[t_zikan_meisi]),_1726=[t_zikan_meisi|_1727].
pdcg(n_n_time,_1726,_1727) :- fstck(n_n_time,_1726),msw(n_n_time,[t_zikan_meisi_ippai]),_1726=[t_zikan_meisi_ippai|_1727].
pdcg(n_pp_quote,_1728,_1729) :- fstck(n_pp_quote,_1728),msw(n_pp_quote,[n_verb,n_p_quote]),pdcg(n_verb,_1728,_1733),pdcg(n_p_quote,_1733,_1729).
pdcg(n_pp_quote,_1728,_1729) :- fstck(n_pp_quote,_1728),msw(n_pp_quote,[n_vaux,n_p_quote]),pdcg(n_vaux,_1728,_1733),pdcg(n_p_quote,_1733,_1729).
pdcg(n_pp_quote,_1728,_1729) :- fstck(n_pp_quote,_1728),msw(n_pp_quote,[n_pp_quote,n_p_kakari]),pdcg(n_pp_quote,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_name,_1728,_1729) :- fstck(n_name,_1728),msw(n_name,[n_mod_n,n_name]),pdcg(n_mod_n,_1728,_1733),pdcg(n_name,_1733,_1729).
pdcg(n_name,_1726,_1727) :- fstck(n_name,_1726),msw(n_name,[n_n_name]),pdcg(n_n_name,_1726,_1727).
pdcg(n_name,_1728,_1729) :- fstck(n_name,_1728),msw(n_name,[n_n_name,n_n_name]),pdcg(n_n_name,_1728,_1733),pdcg(n_n_name,_1733,_1729).
pdcg(n_n_num_zyuu,_1726,_1727) :- fstck(n_n_num_zyuu,_1726),msw(n_n_num_zyuu,[n_n_num_keta_zyuu]),pdcg(n_n_num_keta_zyuu,_1726,_1727).
pdcg(n_n_num_zyuu,_1728,_1729) :- fstck(n_n_num_zyuu,_1728),msw(n_n_num_zyuu,[n_n_num_keta_zyuu,n_n_num_ichi]),pdcg(n_n_num_keta_zyuu,_1728,_1733),pdcg(n_n_num_ichi,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_quote,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_quote,_1728),msw(n_n_sahen_2FH_ga_quote,[n_prefix,n_verb_2FH_ga_quote]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_quote,_1733,_1729).
pdcg(n_pp,_1728,_1729) :- fstck(n_pp,_1728),msw(n_pp,[n_advp,t_p_kaku_ni]),pdcg(n_advp,_1728,_1733),_1733=[t_p_kaku_ni|_1729].
pdcg(n_pp,_1728,_1729) :- fstck(n_pp,_1728),msw(n_pp,[n_np,n_p_kaku_optn]),pdcg(n_np,_1728,_1733),pdcg(n_p_kaku_optn,_1733,_1729).
pdcg(n_pp,_1726,_1727) :- fstck(n_pp,_1726),msw(n_pp,[n_pro_domo]),pdcg(n_pro_domo,_1726,_1727).
pdcg(n_pp,_1726,_1727) :- fstck(n_pp,_1726),msw(n_pp,[n_pro_exp]),pdcg(n_pro_exp,_1726,_1727).
pdcg(n_pp,_1728,_1729) :- fstck(n_pp,_1728),msw(n_pp,[n_np,n_p_kakari]),pdcg(n_np,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_pp,_1728,_1729) :- fstck(n_pp,_1728),msw(n_pp,[n_np,n_p_fuku]),pdcg(n_np,_1728,_1733),pdcg(n_p_fuku,_1733,_1729).
pdcg(n_pp,_1728,_1729) :- fstck(n_pp,_1728),msw(n_pp,[n_n_cl,n_p_kaku_optn]),pdcg(n_n_cl,_1728,_1733),pdcg(n_p_kaku_optn,_1733,_1729).
pdcg(n_pp,_1728,_1729) :- fstck(n_pp,_1728),msw(n_pp,[n_n_cl,n_p_kakari]),pdcg(n_n_cl,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_pp,_1728,_1729) :- fstck(n_pp,_1728),msw(n_pp,[n_pp,n_p_kakari]),pdcg(n_pp,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_pp_de,_1728,_1729) :- fstck(n_pp_de,_1728),msw(n_pp_de,[n_np,t_p_kaku_de]),pdcg(n_np,_1728,_1733),_1733=[t_p_kaku_de|_1729].
pdcg(n_pp_de,_1728,_1729) :- fstck(n_pp_de,_1728),msw(n_pp_de,[n_pp_de,n_p_kakari]),pdcg(n_pp_de,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e,_1728),msw(n_verb_2FH_ga_ni_5EH_e,[n_vstem5_2FH_ga_ni_5EH_e,n_infl]),pdcg(n_vstem5_2FH_ga_ni_5EH_e,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e,_1728),msw(n_verb_2FH_ga_ni_5EH_e,[n_vstem1_2FH_ga_ni_5EH_e,n_infl]),pdcg(n_vstem1_2FH_ga_ni_5EH_e,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e,_1728),msw(n_verb_2FH_ga_ni_5EH_e,[n_pp_o,n_verb_2FH_ga_ni_5EH_e_o]),pdcg(n_pp_o,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e_o,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e,_1728),msw(n_verb_2FH_ga_ni_5EH_e,[n_mod_v,n_verb_2FH_ga_ni_5EH_e]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e,_1733,_1729).
pdcg(n_verb_2FH_ga_ni_5EH_e,_1728,_1729) :- fstck(n_verb_2FH_ga_ni_5EH_e,_1728),msw(n_verb_2FH_ga_ni_5EH_e,[n_mod_v,n_n_sahen_2FH_ga_ni_5EH_e]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni_5EH_e,_1733,_1729).
pdcg(n_vstem1_2FH_ga_ni_o,_1726,_1727) :- fstck(n_vstem1_2FH_ga_ni_o,_1726),msw(n_vstem1_2FH_ga_ni_o,[t_vstem_1_2FH_ga_ni_o]),_1726=[t_vstem_1_2FH_ga_ni_o|_1727].
pdcg(n_n_num_syosu,_1728,_1729) :- fstck(n_n_num_syosu,_1728),msw(n_n_num_syosu,[n_n_num_ex,n_n_num_ex]),pdcg(n_n_num_ex,_1728,_1733),pdcg(n_n_num_ex,_1733,_1729).
pdcg(n_p_para,_1728,_1729) :- fstck(n_p_para,_1728),msw(n_p_para,[n_p_para,n_p_para]),pdcg(n_p_para,_1728,_1733),pdcg(n_p_para,_1733,_1729).
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_ka]),_1726=[t_p_para_ka|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_to]),_1726=[t_p_para_to|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_toka]),_1726=[t_p_para_toka|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_ni]),_1726=[t_p_para_ni|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_matawa]),_1726=[t_p_para_matawa|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_moshikuwa]),_1726=[t_p_para_moshikuwa|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_ya]),_1726=[t_p_para_ya|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_nari]),_1726=[t_p_para_nari|_1727].
pdcg(n_p_para,_1726,_1727) :- fstck(n_p_para,_1726),msw(n_p_para,[t_p_para_tari]),_1726=[t_p_para_tari|_1727].
pdcg(n_pro_domo,_1728,_1729) :- fstck(n_pro_domo,_1728),msw(n_pro_domo,[n_mod_n,n_pro_domo]),pdcg(n_mod_n,_1728,_1733),pdcg(n_pro_domo,_1733,_1729).
pdcg(n_pro_domo,_1726,_1727) :- fstck(n_pro_domo,_1726),msw(n_pro_domo,[t_daimeisi_domo]),_1726=[t_daimeisi_domo|_1727].
pdcg(n_n_num_keta_sen,_1726,_1727) :- fstck(n_n_num_keta_sen,_1726),msw(n_n_num_keta_sen,[n_num_suf_sen]),pdcg(n_num_suf_sen,_1726,_1727).
pdcg(n_n_num_keta_sen,_1728,_1729) :- fstck(n_n_num_keta_sen,_1728),msw(n_n_num_keta_sen,[n_n_num_ichi,n_num_suf_sen]),pdcg(n_n_num_ichi,_1728,_1733),pdcg(n_num_suf_sen,_1733,_1729).
pdcg(n_n_year,_1728,_1729) :- fstck(n_n_year,_1728),msw(n_n_year,[n_n_num,t_suffix_nen]),pdcg(n_n_num,_1728,_1733),_1733=[t_suffix_nen|_1729].
pdcg(n_num_ex_2,_1728,_1729) :- fstck(n_num_ex_2,_1728),msw(n_num_ex_2,[n_n_num_ex,n_n_num_ex]),pdcg(n_n_num_ex,_1728,_1733),pdcg(n_n_num_ex,_1733,_1729).
pdcg(n_x_haku,_1728,_1729) :- fstck(n_x_haku,_1728),msw(n_x_haku,[n_n_num,n_suffix_unit]),pdcg(n_n_num,_1728,_1733),pdcg(n_suffix_unit,_1733,_1729).
pdcg(n_vstem1_2FH_ga,_1726,_1727) :- fstck(n_vstem1_2FH_ga,_1726),msw(n_vstem1_2FH_ga,[t_vstem_1_2FH_ga]),_1726=[t_vstem_1_2FH_ga|_1727].
pdcg(n_advp,_1726,_1727) :- fstck(n_advp,_1726),msw(n_advp,[n_adv]),pdcg(n_adv,_1726,_1727).
pdcg(n_advp,_1726,_1727) :- fstck(n_advp,_1726),msw(n_advp,[n_wh_adv]),pdcg(n_wh_adv,_1726,_1727).
pdcg(n_advp,_1728,_1729) :- fstck(n_advp,_1728),msw(n_advp,[n_verb,n_p_kaku_optn]),pdcg(n_verb,_1728,_1733),pdcg(n_p_kaku_optn,_1733,_1729).
pdcg(n_advp,_1728,_1729) :- fstck(n_advp,_1728),msw(n_advp,[n_verb,n_p_fuku]),pdcg(n_verb,_1728,_1733),pdcg(n_p_fuku,_1733,_1729).
pdcg(n_advp,_1728,_1729) :- fstck(n_advp,_1728),msw(n_advp,[n_vaux,n_p_fuku]),pdcg(n_vaux,_1728,_1733),pdcg(n_p_fuku,_1733,_1729).
pdcg(n_advp,_1728,_1729) :- fstck(n_advp,_1728),msw(n_advp,[n_mod_n,n_n_adv]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_adv,_1733,_1729).
pdcg(n_advp,_1728,_1729) :- fstck(n_advp,_1728),msw(n_advp,[n_verb,n_p_conj_advp]),pdcg(n_verb,_1728,_1733),pdcg(n_p_conj_advp,_1733,_1729).
pdcg(n_advp,_1728,_1729) :- fstck(n_advp,_1728),msw(n_advp,[n_vaux,n_p_conj_advp]),pdcg(n_vaux,_1728,_1733),pdcg(n_p_conj_advp,_1733,_1729).
pdcg(n_num_ex_3,_1728,_1729) :- fstck(n_num_ex_3,_1728),msw(n_num_ex_3,[n_num_ex_rentai,n_num_ex_3]),pdcg(n_num_ex_rentai,_1728,_1733),pdcg(n_num_ex_3,_1733,_1729).
pdcg(n_num_ex_3,_1730,_1731) :- fstck(n_num_ex_3,_1730),msw(n_num_ex_3,[n_n_num_ex,n_n_num_ex,n_n_num_ex]),pdcg(n_n_num_ex,_1730,_1735),pdcg(n_n_num_ex,_1735,_1742),pdcg(n_n_num_ex,_1742,_1731).
pdcg(n_start,_1726,_1727) :- fstck(n_start,_1726),msw(n_start,[n_sent]),pdcg(n_sent,_1726,_1727).
pdcg(n_pro_exp,_1726,_1727) :- fstck(n_pro_exp,_1726),msw(n_pro_exp,[t_daimeisi_exp]),_1726=[t_daimeisi_exp|_1727].
pdcg(n_vstem_spe_2FH_ga,_1726,_1727) :- fstck(n_vstem_spe_2FH_ga,_1726),msw(n_vstem_spe_2FH_ga,[t_vstem_masu_2FH_ga]),_1726=[t_vstem_masu_2FH_ga|_1727].
pdcg(n_pp_e,_1728,_1729) :- fstck(n_pp_e,_1728),msw(n_pp_e,[n_np,t_p_kaku_e]),pdcg(n_np,_1728,_1733),_1733=[t_p_kaku_e|_1729].
pdcg(n_num_ex_4,_1728,_1729) :- fstck(n_num_ex_4,_1728),msw(n_num_ex_4,[n_num_ex_rentai,n_num_ex_4]),pdcg(n_num_ex_rentai,_1728,_1733),pdcg(n_num_ex_4,_1733,_1729).
pdcg(n_num_ex_4,_1732,_1733) :- fstck(n_num_ex_4,_1732),msw(n_num_ex_4,[n_n_num_ex,n_n_num_ex,n_n_num_ex,n_n_num_ex]),pdcg(n_n_num_ex,_1732,_1737),pdcg(n_n_num_ex,_1737,_1744),pdcg(n_n_num_ex,_1744,_1751),pdcg(n_n_num_ex,_1751,_1733).
pdcg(n_n_sahen_2FH_ga_to,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_to,_1728),msw(n_n_sahen_2FH_ga_to,[n_prefix,n_verb_2FH_ga_to]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_to,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_to,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_to,_1728),msw(n_n_sahen_2FH_ga_to,[n_prefix,t_sahen_meisi_2FH_ga_to]),pdcg(n_prefix,_1728,_1733),_1733=[t_sahen_meisi_2FH_ga_to|_1729].
pdcg(n_n_sahen_2FH_ga_to,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_to,_1726),msw(n_n_sahen_2FH_ga_to,[t_sahen_meisi_2FH_ga_to]),_1726=[t_sahen_meisi_2FH_ga_to|_1727].
pdcg(n_n_sahen_2FH_ga_to,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_to,_1726),msw(n_n_sahen_2FH_ga_to,[t_sahen_meisi_pol_2FH_ga_to]),_1726=[t_sahen_meisi_pol_2FH_ga_to|_1727].
pdcg(n_n_week,_1726,_1727) :- fstck(n_n_week,_1726),msw(n_n_week,[t_meisi_youbi]),_1726=[t_meisi_youbi|_1727].
pdcg(n_n_sahen_2FH_ga_o,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_o,_1728),msw(n_n_sahen_2FH_ga_o,[n_prefix,n_verb_2FH_ga_o]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_o,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_o,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_o,_1728),msw(n_n_sahen_2FH_ga_o,[n_prefix,t_sahen_meisi_2FH_ga_o]),pdcg(n_prefix,_1728,_1733),_1733=[t_sahen_meisi_2FH_ga_o|_1729].
pdcg(n_n_sahen_2FH_ga_o,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_o,_1726),msw(n_n_sahen_2FH_ga_o,[t_sahen_meisi_2FH_ga_o]),_1726=[t_sahen_meisi_2FH_ga_o|_1727].
pdcg(n_n_sahen_2FH_ga_o,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_o,_1726),msw(n_n_sahen_2FH_ga_o,[t_sahen_meisi_pol_2FH_ga_o]),_1726=[t_sahen_meisi_pol_2FH_ga_o|_1727].
pdcg(n_auxv,_1728,_1729) :- fstck(n_auxv,_1728),msw(n_auxv,[n_auxvstem,n_infl]),pdcg(n_auxvstem,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_to,_1728,_1729) :- fstck(n_verb_2FH_to,_1728),msw(n_verb_2FH_to,[n_pp_ga,n_n_sahen_2FH_ga_to]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_n_sahen_2FH_ga_to,_1733,_1729).
pdcg(n_wh_pro,_1728,_1729) :- fstck(n_wh_pro,_1728),msw(n_wh_pro,[n_mod_n,n_wh_pro]),pdcg(n_mod_n,_1728,_1733),pdcg(n_wh_pro,_1733,_1729).
pdcg(n_wh_pro,_1728,_1729) :- fstck(n_wh_pro,_1728),msw(n_wh_pro,[n_prefix,n_wh_pro]),pdcg(n_prefix,_1728,_1733),pdcg(n_wh_pro,_1733,_1729).
pdcg(n_wh_pro,_1726,_1727) :- fstck(n_wh_pro,_1726),msw(n_wh_pro,[t_wh_daimeisi]),_1726=[t_wh_daimeisi|_1727].
pdcg(n_wh_pro,_1726,_1727) :- fstck(n_wh_pro,_1726),msw(n_wh_pro,[t_wh_daimeisi_nan]),_1726=[t_wh_daimeisi_nan|_1727].
pdcg(n_pro,_1726,_1727) :- fstck(n_pro,_1726),msw(n_pro,[t_daimeisi]),_1726=[t_daimeisi|_1727].
pdcg(n_vstem1_2FH_ga_ni,_1726,_1727) :- fstck(n_vstem1_2FH_ga_ni,_1726),msw(n_vstem1_2FH_ga_ni,[t_vstem_1_2FH_ga_ni]),_1726=[t_vstem_1_2FH_ga_ni|_1727].
pdcg(n_vstem5_2FH_ga_ni_5EH_to,_1726,_1727) :- fstck(n_vstem5_2FH_ga_ni_5EH_to,_1726),msw(n_vstem5_2FH_ga_ni_5EH_to,[t_vstem_5_r_2FH_ga_ni_5EH_to]),_1726=[t_vstem_5_r_2FH_ga_ni_5EH_to|_1727].
pdcg(n_vaux,_1728,_1729) :- fstck(n_vaux,_1728),msw(n_vaux,[n_verb,n_aux]),pdcg(n_verb,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_vaux,_1728,_1729) :- fstck(n_vaux,_1728),msw(n_vaux,[n_verb,n_auxv]),pdcg(n_verb,_1728,_1733),pdcg(n_auxv,_1733,_1729).
pdcg(n_vaux,_1728,_1729) :- fstck(n_vaux,_1728),msw(n_vaux,[n_vaux,n_aux]),pdcg(n_vaux,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_vaux,_1728,_1729) :- fstck(n_vaux,_1728),msw(n_vaux,[n_vaux,n_p_kakari]),pdcg(n_vaux,_1728,_1733),pdcg(n_p_kakari,_1733,_1729).
pdcg(n_vaux,_1728,_1729) :- fstck(n_vaux,_1728),msw(n_vaux,[n_n_sahen,n_aux]),pdcg(n_n_sahen,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_vaux,_1728,_1729) :- fstck(n_vaux,_1728),msw(n_vaux,[n_n_adj,n_aux]),pdcg(n_n_adj,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_vaux,_1728,_1729) :- fstck(n_vaux,_1728),msw(n_vaux,[n_n_cl,n_aux]),pdcg(n_n_cl,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_kajo,_1726,_1727) :- fstck(n_kajo,_1726),msw(n_kajo,[n_stay]),pdcg(n_stay,_1726,_1727).
pdcg(n_prefix,_1726,_1727) :- fstck(n_prefix,_1726),msw(n_prefix,[t_prefix_o]),_1726=[t_prefix_o|_1727].
pdcg(n_prefix,_1726,_1727) :- fstck(n_prefix,_1726),msw(n_prefix,[t_prefix_go]),_1726=[t_prefix_go|_1727].
pdcg(n_prefix,_1726,_1727) :- fstck(n_prefix,_1726),msw(n_prefix,[t_prefix_hutu_hutu]),_1726=[t_prefix_hutu_hutu|_1727].
pdcg(n_prefix,_1726,_1727) :- fstck(n_prefix,_1726),msw(n_prefix,[t_prefix_quant_quant]),_1726=[t_prefix_quant_quant|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_5_k]),_1726=[t_auxstem_te_5_k|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_de_5_k]),_1726=[t_auxstem_de_5_k|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_5_r]),_1726=[t_auxstem_te_5_r|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_de_5_r]),_1726=[t_auxstem_de_5_r|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_5_s]),_1726=[t_auxstem_te_5_s|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_5_w]),_1726=[t_auxstem_te_5_w|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_de_5_w]),_1726=[t_auxstem_de_5_w|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_1]),_1726=[t_auxstem_te_1|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_de_1]),_1726=[t_auxstem_de_1|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_adj]),_1726=[t_auxstem_te_adj|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_de_adj]),_1726=[t_auxstem_de_adj|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_kahen_mizen]),_1726=[t_auxstem_te_kahen_mizen|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_kahen_renyo]),_1726=[t_auxstem_te_kahen_renyo|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_kahen_syusi]),_1726=[t_auxstem_te_kahen_syusi|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_kahen_rentai]),_1726=[t_auxstem_te_kahen_rentai|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_kahen_katei]),_1726=[t_auxstem_te_kahen_katei|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_de_kahen_renyo]),_1726=[t_auxstem_de_kahen_renyo|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_wish]),_1726=[t_auxstem_wish|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_negt]),_1726=[t_auxstem_negt|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_oblg_mizen]),_1726=[t_auxstem_oblg_mizen|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_oblg_syusi]),_1726=[t_auxstem_oblg_syusi|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_oblg_katei]),_1726=[t_auxstem_oblg_katei|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_intn_u]),_1726=[t_auxstem_intn_u|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_intn_you]),_1726=[t_auxstem_intn_you|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_masu]),_1726=[t_auxstem_masu|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_desu]),_1726=[t_auxstem_desu|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_copula_masu]),_1726=[t_auxstem_copula_masu|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_infr_spe]),_1726=[t_auxstem_infr_spe|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_kdo]),_1726=[t_auxstem_te_kdo|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_te_masu]),_1726=[t_auxstem_te_masu|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_de_masu]),_1726=[t_auxstem_de_masu|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_sahen_5_k]),_1726=[t_auxstem_sahen_5_k|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_sahen_5_s]),_1726=[t_auxstem_sahen_5_s|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_sahen_5_r]),_1726=[t_auxstem_sahen_5_r|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_sahen_1]),_1726=[t_auxstem_sahen_1|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_copula_5_r]),_1726=[t_auxstem_copula_5_r|_1727].
pdcg(n_auxstem,_1726,_1727) :- fstck(n_auxstem,_1726),msw(n_auxstem,[t_auxstem_sahen_5_w]),_1726=[t_auxstem_sahen_5_w|_1727].
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_vstem5_2FH_ga,n_infl]),pdcg(n_vstem5_2FH_ga,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_vstem1_2FH_ga,n_infl]),pdcg(n_vstem1_2FH_ga,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_vstem_spe_2FH_ga,n_infl]),pdcg(n_vstem_spe_2FH_ga,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[t_adjstem_2FH_ga,n_infl]),_1728=[t_adjstem_2FH_ga|_1740],pdcg(n_infl,_1740,_1729).
pdcg(n_verb_2FH_ga,_1726,_1727) :- fstck(n_verb_2FH_ga,_1726),msw(n_verb_2FH_ga,[t_adj_renyo_2FH_ga]),_1726=[t_adj_renyo_2FH_ga|_1727].
pdcg(n_verb_2FH_ga,_1726,_1727) :- fstck(n_verb_2FH_ga,_1726),msw(n_verb_2FH_ga,[n_vstem1_2FH_ga]),pdcg(n_vstem1_2FH_ga,_1726,_1727).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_o,n_verb_2FH_ga_o]),pdcg(n_pp_o,_1728,_1733),pdcg(n_verb_2FH_ga_o,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_ni,n_verb_2FH_ga_ni]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_verb_2FH_ga_ni,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_ni,n_verb_2FH_ga_ni_5EH_e]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_e,n_verb_2FH_ga_ni_5EH_e]),pdcg(n_pp_e,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_e,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_ni,n_verb_2FH_ga_ni_5EH_to]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_to,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_to,n_verb_2FH_ga_to]),pdcg(n_pp_to,_1728,_1733),pdcg(n_verb_2FH_ga_to,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_to,n_verb_2FH_ga_ni_5EH_to]),pdcg(n_pp_to,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_to,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_de,n_verb_2FH_ga_de]),pdcg(n_pp_de,_1728,_1733),pdcg(n_verb_2FH_ga_de,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_quote,n_verb_2FH_ga_quote]),pdcg(n_pp_quote,_1728,_1733),pdcg(n_verb_2FH_ga_quote,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_mod_v,n_verb_2FH_ga]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_o,n_n_sahen_2FH_ga_o]),pdcg(n_pp_o,_1728,_1733),pdcg(n_n_sahen_2FH_ga_o,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_ni,n_n_sahen_2FH_ga_ni]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_to,n_n_sahen_2FH_ga_to]),pdcg(n_pp_to,_1728,_1733),pdcg(n_n_sahen_2FH_ga_to,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_ni,n_n_sahen_2FH_ga_ni_5EH_e]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni_5EH_e,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_e,n_n_sahen_2FH_ga_ni_5EH_e]),pdcg(n_pp_e,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni_5EH_e,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_quote,n_n_sahen_2FH_ga_quote]),pdcg(n_pp_quote,_1728,_1733),pdcg(n_n_sahen_2FH_ga_quote,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_mod_v,n_n_sahen_2FH_ga]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_de,n_n_adj_2FH_ga_de]),pdcg(n_pp_de,_1728,_1733),pdcg(n_n_adj_2FH_ga_de,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp_to,n_n_adj_2FH_ga_to]),pdcg(n_pp_to,_1728,_1733),pdcg(n_n_adj_2FH_ga_to,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_mod_v,n_n_adj_2FH_ga]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_adj_2FH_ga,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_np,n_aux]),pdcg(n_np,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_num_ex_4,n_aux]),pdcg(n_num_ex_4,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_pp,n_aux]),pdcg(n_pp,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_adv,n_aux]),pdcg(n_adv,_1728,_1733),pdcg(n_aux,_1733,_1729).
pdcg(n_verb_2FH_ga,_1728,_1729) :- fstck(n_verb_2FH_ga,_1728),msw(n_verb_2FH_ga,[n_verb_2FH_ga,n_auxv]),pdcg(n_verb_2FH_ga,_1728,_1733),pdcg(n_auxv,_1733,_1729).
pdcg(n_n_num_hyaku,_1726,_1727) :- fstck(n_n_num_hyaku,_1726),msw(n_n_num_hyaku,[n_n_num_keta_hyaku]),pdcg(n_n_num_keta_hyaku,_1726,_1727).
pdcg(n_n_num_hyaku,_1728,_1729) :- fstck(n_n_num_hyaku,_1728),msw(n_n_num_hyaku,[n_n_num_keta_hyaku,n_n_num_ichi]),pdcg(n_n_num_keta_hyaku,_1728,_1733),pdcg(n_n_num_ichi,_1733,_1729).
pdcg(n_n_num_hyaku,_1728,_1729) :- fstck(n_n_num_hyaku,_1728),msw(n_n_num_hyaku,[n_n_num_keta_hyaku,n_n_num_zyuu]),pdcg(n_n_num_keta_hyaku,_1728,_1733),pdcg(n_n_num_zyuu,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_ni_5EH_to,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni_5EH_to,_1728),msw(n_n_sahen_2FH_ga_ni_5EH_to,[n_prefix,n_verb_2FH_ga_ni_5EH_to]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_ni_5EH_to,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_de,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_de,_1728),msw(n_n_sahen_2FH_ga_de,[n_prefix,n_verb_2FH_ga_de]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_de,_1733,_1729).
pdcg(n_verb_2FH_ga_ni,_1728,_1729) :- fstck(n_verb_2FH_ga_ni,_1728),msw(n_verb_2FH_ga_ni,[n_vstem5_2FH_ga_ni,n_infl]),pdcg(n_vstem5_2FH_ga_ni,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni,_1728,_1729) :- fstck(n_verb_2FH_ga_ni,_1728),msw(n_verb_2FH_ga_ni,[n_vstem1_2FH_ga_ni,n_infl]),pdcg(n_vstem1_2FH_ga_ni,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni,_1728,_1729) :- fstck(n_verb_2FH_ga_ni,_1728),msw(n_verb_2FH_ga_ni,[n_vstem_spe_2FH_ga_ni,n_infl]),pdcg(n_vstem_spe_2FH_ga_ni,_1728,_1733),pdcg(n_infl,_1733,_1729).
pdcg(n_verb_2FH_ga_ni,_1726,_1727) :- fstck(n_verb_2FH_ga_ni,_1726),msw(n_verb_2FH_ga_ni,[n_vstem1_2FH_ga_ni]),pdcg(n_vstem1_2FH_ga_ni,_1726,_1727).
pdcg(n_verb_2FH_ga_ni,_1728,_1729) :- fstck(n_verb_2FH_ga_ni,_1728),msw(n_verb_2FH_ga_ni,[n_pp_o,n_verb_2FH_ga_ni_o]),pdcg(n_pp_o,_1728,_1733),pdcg(n_verb_2FH_ga_ni_o,_1733,_1729).
pdcg(n_verb_2FH_ga_ni,_1728,_1729) :- fstck(n_verb_2FH_ga_ni,_1728),msw(n_verb_2FH_ga_ni,[n_mod_v,n_verb_2FH_ga_ni]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_ga_ni,_1733,_1729).
pdcg(n_verb_2FH_ga_ni,_1728,_1729) :- fstck(n_verb_2FH_ga_ni,_1728),msw(n_verb_2FH_ga_ni,[n_pp_o,n_n_sahen_2FH_ga_ni_o]),pdcg(n_pp_o,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni_o,_1733,_1729).
pdcg(n_verb_2FH_ga_ni,_1728,_1729) :- fstck(n_verb_2FH_ga_ni,_1728),msw(n_verb_2FH_ga_ni,[n_mod_v,n_n_sahen_2FH_ga_ni]),pdcg(n_mod_v,_1728,_1733),pdcg(n_n_sahen_2FH_ga_ni,_1733,_1729).
pdcg(n_n_num_sen,_1726,_1727) :- fstck(n_n_num_sen,_1726),msw(n_n_num_sen,[n_n_num_keta_sen]),pdcg(n_n_num_keta_sen,_1726,_1727).
pdcg(n_n_num_sen,_1728,_1729) :- fstck(n_n_num_sen,_1728),msw(n_n_num_sen,[n_n_num_keta_sen,n_n_num_ichi]),pdcg(n_n_num_keta_sen,_1728,_1733),pdcg(n_n_num_ichi,_1733,_1729).
pdcg(n_n_num_sen,_1728,_1729) :- fstck(n_n_num_sen,_1728),msw(n_n_num_sen,[n_n_num_keta_sen,n_n_num_zyuu]),pdcg(n_n_num_keta_sen,_1728,_1733),pdcg(n_n_num_zyuu,_1733,_1729).
pdcg(n_n_num_sen,_1728,_1729) :- fstck(n_n_num_sen,_1728),msw(n_n_num_sen,[n_n_num_keta_sen,n_n_num_hyaku]),pdcg(n_n_num_keta_sen,_1728,_1733),pdcg(n_n_num_hyaku,_1733,_1729).
pdcg(n_v_kahen_2FH_ga,_1728,_1729) :- fstck(n_v_kahen_2FH_ga,_1728),msw(n_v_kahen_2FH_ga,[n_pp_ni,n_v_kahen_2FH_ga_ni]),pdcg(n_pp_ni,_1728,_1733),pdcg(n_v_kahen_2FH_ga_ni,_1733,_1729).
pdcg(n_v_kahen_2FH_ga,_1728,_1729) :- fstck(n_v_kahen_2FH_ga,_1728),msw(n_v_kahen_2FH_ga,[n_mod_v,n_v_kahen_2FH_ga]),pdcg(n_mod_v,_1728,_1733),pdcg(n_v_kahen_2FH_ga,_1733,_1729).
pdcg(n_num_ex_rentai,_1728,_1729) :- fstck(n_num_ex_rentai,_1728),msw(n_num_ex_rentai,[n_num_ex_3,n_p_rentai]),pdcg(n_num_ex_3,_1728,_1733),pdcg(n_p_rentai,_1733,_1729).
pdcg(n_num_ex_rentai,_1728,_1729) :- fstck(n_num_ex_rentai,_1728),msw(n_num_ex_rentai,[n_num_ex_2,n_p_rentai]),pdcg(n_num_ex_2,_1728,_1733),pdcg(n_p_rentai,_1733,_1729).
pdcg(n_num_ex_rentai,_1728,_1729) :- fstck(n_num_ex_rentai,_1728),msw(n_num_ex_rentai,[n_num_ex_4,t_p_rentai_no]),pdcg(n_num_ex_4,_1728,_1733),_1733=[t_p_rentai_no|_1729].
pdcg(n_stay_period,_1728,_1729) :- fstck(n_stay_period,_1728),msw(n_stay_period,[n_period_kara,n_period_made]),pdcg(n_period_kara,_1728,_1733),pdcg(n_period_made,_1733,_1729).
pdcg(n_stay_period,_1726,_1727) :- fstck(n_stay_period,_1726),msw(n_stay_period,[n_period_kara]),pdcg(n_period_kara,_1726,_1727).
pdcg(n_stay_period,_1726,_1727) :- fstck(n_stay_period,_1726),msw(n_stay_period,[n_period_begin]),pdcg(n_period_begin,_1726,_1727).
pdcg(n_stay_period,_1728,_1729) :- fstck(n_stay_period,_1728),msw(n_stay_period,[n_period_begin,n_period_end]),pdcg(n_period_begin,_1728,_1733),pdcg(n_period_end,_1733,_1729).
pdcg(n_stay_period,_1728,_1729) :- fstck(n_stay_period,_1728),msw(n_stay_period,[n_period_to,n_period_end]),pdcg(n_period_to,_1728,_1733),pdcg(n_period_end,_1733,_1729).
pdcg(n_vstem1_2FH_ga_quote,_1726,_1727) :- fstck(n_vstem1_2FH_ga_quote,_1726),msw(n_vstem1_2FH_ga_quote,[t_vstem_1_2FH_ga_quote]),_1726=[t_vstem_1_2FH_ga_quote|_1727].
pdcg(n_n_spel,_1726,_1727) :- fstck(n_n_spel,_1726),msw(n_n_spel,[t_tsuzuri]),_1726=[t_tsuzuri|_1727].
pdcg(n_verb_2FH_de,_1728,_1729) :- fstck(n_verb_2FH_de,_1728),msw(n_verb_2FH_de,[n_pp_ga,n_verb_2FH_ga_de]),pdcg(n_pp_ga,_1728,_1733),pdcg(n_verb_2FH_ga_de,_1733,_1729).
pdcg(n_verb_2FH_de,_1728,_1729) :- fstck(n_verb_2FH_de,_1728),msw(n_verb_2FH_de,[n_mod_v,n_verb_2FH_de]),pdcg(n_mod_v,_1728,_1733),pdcg(n_verb_2FH_de,_1733,_1729).
pdcg(n_np,_1728,_1729) :- fstck(n_np,_1728),msw(n_np,[n_mod_n,n_n_adv]),pdcg(n_mod_n,_1728,_1733),pdcg(n_n_adv,_1733,_1729).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_hutu]),pdcg(n_n_hutu,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_proper]),pdcg(n_n_proper,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_pro]),pdcg(n_pro,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_pro_domo]),pdcg(n_pro_domo,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_pro_exp]),pdcg(n_pro_exp,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_wh_pro]),pdcg(n_wh_pro,_1726,_1727).
pdcg(n_np,_1728,_1729) :- fstck(n_np,_1728),msw(n_np,[n_pro_domo,t_suffix_pro]),pdcg(n_pro_domo,_1728,_1733),_1733=[t_suffix_pro|_1729].
pdcg(n_np,_1728,_1729) :- fstck(n_np,_1728),msw(n_np,[n_pro_exp,t_suffix_name]),pdcg(n_pro_exp,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_np,_1728,_1729) :- fstck(n_np,_1728),msw(n_np,[n_wh_pro,t_suffix_name]),pdcg(n_wh_pro,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_sahen]),pdcg(n_n_sahen,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_name]),pdcg(n_name,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_num]),pdcg(n_n_num,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_num_bango]),pdcg(n_n_num_bango,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_quant]),pdcg(n_n_quant,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_time]),pdcg(n_n_time,_1726,_1727).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_n_date_and_time]),pdcg(n_n_date_and_time,_1726,_1727).
pdcg(n_np,_1728,_1729) :- fstck(n_np,_1728),msw(n_np,[n_vaux,n_np]),pdcg(n_vaux,_1728,_1733),pdcg(n_np,_1733,_1729).
pdcg(n_np,_1728,_1729) :- fstck(n_np,_1728),msw(n_np,[n_name,t_suffix_name]),pdcg(n_name,_1728,_1733),_1733=[t_suffix_name|_1729].
pdcg(n_np,_1728,_1729) :- fstck(n_np,_1728),msw(n_np,[n_np,n_p_fuku]),pdcg(n_np,_1728,_1733),pdcg(n_p_fuku,_1733,_1729).
pdcg(n_np,_1726,_1727) :- fstck(n_np,_1726),msw(n_np,[n_kajo]),pdcg(n_kajo,_1726,_1727).
pdcg(n_n_sahen_2FH_ga_ni_o,_1728,_1729) :- fstck(n_n_sahen_2FH_ga_ni_o,_1728),msw(n_n_sahen_2FH_ga_ni_o,[n_prefix,n_verb_2FH_ga_ni_o]),pdcg(n_prefix,_1728,_1733),pdcg(n_verb_2FH_ga_ni_o,_1733,_1729).
pdcg(n_n_sahen_2FH_ga_ni_o,_1726,_1727) :- fstck(n_n_sahen_2FH_ga_ni_o,_1726),msw(n_n_sahen_2FH_ga_ni_o,[t_sahen_meisi_2FH_ga_ni_o]),_1726=[t_sahen_meisi_2FH_ga_ni_o|_1727].
pdcg(n_stay_day,_1728,_1729) :- fstck(n_stay_day,_1728),msw(n_stay_day,[n_prefix,n_x_haku]),pdcg(n_prefix,_1728,_1733),pdcg(n_x_haku,_1733,_1729).
pdcg(n_stay_day,_1726,_1727) :- fstck(n_stay_day,_1726),msw(n_stay_day,[n_x_haku]),pdcg(n_x_haku,_1726,_1727).
pdcg(n_stay_day,_1726,_1727) :- fstck(n_stay_day,_1726),msw(n_stay_day,[n_x_haku_y_ka]),pdcg(n_x_haku_y_ka,_1726,_1727).
pdcg(n_stay_day,_1726,_1727) :- fstck(n_stay_day,_1726),msw(n_stay_day,[n_x_ka_kan]),pdcg(n_x_ka_kan,_1726,_1727).
pdcg(n_auxvstem,_1726,_1727) :- fstck(n_auxvstem,_1726),msw(n_auxvstem,[t_auxvstem_renyo_1]),_1726=[t_auxvstem_renyo_1|_1727].
pdcg(n_auxvstem,_1726,_1727) :- fstck(n_auxvstem,_1726),msw(n_auxvstem,[t_auxvstem_renyo_5_s]),_1726=[t_auxvstem_renyo_5_s|_1727].
pdcg(n_vstem1_2FH_ga_ni_5EH_e_o,_1726,_1727) :- fstck(n_vstem1_2FH_ga_ni_5EH_e_o,_1726),msw(n_vstem1_2FH_ga_ni_5EH_e_o,[t_vstem_1_2FH_ga_ni_5EH_e_o]),_1726=[t_vstem_1_2FH_ga_ni_5EH_e_o|_1727].
pdcg(n_n_num_keta_zyuu,_1726,_1727) :- fstck(n_n_num_keta_zyuu,_1726),msw(n_n_num_keta_zyuu,[n_num_suf_zyuu]),pdcg(n_num_suf_zyuu,_1726,_1727).
pdcg(n_n_num_keta_zyuu,_1728,_1729) :- fstck(n_n_num_keta_zyuu,_1728),msw(n_n_num_keta_zyuu,[n_n_num_ichi,n_num_suf_zyuu]),pdcg(n_n_num_ichi,_1728,_1733),pdcg(n_num_suf_zyuu,_1733,_1729).
pdcg(n_n_month,_1726,_1727) :- fstck(n_n_month,_1726),msw(n_n_month,[t_meisi_tsuki]),_1726=[t_meisi_tsuki|_1727].
pdcg(n_cl,_1726,_1727) :- fstck(n_cl,_1726),msw(n_cl,[n_verb]),pdcg(n_verb,_1726,_1727).
pdcg(n_cl,_1726,_1727) :- fstck(n_cl,_1726),msw(n_cl,[n_vaux]),pdcg(n_vaux,_1726,_1727).
pdcg(n_cl,_1726,_1727) :- fstck(n_cl,_1726),msw(n_cl,[n_interj]),pdcg(n_interj,_1726,_1727).
pdcg(n_cl,_1728,_1729) :- fstck(n_cl,_1728),msw(n_cl,[n_interj,n_cl]),pdcg(n_interj,_1728,_1733),pdcg(n_cl,_1733,_1729).
pdcg(n_cl,_1728,_1729) :- fstck(n_cl,_1728),msw(n_cl,[t_conj,n_cl]),_1728=[t_conj|_1740],pdcg(n_cl,_1740,_1729).
pdcg(n_cl,_1728,_1729) :- fstck(n_cl,_1728),msw(n_cl,[n_adv_sent,n_cl]),pdcg(n_adv_sent,_1728,_1733),pdcg(n_cl,_1733,_1729).
pdcg(n_cl,_1728,_1729) :- fstck(n_cl,_1728),msw(n_cl,[n_adv_cl,n_cl]),pdcg(n_adv_cl,_1728,_1733),pdcg(n_cl,_1733,_1729).
pdcg(n_cl,_1728,_1729) :- fstck(n_cl,_1728),msw(n_cl,[n_renyo_cl,n_cl]),pdcg(n_renyo_cl,_1728,_1733),pdcg(n_cl,_1733,_1729).
pdcg(n_cl,_1728,_1729) :- fstck(n_cl,_1728),msw(n_cl,[n_addr,n_cl]),pdcg(n_addr,_1728,_1733),pdcg(n_cl,_1733,_1729).
pdcg(n_n_day,_1726,_1727) :- fstck(n_n_day,_1726),msw(n_n_day,[t_meisi_hi]),_1726=[t_meisi_hi|_1727].
pdcg(n_wh_adv,_1726,_1727) :- fstck(n_wh_adv,_1726),msw(n_wh_adv,[t_wh_hukusi]),_1726=[t_wh_hukusi|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_ichi]),_1726=[t_num_ichi|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_iq]),_1726=[t_num_iq|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_ni]),_1726=[t_num_ni|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_san]),_1726=[t_num_san|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_shi]),_1726=[t_num_shi|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_yon]),_1726=[t_num_yon|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_yo]),_1726=[t_num_yo|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_go]),_1726=[t_num_go|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_roku]),_1726=[t_num_roku|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_roq]),_1726=[t_num_roq|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_nana]),_1726=[t_num_nana|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_shichi]),_1726=[t_num_shichi|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_hachi]),_1726=[t_num_hachi|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_haq]),_1726=[t_num_haq|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_kyuu]),_1726=[t_num_kyuu|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_ku]),_1726=[t_num_ku|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_one]),_1726=[t_num_one|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_ten]),_1726=[t_num_ten|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_hito]),_1726=[t_num_hito|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_huta]),_1726=[t_num_huta|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_hutsu]),_1726=[t_num_hutsu|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_miq]),_1726=[t_num_miq|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_yoq]),_1726=[t_num_yoq|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_itsu]),_1726=[t_num_itsu|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_muq]),_1726=[t_num_muq|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_mui]),_1726=[t_num_mui|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_nano]),_1726=[t_num_nano|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_yaq]),_1726=[t_num_yaq|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_you]),_1726=[t_num_you|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_kokono]),_1726=[t_num_kokono|_1727].
pdcg(n_n_num_ichi,_1726,_1727) :- fstck(n_n_num_ichi,_1726),msw(n_n_num_ichi,[t_num_tou]),_1726=[t_num_tou|_1727].

%:-mode first(+,+).
first(n_addr,n_capacity).
first(n_addr,n_n_name_jap_honor).
first(n_addr,n_n_name_others_honor).
first(n_addr,n_visitor_name).
first(n_addr,t_adj_meisi).
first(n_addr,t_adj_renyo_2FH_ga).
first(n_addr,t_adj_renyo_2FH_ga_de).
first(n_addr,t_adjstem_2FH_ga).
first(n_addr,t_adjstem_2FH_ga_de).
first(n_addr,t_adjstem_spe_2FH_ga_de).
first(n_addr,t_daimeisi).
first(n_addr,t_daimeisi_domo).
first(n_addr,t_daimeisi_exp).
first(n_addr,t_hukusi).
first(n_addr,t_hukusi_desu).
first(n_addr,t_hutu_meisi).
first(n_addr,t_hutu_meisi_post).
first(n_addr,t_kahen_dousi_katei_2FH_ga_ni).
first(n_addr,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_addr,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_addr,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_addr,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_addr,t_kdo_2FH_ga).
first(n_addr,t_kdo_2FH_ga_de).
first(n_addr,t_kdo_2FH_ga_to).
first(n_addr,t_koyuu_meisi).
first(n_addr,t_meisi_hi).
first(n_addr,t_meisi_hun).
first(n_addr,t_meisi_tsuki).
first(n_addr,t_meisi_youbi).
first(n_addr,t_meisi_zi).
first(n_addr,t_myoji_first).
first(n_addr,t_myoji_last).
first(n_addr,t_n_keisiki).
first(n_addr,t_namae_first).
first(n_addr,t_namae_last).
first(n_addr,t_num_bouyomi).
first(n_addr,t_num_byaku).
first(n_addr,t_num_byaq).
first(n_addr,t_num_go).
first(n_addr,t_num_hachi).
first(n_addr,t_num_haq).
first(n_addr,t_num_hito).
first(n_addr,t_num_huta).
first(n_addr,t_num_hutsu).
first(n_addr,t_num_hyaku).
first(n_addr,t_num_hyaq).
first(n_addr,t_num_ichi).
first(n_addr,t_num_iq).
first(n_addr,t_num_itsu).
first(n_addr,t_num_kokono).
first(n_addr,t_num_ku).
first(n_addr,t_num_kyuu).
first(n_addr,t_num_miq).
first(n_addr,t_num_mui).
first(n_addr,t_num_muq).
first(n_addr,t_num_nana).
first(n_addr,t_num_nano).
first(n_addr,t_num_ni).
first(n_addr,t_num_one).
first(n_addr,t_num_pyaku).
first(n_addr,t_num_pyaq).
first(n_addr,t_num_roku).
first(n_addr,t_num_roq).
first(n_addr,t_num_san).
first(n_addr,t_num_sen).
first(n_addr,t_num_shi).
first(n_addr,t_num_shichi).
first(n_addr,t_num_ten).
first(n_addr,t_num_tou).
first(n_addr,t_num_yaq).
first(n_addr,t_num_yo).
first(n_addr,t_num_yon).
first(n_addr,t_num_yoq).
first(n_addr,t_num_you).
first(n_addr,t_num_zen).
first(n_addr,t_num_zyuq).
first(n_addr,t_num_zyuu).
first(n_addr,t_prefix_go).
first(n_addr,t_prefix_hutu_hutu).
first(n_addr,t_prefix_o).
first(n_addr,t_prefix_quant_quant).
first(n_addr,t_rentai).
first(n_addr,t_sahen_dousi_katei_2FH_ga_ni).
first(n_addr,t_sahen_dousi_katei_2FH_ga_o).
first(n_addr,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_addr,t_sahen_dousi_mizen_2FH_ga_o).
first(n_addr,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_addr,t_sahen_dousi_rentai_2FH_ga_o).
first(n_addr,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_addr,t_sahen_dousi_renyo_2FH_ga_o).
first(n_addr,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_addr,t_sahen_dousi_syusi_2FH_ga_o).
first(n_addr,t_sahen_meisi_2FH_ga).
first(n_addr,t_sahen_meisi_2FH_ga_ni).
first(n_addr,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_addr,t_sahen_meisi_2FH_ga_ni_o).
first(n_addr,t_sahen_meisi_2FH_ga_o).
first(n_addr,t_sahen_meisi_2FH_ga_to).
first(n_addr,t_sahen_meisi_pol_2FH_ga).
first(n_addr,t_sahen_meisi_pol_2FH_ga_ni).
first(n_addr,t_sahen_meisi_pol_2FH_ga_o).
first(n_addr,t_sahen_meisi_pol_2FH_ga_to).
first(n_addr,t_suuryousi).
first(n_addr,t_teido_hukusi).
first(n_addr,t_tsuzuri).
first(n_addr,t_vstem_1_2FH_ga).
first(n_addr,t_vstem_1_2FH_ga_de).
first(n_addr,t_vstem_1_2FH_ga_ni).
first(n_addr,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_addr,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_addr,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_addr,t_vstem_1_2FH_ga_ni_o).
first(n_addr,t_vstem_1_2FH_ga_o).
first(n_addr,t_vstem_1_2FH_ga_quote).
first(n_addr,t_vstem_1_2FH_ga_to).
first(n_addr,t_vstem_5_b_2FH_ga).
first(n_addr,t_vstem_5_b_2FH_ga_ni).
first(n_addr,t_vstem_5_b_2FH_ga_ni_o).
first(n_addr,t_vstem_5_b_2FH_ga_o).
first(n_addr,t_vstem_5_b_2FH_ga_to).
first(n_addr,t_vstem_5_g_2FH_ga).
first(n_addr,t_vstem_5_g_2FH_ga_ni).
first(n_addr,t_vstem_5_g_2FH_ga_ni_o).
first(n_addr,t_vstem_5_g_2FH_ga_o).
first(n_addr,t_vstem_5_k_2FH_ga).
first(n_addr,t_vstem_5_k_2FH_ga_ni).
first(n_addr,t_vstem_5_k_2FH_ga_ni_o).
first(n_addr,t_vstem_5_k_2FH_ga_o).
first(n_addr,t_vstem_5_k_2FH_ga_to).
first(n_addr,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_addr,t_vstem_5_m_2FH_ga).
first(n_addr,t_vstem_5_m_2FH_ga_ni).
first(n_addr,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_addr,t_vstem_5_m_2FH_ga_ni_o).
first(n_addr,t_vstem_5_m_2FH_ga_o).
first(n_addr,t_vstem_5_m_2FH_ga_to).
first(n_addr,t_vstem_5_r_2FH_ga).
first(n_addr,t_vstem_5_r_2FH_ga_ni).
first(n_addr,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_addr,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_addr,t_vstem_5_r_2FH_ga_ni_o).
first(n_addr,t_vstem_5_r_2FH_ga_o).
first(n_addr,t_vstem_5_r_2FH_ga_to).
first(n_addr,t_vstem_5_r_i_2FH_ga).
first(n_addr,t_vstem_5_r_i_2FH_ga_o).
first(n_addr,t_vstem_5_r_i_2FH_ga_quote).
first(n_addr,t_vstem_5_s_2FH_ga).
first(n_addr,t_vstem_5_s_2FH_ga_ni).
first(n_addr,t_vstem_5_s_2FH_ga_ni_o).
first(n_addr,t_vstem_5_s_2FH_ga_o).
first(n_addr,t_vstem_5_s_2FH_ga_quote).
first(n_addr,t_vstem_5_s_2FH_ga_to).
first(n_addr,t_vstem_5_t_2FH_ga).
first(n_addr,t_vstem_5_t_2FH_ga_ni).
first(n_addr,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_addr,t_vstem_5_t_2FH_ga_ni_o).
first(n_addr,t_vstem_5_t_2FH_ga_o).
first(n_addr,t_vstem_5_t_2FH_ga_to).
first(n_addr,t_vstem_5_w_2FH_ga).
first(n_addr,t_vstem_5_w_2FH_ga_de).
first(n_addr,t_vstem_5_w_2FH_ga_ni).
first(n_addr,t_vstem_5_w_2FH_ga_ni_o).
first(n_addr,t_vstem_5_w_2FH_ga_o).
first(n_addr,t_vstem_5_w_2FH_ga_quote).
first(n_addr,t_vstem_5_w_2FH_ga_to).
first(n_addr,t_vstem_masu_2FH_ga).
first(n_addr,t_vstem_sahen_2FH_ga_ni).
first(n_addr,t_wh_daimeisi).
first(n_addr,t_wh_daimeisi_nan).
first(n_addr,t_wh_hukusi).
first(n_addr,t_zikan_meisi).
first(n_addr,t_zikan_meisi_ippai).
first(n_addr,t_zikantai).
first(n_adv,t_hukusi).
first(n_adv,t_hukusi_desu).
first(n_adv_cl,n_capacity).
first(n_adv_cl,n_visitor_name).
first(n_adv_cl,t_adj_meisi).
first(n_adv_cl,t_adj_renyo_2FH_ga).
first(n_adv_cl,t_adj_renyo_2FH_ga_de).
first(n_adv_cl,t_adjstem_2FH_ga).
first(n_adv_cl,t_adjstem_2FH_ga_de).
first(n_adv_cl,t_adjstem_spe_2FH_ga_de).
first(n_adv_cl,t_daimeisi).
first(n_adv_cl,t_daimeisi_domo).
first(n_adv_cl,t_daimeisi_exp).
first(n_adv_cl,t_hukusi).
first(n_adv_cl,t_hukusi_desu).
first(n_adv_cl,t_hutu_meisi).
first(n_adv_cl,t_hutu_meisi_post).
first(n_adv_cl,t_interj_hesit).
first(n_adv_cl,t_kahen_dousi_katei_2FH_ga_ni).
first(n_adv_cl,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_adv_cl,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_adv_cl,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_adv_cl,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_adv_cl,t_kdo_2FH_ga).
first(n_adv_cl,t_kdo_2FH_ga_de).
first(n_adv_cl,t_kdo_2FH_ga_to).
first(n_adv_cl,t_koyuu_meisi).
first(n_adv_cl,t_meisi_hi).
first(n_adv_cl,t_meisi_hun).
first(n_adv_cl,t_meisi_tsuki).
first(n_adv_cl,t_meisi_youbi).
first(n_adv_cl,t_meisi_zi).
first(n_adv_cl,t_myoji_first).
first(n_adv_cl,t_myoji_last).
first(n_adv_cl,t_n_keisiki).
first(n_adv_cl,t_namae_first).
first(n_adv_cl,t_namae_last).
first(n_adv_cl,t_num_bouyomi).
first(n_adv_cl,t_num_byaku).
first(n_adv_cl,t_num_byaq).
first(n_adv_cl,t_num_go).
first(n_adv_cl,t_num_hachi).
first(n_adv_cl,t_num_haq).
first(n_adv_cl,t_num_hito).
first(n_adv_cl,t_num_huta).
first(n_adv_cl,t_num_hutsu).
first(n_adv_cl,t_num_hyaku).
first(n_adv_cl,t_num_hyaq).
first(n_adv_cl,t_num_ichi).
first(n_adv_cl,t_num_iq).
first(n_adv_cl,t_num_itsu).
first(n_adv_cl,t_num_kokono).
first(n_adv_cl,t_num_ku).
first(n_adv_cl,t_num_kyuu).
first(n_adv_cl,t_num_miq).
first(n_adv_cl,t_num_mui).
first(n_adv_cl,t_num_muq).
first(n_adv_cl,t_num_nana).
first(n_adv_cl,t_num_nano).
first(n_adv_cl,t_num_ni).
first(n_adv_cl,t_num_one).
first(n_adv_cl,t_num_pyaku).
first(n_adv_cl,t_num_pyaq).
first(n_adv_cl,t_num_roku).
first(n_adv_cl,t_num_roq).
first(n_adv_cl,t_num_san).
first(n_adv_cl,t_num_sen).
first(n_adv_cl,t_num_shi).
first(n_adv_cl,t_num_shichi).
first(n_adv_cl,t_num_ten).
first(n_adv_cl,t_num_tou).
first(n_adv_cl,t_num_yaq).
first(n_adv_cl,t_num_yo).
first(n_adv_cl,t_num_yon).
first(n_adv_cl,t_num_yoq).
first(n_adv_cl,t_num_you).
first(n_adv_cl,t_num_zen).
first(n_adv_cl,t_num_zyuq).
first(n_adv_cl,t_num_zyuu).
first(n_adv_cl,t_prefix_go).
first(n_adv_cl,t_prefix_hutu_hutu).
first(n_adv_cl,t_prefix_o).
first(n_adv_cl,t_prefix_quant_quant).
first(n_adv_cl,t_rentai).
first(n_adv_cl,t_sahen_dousi_katei_2FH_ga_ni).
first(n_adv_cl,t_sahen_dousi_katei_2FH_ga_o).
first(n_adv_cl,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_adv_cl,t_sahen_dousi_mizen_2FH_ga_o).
first(n_adv_cl,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_adv_cl,t_sahen_dousi_rentai_2FH_ga_o).
first(n_adv_cl,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_adv_cl,t_sahen_dousi_renyo_2FH_ga_o).
first(n_adv_cl,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_adv_cl,t_sahen_dousi_syusi_2FH_ga_o).
first(n_adv_cl,t_sahen_meisi_2FH_ga).
first(n_adv_cl,t_sahen_meisi_2FH_ga_ni).
first(n_adv_cl,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_adv_cl,t_sahen_meisi_2FH_ga_ni_o).
first(n_adv_cl,t_sahen_meisi_2FH_ga_o).
first(n_adv_cl,t_sahen_meisi_2FH_ga_to).
first(n_adv_cl,t_sahen_meisi_pol_2FH_ga).
first(n_adv_cl,t_sahen_meisi_pol_2FH_ga_ni).
first(n_adv_cl,t_sahen_meisi_pol_2FH_ga_o).
first(n_adv_cl,t_sahen_meisi_pol_2FH_ga_to).
first(n_adv_cl,t_suuryousi).
first(n_adv_cl,t_teido_hukusi).
first(n_adv_cl,t_tsuzuri).
first(n_adv_cl,t_vstem_1_2FH_ga).
first(n_adv_cl,t_vstem_1_2FH_ga_de).
first(n_adv_cl,t_vstem_1_2FH_ga_ni).
first(n_adv_cl,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_adv_cl,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_adv_cl,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_adv_cl,t_vstem_1_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_1_2FH_ga_o).
first(n_adv_cl,t_vstem_1_2FH_ga_quote).
first(n_adv_cl,t_vstem_1_2FH_ga_to).
first(n_adv_cl,t_vstem_5_b_2FH_ga).
first(n_adv_cl,t_vstem_5_b_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_b_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_b_2FH_ga_o).
first(n_adv_cl,t_vstem_5_b_2FH_ga_to).
first(n_adv_cl,t_vstem_5_g_2FH_ga).
first(n_adv_cl,t_vstem_5_g_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_g_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_g_2FH_ga_o).
first(n_adv_cl,t_vstem_5_k_2FH_ga).
first(n_adv_cl,t_vstem_5_k_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_k_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_k_2FH_ga_o).
first(n_adv_cl,t_vstem_5_k_2FH_ga_to).
first(n_adv_cl,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_adv_cl,t_vstem_5_m_2FH_ga).
first(n_adv_cl,t_vstem_5_m_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_adv_cl,t_vstem_5_m_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_m_2FH_ga_o).
first(n_adv_cl,t_vstem_5_m_2FH_ga_to).
first(n_adv_cl,t_vstem_5_r_2FH_ga).
first(n_adv_cl,t_vstem_5_r_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_adv_cl,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_adv_cl,t_vstem_5_r_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_r_2FH_ga_o).
first(n_adv_cl,t_vstem_5_r_2FH_ga_to).
first(n_adv_cl,t_vstem_5_r_i_2FH_ga).
first(n_adv_cl,t_vstem_5_r_i_2FH_ga_o).
first(n_adv_cl,t_vstem_5_r_i_2FH_ga_quote).
first(n_adv_cl,t_vstem_5_s_2FH_ga).
first(n_adv_cl,t_vstem_5_s_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_s_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_s_2FH_ga_o).
first(n_adv_cl,t_vstem_5_s_2FH_ga_quote).
first(n_adv_cl,t_vstem_5_s_2FH_ga_to).
first(n_adv_cl,t_vstem_5_t_2FH_ga).
first(n_adv_cl,t_vstem_5_t_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_adv_cl,t_vstem_5_t_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_t_2FH_ga_o).
first(n_adv_cl,t_vstem_5_t_2FH_ga_to).
first(n_adv_cl,t_vstem_5_w_2FH_ga).
first(n_adv_cl,t_vstem_5_w_2FH_ga_de).
first(n_adv_cl,t_vstem_5_w_2FH_ga_ni).
first(n_adv_cl,t_vstem_5_w_2FH_ga_ni_o).
first(n_adv_cl,t_vstem_5_w_2FH_ga_o).
first(n_adv_cl,t_vstem_5_w_2FH_ga_quote).
first(n_adv_cl,t_vstem_5_w_2FH_ga_to).
first(n_adv_cl,t_vstem_masu_2FH_ga).
first(n_adv_cl,t_vstem_sahen_2FH_ga_ni).
first(n_adv_cl,t_wh_daimeisi).
first(n_adv_cl,t_wh_daimeisi_nan).
first(n_adv_cl,t_wh_hukusi).
first(n_adv_cl,t_zikan_meisi).
first(n_adv_cl,t_zikan_meisi_ippai).
first(n_adv_cl,t_zikantai).
first(n_adv_degr,t_teido_hukusi).
first(n_adv_sent,t_bun_hukusi).
first(n_advp,n_capacity).
first(n_advp,n_visitor_name).
first(n_advp,t_adj_meisi).
first(n_advp,t_adj_renyo_2FH_ga).
first(n_advp,t_adj_renyo_2FH_ga_de).
first(n_advp,t_adjstem_2FH_ga).
first(n_advp,t_adjstem_2FH_ga_de).
first(n_advp,t_adjstem_spe_2FH_ga_de).
first(n_advp,t_daimeisi).
first(n_advp,t_daimeisi_domo).
first(n_advp,t_daimeisi_exp).
first(n_advp,t_hukusi).
first(n_advp,t_hukusi_desu).
first(n_advp,t_hutu_meisi).
first(n_advp,t_hutu_meisi_post).
first(n_advp,t_kahen_dousi_katei_2FH_ga_ni).
first(n_advp,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_advp,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_advp,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_advp,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_advp,t_kdo_2FH_ga).
first(n_advp,t_kdo_2FH_ga_de).
first(n_advp,t_kdo_2FH_ga_to).
first(n_advp,t_koyuu_meisi).
first(n_advp,t_meisi_hi).
first(n_advp,t_meisi_hun).
first(n_advp,t_meisi_tsuki).
first(n_advp,t_meisi_youbi).
first(n_advp,t_meisi_zi).
first(n_advp,t_myoji_first).
first(n_advp,t_myoji_last).
first(n_advp,t_n_keisiki).
first(n_advp,t_namae_first).
first(n_advp,t_namae_last).
first(n_advp,t_num_bouyomi).
first(n_advp,t_num_byaku).
first(n_advp,t_num_byaq).
first(n_advp,t_num_go).
first(n_advp,t_num_hachi).
first(n_advp,t_num_haq).
first(n_advp,t_num_hito).
first(n_advp,t_num_huta).
first(n_advp,t_num_hutsu).
first(n_advp,t_num_hyaku).
first(n_advp,t_num_hyaq).
first(n_advp,t_num_ichi).
first(n_advp,t_num_iq).
first(n_advp,t_num_itsu).
first(n_advp,t_num_kokono).
first(n_advp,t_num_ku).
first(n_advp,t_num_kyuu).
first(n_advp,t_num_miq).
first(n_advp,t_num_mui).
first(n_advp,t_num_muq).
first(n_advp,t_num_nana).
first(n_advp,t_num_nano).
first(n_advp,t_num_ni).
first(n_advp,t_num_one).
first(n_advp,t_num_pyaku).
first(n_advp,t_num_pyaq).
first(n_advp,t_num_roku).
first(n_advp,t_num_roq).
first(n_advp,t_num_san).
first(n_advp,t_num_sen).
first(n_advp,t_num_shi).
first(n_advp,t_num_shichi).
first(n_advp,t_num_ten).
first(n_advp,t_num_tou).
first(n_advp,t_num_yaq).
first(n_advp,t_num_yo).
first(n_advp,t_num_yon).
first(n_advp,t_num_yoq).
first(n_advp,t_num_you).
first(n_advp,t_num_zen).
first(n_advp,t_num_zyuq).
first(n_advp,t_num_zyuu).
first(n_advp,t_prefix_go).
first(n_advp,t_prefix_hutu_hutu).
first(n_advp,t_prefix_o).
first(n_advp,t_prefix_quant_quant).
first(n_advp,t_rentai).
first(n_advp,t_sahen_dousi_katei_2FH_ga_ni).
first(n_advp,t_sahen_dousi_katei_2FH_ga_o).
first(n_advp,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_advp,t_sahen_dousi_mizen_2FH_ga_o).
first(n_advp,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_advp,t_sahen_dousi_rentai_2FH_ga_o).
first(n_advp,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_advp,t_sahen_dousi_renyo_2FH_ga_o).
first(n_advp,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_advp,t_sahen_dousi_syusi_2FH_ga_o).
first(n_advp,t_sahen_meisi_2FH_ga).
first(n_advp,t_sahen_meisi_2FH_ga_ni).
first(n_advp,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_advp,t_sahen_meisi_2FH_ga_ni_o).
first(n_advp,t_sahen_meisi_2FH_ga_o).
first(n_advp,t_sahen_meisi_2FH_ga_to).
first(n_advp,t_sahen_meisi_pol_2FH_ga).
first(n_advp,t_sahen_meisi_pol_2FH_ga_ni).
first(n_advp,t_sahen_meisi_pol_2FH_ga_o).
first(n_advp,t_sahen_meisi_pol_2FH_ga_to).
first(n_advp,t_suuryousi).
first(n_advp,t_teido_hukusi).
first(n_advp,t_tsuzuri).
first(n_advp,t_vstem_1_2FH_ga).
first(n_advp,t_vstem_1_2FH_ga_de).
first(n_advp,t_vstem_1_2FH_ga_ni).
first(n_advp,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_advp,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_advp,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_advp,t_vstem_1_2FH_ga_ni_o).
first(n_advp,t_vstem_1_2FH_ga_o).
first(n_advp,t_vstem_1_2FH_ga_quote).
first(n_advp,t_vstem_1_2FH_ga_to).
first(n_advp,t_vstem_5_b_2FH_ga).
first(n_advp,t_vstem_5_b_2FH_ga_ni).
first(n_advp,t_vstem_5_b_2FH_ga_ni_o).
first(n_advp,t_vstem_5_b_2FH_ga_o).
first(n_advp,t_vstem_5_b_2FH_ga_to).
first(n_advp,t_vstem_5_g_2FH_ga).
first(n_advp,t_vstem_5_g_2FH_ga_ni).
first(n_advp,t_vstem_5_g_2FH_ga_ni_o).
first(n_advp,t_vstem_5_g_2FH_ga_o).
first(n_advp,t_vstem_5_k_2FH_ga).
first(n_advp,t_vstem_5_k_2FH_ga_ni).
first(n_advp,t_vstem_5_k_2FH_ga_ni_o).
first(n_advp,t_vstem_5_k_2FH_ga_o).
first(n_advp,t_vstem_5_k_2FH_ga_to).
first(n_advp,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_advp,t_vstem_5_m_2FH_ga).
first(n_advp,t_vstem_5_m_2FH_ga_ni).
first(n_advp,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_advp,t_vstem_5_m_2FH_ga_ni_o).
first(n_advp,t_vstem_5_m_2FH_ga_o).
first(n_advp,t_vstem_5_m_2FH_ga_to).
first(n_advp,t_vstem_5_r_2FH_ga).
first(n_advp,t_vstem_5_r_2FH_ga_ni).
first(n_advp,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_advp,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_advp,t_vstem_5_r_2FH_ga_ni_o).
first(n_advp,t_vstem_5_r_2FH_ga_o).
first(n_advp,t_vstem_5_r_2FH_ga_to).
first(n_advp,t_vstem_5_r_i_2FH_ga).
first(n_advp,t_vstem_5_r_i_2FH_ga_o).
first(n_advp,t_vstem_5_r_i_2FH_ga_quote).
first(n_advp,t_vstem_5_s_2FH_ga).
first(n_advp,t_vstem_5_s_2FH_ga_ni).
first(n_advp,t_vstem_5_s_2FH_ga_ni_o).
first(n_advp,t_vstem_5_s_2FH_ga_o).
first(n_advp,t_vstem_5_s_2FH_ga_quote).
first(n_advp,t_vstem_5_s_2FH_ga_to).
first(n_advp,t_vstem_5_t_2FH_ga).
first(n_advp,t_vstem_5_t_2FH_ga_ni).
first(n_advp,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_advp,t_vstem_5_t_2FH_ga_ni_o).
first(n_advp,t_vstem_5_t_2FH_ga_o).
first(n_advp,t_vstem_5_t_2FH_ga_to).
first(n_advp,t_vstem_5_w_2FH_ga).
first(n_advp,t_vstem_5_w_2FH_ga_de).
first(n_advp,t_vstem_5_w_2FH_ga_ni).
first(n_advp,t_vstem_5_w_2FH_ga_ni_o).
first(n_advp,t_vstem_5_w_2FH_ga_o).
first(n_advp,t_vstem_5_w_2FH_ga_quote).
first(n_advp,t_vstem_5_w_2FH_ga_to).
first(n_advp,t_vstem_masu_2FH_ga).
first(n_advp,t_vstem_sahen_2FH_ga_ni).
first(n_advp,t_wh_daimeisi).
first(n_advp,t_wh_daimeisi_nan).
first(n_advp,t_wh_hukusi).
first(n_advp,t_zikan_meisi).
first(n_advp,t_zikan_meisi_ippai).
first(n_advp,t_zikantai).
first(n_aux,t_aux_da).
first(n_aux,t_aux_daq).
first(n_aux,t_aux_daro).
first(n_aux,t_aux_de).
first(n_aux,t_aux_infr).
first(n_aux,t_aux_infr_spe).
first(n_aux,t_aux_na).
first(n_aux,t_aux_negt_n).
first(n_aux,t_aux_negt_zu).
first(n_aux,t_aux_ni).
first(n_aux,t_aux_oblg_masu).
first(n_aux,t_aux_past).
first(n_aux,t_aux_sfp_ba).
first(n_aux,t_aux_sfp_de).
first(n_aux,t_aux_sfp_ga).
first(n_aux,t_aux_sfp_ka).
first(n_aux,t_aux_sfp_kaa).
first(n_aux,t_aux_sfp_kara).
first(n_aux,t_aux_sfp_kasira).
first(n_aux,t_aux_sfp_kedo).
first(n_aux,t_aux_sfp_kedomo).
first(n_aux,t_aux_sfp_keredo).
first(n_aux,t_aux_sfp_keredomo).
first(n_aux,t_aux_sfp_mono).
first(n_aux,t_aux_sfp_monode).
first(n_aux,t_aux_sfp_monodesukara).
first(n_aux,t_aux_sfp_na).
first(n_aux,t_aux_sfp_naa).
first(n_aux,t_aux_sfp_ne).
first(n_aux,t_aux_sfp_nee).
first(n_aux,t_aux_sfp_no).
first(n_aux,t_aux_sfp_node).
first(n_aux,t_aux_sfp_qke).
first(n_aux,t_aux_sfp_qte).
first(n_aux,t_aux_sfp_si).
first(n_aux,t_aux_sfp_te).
first(n_aux,t_aux_sfp_to).
first(n_aux,t_aux_sfp_tomo).
first(n_aux,t_aux_sfp_wa).
first(n_aux,t_aux_sfp_ya).
first(n_aux,t_aux_sfp_yo).
first(n_aux,t_aux_suru_sa).
first(n_aux,t_aux_suru_se).
first(n_aux,t_aux_suru_shi).
first(n_aux,t_aux_suru_shiro).
first(n_aux,t_aux_suru_sure).
first(n_aux,t_aux_suru_suru).
first(n_aux,t_aux_te_kahen_syusi).
first(n_aux,t_aux_te_masu).
first(n_aux,t_aux_te_orimasen).
first(n_aux,t_aux_zya).
first(n_aux,t_auxstem_caus_saseru).
first(n_aux,t_auxstem_caus_seru).
first(n_aux,t_auxstem_copula_5_r).
first(n_aux,t_auxstem_copula_masu).
first(n_aux,t_auxstem_de_1).
first(n_aux,t_auxstem_de_5_k).
first(n_aux,t_auxstem_de_5_r).
first(n_aux,t_auxstem_de_5_w).
first(n_aux,t_auxstem_de_adj).
first(n_aux,t_auxstem_de_kahen_renyo).
first(n_aux,t_auxstem_de_masu).
first(n_aux,t_auxstem_deac_rareru).
first(n_aux,t_auxstem_deac_reru).
first(n_aux,t_auxstem_desu).
first(n_aux,t_auxstem_infr_spe).
first(n_aux,t_auxstem_intn_u).
first(n_aux,t_auxstem_intn_you).
first(n_aux,t_auxstem_masu).
first(n_aux,t_auxstem_negt).
first(n_aux,t_auxstem_nikui).
first(n_aux,t_auxstem_oblg_katei).
first(n_aux,t_auxstem_oblg_mizen).
first(n_aux,t_auxstem_oblg_syusi).
first(n_aux,t_auxstem_rashii).
first(n_aux,t_auxstem_sahen_1).
first(n_aux,t_auxstem_sahen_5_k).
first(n_aux,t_auxstem_sahen_5_r).
first(n_aux,t_auxstem_sahen_5_s).
first(n_aux,t_auxstem_sahen_5_w).
first(n_aux,t_auxstem_te_1).
first(n_aux,t_auxstem_te_5_k).
first(n_aux,t_auxstem_te_5_r).
first(n_aux,t_auxstem_te_5_s).
first(n_aux,t_auxstem_te_5_w).
first(n_aux,t_auxstem_te_adj).
first(n_aux,t_auxstem_te_kahen_katei).
first(n_aux,t_auxstem_te_kahen_mizen).
first(n_aux,t_auxstem_te_kahen_rentai).
first(n_aux,t_auxstem_te_kahen_renyo).
first(n_aux,t_auxstem_te_kahen_syusi).
first(n_aux,t_auxstem_te_kdo).
first(n_aux,t_auxstem_te_masu).
first(n_aux,t_auxstem_wish).
first(n_aux,t_auxstem_yasui).
first(n_aux_katei,t_aux_nara).
first(n_aux_katei,t_aux_past_katei).
first(n_auxstem,t_auxstem_copula_5_r).
first(n_auxstem,t_auxstem_copula_masu).
first(n_auxstem,t_auxstem_de_1).
first(n_auxstem,t_auxstem_de_5_k).
first(n_auxstem,t_auxstem_de_5_r).
first(n_auxstem,t_auxstem_de_5_w).
first(n_auxstem,t_auxstem_de_adj).
first(n_auxstem,t_auxstem_de_kahen_renyo).
first(n_auxstem,t_auxstem_de_masu).
first(n_auxstem,t_auxstem_desu).
first(n_auxstem,t_auxstem_infr_spe).
first(n_auxstem,t_auxstem_intn_u).
first(n_auxstem,t_auxstem_intn_you).
first(n_auxstem,t_auxstem_masu).
first(n_auxstem,t_auxstem_negt).
first(n_auxstem,t_auxstem_oblg_katei).
first(n_auxstem,t_auxstem_oblg_mizen).
first(n_auxstem,t_auxstem_oblg_syusi).
first(n_auxstem,t_auxstem_sahen_1).
first(n_auxstem,t_auxstem_sahen_5_k).
first(n_auxstem,t_auxstem_sahen_5_r).
first(n_auxstem,t_auxstem_sahen_5_s).
first(n_auxstem,t_auxstem_sahen_5_w).
first(n_auxstem,t_auxstem_te_1).
first(n_auxstem,t_auxstem_te_5_k).
first(n_auxstem,t_auxstem_te_5_r).
first(n_auxstem,t_auxstem_te_5_s).
first(n_auxstem,t_auxstem_te_5_w).
first(n_auxstem,t_auxstem_te_adj).
first(n_auxstem,t_auxstem_te_kahen_katei).
first(n_auxstem,t_auxstem_te_kahen_mizen).
first(n_auxstem,t_auxstem_te_kahen_rentai).
first(n_auxstem,t_auxstem_te_kahen_renyo).
first(n_auxstem,t_auxstem_te_kahen_syusi).
first(n_auxstem,t_auxstem_te_kdo).
first(n_auxstem,t_auxstem_te_masu).
first(n_auxstem,t_auxstem_wish).
first(n_auxstem_caus,t_auxstem_caus_saseru).
first(n_auxstem_caus,t_auxstem_caus_seru).
first(n_auxstem_deac,t_auxstem_deac_rareru).
first(n_auxstem_deac,t_auxstem_deac_reru).
first(n_auxv,t_auxvstem_renyo_1).
first(n_auxv,t_auxvstem_renyo_5_s).
first(n_auxvstem,t_auxvstem_renyo_1).
first(n_auxvstem,t_auxvstem_renyo_5_s).
first(n_cl,n_capacity).
first(n_cl,n_n_name_jap_honor).
first(n_cl,n_n_name_others_honor).
first(n_cl,n_visitor_name).
first(n_cl,t_adj_meisi).
first(n_cl,t_adj_renyo_2FH_ga).
first(n_cl,t_adj_renyo_2FH_ga_de).
first(n_cl,t_adjstem_2FH_ga).
first(n_cl,t_adjstem_2FH_ga_de).
first(n_cl,t_adjstem_spe_2FH_ga_de).
first(n_cl,t_bun_hukusi).
first(n_cl,t_conj).
first(n_cl,t_daimeisi).
first(n_cl,t_daimeisi_domo).
first(n_cl,t_daimeisi_exp).
first(n_cl,t_hukusi).
first(n_cl,t_hukusi_desu).
first(n_cl,t_hutu_meisi).
first(n_cl,t_hutu_meisi_post).
first(n_cl,t_interj_hesit).
first(n_cl,t_interj_post).
first(n_cl,t_interj_pre).
first(n_cl,t_kahen_dousi_katei_2FH_ga_ni).
first(n_cl,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_cl,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_cl,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_cl,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_cl,t_kdo_2FH_ga).
first(n_cl,t_kdo_2FH_ga_de).
first(n_cl,t_kdo_2FH_ga_to).
first(n_cl,t_koyuu_meisi).
first(n_cl,t_meisi_hi).
first(n_cl,t_meisi_hun).
first(n_cl,t_meisi_tsuki).
first(n_cl,t_meisi_youbi).
first(n_cl,t_meisi_zi).
first(n_cl,t_myoji_first).
first(n_cl,t_myoji_last).
first(n_cl,t_n_keisiki).
first(n_cl,t_namae_first).
first(n_cl,t_namae_last).
first(n_cl,t_num_bouyomi).
first(n_cl,t_num_byaku).
first(n_cl,t_num_byaq).
first(n_cl,t_num_go).
first(n_cl,t_num_hachi).
first(n_cl,t_num_haq).
first(n_cl,t_num_hito).
first(n_cl,t_num_huta).
first(n_cl,t_num_hutsu).
first(n_cl,t_num_hyaku).
first(n_cl,t_num_hyaq).
first(n_cl,t_num_ichi).
first(n_cl,t_num_iq).
first(n_cl,t_num_itsu).
first(n_cl,t_num_kokono).
first(n_cl,t_num_ku).
first(n_cl,t_num_kyuu).
first(n_cl,t_num_miq).
first(n_cl,t_num_mui).
first(n_cl,t_num_muq).
first(n_cl,t_num_nana).
first(n_cl,t_num_nano).
first(n_cl,t_num_ni).
first(n_cl,t_num_one).
first(n_cl,t_num_pyaku).
first(n_cl,t_num_pyaq).
first(n_cl,t_num_roku).
first(n_cl,t_num_roq).
first(n_cl,t_num_san).
first(n_cl,t_num_sen).
first(n_cl,t_num_shi).
first(n_cl,t_num_shichi).
first(n_cl,t_num_ten).
first(n_cl,t_num_tou).
first(n_cl,t_num_yaq).
first(n_cl,t_num_yo).
first(n_cl,t_num_yon).
first(n_cl,t_num_yoq).
first(n_cl,t_num_you).
first(n_cl,t_num_zen).
first(n_cl,t_num_zyuq).
first(n_cl,t_num_zyuu).
first(n_cl,t_prefix_go).
first(n_cl,t_prefix_hutu_hutu).
first(n_cl,t_prefix_o).
first(n_cl,t_prefix_quant_quant).
first(n_cl,t_rentai).
first(n_cl,t_sahen_dousi_katei_2FH_ga_ni).
first(n_cl,t_sahen_dousi_katei_2FH_ga_o).
first(n_cl,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_cl,t_sahen_dousi_mizen_2FH_ga_o).
first(n_cl,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_cl,t_sahen_dousi_rentai_2FH_ga_o).
first(n_cl,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_cl,t_sahen_dousi_renyo_2FH_ga_o).
first(n_cl,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_cl,t_sahen_dousi_syusi_2FH_ga_o).
first(n_cl,t_sahen_meisi_2FH_ga).
first(n_cl,t_sahen_meisi_2FH_ga_ni).
first(n_cl,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_cl,t_sahen_meisi_2FH_ga_ni_o).
first(n_cl,t_sahen_meisi_2FH_ga_o).
first(n_cl,t_sahen_meisi_2FH_ga_to).
first(n_cl,t_sahen_meisi_pol_2FH_ga).
first(n_cl,t_sahen_meisi_pol_2FH_ga_ni).
first(n_cl,t_sahen_meisi_pol_2FH_ga_o).
first(n_cl,t_sahen_meisi_pol_2FH_ga_to).
first(n_cl,t_suuryousi).
first(n_cl,t_teido_hukusi).
first(n_cl,t_tsuzuri).
first(n_cl,t_vstem_1_2FH_ga).
first(n_cl,t_vstem_1_2FH_ga_de).
first(n_cl,t_vstem_1_2FH_ga_ni).
first(n_cl,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_cl,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_cl,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_cl,t_vstem_1_2FH_ga_ni_o).
first(n_cl,t_vstem_1_2FH_ga_o).
first(n_cl,t_vstem_1_2FH_ga_quote).
first(n_cl,t_vstem_1_2FH_ga_to).
first(n_cl,t_vstem_5_b_2FH_ga).
first(n_cl,t_vstem_5_b_2FH_ga_ni).
first(n_cl,t_vstem_5_b_2FH_ga_ni_o).
first(n_cl,t_vstem_5_b_2FH_ga_o).
first(n_cl,t_vstem_5_b_2FH_ga_to).
first(n_cl,t_vstem_5_g_2FH_ga).
first(n_cl,t_vstem_5_g_2FH_ga_ni).
first(n_cl,t_vstem_5_g_2FH_ga_ni_o).
first(n_cl,t_vstem_5_g_2FH_ga_o).
first(n_cl,t_vstem_5_k_2FH_ga).
first(n_cl,t_vstem_5_k_2FH_ga_ni).
first(n_cl,t_vstem_5_k_2FH_ga_ni_o).
first(n_cl,t_vstem_5_k_2FH_ga_o).
first(n_cl,t_vstem_5_k_2FH_ga_to).
first(n_cl,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_cl,t_vstem_5_m_2FH_ga).
first(n_cl,t_vstem_5_m_2FH_ga_ni).
first(n_cl,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_cl,t_vstem_5_m_2FH_ga_ni_o).
first(n_cl,t_vstem_5_m_2FH_ga_o).
first(n_cl,t_vstem_5_m_2FH_ga_to).
first(n_cl,t_vstem_5_r_2FH_ga).
first(n_cl,t_vstem_5_r_2FH_ga_ni).
first(n_cl,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_cl,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_cl,t_vstem_5_r_2FH_ga_ni_o).
first(n_cl,t_vstem_5_r_2FH_ga_o).
first(n_cl,t_vstem_5_r_2FH_ga_to).
first(n_cl,t_vstem_5_r_i_2FH_ga).
first(n_cl,t_vstem_5_r_i_2FH_ga_o).
first(n_cl,t_vstem_5_r_i_2FH_ga_quote).
first(n_cl,t_vstem_5_s_2FH_ga).
first(n_cl,t_vstem_5_s_2FH_ga_ni).
first(n_cl,t_vstem_5_s_2FH_ga_ni_o).
first(n_cl,t_vstem_5_s_2FH_ga_o).
first(n_cl,t_vstem_5_s_2FH_ga_quote).
first(n_cl,t_vstem_5_s_2FH_ga_to).
first(n_cl,t_vstem_5_t_2FH_ga).
first(n_cl,t_vstem_5_t_2FH_ga_ni).
first(n_cl,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_cl,t_vstem_5_t_2FH_ga_ni_o).
first(n_cl,t_vstem_5_t_2FH_ga_o).
first(n_cl,t_vstem_5_t_2FH_ga_to).
first(n_cl,t_vstem_5_w_2FH_ga).
first(n_cl,t_vstem_5_w_2FH_ga_de).
first(n_cl,t_vstem_5_w_2FH_ga_ni).
first(n_cl,t_vstem_5_w_2FH_ga_ni_o).
first(n_cl,t_vstem_5_w_2FH_ga_o).
first(n_cl,t_vstem_5_w_2FH_ga_quote).
first(n_cl,t_vstem_5_w_2FH_ga_to).
first(n_cl,t_vstem_masu_2FH_ga).
first(n_cl,t_vstem_sahen_2FH_ga_ni).
first(n_cl,t_wh_daimeisi).
first(n_cl,t_wh_daimeisi_nan).
first(n_cl,t_wh_hukusi).
first(n_cl,t_zikan_meisi).
first(n_cl,t_zikan_meisi_ippai).
first(n_cl,t_zikantai).
first(n_cl_ex,n_capacity).
first(n_cl_ex,n_visitor_name).
first(n_cl_ex,t_adj_meisi).
first(n_cl_ex,t_adj_renyo_2FH_ga).
first(n_cl_ex,t_adj_renyo_2FH_ga_de).
first(n_cl_ex,t_adjstem_2FH_ga).
first(n_cl_ex,t_adjstem_2FH_ga_de).
first(n_cl_ex,t_adjstem_spe_2FH_ga_de).
first(n_cl_ex,t_daimeisi).
first(n_cl_ex,t_daimeisi_domo).
first(n_cl_ex,t_daimeisi_exp).
first(n_cl_ex,t_hukusi).
first(n_cl_ex,t_hukusi_desu).
first(n_cl_ex,t_hutu_meisi).
first(n_cl_ex,t_hutu_meisi_post).
first(n_cl_ex,t_interj_hesit).
first(n_cl_ex,t_interj_post).
first(n_cl_ex,t_interj_pre).
first(n_cl_ex,t_kahen_dousi_katei_2FH_ga_ni).
first(n_cl_ex,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_cl_ex,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_cl_ex,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_cl_ex,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_cl_ex,t_kdo_2FH_ga).
first(n_cl_ex,t_kdo_2FH_ga_de).
first(n_cl_ex,t_kdo_2FH_ga_to).
first(n_cl_ex,t_koyuu_meisi).
first(n_cl_ex,t_meisi_hi).
first(n_cl_ex,t_meisi_hun).
first(n_cl_ex,t_meisi_tsuki).
first(n_cl_ex,t_meisi_youbi).
first(n_cl_ex,t_meisi_zi).
first(n_cl_ex,t_myoji_first).
first(n_cl_ex,t_myoji_last).
first(n_cl_ex,t_n_keisiki).
first(n_cl_ex,t_namae_first).
first(n_cl_ex,t_namae_last).
first(n_cl_ex,t_num_bouyomi).
first(n_cl_ex,t_num_byaku).
first(n_cl_ex,t_num_byaq).
first(n_cl_ex,t_num_go).
first(n_cl_ex,t_num_hachi).
first(n_cl_ex,t_num_haq).
first(n_cl_ex,t_num_hito).
first(n_cl_ex,t_num_huta).
first(n_cl_ex,t_num_hutsu).
first(n_cl_ex,t_num_hyaku).
first(n_cl_ex,t_num_hyaq).
first(n_cl_ex,t_num_ichi).
first(n_cl_ex,t_num_iq).
first(n_cl_ex,t_num_itsu).
first(n_cl_ex,t_num_kokono).
first(n_cl_ex,t_num_ku).
first(n_cl_ex,t_num_kyuu).
first(n_cl_ex,t_num_miq).
first(n_cl_ex,t_num_mui).
first(n_cl_ex,t_num_muq).
first(n_cl_ex,t_num_nana).
first(n_cl_ex,t_num_nano).
first(n_cl_ex,t_num_ni).
first(n_cl_ex,t_num_one).
first(n_cl_ex,t_num_pyaku).
first(n_cl_ex,t_num_pyaq).
first(n_cl_ex,t_num_roku).
first(n_cl_ex,t_num_roq).
first(n_cl_ex,t_num_san).
first(n_cl_ex,t_num_sen).
first(n_cl_ex,t_num_shi).
first(n_cl_ex,t_num_shichi).
first(n_cl_ex,t_num_ten).
first(n_cl_ex,t_num_tou).
first(n_cl_ex,t_num_yaq).
first(n_cl_ex,t_num_yo).
first(n_cl_ex,t_num_yon).
first(n_cl_ex,t_num_yoq).
first(n_cl_ex,t_num_you).
first(n_cl_ex,t_num_zen).
first(n_cl_ex,t_num_zyuq).
first(n_cl_ex,t_num_zyuu).
first(n_cl_ex,t_prefix_go).
first(n_cl_ex,t_prefix_hutu_hutu).
first(n_cl_ex,t_prefix_o).
first(n_cl_ex,t_prefix_quant_quant).
first(n_cl_ex,t_rentai).
first(n_cl_ex,t_sahen_dousi_katei_2FH_ga_ni).
first(n_cl_ex,t_sahen_dousi_katei_2FH_ga_o).
first(n_cl_ex,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_cl_ex,t_sahen_dousi_mizen_2FH_ga_o).
first(n_cl_ex,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_cl_ex,t_sahen_dousi_rentai_2FH_ga_o).
first(n_cl_ex,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_cl_ex,t_sahen_dousi_renyo_2FH_ga_o).
first(n_cl_ex,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_cl_ex,t_sahen_dousi_syusi_2FH_ga_o).
first(n_cl_ex,t_sahen_meisi_2FH_ga).
first(n_cl_ex,t_sahen_meisi_2FH_ga_ni).
first(n_cl_ex,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_cl_ex,t_sahen_meisi_2FH_ga_ni_o).
first(n_cl_ex,t_sahen_meisi_2FH_ga_o).
first(n_cl_ex,t_sahen_meisi_2FH_ga_to).
first(n_cl_ex,t_sahen_meisi_pol_2FH_ga).
first(n_cl_ex,t_sahen_meisi_pol_2FH_ga_ni).
first(n_cl_ex,t_sahen_meisi_pol_2FH_ga_o).
first(n_cl_ex,t_sahen_meisi_pol_2FH_ga_to).
first(n_cl_ex,t_suuryousi).
first(n_cl_ex,t_teido_hukusi).
first(n_cl_ex,t_tsuzuri).
first(n_cl_ex,t_vstem_1_2FH_ga).
first(n_cl_ex,t_vstem_1_2FH_ga_de).
first(n_cl_ex,t_vstem_1_2FH_ga_ni).
first(n_cl_ex,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_cl_ex,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_cl_ex,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_cl_ex,t_vstem_1_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_1_2FH_ga_o).
first(n_cl_ex,t_vstem_1_2FH_ga_quote).
first(n_cl_ex,t_vstem_1_2FH_ga_to).
first(n_cl_ex,t_vstem_5_b_2FH_ga).
first(n_cl_ex,t_vstem_5_b_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_b_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_b_2FH_ga_o).
first(n_cl_ex,t_vstem_5_b_2FH_ga_to).
first(n_cl_ex,t_vstem_5_g_2FH_ga).
first(n_cl_ex,t_vstem_5_g_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_g_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_g_2FH_ga_o).
first(n_cl_ex,t_vstem_5_k_2FH_ga).
first(n_cl_ex,t_vstem_5_k_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_k_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_k_2FH_ga_o).
first(n_cl_ex,t_vstem_5_k_2FH_ga_to).
first(n_cl_ex,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_cl_ex,t_vstem_5_m_2FH_ga).
first(n_cl_ex,t_vstem_5_m_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_cl_ex,t_vstem_5_m_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_m_2FH_ga_o).
first(n_cl_ex,t_vstem_5_m_2FH_ga_to).
first(n_cl_ex,t_vstem_5_r_2FH_ga).
first(n_cl_ex,t_vstem_5_r_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_cl_ex,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_cl_ex,t_vstem_5_r_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_r_2FH_ga_o).
first(n_cl_ex,t_vstem_5_r_2FH_ga_to).
first(n_cl_ex,t_vstem_5_r_i_2FH_ga).
first(n_cl_ex,t_vstem_5_r_i_2FH_ga_o).
first(n_cl_ex,t_vstem_5_r_i_2FH_ga_quote).
first(n_cl_ex,t_vstem_5_s_2FH_ga).
first(n_cl_ex,t_vstem_5_s_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_s_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_s_2FH_ga_o).
first(n_cl_ex,t_vstem_5_s_2FH_ga_quote).
first(n_cl_ex,t_vstem_5_s_2FH_ga_to).
first(n_cl_ex,t_vstem_5_t_2FH_ga).
first(n_cl_ex,t_vstem_5_t_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_cl_ex,t_vstem_5_t_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_t_2FH_ga_o).
first(n_cl_ex,t_vstem_5_t_2FH_ga_to).
first(n_cl_ex,t_vstem_5_w_2FH_ga).
first(n_cl_ex,t_vstem_5_w_2FH_ga_de).
first(n_cl_ex,t_vstem_5_w_2FH_ga_ni).
first(n_cl_ex,t_vstem_5_w_2FH_ga_ni_o).
first(n_cl_ex,t_vstem_5_w_2FH_ga_o).
first(n_cl_ex,t_vstem_5_w_2FH_ga_quote).
first(n_cl_ex,t_vstem_5_w_2FH_ga_to).
first(n_cl_ex,t_vstem_masu_2FH_ga).
first(n_cl_ex,t_vstem_sahen_2FH_ga_ni).
first(n_cl_ex,t_wh_daimeisi).
first(n_cl_ex,t_wh_daimeisi_nan).
first(n_cl_ex,t_wh_hukusi).
first(n_cl_ex,t_zikan_meisi).
first(n_cl_ex,t_zikan_meisi_ippai).
first(n_cl_ex,t_zikantai).
first(n_infl,t_infl_1_re).
first(n_infl,t_infl_1_ro).
first(n_infl,t_infl_1_ru).
first(n_infl,t_infl_1_yo).
first(n_infl,t_infl_5_ba).
first(n_infl,t_infl_5_be).
first(n_infl,t_infl_5_bi).
first(n_infl,t_infl_5_bo).
first(n_infl,t_infl_5_bu).
first(n_infl,t_infl_5_ga).
first(n_infl,t_infl_5_ge).
first(n_infl,t_infl_5_gi).
first(n_infl,t_infl_5_go).
first(n_infl,t_infl_5_gu).
first(n_infl,t_infl_5_i).
first(n_infl,t_infl_5_ka).
first(n_infl,t_infl_5_ke).
first(n_infl,t_infl_5_ki).
first(n_infl,t_infl_5_ko).
first(n_infl,t_infl_5_ku).
first(n_infl,t_infl_5_ma).
first(n_infl,t_infl_5_me).
first(n_infl,t_infl_5_mi).
first(n_infl,t_infl_5_mo).
first(n_infl,t_infl_5_mu).
first(n_infl,t_infl_5_n).
first(n_infl,t_infl_5_na).
first(n_infl,t_infl_5_ne).
first(n_infl,t_infl_5_ni).
first(n_infl,t_infl_5_no).
first(n_infl,t_infl_5_nu).
first(n_infl,t_infl_5_q).
first(n_infl,t_infl_5_ra).
first(n_infl,t_infl_5_re).
first(n_infl,t_infl_5_ri).
first(n_infl,t_infl_5_ro).
first(n_infl,t_infl_5_ru).
first(n_infl,t_infl_5_sa).
first(n_infl,t_infl_5_se).
first(n_infl,t_infl_5_shi).
first(n_infl,t_infl_5_so).
first(n_infl,t_infl_5_su).
first(n_infl,t_infl_5_ta).
first(n_infl,t_infl_5_te).
first(n_infl,t_infl_5_ti).
first(n_infl,t_infl_5_to).
first(n_infl,t_infl_5_tu).
first(n_infl,t_infl_5_wa).
first(n_infl,t_infl_5_we).
first(n_infl,t_infl_5_wi).
first(n_infl,t_infl_5_wo).
first(n_infl,t_infl_5_wu).
first(n_infl,t_infl_adj_i).
first(n_infl,t_infl_adj_kaq).
first(n_infl,t_infl_adj_karo).
first(n_infl,t_infl_adj_kere).
first(n_infl,t_infl_adj_ku).
first(n_infl,t_infl_adj_kya).
first(n_infl,t_infl_adj_u).
first(n_infl,t_infl_caus_re).
first(n_infl,t_infl_caus_ru).
first(n_infl,t_infl_deac_re).
first(n_infl,t_infl_deac_ru).
first(n_infl,t_infl_sahen_shi).
first(n_infl,t_infl_sahen_sure).
first(n_infl,t_infl_sahen_suru).
first(n_infl,t_infl_spe_i).
first(n_infl,t_infl_spe_q).
first(n_infl,t_infl_spe_re).
first(n_infl,t_infl_spe_ru).
first(n_infl,t_infl_spe_se).
first(n_infl,t_infl_spe_shi).
first(n_infl,t_infl_spe_sho).
first(n_infl,t_infl_spe_su).
first(n_interj,n_capacity).
first(n_interj,n_visitor_name).
first(n_interj,t_adj_meisi).
first(n_interj,t_adj_renyo_2FH_ga).
first(n_interj,t_adj_renyo_2FH_ga_de).
first(n_interj,t_adjstem_2FH_ga).
first(n_interj,t_adjstem_2FH_ga_de).
first(n_interj,t_adjstem_spe_2FH_ga_de).
first(n_interj,t_daimeisi).
first(n_interj,t_daimeisi_domo).
first(n_interj,t_daimeisi_exp).
first(n_interj,t_hukusi).
first(n_interj,t_hukusi_desu).
first(n_interj,t_hutu_meisi).
first(n_interj,t_hutu_meisi_post).
first(n_interj,t_interj_hesit).
first(n_interj,t_interj_post).
first(n_interj,t_interj_pre).
first(n_interj,t_kahen_dousi_katei_2FH_ga_ni).
first(n_interj,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_interj,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_interj,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_interj,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_interj,t_kdo_2FH_ga).
first(n_interj,t_kdo_2FH_ga_de).
first(n_interj,t_kdo_2FH_ga_to).
first(n_interj,t_koyuu_meisi).
first(n_interj,t_meisi_hi).
first(n_interj,t_meisi_hun).
first(n_interj,t_meisi_tsuki).
first(n_interj,t_meisi_youbi).
first(n_interj,t_meisi_zi).
first(n_interj,t_myoji_first).
first(n_interj,t_myoji_last).
first(n_interj,t_n_keisiki).
first(n_interj,t_namae_first).
first(n_interj,t_namae_last).
first(n_interj,t_num_bouyomi).
first(n_interj,t_num_byaku).
first(n_interj,t_num_byaq).
first(n_interj,t_num_go).
first(n_interj,t_num_hachi).
first(n_interj,t_num_haq).
first(n_interj,t_num_hito).
first(n_interj,t_num_huta).
first(n_interj,t_num_hutsu).
first(n_interj,t_num_hyaku).
first(n_interj,t_num_hyaq).
first(n_interj,t_num_ichi).
first(n_interj,t_num_iq).
first(n_interj,t_num_itsu).
first(n_interj,t_num_kokono).
first(n_interj,t_num_ku).
first(n_interj,t_num_kyuu).
first(n_interj,t_num_miq).
first(n_interj,t_num_mui).
first(n_interj,t_num_muq).
first(n_interj,t_num_nana).
first(n_interj,t_num_nano).
first(n_interj,t_num_ni).
first(n_interj,t_num_one).
first(n_interj,t_num_pyaku).
first(n_interj,t_num_pyaq).
first(n_interj,t_num_roku).
first(n_interj,t_num_roq).
first(n_interj,t_num_san).
first(n_interj,t_num_sen).
first(n_interj,t_num_shi).
first(n_interj,t_num_shichi).
first(n_interj,t_num_ten).
first(n_interj,t_num_tou).
first(n_interj,t_num_yaq).
first(n_interj,t_num_yo).
first(n_interj,t_num_yon).
first(n_interj,t_num_yoq).
first(n_interj,t_num_you).
first(n_interj,t_num_zen).
first(n_interj,t_num_zyuq).
first(n_interj,t_num_zyuu).
first(n_interj,t_prefix_go).
first(n_interj,t_prefix_hutu_hutu).
first(n_interj,t_prefix_o).
first(n_interj,t_prefix_quant_quant).
first(n_interj,t_rentai).
first(n_interj,t_sahen_dousi_katei_2FH_ga_ni).
first(n_interj,t_sahen_dousi_katei_2FH_ga_o).
first(n_interj,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_interj,t_sahen_dousi_mizen_2FH_ga_o).
first(n_interj,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_interj,t_sahen_dousi_rentai_2FH_ga_o).
first(n_interj,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_interj,t_sahen_dousi_renyo_2FH_ga_o).
first(n_interj,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_interj,t_sahen_dousi_syusi_2FH_ga_o).
first(n_interj,t_sahen_meisi_2FH_ga).
first(n_interj,t_sahen_meisi_2FH_ga_ni).
first(n_interj,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_interj,t_sahen_meisi_2FH_ga_ni_o).
first(n_interj,t_sahen_meisi_2FH_ga_o).
first(n_interj,t_sahen_meisi_2FH_ga_to).
first(n_interj,t_sahen_meisi_pol_2FH_ga).
first(n_interj,t_sahen_meisi_pol_2FH_ga_ni).
first(n_interj,t_sahen_meisi_pol_2FH_ga_o).
first(n_interj,t_sahen_meisi_pol_2FH_ga_to).
first(n_interj,t_suuryousi).
first(n_interj,t_teido_hukusi).
first(n_interj,t_tsuzuri).
first(n_interj,t_vstem_1_2FH_ga).
first(n_interj,t_vstem_1_2FH_ga_de).
first(n_interj,t_vstem_1_2FH_ga_ni).
first(n_interj,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_interj,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_interj,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_interj,t_vstem_1_2FH_ga_ni_o).
first(n_interj,t_vstem_1_2FH_ga_o).
first(n_interj,t_vstem_1_2FH_ga_quote).
first(n_interj,t_vstem_1_2FH_ga_to).
first(n_interj,t_vstem_5_b_2FH_ga).
first(n_interj,t_vstem_5_b_2FH_ga_ni).
first(n_interj,t_vstem_5_b_2FH_ga_ni_o).
first(n_interj,t_vstem_5_b_2FH_ga_o).
first(n_interj,t_vstem_5_b_2FH_ga_to).
first(n_interj,t_vstem_5_g_2FH_ga).
first(n_interj,t_vstem_5_g_2FH_ga_ni).
first(n_interj,t_vstem_5_g_2FH_ga_ni_o).
first(n_interj,t_vstem_5_g_2FH_ga_o).
first(n_interj,t_vstem_5_k_2FH_ga).
first(n_interj,t_vstem_5_k_2FH_ga_ni).
first(n_interj,t_vstem_5_k_2FH_ga_ni_o).
first(n_interj,t_vstem_5_k_2FH_ga_o).
first(n_interj,t_vstem_5_k_2FH_ga_to).
first(n_interj,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_interj,t_vstem_5_m_2FH_ga).
first(n_interj,t_vstem_5_m_2FH_ga_ni).
first(n_interj,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_interj,t_vstem_5_m_2FH_ga_ni_o).
first(n_interj,t_vstem_5_m_2FH_ga_o).
first(n_interj,t_vstem_5_m_2FH_ga_to).
first(n_interj,t_vstem_5_r_2FH_ga).
first(n_interj,t_vstem_5_r_2FH_ga_ni).
first(n_interj,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_interj,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_interj,t_vstem_5_r_2FH_ga_ni_o).
first(n_interj,t_vstem_5_r_2FH_ga_o).
first(n_interj,t_vstem_5_r_2FH_ga_to).
first(n_interj,t_vstem_5_r_i_2FH_ga).
first(n_interj,t_vstem_5_r_i_2FH_ga_o).
first(n_interj,t_vstem_5_r_i_2FH_ga_quote).
first(n_interj,t_vstem_5_s_2FH_ga).
first(n_interj,t_vstem_5_s_2FH_ga_ni).
first(n_interj,t_vstem_5_s_2FH_ga_ni_o).
first(n_interj,t_vstem_5_s_2FH_ga_o).
first(n_interj,t_vstem_5_s_2FH_ga_quote).
first(n_interj,t_vstem_5_s_2FH_ga_to).
first(n_interj,t_vstem_5_t_2FH_ga).
first(n_interj,t_vstem_5_t_2FH_ga_ni).
first(n_interj,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_interj,t_vstem_5_t_2FH_ga_ni_o).
first(n_interj,t_vstem_5_t_2FH_ga_o).
first(n_interj,t_vstem_5_t_2FH_ga_to).
first(n_interj,t_vstem_5_w_2FH_ga).
first(n_interj,t_vstem_5_w_2FH_ga_de).
first(n_interj,t_vstem_5_w_2FH_ga_ni).
first(n_interj,t_vstem_5_w_2FH_ga_ni_o).
first(n_interj,t_vstem_5_w_2FH_ga_o).
first(n_interj,t_vstem_5_w_2FH_ga_quote).
first(n_interj,t_vstem_5_w_2FH_ga_to).
first(n_interj,t_vstem_masu_2FH_ga).
first(n_interj,t_vstem_sahen_2FH_ga_ni).
first(n_interj,t_wh_daimeisi).
first(n_interj,t_wh_daimeisi_nan).
first(n_interj,t_wh_hukusi).
first(n_interj,t_zikan_meisi).
first(n_interj,t_zikan_meisi_ippai).
first(n_interj,t_zikantai).
first(n_kajo,n_capacity).
first(n_kajo,n_visitor_name).
first(n_kajo,t_adj_meisi).
first(n_kajo,t_adj_renyo_2FH_ga).
first(n_kajo,t_adj_renyo_2FH_ga_de).
first(n_kajo,t_adjstem_2FH_ga).
first(n_kajo,t_adjstem_2FH_ga_de).
first(n_kajo,t_adjstem_spe_2FH_ga_de).
first(n_kajo,t_daimeisi).
first(n_kajo,t_daimeisi_domo).
first(n_kajo,t_daimeisi_exp).
first(n_kajo,t_hukusi).
first(n_kajo,t_hukusi_desu).
first(n_kajo,t_hutu_meisi).
first(n_kajo,t_hutu_meisi_post).
first(n_kajo,t_kahen_dousi_katei_2FH_ga_ni).
first(n_kajo,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_kajo,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_kajo,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_kajo,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_kajo,t_kdo_2FH_ga).
first(n_kajo,t_kdo_2FH_ga_de).
first(n_kajo,t_kdo_2FH_ga_to).
first(n_kajo,t_koyuu_meisi).
first(n_kajo,t_meisi_hi).
first(n_kajo,t_meisi_hun).
first(n_kajo,t_meisi_tsuki).
first(n_kajo,t_meisi_youbi).
first(n_kajo,t_meisi_zi).
first(n_kajo,t_myoji_first).
first(n_kajo,t_myoji_last).
first(n_kajo,t_n_keisiki).
first(n_kajo,t_namae_first).
first(n_kajo,t_namae_last).
first(n_kajo,t_num_bouyomi).
first(n_kajo,t_num_byaku).
first(n_kajo,t_num_byaq).
first(n_kajo,t_num_go).
first(n_kajo,t_num_hachi).
first(n_kajo,t_num_haq).
first(n_kajo,t_num_hito).
first(n_kajo,t_num_huta).
first(n_kajo,t_num_hutsu).
first(n_kajo,t_num_hyaku).
first(n_kajo,t_num_hyaq).
first(n_kajo,t_num_ichi).
first(n_kajo,t_num_iq).
first(n_kajo,t_num_itsu).
first(n_kajo,t_num_kokono).
first(n_kajo,t_num_ku).
first(n_kajo,t_num_kyuu).
first(n_kajo,t_num_miq).
first(n_kajo,t_num_mui).
first(n_kajo,t_num_muq).
first(n_kajo,t_num_nana).
first(n_kajo,t_num_nano).
first(n_kajo,t_num_ni).
first(n_kajo,t_num_one).
first(n_kajo,t_num_pyaku).
first(n_kajo,t_num_pyaq).
first(n_kajo,t_num_roku).
first(n_kajo,t_num_roq).
first(n_kajo,t_num_san).
first(n_kajo,t_num_sen).
first(n_kajo,t_num_shi).
first(n_kajo,t_num_shichi).
first(n_kajo,t_num_ten).
first(n_kajo,t_num_tou).
first(n_kajo,t_num_yaq).
first(n_kajo,t_num_yo).
first(n_kajo,t_num_yon).
first(n_kajo,t_num_yoq).
first(n_kajo,t_num_you).
first(n_kajo,t_num_zen).
first(n_kajo,t_num_zyuq).
first(n_kajo,t_num_zyuu).
first(n_kajo,t_prefix_go).
first(n_kajo,t_prefix_hutu_hutu).
first(n_kajo,t_prefix_o).
first(n_kajo,t_prefix_quant_quant).
first(n_kajo,t_rentai).
first(n_kajo,t_sahen_dousi_katei_2FH_ga_ni).
first(n_kajo,t_sahen_dousi_katei_2FH_ga_o).
first(n_kajo,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_kajo,t_sahen_dousi_mizen_2FH_ga_o).
first(n_kajo,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_kajo,t_sahen_dousi_rentai_2FH_ga_o).
first(n_kajo,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_kajo,t_sahen_dousi_renyo_2FH_ga_o).
first(n_kajo,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_kajo,t_sahen_dousi_syusi_2FH_ga_o).
first(n_kajo,t_sahen_meisi_2FH_ga).
first(n_kajo,t_sahen_meisi_2FH_ga_ni).
first(n_kajo,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_kajo,t_sahen_meisi_2FH_ga_ni_o).
first(n_kajo,t_sahen_meisi_2FH_ga_o).
first(n_kajo,t_sahen_meisi_2FH_ga_to).
first(n_kajo,t_sahen_meisi_pol_2FH_ga).
first(n_kajo,t_sahen_meisi_pol_2FH_ga_ni).
first(n_kajo,t_sahen_meisi_pol_2FH_ga_o).
first(n_kajo,t_sahen_meisi_pol_2FH_ga_to).
first(n_kajo,t_suuryousi).
first(n_kajo,t_teido_hukusi).
first(n_kajo,t_tsuzuri).
first(n_kajo,t_vstem_1_2FH_ga).
first(n_kajo,t_vstem_1_2FH_ga_de).
first(n_kajo,t_vstem_1_2FH_ga_ni).
first(n_kajo,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_kajo,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_kajo,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_kajo,t_vstem_1_2FH_ga_ni_o).
first(n_kajo,t_vstem_1_2FH_ga_o).
first(n_kajo,t_vstem_1_2FH_ga_quote).
first(n_kajo,t_vstem_1_2FH_ga_to).
first(n_kajo,t_vstem_5_b_2FH_ga).
first(n_kajo,t_vstem_5_b_2FH_ga_ni).
first(n_kajo,t_vstem_5_b_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_b_2FH_ga_o).
first(n_kajo,t_vstem_5_b_2FH_ga_to).
first(n_kajo,t_vstem_5_g_2FH_ga).
first(n_kajo,t_vstem_5_g_2FH_ga_ni).
first(n_kajo,t_vstem_5_g_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_g_2FH_ga_o).
first(n_kajo,t_vstem_5_k_2FH_ga).
first(n_kajo,t_vstem_5_k_2FH_ga_ni).
first(n_kajo,t_vstem_5_k_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_k_2FH_ga_o).
first(n_kajo,t_vstem_5_k_2FH_ga_to).
first(n_kajo,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_kajo,t_vstem_5_m_2FH_ga).
first(n_kajo,t_vstem_5_m_2FH_ga_ni).
first(n_kajo,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_kajo,t_vstem_5_m_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_m_2FH_ga_o).
first(n_kajo,t_vstem_5_m_2FH_ga_to).
first(n_kajo,t_vstem_5_r_2FH_ga).
first(n_kajo,t_vstem_5_r_2FH_ga_ni).
first(n_kajo,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_kajo,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_kajo,t_vstem_5_r_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_r_2FH_ga_o).
first(n_kajo,t_vstem_5_r_2FH_ga_to).
first(n_kajo,t_vstem_5_r_i_2FH_ga).
first(n_kajo,t_vstem_5_r_i_2FH_ga_o).
first(n_kajo,t_vstem_5_r_i_2FH_ga_quote).
first(n_kajo,t_vstem_5_s_2FH_ga).
first(n_kajo,t_vstem_5_s_2FH_ga_ni).
first(n_kajo,t_vstem_5_s_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_s_2FH_ga_o).
first(n_kajo,t_vstem_5_s_2FH_ga_quote).
first(n_kajo,t_vstem_5_s_2FH_ga_to).
first(n_kajo,t_vstem_5_t_2FH_ga).
first(n_kajo,t_vstem_5_t_2FH_ga_ni).
first(n_kajo,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_kajo,t_vstem_5_t_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_t_2FH_ga_o).
first(n_kajo,t_vstem_5_t_2FH_ga_to).
first(n_kajo,t_vstem_5_w_2FH_ga).
first(n_kajo,t_vstem_5_w_2FH_ga_de).
first(n_kajo,t_vstem_5_w_2FH_ga_ni).
first(n_kajo,t_vstem_5_w_2FH_ga_ni_o).
first(n_kajo,t_vstem_5_w_2FH_ga_o).
first(n_kajo,t_vstem_5_w_2FH_ga_quote).
first(n_kajo,t_vstem_5_w_2FH_ga_to).
first(n_kajo,t_vstem_masu_2FH_ga).
first(n_kajo,t_vstem_sahen_2FH_ga_ni).
first(n_kajo,t_wh_daimeisi).
first(n_kajo,t_wh_daimeisi_nan).
first(n_kajo,t_wh_hukusi).
first(n_kajo,t_zikan_meisi).
first(n_kajo,t_zikan_meisi_ippai).
first(n_kajo,t_zikantai).
first(n_mod_day,t_meisi_tsuki).
first(n_mod_n,n_capacity).
first(n_mod_n,n_visitor_name).
first(n_mod_n,t_adj_meisi).
first(n_mod_n,t_adj_renyo_2FH_ga).
first(n_mod_n,t_adj_renyo_2FH_ga_de).
first(n_mod_n,t_adjstem_2FH_ga).
first(n_mod_n,t_adjstem_2FH_ga_de).
first(n_mod_n,t_adjstem_spe_2FH_ga_de).
first(n_mod_n,t_daimeisi).
first(n_mod_n,t_daimeisi_domo).
first(n_mod_n,t_daimeisi_exp).
first(n_mod_n,t_hukusi).
first(n_mod_n,t_hukusi_desu).
first(n_mod_n,t_hutu_meisi).
first(n_mod_n,t_hutu_meisi_post).
first(n_mod_n,t_kahen_dousi_katei_2FH_ga_ni).
first(n_mod_n,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_mod_n,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_mod_n,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_mod_n,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_mod_n,t_kdo_2FH_ga).
first(n_mod_n,t_kdo_2FH_ga_de).
first(n_mod_n,t_kdo_2FH_ga_to).
first(n_mod_n,t_koyuu_meisi).
first(n_mod_n,t_meisi_hi).
first(n_mod_n,t_meisi_hun).
first(n_mod_n,t_meisi_tsuki).
first(n_mod_n,t_meisi_youbi).
first(n_mod_n,t_meisi_zi).
first(n_mod_n,t_myoji_first).
first(n_mod_n,t_myoji_last).
first(n_mod_n,t_n_keisiki).
first(n_mod_n,t_namae_first).
first(n_mod_n,t_namae_last).
first(n_mod_n,t_num_bouyomi).
first(n_mod_n,t_num_byaku).
first(n_mod_n,t_num_byaq).
first(n_mod_n,t_num_go).
first(n_mod_n,t_num_hachi).
first(n_mod_n,t_num_haq).
first(n_mod_n,t_num_hito).
first(n_mod_n,t_num_huta).
first(n_mod_n,t_num_hutsu).
first(n_mod_n,t_num_hyaku).
first(n_mod_n,t_num_hyaq).
first(n_mod_n,t_num_ichi).
first(n_mod_n,t_num_iq).
first(n_mod_n,t_num_itsu).
first(n_mod_n,t_num_kokono).
first(n_mod_n,t_num_ku).
first(n_mod_n,t_num_kyuu).
first(n_mod_n,t_num_miq).
first(n_mod_n,t_num_mui).
first(n_mod_n,t_num_muq).
first(n_mod_n,t_num_nana).
first(n_mod_n,t_num_nano).
first(n_mod_n,t_num_ni).
first(n_mod_n,t_num_one).
first(n_mod_n,t_num_pyaku).
first(n_mod_n,t_num_pyaq).
first(n_mod_n,t_num_roku).
first(n_mod_n,t_num_roq).
first(n_mod_n,t_num_san).
first(n_mod_n,t_num_sen).
first(n_mod_n,t_num_shi).
first(n_mod_n,t_num_shichi).
first(n_mod_n,t_num_ten).
first(n_mod_n,t_num_tou).
first(n_mod_n,t_num_yaq).
first(n_mod_n,t_num_yo).
first(n_mod_n,t_num_yon).
first(n_mod_n,t_num_yoq).
first(n_mod_n,t_num_you).
first(n_mod_n,t_num_zen).
first(n_mod_n,t_num_zyuq).
first(n_mod_n,t_num_zyuu).
first(n_mod_n,t_prefix_go).
first(n_mod_n,t_prefix_hutu_hutu).
first(n_mod_n,t_prefix_o).
first(n_mod_n,t_prefix_quant_quant).
first(n_mod_n,t_rentai).
first(n_mod_n,t_sahen_dousi_katei_2FH_ga_ni).
first(n_mod_n,t_sahen_dousi_katei_2FH_ga_o).
first(n_mod_n,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_mod_n,t_sahen_dousi_mizen_2FH_ga_o).
first(n_mod_n,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_mod_n,t_sahen_dousi_rentai_2FH_ga_o).
first(n_mod_n,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_mod_n,t_sahen_dousi_renyo_2FH_ga_o).
first(n_mod_n,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_mod_n,t_sahen_dousi_syusi_2FH_ga_o).
first(n_mod_n,t_sahen_meisi_2FH_ga).
first(n_mod_n,t_sahen_meisi_2FH_ga_ni).
first(n_mod_n,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_mod_n,t_sahen_meisi_2FH_ga_ni_o).
first(n_mod_n,t_sahen_meisi_2FH_ga_o).
first(n_mod_n,t_sahen_meisi_2FH_ga_to).
first(n_mod_n,t_sahen_meisi_pol_2FH_ga).
first(n_mod_n,t_sahen_meisi_pol_2FH_ga_ni).
first(n_mod_n,t_sahen_meisi_pol_2FH_ga_o).
first(n_mod_n,t_sahen_meisi_pol_2FH_ga_to).
first(n_mod_n,t_suuryousi).
first(n_mod_n,t_teido_hukusi).
first(n_mod_n,t_tsuzuri).
first(n_mod_n,t_vstem_1_2FH_ga).
first(n_mod_n,t_vstem_1_2FH_ga_de).
first(n_mod_n,t_vstem_1_2FH_ga_ni).
first(n_mod_n,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_mod_n,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_mod_n,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_mod_n,t_vstem_1_2FH_ga_ni_o).
first(n_mod_n,t_vstem_1_2FH_ga_o).
first(n_mod_n,t_vstem_1_2FH_ga_quote).
first(n_mod_n,t_vstem_1_2FH_ga_to).
first(n_mod_n,t_vstem_5_b_2FH_ga).
first(n_mod_n,t_vstem_5_b_2FH_ga_ni).
first(n_mod_n,t_vstem_5_b_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_b_2FH_ga_o).
first(n_mod_n,t_vstem_5_b_2FH_ga_to).
first(n_mod_n,t_vstem_5_g_2FH_ga).
first(n_mod_n,t_vstem_5_g_2FH_ga_ni).
first(n_mod_n,t_vstem_5_g_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_g_2FH_ga_o).
first(n_mod_n,t_vstem_5_k_2FH_ga).
first(n_mod_n,t_vstem_5_k_2FH_ga_ni).
first(n_mod_n,t_vstem_5_k_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_k_2FH_ga_o).
first(n_mod_n,t_vstem_5_k_2FH_ga_to).
first(n_mod_n,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_mod_n,t_vstem_5_m_2FH_ga).
first(n_mod_n,t_vstem_5_m_2FH_ga_ni).
first(n_mod_n,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_mod_n,t_vstem_5_m_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_m_2FH_ga_o).
first(n_mod_n,t_vstem_5_m_2FH_ga_to).
first(n_mod_n,t_vstem_5_r_2FH_ga).
first(n_mod_n,t_vstem_5_r_2FH_ga_ni).
first(n_mod_n,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_mod_n,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_mod_n,t_vstem_5_r_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_r_2FH_ga_o).
first(n_mod_n,t_vstem_5_r_2FH_ga_to).
first(n_mod_n,t_vstem_5_r_i_2FH_ga).
first(n_mod_n,t_vstem_5_r_i_2FH_ga_o).
first(n_mod_n,t_vstem_5_r_i_2FH_ga_quote).
first(n_mod_n,t_vstem_5_s_2FH_ga).
first(n_mod_n,t_vstem_5_s_2FH_ga_ni).
first(n_mod_n,t_vstem_5_s_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_s_2FH_ga_o).
first(n_mod_n,t_vstem_5_s_2FH_ga_quote).
first(n_mod_n,t_vstem_5_s_2FH_ga_to).
first(n_mod_n,t_vstem_5_t_2FH_ga).
first(n_mod_n,t_vstem_5_t_2FH_ga_ni).
first(n_mod_n,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_mod_n,t_vstem_5_t_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_t_2FH_ga_o).
first(n_mod_n,t_vstem_5_t_2FH_ga_to).
first(n_mod_n,t_vstem_5_w_2FH_ga).
first(n_mod_n,t_vstem_5_w_2FH_ga_de).
first(n_mod_n,t_vstem_5_w_2FH_ga_ni).
first(n_mod_n,t_vstem_5_w_2FH_ga_ni_o).
first(n_mod_n,t_vstem_5_w_2FH_ga_o).
first(n_mod_n,t_vstem_5_w_2FH_ga_quote).
first(n_mod_n,t_vstem_5_w_2FH_ga_to).
first(n_mod_n,t_vstem_masu_2FH_ga).
first(n_mod_n,t_vstem_sahen_2FH_ga_ni).
first(n_mod_n,t_wh_daimeisi).
first(n_mod_n,t_wh_daimeisi_nan).
first(n_mod_n,t_wh_hukusi).
first(n_mod_n,t_zikan_meisi).
first(n_mod_n,t_zikan_meisi_ippai).
first(n_mod_n,t_zikantai).
first(n_mod_time,t_meisi_hi).
first(n_mod_v,n_capacity).
first(n_mod_v,n_visitor_name).
first(n_mod_v,t_adj_meisi).
first(n_mod_v,t_adj_renyo_2FH_ga).
first(n_mod_v,t_adj_renyo_2FH_ga_de).
first(n_mod_v,t_adjstem_2FH_ga).
first(n_mod_v,t_adjstem_2FH_ga_de).
first(n_mod_v,t_adjstem_spe_2FH_ga_de).
first(n_mod_v,t_daimeisi).
first(n_mod_v,t_daimeisi_domo).
first(n_mod_v,t_daimeisi_exp).
first(n_mod_v,t_hukusi).
first(n_mod_v,t_hukusi_desu).
first(n_mod_v,t_hutu_meisi).
first(n_mod_v,t_hutu_meisi_post).
first(n_mod_v,t_kahen_dousi_katei_2FH_ga_ni).
first(n_mod_v,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_mod_v,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_mod_v,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_mod_v,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_mod_v,t_kdo_2FH_ga).
first(n_mod_v,t_kdo_2FH_ga_de).
first(n_mod_v,t_kdo_2FH_ga_to).
first(n_mod_v,t_koyuu_meisi).
first(n_mod_v,t_meisi_hi).
first(n_mod_v,t_meisi_hun).
first(n_mod_v,t_meisi_tsuki).
first(n_mod_v,t_meisi_youbi).
first(n_mod_v,t_meisi_zi).
first(n_mod_v,t_myoji_first).
first(n_mod_v,t_myoji_last).
first(n_mod_v,t_n_keisiki).
first(n_mod_v,t_namae_first).
first(n_mod_v,t_namae_last).
first(n_mod_v,t_num_bouyomi).
first(n_mod_v,t_num_byaku).
first(n_mod_v,t_num_byaq).
first(n_mod_v,t_num_go).
first(n_mod_v,t_num_hachi).
first(n_mod_v,t_num_haq).
first(n_mod_v,t_num_hito).
first(n_mod_v,t_num_huta).
first(n_mod_v,t_num_hutsu).
first(n_mod_v,t_num_hyaku).
first(n_mod_v,t_num_hyaq).
first(n_mod_v,t_num_ichi).
first(n_mod_v,t_num_iq).
first(n_mod_v,t_num_itsu).
first(n_mod_v,t_num_kokono).
first(n_mod_v,t_num_ku).
first(n_mod_v,t_num_kyuu).
first(n_mod_v,t_num_miq).
first(n_mod_v,t_num_mui).
first(n_mod_v,t_num_muq).
first(n_mod_v,t_num_nana).
first(n_mod_v,t_num_nano).
first(n_mod_v,t_num_ni).
first(n_mod_v,t_num_one).
first(n_mod_v,t_num_pyaku).
first(n_mod_v,t_num_pyaq).
first(n_mod_v,t_num_roku).
first(n_mod_v,t_num_roq).
first(n_mod_v,t_num_san).
first(n_mod_v,t_num_sen).
first(n_mod_v,t_num_shi).
first(n_mod_v,t_num_shichi).
first(n_mod_v,t_num_ten).
first(n_mod_v,t_num_tou).
first(n_mod_v,t_num_yaq).
first(n_mod_v,t_num_yo).
first(n_mod_v,t_num_yon).
first(n_mod_v,t_num_yoq).
first(n_mod_v,t_num_you).
first(n_mod_v,t_num_zen).
first(n_mod_v,t_num_zyuq).
first(n_mod_v,t_num_zyuu).
first(n_mod_v,t_prefix_go).
first(n_mod_v,t_prefix_hutu_hutu).
first(n_mod_v,t_prefix_o).
first(n_mod_v,t_prefix_quant_quant).
first(n_mod_v,t_rentai).
first(n_mod_v,t_sahen_dousi_katei_2FH_ga_ni).
first(n_mod_v,t_sahen_dousi_katei_2FH_ga_o).
first(n_mod_v,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_mod_v,t_sahen_dousi_mizen_2FH_ga_o).
first(n_mod_v,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_mod_v,t_sahen_dousi_rentai_2FH_ga_o).
first(n_mod_v,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_mod_v,t_sahen_dousi_renyo_2FH_ga_o).
first(n_mod_v,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_mod_v,t_sahen_dousi_syusi_2FH_ga_o).
first(n_mod_v,t_sahen_meisi_2FH_ga).
first(n_mod_v,t_sahen_meisi_2FH_ga_ni).
first(n_mod_v,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_mod_v,t_sahen_meisi_2FH_ga_ni_o).
first(n_mod_v,t_sahen_meisi_2FH_ga_o).
first(n_mod_v,t_sahen_meisi_2FH_ga_to).
first(n_mod_v,t_sahen_meisi_pol_2FH_ga).
first(n_mod_v,t_sahen_meisi_pol_2FH_ga_ni).
first(n_mod_v,t_sahen_meisi_pol_2FH_ga_o).
first(n_mod_v,t_sahen_meisi_pol_2FH_ga_to).
first(n_mod_v,t_suuryousi).
first(n_mod_v,t_teido_hukusi).
first(n_mod_v,t_tsuzuri).
first(n_mod_v,t_vstem_1_2FH_ga).
first(n_mod_v,t_vstem_1_2FH_ga_de).
first(n_mod_v,t_vstem_1_2FH_ga_ni).
first(n_mod_v,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_mod_v,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_mod_v,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_mod_v,t_vstem_1_2FH_ga_ni_o).
first(n_mod_v,t_vstem_1_2FH_ga_o).
first(n_mod_v,t_vstem_1_2FH_ga_quote).
first(n_mod_v,t_vstem_1_2FH_ga_to).
first(n_mod_v,t_vstem_5_b_2FH_ga).
first(n_mod_v,t_vstem_5_b_2FH_ga_ni).
first(n_mod_v,t_vstem_5_b_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_b_2FH_ga_o).
first(n_mod_v,t_vstem_5_b_2FH_ga_to).
first(n_mod_v,t_vstem_5_g_2FH_ga).
first(n_mod_v,t_vstem_5_g_2FH_ga_ni).
first(n_mod_v,t_vstem_5_g_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_g_2FH_ga_o).
first(n_mod_v,t_vstem_5_k_2FH_ga).
first(n_mod_v,t_vstem_5_k_2FH_ga_ni).
first(n_mod_v,t_vstem_5_k_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_k_2FH_ga_o).
first(n_mod_v,t_vstem_5_k_2FH_ga_to).
first(n_mod_v,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_mod_v,t_vstem_5_m_2FH_ga).
first(n_mod_v,t_vstem_5_m_2FH_ga_ni).
first(n_mod_v,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_mod_v,t_vstem_5_m_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_m_2FH_ga_o).
first(n_mod_v,t_vstem_5_m_2FH_ga_to).
first(n_mod_v,t_vstem_5_r_2FH_ga).
first(n_mod_v,t_vstem_5_r_2FH_ga_ni).
first(n_mod_v,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_mod_v,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_mod_v,t_vstem_5_r_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_r_2FH_ga_o).
first(n_mod_v,t_vstem_5_r_2FH_ga_to).
first(n_mod_v,t_vstem_5_r_i_2FH_ga).
first(n_mod_v,t_vstem_5_r_i_2FH_ga_o).
first(n_mod_v,t_vstem_5_r_i_2FH_ga_quote).
first(n_mod_v,t_vstem_5_s_2FH_ga).
first(n_mod_v,t_vstem_5_s_2FH_ga_ni).
first(n_mod_v,t_vstem_5_s_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_s_2FH_ga_o).
first(n_mod_v,t_vstem_5_s_2FH_ga_quote).
first(n_mod_v,t_vstem_5_s_2FH_ga_to).
first(n_mod_v,t_vstem_5_t_2FH_ga).
first(n_mod_v,t_vstem_5_t_2FH_ga_ni).
first(n_mod_v,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_mod_v,t_vstem_5_t_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_t_2FH_ga_o).
first(n_mod_v,t_vstem_5_t_2FH_ga_to).
first(n_mod_v,t_vstem_5_w_2FH_ga).
first(n_mod_v,t_vstem_5_w_2FH_ga_de).
first(n_mod_v,t_vstem_5_w_2FH_ga_ni).
first(n_mod_v,t_vstem_5_w_2FH_ga_ni_o).
first(n_mod_v,t_vstem_5_w_2FH_ga_o).
first(n_mod_v,t_vstem_5_w_2FH_ga_quote).
first(n_mod_v,t_vstem_5_w_2FH_ga_to).
first(n_mod_v,t_vstem_masu_2FH_ga).
first(n_mod_v,t_vstem_sahen_2FH_ga_ni).
first(n_mod_v,t_wh_daimeisi).
first(n_mod_v,t_wh_daimeisi_nan).
first(n_mod_v,t_wh_hukusi).
first(n_mod_v,t_zikan_meisi).
first(n_mod_v,t_zikan_meisi_ippai).
first(n_mod_v,t_zikantai).
first(n_mod_week,t_meisi_tsuki).
first(n_month_day,t_meisi_tsuki).
first(n_n_adj,t_kdo_2FH_ga).
first(n_n_adj,t_kdo_2FH_ga_de).
first(n_n_adj,t_kdo_2FH_ga_to).
first(n_n_adj,t_prefix_go).
first(n_n_adj,t_prefix_hutu_hutu).
first(n_n_adj,t_prefix_o).
first(n_n_adj,t_prefix_quant_quant).
first(n_n_adj_2FH_ga,t_kdo_2FH_ga).
first(n_n_adj_2FH_ga_de,t_kdo_2FH_ga_de).
first(n_n_adj_2FH_ga_to,t_kdo_2FH_ga_to).
first(n_n_adv,t_huku_meisi).
first(n_n_cl,n_capacity).
first(n_n_cl,n_visitor_name).
first(n_n_cl,t_adj_meisi).
first(n_n_cl,t_adj_renyo_2FH_ga).
first(n_n_cl,t_adj_renyo_2FH_ga_de).
first(n_n_cl,t_adjstem_2FH_ga).
first(n_n_cl,t_adjstem_2FH_ga_de).
first(n_n_cl,t_adjstem_spe_2FH_ga_de).
first(n_n_cl,t_daimeisi).
first(n_n_cl,t_daimeisi_domo).
first(n_n_cl,t_daimeisi_exp).
first(n_n_cl,t_hukusi).
first(n_n_cl,t_hukusi_desu).
first(n_n_cl,t_hutu_meisi).
first(n_n_cl,t_hutu_meisi_post).
first(n_n_cl,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_cl,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_cl,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_cl,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_cl,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_cl,t_kdo_2FH_ga).
first(n_n_cl,t_kdo_2FH_ga_de).
first(n_n_cl,t_kdo_2FH_ga_to).
first(n_n_cl,t_koyuu_meisi).
first(n_n_cl,t_meisi_hi).
first(n_n_cl,t_meisi_hun).
first(n_n_cl,t_meisi_tsuki).
first(n_n_cl,t_meisi_youbi).
first(n_n_cl,t_meisi_zi).
first(n_n_cl,t_myoji_first).
first(n_n_cl,t_myoji_last).
first(n_n_cl,t_n_keisiki).
first(n_n_cl,t_namae_first).
first(n_n_cl,t_namae_last).
first(n_n_cl,t_num_bouyomi).
first(n_n_cl,t_num_byaku).
first(n_n_cl,t_num_byaq).
first(n_n_cl,t_num_go).
first(n_n_cl,t_num_hachi).
first(n_n_cl,t_num_haq).
first(n_n_cl,t_num_hito).
first(n_n_cl,t_num_huta).
first(n_n_cl,t_num_hutsu).
first(n_n_cl,t_num_hyaku).
first(n_n_cl,t_num_hyaq).
first(n_n_cl,t_num_ichi).
first(n_n_cl,t_num_iq).
first(n_n_cl,t_num_itsu).
first(n_n_cl,t_num_kokono).
first(n_n_cl,t_num_ku).
first(n_n_cl,t_num_kyuu).
first(n_n_cl,t_num_miq).
first(n_n_cl,t_num_mui).
first(n_n_cl,t_num_muq).
first(n_n_cl,t_num_nana).
first(n_n_cl,t_num_nano).
first(n_n_cl,t_num_ni).
first(n_n_cl,t_num_one).
first(n_n_cl,t_num_pyaku).
first(n_n_cl,t_num_pyaq).
first(n_n_cl,t_num_roku).
first(n_n_cl,t_num_roq).
first(n_n_cl,t_num_san).
first(n_n_cl,t_num_sen).
first(n_n_cl,t_num_shi).
first(n_n_cl,t_num_shichi).
first(n_n_cl,t_num_ten).
first(n_n_cl,t_num_tou).
first(n_n_cl,t_num_yaq).
first(n_n_cl,t_num_yo).
first(n_n_cl,t_num_yon).
first(n_n_cl,t_num_yoq).
first(n_n_cl,t_num_you).
first(n_n_cl,t_num_zen).
first(n_n_cl,t_num_zyuq).
first(n_n_cl,t_num_zyuu).
first(n_n_cl,t_prefix_go).
first(n_n_cl,t_prefix_hutu_hutu).
first(n_n_cl,t_prefix_o).
first(n_n_cl,t_prefix_quant_quant).
first(n_n_cl,t_rentai).
first(n_n_cl,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_cl,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_cl,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_cl,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_cl,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_cl,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_cl,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_cl,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_cl,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_cl,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_cl,t_sahen_meisi_2FH_ga).
first(n_n_cl,t_sahen_meisi_2FH_ga_ni).
first(n_n_cl,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_cl,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_cl,t_sahen_meisi_2FH_ga_o).
first(n_n_cl,t_sahen_meisi_2FH_ga_to).
first(n_n_cl,t_sahen_meisi_pol_2FH_ga).
first(n_n_cl,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_cl,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_cl,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_cl,t_suuryousi).
first(n_n_cl,t_teido_hukusi).
first(n_n_cl,t_tsuzuri).
first(n_n_cl,t_vstem_1_2FH_ga).
first(n_n_cl,t_vstem_1_2FH_ga_de).
first(n_n_cl,t_vstem_1_2FH_ga_ni).
first(n_n_cl,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_cl,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_cl,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_cl,t_vstem_1_2FH_ga_ni_o).
first(n_n_cl,t_vstem_1_2FH_ga_o).
first(n_n_cl,t_vstem_1_2FH_ga_quote).
first(n_n_cl,t_vstem_1_2FH_ga_to).
first(n_n_cl,t_vstem_5_b_2FH_ga).
first(n_n_cl,t_vstem_5_b_2FH_ga_ni).
first(n_n_cl,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_b_2FH_ga_o).
first(n_n_cl,t_vstem_5_b_2FH_ga_to).
first(n_n_cl,t_vstem_5_g_2FH_ga).
first(n_n_cl,t_vstem_5_g_2FH_ga_ni).
first(n_n_cl,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_g_2FH_ga_o).
first(n_n_cl,t_vstem_5_k_2FH_ga).
first(n_n_cl,t_vstem_5_k_2FH_ga_ni).
first(n_n_cl,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_k_2FH_ga_o).
first(n_n_cl,t_vstem_5_k_2FH_ga_to).
first(n_n_cl,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_cl,t_vstem_5_m_2FH_ga).
first(n_n_cl,t_vstem_5_m_2FH_ga_ni).
first(n_n_cl,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_cl,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_m_2FH_ga_o).
first(n_n_cl,t_vstem_5_m_2FH_ga_to).
first(n_n_cl,t_vstem_5_r_2FH_ga).
first(n_n_cl,t_vstem_5_r_2FH_ga_ni).
first(n_n_cl,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_cl,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_cl,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_r_2FH_ga_o).
first(n_n_cl,t_vstem_5_r_2FH_ga_to).
first(n_n_cl,t_vstem_5_r_i_2FH_ga).
first(n_n_cl,t_vstem_5_r_i_2FH_ga_o).
first(n_n_cl,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_cl,t_vstem_5_s_2FH_ga).
first(n_n_cl,t_vstem_5_s_2FH_ga_ni).
first(n_n_cl,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_s_2FH_ga_o).
first(n_n_cl,t_vstem_5_s_2FH_ga_quote).
first(n_n_cl,t_vstem_5_s_2FH_ga_to).
first(n_n_cl,t_vstem_5_t_2FH_ga).
first(n_n_cl,t_vstem_5_t_2FH_ga_ni).
first(n_n_cl,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_cl,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_t_2FH_ga_o).
first(n_n_cl,t_vstem_5_t_2FH_ga_to).
first(n_n_cl,t_vstem_5_w_2FH_ga).
first(n_n_cl,t_vstem_5_w_2FH_ga_de).
first(n_n_cl,t_vstem_5_w_2FH_ga_ni).
first(n_n_cl,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_cl,t_vstem_5_w_2FH_ga_o).
first(n_n_cl,t_vstem_5_w_2FH_ga_quote).
first(n_n_cl,t_vstem_5_w_2FH_ga_to).
first(n_n_cl,t_vstem_masu_2FH_ga).
first(n_n_cl,t_vstem_sahen_2FH_ga_ni).
first(n_n_cl,t_wh_daimeisi).
first(n_n_cl,t_wh_daimeisi_nan).
first(n_n_cl,t_wh_hukusi).
first(n_n_cl,t_zikan_meisi).
first(n_n_cl,t_zikan_meisi_ippai).
first(n_n_cl,t_zikantai).
first(n_n_date_and_time,n_capacity).
first(n_n_date_and_time,n_visitor_name).
first(n_n_date_and_time,t_adj_meisi).
first(n_n_date_and_time,t_adj_renyo_2FH_ga).
first(n_n_date_and_time,t_adj_renyo_2FH_ga_de).
first(n_n_date_and_time,t_adjstem_2FH_ga).
first(n_n_date_and_time,t_adjstem_2FH_ga_de).
first(n_n_date_and_time,t_adjstem_spe_2FH_ga_de).
first(n_n_date_and_time,t_daimeisi).
first(n_n_date_and_time,t_daimeisi_domo).
first(n_n_date_and_time,t_daimeisi_exp).
first(n_n_date_and_time,t_hukusi).
first(n_n_date_and_time,t_hukusi_desu).
first(n_n_date_and_time,t_hutu_meisi).
first(n_n_date_and_time,t_hutu_meisi_post).
first(n_n_date_and_time,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_date_and_time,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_date_and_time,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_date_and_time,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_date_and_time,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_date_and_time,t_kdo_2FH_ga).
first(n_n_date_and_time,t_kdo_2FH_ga_de).
first(n_n_date_and_time,t_kdo_2FH_ga_to).
first(n_n_date_and_time,t_koyuu_meisi).
first(n_n_date_and_time,t_meisi_hi).
first(n_n_date_and_time,t_meisi_hun).
first(n_n_date_and_time,t_meisi_tsuki).
first(n_n_date_and_time,t_meisi_youbi).
first(n_n_date_and_time,t_meisi_zi).
first(n_n_date_and_time,t_myoji_first).
first(n_n_date_and_time,t_myoji_last).
first(n_n_date_and_time,t_n_keisiki).
first(n_n_date_and_time,t_namae_first).
first(n_n_date_and_time,t_namae_last).
first(n_n_date_and_time,t_num_bouyomi).
first(n_n_date_and_time,t_num_byaku).
first(n_n_date_and_time,t_num_byaq).
first(n_n_date_and_time,t_num_go).
first(n_n_date_and_time,t_num_hachi).
first(n_n_date_and_time,t_num_haq).
first(n_n_date_and_time,t_num_hito).
first(n_n_date_and_time,t_num_huta).
first(n_n_date_and_time,t_num_hutsu).
first(n_n_date_and_time,t_num_hyaku).
first(n_n_date_and_time,t_num_hyaq).
first(n_n_date_and_time,t_num_ichi).
first(n_n_date_and_time,t_num_iq).
first(n_n_date_and_time,t_num_itsu).
first(n_n_date_and_time,t_num_kokono).
first(n_n_date_and_time,t_num_ku).
first(n_n_date_and_time,t_num_kyuu).
first(n_n_date_and_time,t_num_miq).
first(n_n_date_and_time,t_num_mui).
first(n_n_date_and_time,t_num_muq).
first(n_n_date_and_time,t_num_nana).
first(n_n_date_and_time,t_num_nano).
first(n_n_date_and_time,t_num_ni).
first(n_n_date_and_time,t_num_one).
first(n_n_date_and_time,t_num_pyaku).
first(n_n_date_and_time,t_num_pyaq).
first(n_n_date_and_time,t_num_roku).
first(n_n_date_and_time,t_num_roq).
first(n_n_date_and_time,t_num_san).
first(n_n_date_and_time,t_num_sen).
first(n_n_date_and_time,t_num_shi).
first(n_n_date_and_time,t_num_shichi).
first(n_n_date_and_time,t_num_ten).
first(n_n_date_and_time,t_num_tou).
first(n_n_date_and_time,t_num_yaq).
first(n_n_date_and_time,t_num_yo).
first(n_n_date_and_time,t_num_yon).
first(n_n_date_and_time,t_num_yoq).
first(n_n_date_and_time,t_num_you).
first(n_n_date_and_time,t_num_zen).
first(n_n_date_and_time,t_num_zyuq).
first(n_n_date_and_time,t_num_zyuu).
first(n_n_date_and_time,t_prefix_go).
first(n_n_date_and_time,t_prefix_hutu_hutu).
first(n_n_date_and_time,t_prefix_o).
first(n_n_date_and_time,t_prefix_quant_quant).
first(n_n_date_and_time,t_rentai).
first(n_n_date_and_time,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_date_and_time,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_date_and_time,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_date_and_time,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_date_and_time,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_date_and_time,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_date_and_time,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_date_and_time,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_date_and_time,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_date_and_time,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_date_and_time,t_sahen_meisi_2FH_ga).
first(n_n_date_and_time,t_sahen_meisi_2FH_ga_ni).
first(n_n_date_and_time,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_date_and_time,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_date_and_time,t_sahen_meisi_2FH_ga_o).
first(n_n_date_and_time,t_sahen_meisi_2FH_ga_to).
first(n_n_date_and_time,t_sahen_meisi_pol_2FH_ga).
first(n_n_date_and_time,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_date_and_time,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_date_and_time,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_date_and_time,t_suuryousi).
first(n_n_date_and_time,t_teido_hukusi).
first(n_n_date_and_time,t_tsuzuri).
first(n_n_date_and_time,t_vstem_1_2FH_ga).
first(n_n_date_and_time,t_vstem_1_2FH_ga_de).
first(n_n_date_and_time,t_vstem_1_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_date_and_time,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_date_and_time,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_date_and_time,t_vstem_1_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_1_2FH_ga_o).
first(n_n_date_and_time,t_vstem_1_2FH_ga_quote).
first(n_n_date_and_time,t_vstem_1_2FH_ga_to).
first(n_n_date_and_time,t_vstem_5_b_2FH_ga).
first(n_n_date_and_time,t_vstem_5_b_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_b_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_b_2FH_ga_to).
first(n_n_date_and_time,t_vstem_5_g_2FH_ga).
first(n_n_date_and_time,t_vstem_5_g_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_g_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_k_2FH_ga).
first(n_n_date_and_time,t_vstem_5_k_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_k_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_k_2FH_ga_to).
first(n_n_date_and_time,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_date_and_time,t_vstem_5_m_2FH_ga).
first(n_n_date_and_time,t_vstem_5_m_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_date_and_time,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_m_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_m_2FH_ga_to).
first(n_n_date_and_time,t_vstem_5_r_2FH_ga).
first(n_n_date_and_time,t_vstem_5_r_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_date_and_time,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_date_and_time,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_r_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_r_2FH_ga_to).
first(n_n_date_and_time,t_vstem_5_r_i_2FH_ga).
first(n_n_date_and_time,t_vstem_5_r_i_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_date_and_time,t_vstem_5_s_2FH_ga).
first(n_n_date_and_time,t_vstem_5_s_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_s_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_s_2FH_ga_quote).
first(n_n_date_and_time,t_vstem_5_s_2FH_ga_to).
first(n_n_date_and_time,t_vstem_5_t_2FH_ga).
first(n_n_date_and_time,t_vstem_5_t_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_date_and_time,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_t_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_t_2FH_ga_to).
first(n_n_date_and_time,t_vstem_5_w_2FH_ga).
first(n_n_date_and_time,t_vstem_5_w_2FH_ga_de).
first(n_n_date_and_time,t_vstem_5_w_2FH_ga_ni).
first(n_n_date_and_time,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_date_and_time,t_vstem_5_w_2FH_ga_o).
first(n_n_date_and_time,t_vstem_5_w_2FH_ga_quote).
first(n_n_date_and_time,t_vstem_5_w_2FH_ga_to).
first(n_n_date_and_time,t_vstem_masu_2FH_ga).
first(n_n_date_and_time,t_vstem_sahen_2FH_ga_ni).
first(n_n_date_and_time,t_wh_daimeisi).
first(n_n_date_and_time,t_wh_daimeisi_nan).
first(n_n_date_and_time,t_wh_hukusi).
first(n_n_date_and_time,t_zikan_meisi).
first(n_n_date_and_time,t_zikan_meisi_ippai).
first(n_n_date_and_time,t_zikantai).
first(n_n_day,t_meisi_hi).
first(n_n_hour,t_meisi_zi).
first(n_n_hutu,n_capacity).
first(n_n_hutu,n_visitor_name).
first(n_n_hutu,t_adj_meisi).
first(n_n_hutu,t_adj_renyo_2FH_ga).
first(n_n_hutu,t_adj_renyo_2FH_ga_de).
first(n_n_hutu,t_adjstem_2FH_ga).
first(n_n_hutu,t_adjstem_2FH_ga_de).
first(n_n_hutu,t_adjstem_spe_2FH_ga_de).
first(n_n_hutu,t_daimeisi).
first(n_n_hutu,t_daimeisi_domo).
first(n_n_hutu,t_daimeisi_exp).
first(n_n_hutu,t_hukusi).
first(n_n_hutu,t_hukusi_desu).
first(n_n_hutu,t_hutu_meisi).
first(n_n_hutu,t_hutu_meisi_post).
first(n_n_hutu,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_hutu,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_hutu,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_hutu,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_hutu,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_hutu,t_kdo_2FH_ga).
first(n_n_hutu,t_kdo_2FH_ga_de).
first(n_n_hutu,t_kdo_2FH_ga_to).
first(n_n_hutu,t_koyuu_meisi).
first(n_n_hutu,t_meisi_hi).
first(n_n_hutu,t_meisi_hun).
first(n_n_hutu,t_meisi_tsuki).
first(n_n_hutu,t_meisi_youbi).
first(n_n_hutu,t_meisi_zi).
first(n_n_hutu,t_myoji_first).
first(n_n_hutu,t_myoji_last).
first(n_n_hutu,t_n_keisiki).
first(n_n_hutu,t_namae_first).
first(n_n_hutu,t_namae_last).
first(n_n_hutu,t_num_bouyomi).
first(n_n_hutu,t_num_byaku).
first(n_n_hutu,t_num_byaq).
first(n_n_hutu,t_num_go).
first(n_n_hutu,t_num_hachi).
first(n_n_hutu,t_num_haq).
first(n_n_hutu,t_num_hito).
first(n_n_hutu,t_num_huta).
first(n_n_hutu,t_num_hutsu).
first(n_n_hutu,t_num_hyaku).
first(n_n_hutu,t_num_hyaq).
first(n_n_hutu,t_num_ichi).
first(n_n_hutu,t_num_iq).
first(n_n_hutu,t_num_itsu).
first(n_n_hutu,t_num_kokono).
first(n_n_hutu,t_num_ku).
first(n_n_hutu,t_num_kyuu).
first(n_n_hutu,t_num_miq).
first(n_n_hutu,t_num_mui).
first(n_n_hutu,t_num_muq).
first(n_n_hutu,t_num_nana).
first(n_n_hutu,t_num_nano).
first(n_n_hutu,t_num_ni).
first(n_n_hutu,t_num_one).
first(n_n_hutu,t_num_pyaku).
first(n_n_hutu,t_num_pyaq).
first(n_n_hutu,t_num_roku).
first(n_n_hutu,t_num_roq).
first(n_n_hutu,t_num_san).
first(n_n_hutu,t_num_sen).
first(n_n_hutu,t_num_shi).
first(n_n_hutu,t_num_shichi).
first(n_n_hutu,t_num_ten).
first(n_n_hutu,t_num_tou).
first(n_n_hutu,t_num_yaq).
first(n_n_hutu,t_num_yo).
first(n_n_hutu,t_num_yon).
first(n_n_hutu,t_num_yoq).
first(n_n_hutu,t_num_you).
first(n_n_hutu,t_num_zen).
first(n_n_hutu,t_num_zyuq).
first(n_n_hutu,t_num_zyuu).
first(n_n_hutu,t_prefix_go).
first(n_n_hutu,t_prefix_hutu_hutu).
first(n_n_hutu,t_prefix_o).
first(n_n_hutu,t_prefix_quant_quant).
first(n_n_hutu,t_rentai).
first(n_n_hutu,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_hutu,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_hutu,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_hutu,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_hutu,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_hutu,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_hutu,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_hutu,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_hutu,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_hutu,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_hutu,t_sahen_meisi_2FH_ga).
first(n_n_hutu,t_sahen_meisi_2FH_ga_ni).
first(n_n_hutu,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_hutu,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_hutu,t_sahen_meisi_2FH_ga_o).
first(n_n_hutu,t_sahen_meisi_2FH_ga_to).
first(n_n_hutu,t_sahen_meisi_pol_2FH_ga).
first(n_n_hutu,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_hutu,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_hutu,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_hutu,t_suuryousi).
first(n_n_hutu,t_teido_hukusi).
first(n_n_hutu,t_tsuzuri).
first(n_n_hutu,t_vstem_1_2FH_ga).
first(n_n_hutu,t_vstem_1_2FH_ga_de).
first(n_n_hutu,t_vstem_1_2FH_ga_ni).
first(n_n_hutu,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_hutu,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_hutu,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_hutu,t_vstem_1_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_1_2FH_ga_o).
first(n_n_hutu,t_vstem_1_2FH_ga_quote).
first(n_n_hutu,t_vstem_1_2FH_ga_to).
first(n_n_hutu,t_vstem_5_b_2FH_ga).
first(n_n_hutu,t_vstem_5_b_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_b_2FH_ga_o).
first(n_n_hutu,t_vstem_5_b_2FH_ga_to).
first(n_n_hutu,t_vstem_5_g_2FH_ga).
first(n_n_hutu,t_vstem_5_g_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_g_2FH_ga_o).
first(n_n_hutu,t_vstem_5_k_2FH_ga).
first(n_n_hutu,t_vstem_5_k_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_k_2FH_ga_o).
first(n_n_hutu,t_vstem_5_k_2FH_ga_to).
first(n_n_hutu,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_hutu,t_vstem_5_m_2FH_ga).
first(n_n_hutu,t_vstem_5_m_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_hutu,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_m_2FH_ga_o).
first(n_n_hutu,t_vstem_5_m_2FH_ga_to).
first(n_n_hutu,t_vstem_5_r_2FH_ga).
first(n_n_hutu,t_vstem_5_r_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_hutu,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_hutu,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_r_2FH_ga_o).
first(n_n_hutu,t_vstem_5_r_2FH_ga_to).
first(n_n_hutu,t_vstem_5_r_i_2FH_ga).
first(n_n_hutu,t_vstem_5_r_i_2FH_ga_o).
first(n_n_hutu,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_hutu,t_vstem_5_s_2FH_ga).
first(n_n_hutu,t_vstem_5_s_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_s_2FH_ga_o).
first(n_n_hutu,t_vstem_5_s_2FH_ga_quote).
first(n_n_hutu,t_vstem_5_s_2FH_ga_to).
first(n_n_hutu,t_vstem_5_t_2FH_ga).
first(n_n_hutu,t_vstem_5_t_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_hutu,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_t_2FH_ga_o).
first(n_n_hutu,t_vstem_5_t_2FH_ga_to).
first(n_n_hutu,t_vstem_5_w_2FH_ga).
first(n_n_hutu,t_vstem_5_w_2FH_ga_de).
first(n_n_hutu,t_vstem_5_w_2FH_ga_ni).
first(n_n_hutu,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_hutu,t_vstem_5_w_2FH_ga_o).
first(n_n_hutu,t_vstem_5_w_2FH_ga_quote).
first(n_n_hutu,t_vstem_5_w_2FH_ga_to).
first(n_n_hutu,t_vstem_masu_2FH_ga).
first(n_n_hutu,t_vstem_sahen_2FH_ga_ni).
first(n_n_hutu,t_wh_daimeisi).
first(n_n_hutu,t_wh_daimeisi_nan).
first(n_n_hutu,t_wh_hukusi).
first(n_n_hutu,t_zikan_meisi).
first(n_n_hutu,t_zikan_meisi_ippai).
first(n_n_hutu,t_zikantai).
first(n_n_minute,t_meisi_hun).
first(n_n_month,t_meisi_tsuki).
first(n_n_name,t_myoji_first).
first(n_n_name,t_myoji_last).
first(n_n_name,t_namae_first).
first(n_n_name,t_namae_last).
first(n_n_num,t_num_byaku).
first(n_n_num,t_num_byaq).
first(n_n_num,t_num_go).
first(n_n_num,t_num_hachi).
first(n_n_num,t_num_haq).
first(n_n_num,t_num_hito).
first(n_n_num,t_num_huta).
first(n_n_num,t_num_hutsu).
first(n_n_num,t_num_hyaku).
first(n_n_num,t_num_hyaq).
first(n_n_num,t_num_ichi).
first(n_n_num,t_num_iq).
first(n_n_num,t_num_itsu).
first(n_n_num,t_num_kokono).
first(n_n_num,t_num_ku).
first(n_n_num,t_num_kyuu).
first(n_n_num,t_num_miq).
first(n_n_num,t_num_mui).
first(n_n_num,t_num_muq).
first(n_n_num,t_num_nana).
first(n_n_num,t_num_nano).
first(n_n_num,t_num_ni).
first(n_n_num,t_num_one).
first(n_n_num,t_num_pyaku).
first(n_n_num,t_num_pyaq).
first(n_n_num,t_num_roku).
first(n_n_num,t_num_roq).
first(n_n_num,t_num_san).
first(n_n_num,t_num_sen).
first(n_n_num,t_num_shi).
first(n_n_num,t_num_shichi).
first(n_n_num,t_num_ten).
first(n_n_num,t_num_tou).
first(n_n_num,t_num_yaq).
first(n_n_num,t_num_yo).
first(n_n_num,t_num_yon).
first(n_n_num,t_num_yoq).
first(n_n_num,t_num_you).
first(n_n_num,t_num_zen).
first(n_n_num,t_num_zyuq).
first(n_n_num,t_num_zyuu).
first(n_n_num_bango,t_num_bouyomi).
first(n_n_num_ex,t_num_bouyomi).
first(n_n_num_hyaku,t_num_byaku).
first(n_n_num_hyaku,t_num_byaq).
first(n_n_num_hyaku,t_num_go).
first(n_n_num_hyaku,t_num_hachi).
first(n_n_num_hyaku,t_num_haq).
first(n_n_num_hyaku,t_num_hito).
first(n_n_num_hyaku,t_num_huta).
first(n_n_num_hyaku,t_num_hutsu).
first(n_n_num_hyaku,t_num_hyaku).
first(n_n_num_hyaku,t_num_hyaq).
first(n_n_num_hyaku,t_num_ichi).
first(n_n_num_hyaku,t_num_iq).
first(n_n_num_hyaku,t_num_itsu).
first(n_n_num_hyaku,t_num_kokono).
first(n_n_num_hyaku,t_num_ku).
first(n_n_num_hyaku,t_num_kyuu).
first(n_n_num_hyaku,t_num_miq).
first(n_n_num_hyaku,t_num_mui).
first(n_n_num_hyaku,t_num_muq).
first(n_n_num_hyaku,t_num_nana).
first(n_n_num_hyaku,t_num_nano).
first(n_n_num_hyaku,t_num_ni).
first(n_n_num_hyaku,t_num_one).
first(n_n_num_hyaku,t_num_pyaku).
first(n_n_num_hyaku,t_num_pyaq).
first(n_n_num_hyaku,t_num_roku).
first(n_n_num_hyaku,t_num_roq).
first(n_n_num_hyaku,t_num_san).
first(n_n_num_hyaku,t_num_shi).
first(n_n_num_hyaku,t_num_shichi).
first(n_n_num_hyaku,t_num_ten).
first(n_n_num_hyaku,t_num_tou).
first(n_n_num_hyaku,t_num_yaq).
first(n_n_num_hyaku,t_num_yo).
first(n_n_num_hyaku,t_num_yon).
first(n_n_num_hyaku,t_num_yoq).
first(n_n_num_hyaku,t_num_you).
first(n_n_num_ichi,t_num_go).
first(n_n_num_ichi,t_num_hachi).
first(n_n_num_ichi,t_num_haq).
first(n_n_num_ichi,t_num_hito).
first(n_n_num_ichi,t_num_huta).
first(n_n_num_ichi,t_num_hutsu).
first(n_n_num_ichi,t_num_ichi).
first(n_n_num_ichi,t_num_iq).
first(n_n_num_ichi,t_num_itsu).
first(n_n_num_ichi,t_num_kokono).
first(n_n_num_ichi,t_num_ku).
first(n_n_num_ichi,t_num_kyuu).
first(n_n_num_ichi,t_num_miq).
first(n_n_num_ichi,t_num_mui).
first(n_n_num_ichi,t_num_muq).
first(n_n_num_ichi,t_num_nana).
first(n_n_num_ichi,t_num_nano).
first(n_n_num_ichi,t_num_ni).
first(n_n_num_ichi,t_num_one).
first(n_n_num_ichi,t_num_roku).
first(n_n_num_ichi,t_num_roq).
first(n_n_num_ichi,t_num_san).
first(n_n_num_ichi,t_num_shi).
first(n_n_num_ichi,t_num_shichi).
first(n_n_num_ichi,t_num_ten).
first(n_n_num_ichi,t_num_tou).
first(n_n_num_ichi,t_num_yaq).
first(n_n_num_ichi,t_num_yo).
first(n_n_num_ichi,t_num_yon).
first(n_n_num_ichi,t_num_yoq).
first(n_n_num_ichi,t_num_you).
first(n_n_num_keta_hyaku,t_num_byaku).
first(n_n_num_keta_hyaku,t_num_byaq).
first(n_n_num_keta_hyaku,t_num_go).
first(n_n_num_keta_hyaku,t_num_hachi).
first(n_n_num_keta_hyaku,t_num_haq).
first(n_n_num_keta_hyaku,t_num_hito).
first(n_n_num_keta_hyaku,t_num_huta).
first(n_n_num_keta_hyaku,t_num_hutsu).
first(n_n_num_keta_hyaku,t_num_hyaku).
first(n_n_num_keta_hyaku,t_num_hyaq).
first(n_n_num_keta_hyaku,t_num_ichi).
first(n_n_num_keta_hyaku,t_num_iq).
first(n_n_num_keta_hyaku,t_num_itsu).
first(n_n_num_keta_hyaku,t_num_kokono).
first(n_n_num_keta_hyaku,t_num_ku).
first(n_n_num_keta_hyaku,t_num_kyuu).
first(n_n_num_keta_hyaku,t_num_miq).
first(n_n_num_keta_hyaku,t_num_mui).
first(n_n_num_keta_hyaku,t_num_muq).
first(n_n_num_keta_hyaku,t_num_nana).
first(n_n_num_keta_hyaku,t_num_nano).
first(n_n_num_keta_hyaku,t_num_ni).
first(n_n_num_keta_hyaku,t_num_one).
first(n_n_num_keta_hyaku,t_num_pyaku).
first(n_n_num_keta_hyaku,t_num_pyaq).
first(n_n_num_keta_hyaku,t_num_roku).
first(n_n_num_keta_hyaku,t_num_roq).
first(n_n_num_keta_hyaku,t_num_san).
first(n_n_num_keta_hyaku,t_num_shi).
first(n_n_num_keta_hyaku,t_num_shichi).
first(n_n_num_keta_hyaku,t_num_ten).
first(n_n_num_keta_hyaku,t_num_tou).
first(n_n_num_keta_hyaku,t_num_yaq).
first(n_n_num_keta_hyaku,t_num_yo).
first(n_n_num_keta_hyaku,t_num_yon).
first(n_n_num_keta_hyaku,t_num_yoq).
first(n_n_num_keta_hyaku,t_num_you).
first(n_n_num_keta_man,t_num_go).
first(n_n_num_keta_man,t_num_hachi).
first(n_n_num_keta_man,t_num_haq).
first(n_n_num_keta_man,t_num_hito).
first(n_n_num_keta_man,t_num_huta).
first(n_n_num_keta_man,t_num_hutsu).
first(n_n_num_keta_man,t_num_ichi).
first(n_n_num_keta_man,t_num_iq).
first(n_n_num_keta_man,t_num_itsu).
first(n_n_num_keta_man,t_num_kokono).
first(n_n_num_keta_man,t_num_ku).
first(n_n_num_keta_man,t_num_kyuu).
first(n_n_num_keta_man,t_num_miq).
first(n_n_num_keta_man,t_num_mui).
first(n_n_num_keta_man,t_num_muq).
first(n_n_num_keta_man,t_num_nana).
first(n_n_num_keta_man,t_num_nano).
first(n_n_num_keta_man,t_num_ni).
first(n_n_num_keta_man,t_num_one).
first(n_n_num_keta_man,t_num_roku).
first(n_n_num_keta_man,t_num_roq).
first(n_n_num_keta_man,t_num_san).
first(n_n_num_keta_man,t_num_shi).
first(n_n_num_keta_man,t_num_shichi).
first(n_n_num_keta_man,t_num_ten).
first(n_n_num_keta_man,t_num_tou).
first(n_n_num_keta_man,t_num_yaq).
first(n_n_num_keta_man,t_num_yo).
first(n_n_num_keta_man,t_num_yon).
first(n_n_num_keta_man,t_num_yoq).
first(n_n_num_keta_man,t_num_you).
first(n_n_num_keta_sen,t_num_go).
first(n_n_num_keta_sen,t_num_hachi).
first(n_n_num_keta_sen,t_num_haq).
first(n_n_num_keta_sen,t_num_hito).
first(n_n_num_keta_sen,t_num_huta).
first(n_n_num_keta_sen,t_num_hutsu).
first(n_n_num_keta_sen,t_num_ichi).
first(n_n_num_keta_sen,t_num_iq).
first(n_n_num_keta_sen,t_num_itsu).
first(n_n_num_keta_sen,t_num_kokono).
first(n_n_num_keta_sen,t_num_ku).
first(n_n_num_keta_sen,t_num_kyuu).
first(n_n_num_keta_sen,t_num_miq).
first(n_n_num_keta_sen,t_num_mui).
first(n_n_num_keta_sen,t_num_muq).
first(n_n_num_keta_sen,t_num_nana).
first(n_n_num_keta_sen,t_num_nano).
first(n_n_num_keta_sen,t_num_ni).
first(n_n_num_keta_sen,t_num_one).
first(n_n_num_keta_sen,t_num_roku).
first(n_n_num_keta_sen,t_num_roq).
first(n_n_num_keta_sen,t_num_san).
first(n_n_num_keta_sen,t_num_sen).
first(n_n_num_keta_sen,t_num_shi).
first(n_n_num_keta_sen,t_num_shichi).
first(n_n_num_keta_sen,t_num_ten).
first(n_n_num_keta_sen,t_num_tou).
first(n_n_num_keta_sen,t_num_yaq).
first(n_n_num_keta_sen,t_num_yo).
first(n_n_num_keta_sen,t_num_yon).
first(n_n_num_keta_sen,t_num_yoq).
first(n_n_num_keta_sen,t_num_you).
first(n_n_num_keta_sen,t_num_zen).
first(n_n_num_keta_zyuu,t_num_go).
first(n_n_num_keta_zyuu,t_num_hachi).
first(n_n_num_keta_zyuu,t_num_haq).
first(n_n_num_keta_zyuu,t_num_hito).
first(n_n_num_keta_zyuu,t_num_huta).
first(n_n_num_keta_zyuu,t_num_hutsu).
first(n_n_num_keta_zyuu,t_num_ichi).
first(n_n_num_keta_zyuu,t_num_iq).
first(n_n_num_keta_zyuu,t_num_itsu).
first(n_n_num_keta_zyuu,t_num_kokono).
first(n_n_num_keta_zyuu,t_num_ku).
first(n_n_num_keta_zyuu,t_num_kyuu).
first(n_n_num_keta_zyuu,t_num_miq).
first(n_n_num_keta_zyuu,t_num_mui).
first(n_n_num_keta_zyuu,t_num_muq).
first(n_n_num_keta_zyuu,t_num_nana).
first(n_n_num_keta_zyuu,t_num_nano).
first(n_n_num_keta_zyuu,t_num_ni).
first(n_n_num_keta_zyuu,t_num_one).
first(n_n_num_keta_zyuu,t_num_roku).
first(n_n_num_keta_zyuu,t_num_roq).
first(n_n_num_keta_zyuu,t_num_san).
first(n_n_num_keta_zyuu,t_num_shi).
first(n_n_num_keta_zyuu,t_num_shichi).
first(n_n_num_keta_zyuu,t_num_ten).
first(n_n_num_keta_zyuu,t_num_tou).
first(n_n_num_keta_zyuu,t_num_yaq).
first(n_n_num_keta_zyuu,t_num_yo).
first(n_n_num_keta_zyuu,t_num_yon).
first(n_n_num_keta_zyuu,t_num_yoq).
first(n_n_num_keta_zyuu,t_num_you).
first(n_n_num_keta_zyuu,t_num_zyuq).
first(n_n_num_keta_zyuu,t_num_zyuu).
first(n_n_num_man,t_num_go).
first(n_n_num_man,t_num_hachi).
first(n_n_num_man,t_num_haq).
first(n_n_num_man,t_num_hito).
first(n_n_num_man,t_num_huta).
first(n_n_num_man,t_num_hutsu).
first(n_n_num_man,t_num_ichi).
first(n_n_num_man,t_num_iq).
first(n_n_num_man,t_num_itsu).
first(n_n_num_man,t_num_kokono).
first(n_n_num_man,t_num_ku).
first(n_n_num_man,t_num_kyuu).
first(n_n_num_man,t_num_miq).
first(n_n_num_man,t_num_mui).
first(n_n_num_man,t_num_muq).
first(n_n_num_man,t_num_nana).
first(n_n_num_man,t_num_nano).
first(n_n_num_man,t_num_ni).
first(n_n_num_man,t_num_one).
first(n_n_num_man,t_num_roku).
first(n_n_num_man,t_num_roq).
first(n_n_num_man,t_num_san).
first(n_n_num_man,t_num_shi).
first(n_n_num_man,t_num_shichi).
first(n_n_num_man,t_num_ten).
first(n_n_num_man,t_num_tou).
first(n_n_num_man,t_num_yaq).
first(n_n_num_man,t_num_yo).
first(n_n_num_man,t_num_yon).
first(n_n_num_man,t_num_yoq).
first(n_n_num_man,t_num_you).
first(n_n_num_sen,t_num_go).
first(n_n_num_sen,t_num_hachi).
first(n_n_num_sen,t_num_haq).
first(n_n_num_sen,t_num_hito).
first(n_n_num_sen,t_num_huta).
first(n_n_num_sen,t_num_hutsu).
first(n_n_num_sen,t_num_ichi).
first(n_n_num_sen,t_num_iq).
first(n_n_num_sen,t_num_itsu).
first(n_n_num_sen,t_num_kokono).
first(n_n_num_sen,t_num_ku).
first(n_n_num_sen,t_num_kyuu).
first(n_n_num_sen,t_num_miq).
first(n_n_num_sen,t_num_mui).
first(n_n_num_sen,t_num_muq).
first(n_n_num_sen,t_num_nana).
first(n_n_num_sen,t_num_nano).
first(n_n_num_sen,t_num_ni).
first(n_n_num_sen,t_num_one).
first(n_n_num_sen,t_num_roku).
first(n_n_num_sen,t_num_roq).
first(n_n_num_sen,t_num_san).
first(n_n_num_sen,t_num_sen).
first(n_n_num_sen,t_num_shi).
first(n_n_num_sen,t_num_shichi).
first(n_n_num_sen,t_num_ten).
first(n_n_num_sen,t_num_tou).
first(n_n_num_sen,t_num_yaq).
first(n_n_num_sen,t_num_yo).
first(n_n_num_sen,t_num_yon).
first(n_n_num_sen,t_num_yoq).
first(n_n_num_sen,t_num_you).
first(n_n_num_sen,t_num_zen).
first(n_n_num_syosu,t_num_bouyomi).
first(n_n_num_ten,t_num_byaku).
first(n_n_num_ten,t_num_byaq).
first(n_n_num_ten,t_num_go).
first(n_n_num_ten,t_num_hachi).
first(n_n_num_ten,t_num_haq).
first(n_n_num_ten,t_num_hito).
first(n_n_num_ten,t_num_huta).
first(n_n_num_ten,t_num_hutsu).
first(n_n_num_ten,t_num_hyaku).
first(n_n_num_ten,t_num_hyaq).
first(n_n_num_ten,t_num_ichi).
first(n_n_num_ten,t_num_iq).
first(n_n_num_ten,t_num_itsu).
first(n_n_num_ten,t_num_kokono).
first(n_n_num_ten,t_num_ku).
first(n_n_num_ten,t_num_kyuu).
first(n_n_num_ten,t_num_miq).
first(n_n_num_ten,t_num_mui).
first(n_n_num_ten,t_num_muq).
first(n_n_num_ten,t_num_nana).
first(n_n_num_ten,t_num_nano).
first(n_n_num_ten,t_num_ni).
first(n_n_num_ten,t_num_one).
first(n_n_num_ten,t_num_pyaku).
first(n_n_num_ten,t_num_pyaq).
first(n_n_num_ten,t_num_roku).
first(n_n_num_ten,t_num_roq).
first(n_n_num_ten,t_num_san).
first(n_n_num_ten,t_num_sen).
first(n_n_num_ten,t_num_shi).
first(n_n_num_ten,t_num_shichi).
first(n_n_num_ten,t_num_ten).
first(n_n_num_ten,t_num_tou).
first(n_n_num_ten,t_num_yaq).
first(n_n_num_ten,t_num_yo).
first(n_n_num_ten,t_num_yon).
first(n_n_num_ten,t_num_yoq).
first(n_n_num_ten,t_num_you).
first(n_n_num_ten,t_num_zen).
first(n_n_num_ten,t_num_zyuq).
first(n_n_num_ten,t_num_zyuu).
first(n_n_num_zyuu,t_num_go).
first(n_n_num_zyuu,t_num_hachi).
first(n_n_num_zyuu,t_num_haq).
first(n_n_num_zyuu,t_num_hito).
first(n_n_num_zyuu,t_num_huta).
first(n_n_num_zyuu,t_num_hutsu).
first(n_n_num_zyuu,t_num_ichi).
first(n_n_num_zyuu,t_num_iq).
first(n_n_num_zyuu,t_num_itsu).
first(n_n_num_zyuu,t_num_kokono).
first(n_n_num_zyuu,t_num_ku).
first(n_n_num_zyuu,t_num_kyuu).
first(n_n_num_zyuu,t_num_miq).
first(n_n_num_zyuu,t_num_mui).
first(n_n_num_zyuu,t_num_muq).
first(n_n_num_zyuu,t_num_nana).
first(n_n_num_zyuu,t_num_nano).
first(n_n_num_zyuu,t_num_ni).
first(n_n_num_zyuu,t_num_one).
first(n_n_num_zyuu,t_num_roku).
first(n_n_num_zyuu,t_num_roq).
first(n_n_num_zyuu,t_num_san).
first(n_n_num_zyuu,t_num_shi).
first(n_n_num_zyuu,t_num_shichi).
first(n_n_num_zyuu,t_num_ten).
first(n_n_num_zyuu,t_num_tou).
first(n_n_num_zyuu,t_num_yaq).
first(n_n_num_zyuu,t_num_yo).
first(n_n_num_zyuu,t_num_yon).
first(n_n_num_zyuu,t_num_yoq).
first(n_n_num_zyuu,t_num_you).
first(n_n_num_zyuu,t_num_zyuq).
first(n_n_num_zyuu,t_num_zyuu).
first(n_n_proper,n_capacity).
first(n_n_proper,n_visitor_name).
first(n_n_proper,t_adj_meisi).
first(n_n_proper,t_adj_renyo_2FH_ga).
first(n_n_proper,t_adj_renyo_2FH_ga_de).
first(n_n_proper,t_adjstem_2FH_ga).
first(n_n_proper,t_adjstem_2FH_ga_de).
first(n_n_proper,t_adjstem_spe_2FH_ga_de).
first(n_n_proper,t_daimeisi).
first(n_n_proper,t_daimeisi_domo).
first(n_n_proper,t_daimeisi_exp).
first(n_n_proper,t_hukusi).
first(n_n_proper,t_hukusi_desu).
first(n_n_proper,t_hutu_meisi).
first(n_n_proper,t_hutu_meisi_post).
first(n_n_proper,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_proper,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_proper,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_proper,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_proper,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_proper,t_kdo_2FH_ga).
first(n_n_proper,t_kdo_2FH_ga_de).
first(n_n_proper,t_kdo_2FH_ga_to).
first(n_n_proper,t_koyuu_meisi).
first(n_n_proper,t_meisi_hi).
first(n_n_proper,t_meisi_hun).
first(n_n_proper,t_meisi_tsuki).
first(n_n_proper,t_meisi_youbi).
first(n_n_proper,t_meisi_zi).
first(n_n_proper,t_myoji_first).
first(n_n_proper,t_myoji_last).
first(n_n_proper,t_n_keisiki).
first(n_n_proper,t_namae_first).
first(n_n_proper,t_namae_last).
first(n_n_proper,t_num_bouyomi).
first(n_n_proper,t_num_byaku).
first(n_n_proper,t_num_byaq).
first(n_n_proper,t_num_go).
first(n_n_proper,t_num_hachi).
first(n_n_proper,t_num_haq).
first(n_n_proper,t_num_hito).
first(n_n_proper,t_num_huta).
first(n_n_proper,t_num_hutsu).
first(n_n_proper,t_num_hyaku).
first(n_n_proper,t_num_hyaq).
first(n_n_proper,t_num_ichi).
first(n_n_proper,t_num_iq).
first(n_n_proper,t_num_itsu).
first(n_n_proper,t_num_kokono).
first(n_n_proper,t_num_ku).
first(n_n_proper,t_num_kyuu).
first(n_n_proper,t_num_miq).
first(n_n_proper,t_num_mui).
first(n_n_proper,t_num_muq).
first(n_n_proper,t_num_nana).
first(n_n_proper,t_num_nano).
first(n_n_proper,t_num_ni).
first(n_n_proper,t_num_one).
first(n_n_proper,t_num_pyaku).
first(n_n_proper,t_num_pyaq).
first(n_n_proper,t_num_roku).
first(n_n_proper,t_num_roq).
first(n_n_proper,t_num_san).
first(n_n_proper,t_num_sen).
first(n_n_proper,t_num_shi).
first(n_n_proper,t_num_shichi).
first(n_n_proper,t_num_ten).
first(n_n_proper,t_num_tou).
first(n_n_proper,t_num_yaq).
first(n_n_proper,t_num_yo).
first(n_n_proper,t_num_yon).
first(n_n_proper,t_num_yoq).
first(n_n_proper,t_num_you).
first(n_n_proper,t_num_zen).
first(n_n_proper,t_num_zyuq).
first(n_n_proper,t_num_zyuu).
first(n_n_proper,t_prefix_go).
first(n_n_proper,t_prefix_hutu_hutu).
first(n_n_proper,t_prefix_o).
first(n_n_proper,t_prefix_quant_quant).
first(n_n_proper,t_rentai).
first(n_n_proper,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_proper,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_proper,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_proper,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_proper,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_proper,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_proper,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_proper,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_proper,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_proper,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_proper,t_sahen_meisi_2FH_ga).
first(n_n_proper,t_sahen_meisi_2FH_ga_ni).
first(n_n_proper,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_proper,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_proper,t_sahen_meisi_2FH_ga_o).
first(n_n_proper,t_sahen_meisi_2FH_ga_to).
first(n_n_proper,t_sahen_meisi_pol_2FH_ga).
first(n_n_proper,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_proper,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_proper,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_proper,t_suuryousi).
first(n_n_proper,t_teido_hukusi).
first(n_n_proper,t_tsuzuri).
first(n_n_proper,t_vstem_1_2FH_ga).
first(n_n_proper,t_vstem_1_2FH_ga_de).
first(n_n_proper,t_vstem_1_2FH_ga_ni).
first(n_n_proper,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_proper,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_proper,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_proper,t_vstem_1_2FH_ga_ni_o).
first(n_n_proper,t_vstem_1_2FH_ga_o).
first(n_n_proper,t_vstem_1_2FH_ga_quote).
first(n_n_proper,t_vstem_1_2FH_ga_to).
first(n_n_proper,t_vstem_5_b_2FH_ga).
first(n_n_proper,t_vstem_5_b_2FH_ga_ni).
first(n_n_proper,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_b_2FH_ga_o).
first(n_n_proper,t_vstem_5_b_2FH_ga_to).
first(n_n_proper,t_vstem_5_g_2FH_ga).
first(n_n_proper,t_vstem_5_g_2FH_ga_ni).
first(n_n_proper,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_g_2FH_ga_o).
first(n_n_proper,t_vstem_5_k_2FH_ga).
first(n_n_proper,t_vstem_5_k_2FH_ga_ni).
first(n_n_proper,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_k_2FH_ga_o).
first(n_n_proper,t_vstem_5_k_2FH_ga_to).
first(n_n_proper,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_proper,t_vstem_5_m_2FH_ga).
first(n_n_proper,t_vstem_5_m_2FH_ga_ni).
first(n_n_proper,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_proper,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_m_2FH_ga_o).
first(n_n_proper,t_vstem_5_m_2FH_ga_to).
first(n_n_proper,t_vstem_5_r_2FH_ga).
first(n_n_proper,t_vstem_5_r_2FH_ga_ni).
first(n_n_proper,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_proper,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_proper,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_r_2FH_ga_o).
first(n_n_proper,t_vstem_5_r_2FH_ga_to).
first(n_n_proper,t_vstem_5_r_i_2FH_ga).
first(n_n_proper,t_vstem_5_r_i_2FH_ga_o).
first(n_n_proper,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_proper,t_vstem_5_s_2FH_ga).
first(n_n_proper,t_vstem_5_s_2FH_ga_ni).
first(n_n_proper,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_s_2FH_ga_o).
first(n_n_proper,t_vstem_5_s_2FH_ga_quote).
first(n_n_proper,t_vstem_5_s_2FH_ga_to).
first(n_n_proper,t_vstem_5_t_2FH_ga).
first(n_n_proper,t_vstem_5_t_2FH_ga_ni).
first(n_n_proper,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_proper,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_t_2FH_ga_o).
first(n_n_proper,t_vstem_5_t_2FH_ga_to).
first(n_n_proper,t_vstem_5_w_2FH_ga).
first(n_n_proper,t_vstem_5_w_2FH_ga_de).
first(n_n_proper,t_vstem_5_w_2FH_ga_ni).
first(n_n_proper,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_proper,t_vstem_5_w_2FH_ga_o).
first(n_n_proper,t_vstem_5_w_2FH_ga_quote).
first(n_n_proper,t_vstem_5_w_2FH_ga_to).
first(n_n_proper,t_vstem_masu_2FH_ga).
first(n_n_proper,t_vstem_sahen_2FH_ga_ni).
first(n_n_proper,t_wh_daimeisi).
first(n_n_proper,t_wh_daimeisi_nan).
first(n_n_proper,t_wh_hukusi).
first(n_n_proper,t_zikan_meisi).
first(n_n_proper,t_zikan_meisi_ippai).
first(n_n_proper,t_zikantai).
first(n_n_quant,n_capacity).
first(n_n_quant,n_visitor_name).
first(n_n_quant,t_adj_meisi).
first(n_n_quant,t_adj_renyo_2FH_ga).
first(n_n_quant,t_adj_renyo_2FH_ga_de).
first(n_n_quant,t_adjstem_2FH_ga).
first(n_n_quant,t_adjstem_2FH_ga_de).
first(n_n_quant,t_adjstem_spe_2FH_ga_de).
first(n_n_quant,t_daimeisi).
first(n_n_quant,t_daimeisi_domo).
first(n_n_quant,t_daimeisi_exp).
first(n_n_quant,t_hukusi).
first(n_n_quant,t_hukusi_desu).
first(n_n_quant,t_hutu_meisi).
first(n_n_quant,t_hutu_meisi_post).
first(n_n_quant,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_quant,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_quant,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_quant,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_quant,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_quant,t_kdo_2FH_ga).
first(n_n_quant,t_kdo_2FH_ga_de).
first(n_n_quant,t_kdo_2FH_ga_to).
first(n_n_quant,t_koyuu_meisi).
first(n_n_quant,t_meisi_hi).
first(n_n_quant,t_meisi_hun).
first(n_n_quant,t_meisi_tsuki).
first(n_n_quant,t_meisi_youbi).
first(n_n_quant,t_meisi_zi).
first(n_n_quant,t_myoji_first).
first(n_n_quant,t_myoji_last).
first(n_n_quant,t_n_keisiki).
first(n_n_quant,t_namae_first).
first(n_n_quant,t_namae_last).
first(n_n_quant,t_num_bouyomi).
first(n_n_quant,t_num_byaku).
first(n_n_quant,t_num_byaq).
first(n_n_quant,t_num_go).
first(n_n_quant,t_num_hachi).
first(n_n_quant,t_num_haq).
first(n_n_quant,t_num_hito).
first(n_n_quant,t_num_huta).
first(n_n_quant,t_num_hutsu).
first(n_n_quant,t_num_hyaku).
first(n_n_quant,t_num_hyaq).
first(n_n_quant,t_num_ichi).
first(n_n_quant,t_num_iq).
first(n_n_quant,t_num_itsu).
first(n_n_quant,t_num_kokono).
first(n_n_quant,t_num_ku).
first(n_n_quant,t_num_kyuu).
first(n_n_quant,t_num_miq).
first(n_n_quant,t_num_mui).
first(n_n_quant,t_num_muq).
first(n_n_quant,t_num_nana).
first(n_n_quant,t_num_nano).
first(n_n_quant,t_num_ni).
first(n_n_quant,t_num_one).
first(n_n_quant,t_num_pyaku).
first(n_n_quant,t_num_pyaq).
first(n_n_quant,t_num_roku).
first(n_n_quant,t_num_roq).
first(n_n_quant,t_num_san).
first(n_n_quant,t_num_sen).
first(n_n_quant,t_num_shi).
first(n_n_quant,t_num_shichi).
first(n_n_quant,t_num_ten).
first(n_n_quant,t_num_tou).
first(n_n_quant,t_num_yaq).
first(n_n_quant,t_num_yo).
first(n_n_quant,t_num_yon).
first(n_n_quant,t_num_yoq).
first(n_n_quant,t_num_you).
first(n_n_quant,t_num_zen).
first(n_n_quant,t_num_zyuq).
first(n_n_quant,t_num_zyuu).
first(n_n_quant,t_prefix_go).
first(n_n_quant,t_prefix_hutu_hutu).
first(n_n_quant,t_prefix_o).
first(n_n_quant,t_prefix_quant_quant).
first(n_n_quant,t_rentai).
first(n_n_quant,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_quant,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_quant,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_quant,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_quant,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_quant,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_quant,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_quant,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_quant,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_quant,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_quant,t_sahen_meisi_2FH_ga).
first(n_n_quant,t_sahen_meisi_2FH_ga_ni).
first(n_n_quant,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_quant,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_quant,t_sahen_meisi_2FH_ga_o).
first(n_n_quant,t_sahen_meisi_2FH_ga_to).
first(n_n_quant,t_sahen_meisi_pol_2FH_ga).
first(n_n_quant,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_quant,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_quant,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_quant,t_suuryousi).
first(n_n_quant,t_teido_hukusi).
first(n_n_quant,t_tsuzuri).
first(n_n_quant,t_vstem_1_2FH_ga).
first(n_n_quant,t_vstem_1_2FH_ga_de).
first(n_n_quant,t_vstem_1_2FH_ga_ni).
first(n_n_quant,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_quant,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_quant,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_quant,t_vstem_1_2FH_ga_ni_o).
first(n_n_quant,t_vstem_1_2FH_ga_o).
first(n_n_quant,t_vstem_1_2FH_ga_quote).
first(n_n_quant,t_vstem_1_2FH_ga_to).
first(n_n_quant,t_vstem_5_b_2FH_ga).
first(n_n_quant,t_vstem_5_b_2FH_ga_ni).
first(n_n_quant,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_b_2FH_ga_o).
first(n_n_quant,t_vstem_5_b_2FH_ga_to).
first(n_n_quant,t_vstem_5_g_2FH_ga).
first(n_n_quant,t_vstem_5_g_2FH_ga_ni).
first(n_n_quant,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_g_2FH_ga_o).
first(n_n_quant,t_vstem_5_k_2FH_ga).
first(n_n_quant,t_vstem_5_k_2FH_ga_ni).
first(n_n_quant,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_k_2FH_ga_o).
first(n_n_quant,t_vstem_5_k_2FH_ga_to).
first(n_n_quant,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_quant,t_vstem_5_m_2FH_ga).
first(n_n_quant,t_vstem_5_m_2FH_ga_ni).
first(n_n_quant,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_quant,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_m_2FH_ga_o).
first(n_n_quant,t_vstem_5_m_2FH_ga_to).
first(n_n_quant,t_vstem_5_r_2FH_ga).
first(n_n_quant,t_vstem_5_r_2FH_ga_ni).
first(n_n_quant,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_quant,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_quant,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_r_2FH_ga_o).
first(n_n_quant,t_vstem_5_r_2FH_ga_to).
first(n_n_quant,t_vstem_5_r_i_2FH_ga).
first(n_n_quant,t_vstem_5_r_i_2FH_ga_o).
first(n_n_quant,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_quant,t_vstem_5_s_2FH_ga).
first(n_n_quant,t_vstem_5_s_2FH_ga_ni).
first(n_n_quant,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_s_2FH_ga_o).
first(n_n_quant,t_vstem_5_s_2FH_ga_quote).
first(n_n_quant,t_vstem_5_s_2FH_ga_to).
first(n_n_quant,t_vstem_5_t_2FH_ga).
first(n_n_quant,t_vstem_5_t_2FH_ga_ni).
first(n_n_quant,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_quant,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_t_2FH_ga_o).
first(n_n_quant,t_vstem_5_t_2FH_ga_to).
first(n_n_quant,t_vstem_5_w_2FH_ga).
first(n_n_quant,t_vstem_5_w_2FH_ga_de).
first(n_n_quant,t_vstem_5_w_2FH_ga_ni).
first(n_n_quant,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_quant,t_vstem_5_w_2FH_ga_o).
first(n_n_quant,t_vstem_5_w_2FH_ga_quote).
first(n_n_quant,t_vstem_5_w_2FH_ga_to).
first(n_n_quant,t_vstem_masu_2FH_ga).
first(n_n_quant,t_vstem_sahen_2FH_ga_ni).
first(n_n_quant,t_wh_daimeisi).
first(n_n_quant,t_wh_daimeisi_nan).
first(n_n_quant,t_wh_hukusi).
first(n_n_quant,t_zikan_meisi).
first(n_n_quant,t_zikan_meisi_ippai).
first(n_n_quant,t_zikantai).
first(n_n_sahen,n_capacity).
first(n_n_sahen,n_visitor_name).
first(n_n_sahen,t_adj_meisi).
first(n_n_sahen,t_adj_renyo_2FH_ga).
first(n_n_sahen,t_adj_renyo_2FH_ga_de).
first(n_n_sahen,t_adjstem_2FH_ga).
first(n_n_sahen,t_adjstem_2FH_ga_de).
first(n_n_sahen,t_adjstem_spe_2FH_ga_de).
first(n_n_sahen,t_daimeisi).
first(n_n_sahen,t_daimeisi_domo).
first(n_n_sahen,t_daimeisi_exp).
first(n_n_sahen,t_hukusi).
first(n_n_sahen,t_hukusi_desu).
first(n_n_sahen,t_hutu_meisi).
first(n_n_sahen,t_hutu_meisi_post).
first(n_n_sahen,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_sahen,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_sahen,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_sahen,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_sahen,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_sahen,t_kdo_2FH_ga).
first(n_n_sahen,t_kdo_2FH_ga_de).
first(n_n_sahen,t_kdo_2FH_ga_to).
first(n_n_sahen,t_koyuu_meisi).
first(n_n_sahen,t_meisi_hi).
first(n_n_sahen,t_meisi_hun).
first(n_n_sahen,t_meisi_tsuki).
first(n_n_sahen,t_meisi_youbi).
first(n_n_sahen,t_meisi_zi).
first(n_n_sahen,t_myoji_first).
first(n_n_sahen,t_myoji_last).
first(n_n_sahen,t_n_keisiki).
first(n_n_sahen,t_namae_first).
first(n_n_sahen,t_namae_last).
first(n_n_sahen,t_num_bouyomi).
first(n_n_sahen,t_num_byaku).
first(n_n_sahen,t_num_byaq).
first(n_n_sahen,t_num_go).
first(n_n_sahen,t_num_hachi).
first(n_n_sahen,t_num_haq).
first(n_n_sahen,t_num_hito).
first(n_n_sahen,t_num_huta).
first(n_n_sahen,t_num_hutsu).
first(n_n_sahen,t_num_hyaku).
first(n_n_sahen,t_num_hyaq).
first(n_n_sahen,t_num_ichi).
first(n_n_sahen,t_num_iq).
first(n_n_sahen,t_num_itsu).
first(n_n_sahen,t_num_kokono).
first(n_n_sahen,t_num_ku).
first(n_n_sahen,t_num_kyuu).
first(n_n_sahen,t_num_miq).
first(n_n_sahen,t_num_mui).
first(n_n_sahen,t_num_muq).
first(n_n_sahen,t_num_nana).
first(n_n_sahen,t_num_nano).
first(n_n_sahen,t_num_ni).
first(n_n_sahen,t_num_one).
first(n_n_sahen,t_num_pyaku).
first(n_n_sahen,t_num_pyaq).
first(n_n_sahen,t_num_roku).
first(n_n_sahen,t_num_roq).
first(n_n_sahen,t_num_san).
first(n_n_sahen,t_num_sen).
first(n_n_sahen,t_num_shi).
first(n_n_sahen,t_num_shichi).
first(n_n_sahen,t_num_ten).
first(n_n_sahen,t_num_tou).
first(n_n_sahen,t_num_yaq).
first(n_n_sahen,t_num_yo).
first(n_n_sahen,t_num_yon).
first(n_n_sahen,t_num_yoq).
first(n_n_sahen,t_num_you).
first(n_n_sahen,t_num_zen).
first(n_n_sahen,t_num_zyuq).
first(n_n_sahen,t_num_zyuu).
first(n_n_sahen,t_prefix_go).
first(n_n_sahen,t_prefix_hutu_hutu).
first(n_n_sahen,t_prefix_o).
first(n_n_sahen,t_prefix_quant_quant).
first(n_n_sahen,t_rentai).
first(n_n_sahen,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_sahen,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_sahen,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_sahen,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_sahen,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_sahen,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_sahen,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_sahen,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_sahen,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_sahen,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_sahen,t_sahen_meisi_2FH_ga).
first(n_n_sahen,t_sahen_meisi_2FH_ga_ni).
first(n_n_sahen,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_sahen,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_sahen,t_sahen_meisi_2FH_ga_o).
first(n_n_sahen,t_sahen_meisi_2FH_ga_to).
first(n_n_sahen,t_sahen_meisi_pol_2FH_ga).
first(n_n_sahen,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_sahen,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_sahen,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_sahen,t_suuryousi).
first(n_n_sahen,t_teido_hukusi).
first(n_n_sahen,t_tsuzuri).
first(n_n_sahen,t_vstem_1_2FH_ga).
first(n_n_sahen,t_vstem_1_2FH_ga_de).
first(n_n_sahen,t_vstem_1_2FH_ga_ni).
first(n_n_sahen,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_sahen,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_sahen,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_sahen,t_vstem_1_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_1_2FH_ga_o).
first(n_n_sahen,t_vstem_1_2FH_ga_quote).
first(n_n_sahen,t_vstem_1_2FH_ga_to).
first(n_n_sahen,t_vstem_5_b_2FH_ga).
first(n_n_sahen,t_vstem_5_b_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_b_2FH_ga_o).
first(n_n_sahen,t_vstem_5_b_2FH_ga_to).
first(n_n_sahen,t_vstem_5_g_2FH_ga).
first(n_n_sahen,t_vstem_5_g_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_g_2FH_ga_o).
first(n_n_sahen,t_vstem_5_k_2FH_ga).
first(n_n_sahen,t_vstem_5_k_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_k_2FH_ga_o).
first(n_n_sahen,t_vstem_5_k_2FH_ga_to).
first(n_n_sahen,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_sahen,t_vstem_5_m_2FH_ga).
first(n_n_sahen,t_vstem_5_m_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_sahen,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_m_2FH_ga_o).
first(n_n_sahen,t_vstem_5_m_2FH_ga_to).
first(n_n_sahen,t_vstem_5_r_2FH_ga).
first(n_n_sahen,t_vstem_5_r_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_sahen,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_sahen,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_r_2FH_ga_o).
first(n_n_sahen,t_vstem_5_r_2FH_ga_to).
first(n_n_sahen,t_vstem_5_r_i_2FH_ga).
first(n_n_sahen,t_vstem_5_r_i_2FH_ga_o).
first(n_n_sahen,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_sahen,t_vstem_5_s_2FH_ga).
first(n_n_sahen,t_vstem_5_s_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_s_2FH_ga_o).
first(n_n_sahen,t_vstem_5_s_2FH_ga_quote).
first(n_n_sahen,t_vstem_5_s_2FH_ga_to).
first(n_n_sahen,t_vstem_5_t_2FH_ga).
first(n_n_sahen,t_vstem_5_t_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_sahen,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_t_2FH_ga_o).
first(n_n_sahen,t_vstem_5_t_2FH_ga_to).
first(n_n_sahen,t_vstem_5_w_2FH_ga).
first(n_n_sahen,t_vstem_5_w_2FH_ga_de).
first(n_n_sahen,t_vstem_5_w_2FH_ga_ni).
first(n_n_sahen,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_sahen,t_vstem_5_w_2FH_ga_o).
first(n_n_sahen,t_vstem_5_w_2FH_ga_quote).
first(n_n_sahen,t_vstem_5_w_2FH_ga_to).
first(n_n_sahen,t_vstem_masu_2FH_ga).
first(n_n_sahen,t_vstem_sahen_2FH_ga_ni).
first(n_n_sahen,t_wh_daimeisi).
first(n_n_sahen,t_wh_daimeisi_nan).
first(n_n_sahen,t_wh_hukusi).
first(n_n_sahen,t_zikan_meisi).
first(n_n_sahen,t_zikan_meisi_ippai).
first(n_n_sahen,t_zikantai).
first(n_n_sahen_2FH_ga,t_prefix_go).
first(n_n_sahen_2FH_ga,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga,t_prefix_o).
first(n_n_sahen_2FH_ga,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga,t_sahen_meisi_2FH_ga).
first(n_n_sahen_2FH_ga,t_sahen_meisi_pol_2FH_ga).
first(n_n_sahen_2FH_ga_de,t_prefix_go).
first(n_n_sahen_2FH_ga_de,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_de,t_prefix_o).
first(n_n_sahen_2FH_ga_de,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_ni,n_capacity).
first(n_n_sahen_2FH_ga_ni,n_visitor_name).
first(n_n_sahen_2FH_ga_ni,t_adj_meisi).
first(n_n_sahen_2FH_ga_ni,t_adj_renyo_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_adj_renyo_2FH_ga_de).
first(n_n_sahen_2FH_ga_ni,t_adjstem_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_adjstem_2FH_ga_de).
first(n_n_sahen_2FH_ga_ni,t_adjstem_spe_2FH_ga_de).
first(n_n_sahen_2FH_ga_ni,t_daimeisi).
first(n_n_sahen_2FH_ga_ni,t_daimeisi_domo).
first(n_n_sahen_2FH_ga_ni,t_daimeisi_exp).
first(n_n_sahen_2FH_ga_ni,t_hukusi).
first(n_n_sahen_2FH_ga_ni,t_hukusi_desu).
first(n_n_sahen_2FH_ga_ni,t_hutu_meisi).
first(n_n_sahen_2FH_ga_ni,t_hutu_meisi_post).
first(n_n_sahen_2FH_ga_ni,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_kdo_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_kdo_2FH_ga_de).
first(n_n_sahen_2FH_ga_ni,t_kdo_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_koyuu_meisi).
first(n_n_sahen_2FH_ga_ni,t_meisi_hi).
first(n_n_sahen_2FH_ga_ni,t_meisi_hun).
first(n_n_sahen_2FH_ga_ni,t_meisi_tsuki).
first(n_n_sahen_2FH_ga_ni,t_meisi_youbi).
first(n_n_sahen_2FH_ga_ni,t_meisi_zi).
first(n_n_sahen_2FH_ga_ni,t_myoji_first).
first(n_n_sahen_2FH_ga_ni,t_myoji_last).
first(n_n_sahen_2FH_ga_ni,t_n_keisiki).
first(n_n_sahen_2FH_ga_ni,t_namae_first).
first(n_n_sahen_2FH_ga_ni,t_namae_last).
first(n_n_sahen_2FH_ga_ni,t_num_bouyomi).
first(n_n_sahen_2FH_ga_ni,t_num_byaku).
first(n_n_sahen_2FH_ga_ni,t_num_byaq).
first(n_n_sahen_2FH_ga_ni,t_num_go).
first(n_n_sahen_2FH_ga_ni,t_num_hachi).
first(n_n_sahen_2FH_ga_ni,t_num_haq).
first(n_n_sahen_2FH_ga_ni,t_num_hito).
first(n_n_sahen_2FH_ga_ni,t_num_huta).
first(n_n_sahen_2FH_ga_ni,t_num_hutsu).
first(n_n_sahen_2FH_ga_ni,t_num_hyaku).
first(n_n_sahen_2FH_ga_ni,t_num_hyaq).
first(n_n_sahen_2FH_ga_ni,t_num_ichi).
first(n_n_sahen_2FH_ga_ni,t_num_iq).
first(n_n_sahen_2FH_ga_ni,t_num_itsu).
first(n_n_sahen_2FH_ga_ni,t_num_kokono).
first(n_n_sahen_2FH_ga_ni,t_num_ku).
first(n_n_sahen_2FH_ga_ni,t_num_kyuu).
first(n_n_sahen_2FH_ga_ni,t_num_miq).
first(n_n_sahen_2FH_ga_ni,t_num_mui).
first(n_n_sahen_2FH_ga_ni,t_num_muq).
first(n_n_sahen_2FH_ga_ni,t_num_nana).
first(n_n_sahen_2FH_ga_ni,t_num_nano).
first(n_n_sahen_2FH_ga_ni,t_num_ni).
first(n_n_sahen_2FH_ga_ni,t_num_one).
first(n_n_sahen_2FH_ga_ni,t_num_pyaku).
first(n_n_sahen_2FH_ga_ni,t_num_pyaq).
first(n_n_sahen_2FH_ga_ni,t_num_roku).
first(n_n_sahen_2FH_ga_ni,t_num_roq).
first(n_n_sahen_2FH_ga_ni,t_num_san).
first(n_n_sahen_2FH_ga_ni,t_num_sen).
first(n_n_sahen_2FH_ga_ni,t_num_shi).
first(n_n_sahen_2FH_ga_ni,t_num_shichi).
first(n_n_sahen_2FH_ga_ni,t_num_ten).
first(n_n_sahen_2FH_ga_ni,t_num_tou).
first(n_n_sahen_2FH_ga_ni,t_num_yaq).
first(n_n_sahen_2FH_ga_ni,t_num_yo).
first(n_n_sahen_2FH_ga_ni,t_num_yon).
first(n_n_sahen_2FH_ga_ni,t_num_yoq).
first(n_n_sahen_2FH_ga_ni,t_num_you).
first(n_n_sahen_2FH_ga_ni,t_num_zen).
first(n_n_sahen_2FH_ga_ni,t_num_zyuq).
first(n_n_sahen_2FH_ga_ni,t_num_zyuu).
first(n_n_sahen_2FH_ga_ni,t_prefix_go).
first(n_n_sahen_2FH_ga_ni,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_ni,t_prefix_o).
first(n_n_sahen_2FH_ga_ni,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_ni,t_rentai).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_suuryousi).
first(n_n_sahen_2FH_ga_ni,t_teido_hukusi).
first(n_n_sahen_2FH_ga_ni,t_tsuzuri).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_de).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_quote).
first(n_n_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_quote).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_de).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_o).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_quote).
first(n_n_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_to).
first(n_n_sahen_2FH_ga_ni,t_vstem_masu_2FH_ga).
first(n_n_sahen_2FH_ga_ni,t_vstem_sahen_2FH_ga_ni).
first(n_n_sahen_2FH_ga_ni,t_wh_daimeisi).
first(n_n_sahen_2FH_ga_ni,t_wh_daimeisi_nan).
first(n_n_sahen_2FH_ga_ni,t_wh_hukusi).
first(n_n_sahen_2FH_ga_ni,t_zikan_meisi).
first(n_n_sahen_2FH_ga_ni,t_zikan_meisi_ippai).
first(n_n_sahen_2FH_ga_ni,t_zikantai).
first(n_n_sahen_2FH_ga_ni_5EH_e,t_prefix_go).
first(n_n_sahen_2FH_ga_ni_5EH_e,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_ni_5EH_e,t_prefix_o).
first(n_n_sahen_2FH_ga_ni_5EH_e,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_ni_5EH_e,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_sahen_2FH_ga_ni_5EH_e_o,t_prefix_go).
first(n_n_sahen_2FH_ga_ni_5EH_e_o,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_ni_5EH_e_o,t_prefix_o).
first(n_n_sahen_2FH_ga_ni_5EH_e_o,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_ni_5EH_to,t_prefix_go).
first(n_n_sahen_2FH_ga_ni_5EH_to,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_ni_5EH_to,t_prefix_o).
first(n_n_sahen_2FH_ga_ni_5EH_to,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_ni_o,t_prefix_go).
first(n_n_sahen_2FH_ga_ni_o,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_ni_o,t_prefix_o).
first(n_n_sahen_2FH_ga_ni_o,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_ni_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_sahen_2FH_ga_o,t_prefix_go).
first(n_n_sahen_2FH_ga_o,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_o,t_prefix_o).
first(n_n_sahen_2FH_ga_o,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_o,t_sahen_meisi_2FH_ga_o).
first(n_n_sahen_2FH_ga_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_sahen_2FH_ga_quote,t_prefix_go).
first(n_n_sahen_2FH_ga_quote,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_quote,t_prefix_o).
first(n_n_sahen_2FH_ga_quote,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_to,t_prefix_go).
first(n_n_sahen_2FH_ga_to,t_prefix_hutu_hutu).
first(n_n_sahen_2FH_ga_to,t_prefix_o).
first(n_n_sahen_2FH_ga_to,t_prefix_quant_quant).
first(n_n_sahen_2FH_ga_to,t_sahen_meisi_2FH_ga_to).
first(n_n_sahen_2FH_ga_to,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_spel,t_tsuzuri).
first(n_n_time,n_capacity).
first(n_n_time,n_visitor_name).
first(n_n_time,t_adj_meisi).
first(n_n_time,t_adj_renyo_2FH_ga).
first(n_n_time,t_adj_renyo_2FH_ga_de).
first(n_n_time,t_adjstem_2FH_ga).
first(n_n_time,t_adjstem_2FH_ga_de).
first(n_n_time,t_adjstem_spe_2FH_ga_de).
first(n_n_time,t_daimeisi).
first(n_n_time,t_daimeisi_domo).
first(n_n_time,t_daimeisi_exp).
first(n_n_time,t_hukusi).
first(n_n_time,t_hukusi_desu).
first(n_n_time,t_hutu_meisi).
first(n_n_time,t_hutu_meisi_post).
first(n_n_time,t_kahen_dousi_katei_2FH_ga_ni).
first(n_n_time,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_n_time,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_n_time,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_n_time,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_n_time,t_kdo_2FH_ga).
first(n_n_time,t_kdo_2FH_ga_de).
first(n_n_time,t_kdo_2FH_ga_to).
first(n_n_time,t_koyuu_meisi).
first(n_n_time,t_meisi_hi).
first(n_n_time,t_meisi_hun).
first(n_n_time,t_meisi_tsuki).
first(n_n_time,t_meisi_youbi).
first(n_n_time,t_meisi_zi).
first(n_n_time,t_myoji_first).
first(n_n_time,t_myoji_last).
first(n_n_time,t_n_keisiki).
first(n_n_time,t_namae_first).
first(n_n_time,t_namae_last).
first(n_n_time,t_num_bouyomi).
first(n_n_time,t_num_byaku).
first(n_n_time,t_num_byaq).
first(n_n_time,t_num_go).
first(n_n_time,t_num_hachi).
first(n_n_time,t_num_haq).
first(n_n_time,t_num_hito).
first(n_n_time,t_num_huta).
first(n_n_time,t_num_hutsu).
first(n_n_time,t_num_hyaku).
first(n_n_time,t_num_hyaq).
first(n_n_time,t_num_ichi).
first(n_n_time,t_num_iq).
first(n_n_time,t_num_itsu).
first(n_n_time,t_num_kokono).
first(n_n_time,t_num_ku).
first(n_n_time,t_num_kyuu).
first(n_n_time,t_num_miq).
first(n_n_time,t_num_mui).
first(n_n_time,t_num_muq).
first(n_n_time,t_num_nana).
first(n_n_time,t_num_nano).
first(n_n_time,t_num_ni).
first(n_n_time,t_num_one).
first(n_n_time,t_num_pyaku).
first(n_n_time,t_num_pyaq).
first(n_n_time,t_num_roku).
first(n_n_time,t_num_roq).
first(n_n_time,t_num_san).
first(n_n_time,t_num_sen).
first(n_n_time,t_num_shi).
first(n_n_time,t_num_shichi).
first(n_n_time,t_num_ten).
first(n_n_time,t_num_tou).
first(n_n_time,t_num_yaq).
first(n_n_time,t_num_yo).
first(n_n_time,t_num_yon).
first(n_n_time,t_num_yoq).
first(n_n_time,t_num_you).
first(n_n_time,t_num_zen).
first(n_n_time,t_num_zyuq).
first(n_n_time,t_num_zyuu).
first(n_n_time,t_prefix_go).
first(n_n_time,t_prefix_hutu_hutu).
first(n_n_time,t_prefix_o).
first(n_n_time,t_prefix_quant_quant).
first(n_n_time,t_rentai).
first(n_n_time,t_sahen_dousi_katei_2FH_ga_ni).
first(n_n_time,t_sahen_dousi_katei_2FH_ga_o).
first(n_n_time,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_n_time,t_sahen_dousi_mizen_2FH_ga_o).
first(n_n_time,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_n_time,t_sahen_dousi_rentai_2FH_ga_o).
first(n_n_time,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_n_time,t_sahen_dousi_renyo_2FH_ga_o).
first(n_n_time,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_n_time,t_sahen_dousi_syusi_2FH_ga_o).
first(n_n_time,t_sahen_meisi_2FH_ga).
first(n_n_time,t_sahen_meisi_2FH_ga_ni).
first(n_n_time,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_n_time,t_sahen_meisi_2FH_ga_ni_o).
first(n_n_time,t_sahen_meisi_2FH_ga_o).
first(n_n_time,t_sahen_meisi_2FH_ga_to).
first(n_n_time,t_sahen_meisi_pol_2FH_ga).
first(n_n_time,t_sahen_meisi_pol_2FH_ga_ni).
first(n_n_time,t_sahen_meisi_pol_2FH_ga_o).
first(n_n_time,t_sahen_meisi_pol_2FH_ga_to).
first(n_n_time,t_suuryousi).
first(n_n_time,t_teido_hukusi).
first(n_n_time,t_tsuzuri).
first(n_n_time,t_vstem_1_2FH_ga).
first(n_n_time,t_vstem_1_2FH_ga_de).
first(n_n_time,t_vstem_1_2FH_ga_ni).
first(n_n_time,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_n_time,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_n_time,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_n_time,t_vstem_1_2FH_ga_ni_o).
first(n_n_time,t_vstem_1_2FH_ga_o).
first(n_n_time,t_vstem_1_2FH_ga_quote).
first(n_n_time,t_vstem_1_2FH_ga_to).
first(n_n_time,t_vstem_5_b_2FH_ga).
first(n_n_time,t_vstem_5_b_2FH_ga_ni).
first(n_n_time,t_vstem_5_b_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_b_2FH_ga_o).
first(n_n_time,t_vstem_5_b_2FH_ga_to).
first(n_n_time,t_vstem_5_g_2FH_ga).
first(n_n_time,t_vstem_5_g_2FH_ga_ni).
first(n_n_time,t_vstem_5_g_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_g_2FH_ga_o).
first(n_n_time,t_vstem_5_k_2FH_ga).
first(n_n_time,t_vstem_5_k_2FH_ga_ni).
first(n_n_time,t_vstem_5_k_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_k_2FH_ga_o).
first(n_n_time,t_vstem_5_k_2FH_ga_to).
first(n_n_time,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_n_time,t_vstem_5_m_2FH_ga).
first(n_n_time,t_vstem_5_m_2FH_ga_ni).
first(n_n_time,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_n_time,t_vstem_5_m_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_m_2FH_ga_o).
first(n_n_time,t_vstem_5_m_2FH_ga_to).
first(n_n_time,t_vstem_5_r_2FH_ga).
first(n_n_time,t_vstem_5_r_2FH_ga_ni).
first(n_n_time,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_n_time,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_n_time,t_vstem_5_r_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_r_2FH_ga_o).
first(n_n_time,t_vstem_5_r_2FH_ga_to).
first(n_n_time,t_vstem_5_r_i_2FH_ga).
first(n_n_time,t_vstem_5_r_i_2FH_ga_o).
first(n_n_time,t_vstem_5_r_i_2FH_ga_quote).
first(n_n_time,t_vstem_5_s_2FH_ga).
first(n_n_time,t_vstem_5_s_2FH_ga_ni).
first(n_n_time,t_vstem_5_s_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_s_2FH_ga_o).
first(n_n_time,t_vstem_5_s_2FH_ga_quote).
first(n_n_time,t_vstem_5_s_2FH_ga_to).
first(n_n_time,t_vstem_5_t_2FH_ga).
first(n_n_time,t_vstem_5_t_2FH_ga_ni).
first(n_n_time,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_n_time,t_vstem_5_t_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_t_2FH_ga_o).
first(n_n_time,t_vstem_5_t_2FH_ga_to).
first(n_n_time,t_vstem_5_w_2FH_ga).
first(n_n_time,t_vstem_5_w_2FH_ga_de).
first(n_n_time,t_vstem_5_w_2FH_ga_ni).
first(n_n_time,t_vstem_5_w_2FH_ga_ni_o).
first(n_n_time,t_vstem_5_w_2FH_ga_o).
first(n_n_time,t_vstem_5_w_2FH_ga_quote).
first(n_n_time,t_vstem_5_w_2FH_ga_to).
first(n_n_time,t_vstem_masu_2FH_ga).
first(n_n_time,t_vstem_sahen_2FH_ga_ni).
first(n_n_time,t_wh_daimeisi).
first(n_n_time,t_wh_daimeisi_nan).
first(n_n_time,t_wh_hukusi).
first(n_n_time,t_zikan_meisi).
first(n_n_time,t_zikan_meisi_ippai).
first(n_n_time,t_zikantai).
first(n_n_week,t_meisi_youbi).
first(n_n_year,t_num_byaku).
first(n_n_year,t_num_byaq).
first(n_n_year,t_num_go).
first(n_n_year,t_num_hachi).
first(n_n_year,t_num_haq).
first(n_n_year,t_num_hito).
first(n_n_year,t_num_huta).
first(n_n_year,t_num_hutsu).
first(n_n_year,t_num_hyaku).
first(n_n_year,t_num_hyaq).
first(n_n_year,t_num_ichi).
first(n_n_year,t_num_iq).
first(n_n_year,t_num_itsu).
first(n_n_year,t_num_kokono).
first(n_n_year,t_num_ku).
first(n_n_year,t_num_kyuu).
first(n_n_year,t_num_miq).
first(n_n_year,t_num_mui).
first(n_n_year,t_num_muq).
first(n_n_year,t_num_nana).
first(n_n_year,t_num_nano).
first(n_n_year,t_num_ni).
first(n_n_year,t_num_one).
first(n_n_year,t_num_pyaku).
first(n_n_year,t_num_pyaq).
first(n_n_year,t_num_roku).
first(n_n_year,t_num_roq).
first(n_n_year,t_num_san).
first(n_n_year,t_num_sen).
first(n_n_year,t_num_shi).
first(n_n_year,t_num_shichi).
first(n_n_year,t_num_ten).
first(n_n_year,t_num_tou).
first(n_n_year,t_num_yaq).
first(n_n_year,t_num_yo).
first(n_n_year,t_num_yon).
first(n_n_year,t_num_yoq).
first(n_n_year,t_num_you).
first(n_n_year,t_num_zen).
first(n_n_year,t_num_zyuq).
first(n_n_year,t_num_zyuu).
first(n_name,n_capacity).
first(n_name,n_visitor_name).
first(n_name,t_adj_meisi).
first(n_name,t_adj_renyo_2FH_ga).
first(n_name,t_adj_renyo_2FH_ga_de).
first(n_name,t_adjstem_2FH_ga).
first(n_name,t_adjstem_2FH_ga_de).
first(n_name,t_adjstem_spe_2FH_ga_de).
first(n_name,t_daimeisi).
first(n_name,t_daimeisi_domo).
first(n_name,t_daimeisi_exp).
first(n_name,t_hukusi).
first(n_name,t_hukusi_desu).
first(n_name,t_hutu_meisi).
first(n_name,t_hutu_meisi_post).
first(n_name,t_kahen_dousi_katei_2FH_ga_ni).
first(n_name,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_name,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_name,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_name,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_name,t_kdo_2FH_ga).
first(n_name,t_kdo_2FH_ga_de).
first(n_name,t_kdo_2FH_ga_to).
first(n_name,t_koyuu_meisi).
first(n_name,t_meisi_hi).
first(n_name,t_meisi_hun).
first(n_name,t_meisi_tsuki).
first(n_name,t_meisi_youbi).
first(n_name,t_meisi_zi).
first(n_name,t_myoji_first).
first(n_name,t_myoji_last).
first(n_name,t_n_keisiki).
first(n_name,t_namae_first).
first(n_name,t_namae_last).
first(n_name,t_num_bouyomi).
first(n_name,t_num_byaku).
first(n_name,t_num_byaq).
first(n_name,t_num_go).
first(n_name,t_num_hachi).
first(n_name,t_num_haq).
first(n_name,t_num_hito).
first(n_name,t_num_huta).
first(n_name,t_num_hutsu).
first(n_name,t_num_hyaku).
first(n_name,t_num_hyaq).
first(n_name,t_num_ichi).
first(n_name,t_num_iq).
first(n_name,t_num_itsu).
first(n_name,t_num_kokono).
first(n_name,t_num_ku).
first(n_name,t_num_kyuu).
first(n_name,t_num_miq).
first(n_name,t_num_mui).
first(n_name,t_num_muq).
first(n_name,t_num_nana).
first(n_name,t_num_nano).
first(n_name,t_num_ni).
first(n_name,t_num_one).
first(n_name,t_num_pyaku).
first(n_name,t_num_pyaq).
first(n_name,t_num_roku).
first(n_name,t_num_roq).
first(n_name,t_num_san).
first(n_name,t_num_sen).
first(n_name,t_num_shi).
first(n_name,t_num_shichi).
first(n_name,t_num_ten).
first(n_name,t_num_tou).
first(n_name,t_num_yaq).
first(n_name,t_num_yo).
first(n_name,t_num_yon).
first(n_name,t_num_yoq).
first(n_name,t_num_you).
first(n_name,t_num_zen).
first(n_name,t_num_zyuq).
first(n_name,t_num_zyuu).
first(n_name,t_prefix_go).
first(n_name,t_prefix_hutu_hutu).
first(n_name,t_prefix_o).
first(n_name,t_prefix_quant_quant).
first(n_name,t_rentai).
first(n_name,t_sahen_dousi_katei_2FH_ga_ni).
first(n_name,t_sahen_dousi_katei_2FH_ga_o).
first(n_name,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_name,t_sahen_dousi_mizen_2FH_ga_o).
first(n_name,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_name,t_sahen_dousi_rentai_2FH_ga_o).
first(n_name,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_name,t_sahen_dousi_renyo_2FH_ga_o).
first(n_name,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_name,t_sahen_dousi_syusi_2FH_ga_o).
first(n_name,t_sahen_meisi_2FH_ga).
first(n_name,t_sahen_meisi_2FH_ga_ni).
first(n_name,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_name,t_sahen_meisi_2FH_ga_ni_o).
first(n_name,t_sahen_meisi_2FH_ga_o).
first(n_name,t_sahen_meisi_2FH_ga_to).
first(n_name,t_sahen_meisi_pol_2FH_ga).
first(n_name,t_sahen_meisi_pol_2FH_ga_ni).
first(n_name,t_sahen_meisi_pol_2FH_ga_o).
first(n_name,t_sahen_meisi_pol_2FH_ga_to).
first(n_name,t_suuryousi).
first(n_name,t_teido_hukusi).
first(n_name,t_tsuzuri).
first(n_name,t_vstem_1_2FH_ga).
first(n_name,t_vstem_1_2FH_ga_de).
first(n_name,t_vstem_1_2FH_ga_ni).
first(n_name,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_name,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_name,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_name,t_vstem_1_2FH_ga_ni_o).
first(n_name,t_vstem_1_2FH_ga_o).
first(n_name,t_vstem_1_2FH_ga_quote).
first(n_name,t_vstem_1_2FH_ga_to).
first(n_name,t_vstem_5_b_2FH_ga).
first(n_name,t_vstem_5_b_2FH_ga_ni).
first(n_name,t_vstem_5_b_2FH_ga_ni_o).
first(n_name,t_vstem_5_b_2FH_ga_o).
first(n_name,t_vstem_5_b_2FH_ga_to).
first(n_name,t_vstem_5_g_2FH_ga).
first(n_name,t_vstem_5_g_2FH_ga_ni).
first(n_name,t_vstem_5_g_2FH_ga_ni_o).
first(n_name,t_vstem_5_g_2FH_ga_o).
first(n_name,t_vstem_5_k_2FH_ga).
first(n_name,t_vstem_5_k_2FH_ga_ni).
first(n_name,t_vstem_5_k_2FH_ga_ni_o).
first(n_name,t_vstem_5_k_2FH_ga_o).
first(n_name,t_vstem_5_k_2FH_ga_to).
first(n_name,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_name,t_vstem_5_m_2FH_ga).
first(n_name,t_vstem_5_m_2FH_ga_ni).
first(n_name,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_name,t_vstem_5_m_2FH_ga_ni_o).
first(n_name,t_vstem_5_m_2FH_ga_o).
first(n_name,t_vstem_5_m_2FH_ga_to).
first(n_name,t_vstem_5_r_2FH_ga).
first(n_name,t_vstem_5_r_2FH_ga_ni).
first(n_name,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_name,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_name,t_vstem_5_r_2FH_ga_ni_o).
first(n_name,t_vstem_5_r_2FH_ga_o).
first(n_name,t_vstem_5_r_2FH_ga_to).
first(n_name,t_vstem_5_r_i_2FH_ga).
first(n_name,t_vstem_5_r_i_2FH_ga_o).
first(n_name,t_vstem_5_r_i_2FH_ga_quote).
first(n_name,t_vstem_5_s_2FH_ga).
first(n_name,t_vstem_5_s_2FH_ga_ni).
first(n_name,t_vstem_5_s_2FH_ga_ni_o).
first(n_name,t_vstem_5_s_2FH_ga_o).
first(n_name,t_vstem_5_s_2FH_ga_quote).
first(n_name,t_vstem_5_s_2FH_ga_to).
first(n_name,t_vstem_5_t_2FH_ga).
first(n_name,t_vstem_5_t_2FH_ga_ni).
first(n_name,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_name,t_vstem_5_t_2FH_ga_ni_o).
first(n_name,t_vstem_5_t_2FH_ga_o).
first(n_name,t_vstem_5_t_2FH_ga_to).
first(n_name,t_vstem_5_w_2FH_ga).
first(n_name,t_vstem_5_w_2FH_ga_de).
first(n_name,t_vstem_5_w_2FH_ga_ni).
first(n_name,t_vstem_5_w_2FH_ga_ni_o).
first(n_name,t_vstem_5_w_2FH_ga_o).
first(n_name,t_vstem_5_w_2FH_ga_quote).
first(n_name,t_vstem_5_w_2FH_ga_to).
first(n_name,t_vstem_masu_2FH_ga).
first(n_name,t_vstem_sahen_2FH_ga_ni).
first(n_name,t_wh_daimeisi).
first(n_name,t_wh_daimeisi_nan).
first(n_name,t_wh_hukusi).
first(n_name,t_zikan_meisi).
first(n_name,t_zikan_meisi_ippai).
first(n_name,t_zikantai).
first(n_np,n_capacity).
first(n_np,n_visitor_name).
first(n_np,t_adj_meisi).
first(n_np,t_adj_renyo_2FH_ga).
first(n_np,t_adj_renyo_2FH_ga_de).
first(n_np,t_adjstem_2FH_ga).
first(n_np,t_adjstem_2FH_ga_de).
first(n_np,t_adjstem_spe_2FH_ga_de).
first(n_np,t_daimeisi).
first(n_np,t_daimeisi_domo).
first(n_np,t_daimeisi_exp).
first(n_np,t_hukusi).
first(n_np,t_hukusi_desu).
first(n_np,t_hutu_meisi).
first(n_np,t_hutu_meisi_post).
first(n_np,t_kahen_dousi_katei_2FH_ga_ni).
first(n_np,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_np,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_np,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_np,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_np,t_kdo_2FH_ga).
first(n_np,t_kdo_2FH_ga_de).
first(n_np,t_kdo_2FH_ga_to).
first(n_np,t_koyuu_meisi).
first(n_np,t_meisi_hi).
first(n_np,t_meisi_hun).
first(n_np,t_meisi_tsuki).
first(n_np,t_meisi_youbi).
first(n_np,t_meisi_zi).
first(n_np,t_myoji_first).
first(n_np,t_myoji_last).
first(n_np,t_n_keisiki).
first(n_np,t_namae_first).
first(n_np,t_namae_last).
first(n_np,t_num_bouyomi).
first(n_np,t_num_byaku).
first(n_np,t_num_byaq).
first(n_np,t_num_go).
first(n_np,t_num_hachi).
first(n_np,t_num_haq).
first(n_np,t_num_hito).
first(n_np,t_num_huta).
first(n_np,t_num_hutsu).
first(n_np,t_num_hyaku).
first(n_np,t_num_hyaq).
first(n_np,t_num_ichi).
first(n_np,t_num_iq).
first(n_np,t_num_itsu).
first(n_np,t_num_kokono).
first(n_np,t_num_ku).
first(n_np,t_num_kyuu).
first(n_np,t_num_miq).
first(n_np,t_num_mui).
first(n_np,t_num_muq).
first(n_np,t_num_nana).
first(n_np,t_num_nano).
first(n_np,t_num_ni).
first(n_np,t_num_one).
first(n_np,t_num_pyaku).
first(n_np,t_num_pyaq).
first(n_np,t_num_roku).
first(n_np,t_num_roq).
first(n_np,t_num_san).
first(n_np,t_num_sen).
first(n_np,t_num_shi).
first(n_np,t_num_shichi).
first(n_np,t_num_ten).
first(n_np,t_num_tou).
first(n_np,t_num_yaq).
first(n_np,t_num_yo).
first(n_np,t_num_yon).
first(n_np,t_num_yoq).
first(n_np,t_num_you).
first(n_np,t_num_zen).
first(n_np,t_num_zyuq).
first(n_np,t_num_zyuu).
first(n_np,t_prefix_go).
first(n_np,t_prefix_hutu_hutu).
first(n_np,t_prefix_o).
first(n_np,t_prefix_quant_quant).
first(n_np,t_rentai).
first(n_np,t_sahen_dousi_katei_2FH_ga_ni).
first(n_np,t_sahen_dousi_katei_2FH_ga_o).
first(n_np,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_np,t_sahen_dousi_mizen_2FH_ga_o).
first(n_np,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_np,t_sahen_dousi_rentai_2FH_ga_o).
first(n_np,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_np,t_sahen_dousi_renyo_2FH_ga_o).
first(n_np,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_np,t_sahen_dousi_syusi_2FH_ga_o).
first(n_np,t_sahen_meisi_2FH_ga).
first(n_np,t_sahen_meisi_2FH_ga_ni).
first(n_np,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_np,t_sahen_meisi_2FH_ga_ni_o).
first(n_np,t_sahen_meisi_2FH_ga_o).
first(n_np,t_sahen_meisi_2FH_ga_to).
first(n_np,t_sahen_meisi_pol_2FH_ga).
first(n_np,t_sahen_meisi_pol_2FH_ga_ni).
first(n_np,t_sahen_meisi_pol_2FH_ga_o).
first(n_np,t_sahen_meisi_pol_2FH_ga_to).
first(n_np,t_suuryousi).
first(n_np,t_teido_hukusi).
first(n_np,t_tsuzuri).
first(n_np,t_vstem_1_2FH_ga).
first(n_np,t_vstem_1_2FH_ga_de).
first(n_np,t_vstem_1_2FH_ga_ni).
first(n_np,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_np,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_np,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_np,t_vstem_1_2FH_ga_ni_o).
first(n_np,t_vstem_1_2FH_ga_o).
first(n_np,t_vstem_1_2FH_ga_quote).
first(n_np,t_vstem_1_2FH_ga_to).
first(n_np,t_vstem_5_b_2FH_ga).
first(n_np,t_vstem_5_b_2FH_ga_ni).
first(n_np,t_vstem_5_b_2FH_ga_ni_o).
first(n_np,t_vstem_5_b_2FH_ga_o).
first(n_np,t_vstem_5_b_2FH_ga_to).
first(n_np,t_vstem_5_g_2FH_ga).
first(n_np,t_vstem_5_g_2FH_ga_ni).
first(n_np,t_vstem_5_g_2FH_ga_ni_o).
first(n_np,t_vstem_5_g_2FH_ga_o).
first(n_np,t_vstem_5_k_2FH_ga).
first(n_np,t_vstem_5_k_2FH_ga_ni).
first(n_np,t_vstem_5_k_2FH_ga_ni_o).
first(n_np,t_vstem_5_k_2FH_ga_o).
first(n_np,t_vstem_5_k_2FH_ga_to).
first(n_np,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_np,t_vstem_5_m_2FH_ga).
first(n_np,t_vstem_5_m_2FH_ga_ni).
first(n_np,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_np,t_vstem_5_m_2FH_ga_ni_o).
first(n_np,t_vstem_5_m_2FH_ga_o).
first(n_np,t_vstem_5_m_2FH_ga_to).
first(n_np,t_vstem_5_r_2FH_ga).
first(n_np,t_vstem_5_r_2FH_ga_ni).
first(n_np,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_np,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_np,t_vstem_5_r_2FH_ga_ni_o).
first(n_np,t_vstem_5_r_2FH_ga_o).
first(n_np,t_vstem_5_r_2FH_ga_to).
first(n_np,t_vstem_5_r_i_2FH_ga).
first(n_np,t_vstem_5_r_i_2FH_ga_o).
first(n_np,t_vstem_5_r_i_2FH_ga_quote).
first(n_np,t_vstem_5_s_2FH_ga).
first(n_np,t_vstem_5_s_2FH_ga_ni).
first(n_np,t_vstem_5_s_2FH_ga_ni_o).
first(n_np,t_vstem_5_s_2FH_ga_o).
first(n_np,t_vstem_5_s_2FH_ga_quote).
first(n_np,t_vstem_5_s_2FH_ga_to).
first(n_np,t_vstem_5_t_2FH_ga).
first(n_np,t_vstem_5_t_2FH_ga_ni).
first(n_np,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_np,t_vstem_5_t_2FH_ga_ni_o).
first(n_np,t_vstem_5_t_2FH_ga_o).
first(n_np,t_vstem_5_t_2FH_ga_to).
first(n_np,t_vstem_5_w_2FH_ga).
first(n_np,t_vstem_5_w_2FH_ga_de).
first(n_np,t_vstem_5_w_2FH_ga_ni).
first(n_np,t_vstem_5_w_2FH_ga_ni_o).
first(n_np,t_vstem_5_w_2FH_ga_o).
first(n_np,t_vstem_5_w_2FH_ga_quote).
first(n_np,t_vstem_5_w_2FH_ga_to).
first(n_np,t_vstem_masu_2FH_ga).
first(n_np,t_vstem_sahen_2FH_ga_ni).
first(n_np,t_wh_daimeisi).
first(n_np,t_wh_daimeisi_nan).
first(n_np,t_wh_hukusi).
first(n_np,t_zikan_meisi).
first(n_np,t_zikan_meisi_ippai).
first(n_np,t_zikantai).
first(n_num_ex_2,t_num_bouyomi).
first(n_num_ex_3,t_num_bouyomi).
first(n_num_ex_4,t_num_bouyomi).
first(n_num_ex_rentai,t_num_bouyomi).
first(n_num_suf_hyaku,t_num_byaku).
first(n_num_suf_hyaku,t_num_byaq).
first(n_num_suf_hyaku,t_num_hyaku).
first(n_num_suf_hyaku,t_num_hyaq).
first(n_num_suf_hyaku,t_num_pyaku).
first(n_num_suf_hyaku,t_num_pyaq).
first(n_num_suf_man,t_num_man).
first(n_num_suf_sen,t_num_sen).
first(n_num_suf_sen,t_num_zen).
first(n_num_suf_zyuu,t_num_zyuq).
first(n_num_suf_zyuu,t_num_zyuu).
first(n_p_conj_advcl,t_p_conj_katei).
first(n_p_conj_advcl,t_p_conj_rentai).
first(n_p_conj_advcl,t_p_conj_renyo).
first(n_p_conj_advcl,t_p_conj_renyo_te).
first(n_p_conj_advcl,t_p_conj_syusi).
first(n_p_conj_advp,t_p_conj_renyo_te).
first(n_p_conj_advp,t_p_conj_syusi_to).
first(n_p_fuku,t_p_fuku_bakari).
first(n_p_fuku,t_p_fuku_dake).
first(n_p_fuku,t_p_fuku_demo).
first(n_p_fuku,t_p_fuku_goto).
first(n_p_fuku,t_p_fuku_gurai).
first(n_p_fuku,t_p_fuku_hodo).
first(n_p_fuku,t_p_fuku_ka).
first(n_p_fuku,t_p_fuku_kadouka).
first(n_p_fuku,t_p_fuku_kato).
first(n_p_fuku,t_p_fuku_koso).
first(n_p_fuku,t_p_fuku_kurai).
first(n_p_fuku,t_p_fuku_made).
first(n_p_fuku,t_p_fuku_nado).
first(n_p_fuku,t_p_fuku_nanka).
first(n_p_fuku,t_p_fuku_nante).
first(n_p_fuku,t_p_fuku_nomi).
first(n_p_fuku,t_p_fuku_qteiyaa).
first(n_p_fuku,t_p_fuku_sae).
first(n_p_fuku,t_p_fuku_shika).
first(n_p_fuku,t_p_fuku_toka).
first(n_p_fuku,t_p_fuku_tou).
first(n_p_fuku,t_p_fuku_zutu).
first(n_p_kakari,t_p_kakari_mo).
first(n_p_kakari,t_p_kakari_qte).
first(n_p_kakari,t_p_kakari_te).
first(n_p_kakari,t_p_kakari_wa).
first(n_p_kaku_optn,t_p_kaku_de).
first(n_p_kaku_optn,t_p_kaku_e).
first(n_p_kaku_optn,t_p_kaku_hukugo).
first(n_p_kaku_optn,t_p_kaku_kara).
first(n_p_kaku_optn,t_p_kaku_made).
first(n_p_kaku_optn,t_p_kaku_ni).
first(n_p_kaku_optn,t_p_kaku_to).
first(n_p_kaku_optn,t_p_kaku_yori).
first(n_p_para,t_p_para_ka).
first(n_p_para,t_p_para_matawa).
first(n_p_para,t_p_para_moshikuwa).
first(n_p_para,t_p_para_nari).
first(n_p_para,t_p_para_ni).
first(n_p_para,t_p_para_tari).
first(n_p_para,t_p_para_to).
first(n_p_para,t_p_para_toka).
first(n_p_para,t_p_para_ya).
first(n_p_quote,t_p_quote_ka).
first(n_p_quote,t_p_quote_kato).
first(n_p_quote,t_p_quote_noka).
first(n_p_quote,t_p_quote_to).
first(n_p_quote,t_p_quote_toka).
first(n_p_rentai,t_p_rentai_hukugo).
first(n_p_rentai,t_p_rentai_no).
first(n_period_begin,n_capacity).
first(n_period_begin,n_visitor_name).
first(n_period_begin,t_adj_meisi).
first(n_period_begin,t_adj_renyo_2FH_ga).
first(n_period_begin,t_adj_renyo_2FH_ga_de).
first(n_period_begin,t_adjstem_2FH_ga).
first(n_period_begin,t_adjstem_2FH_ga_de).
first(n_period_begin,t_adjstem_spe_2FH_ga_de).
first(n_period_begin,t_daimeisi).
first(n_period_begin,t_daimeisi_domo).
first(n_period_begin,t_daimeisi_exp).
first(n_period_begin,t_hukusi).
first(n_period_begin,t_hukusi_desu).
first(n_period_begin,t_hutu_meisi).
first(n_period_begin,t_hutu_meisi_post).
first(n_period_begin,t_kahen_dousi_katei_2FH_ga_ni).
first(n_period_begin,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_period_begin,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_period_begin,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_period_begin,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_period_begin,t_kdo_2FH_ga).
first(n_period_begin,t_kdo_2FH_ga_de).
first(n_period_begin,t_kdo_2FH_ga_to).
first(n_period_begin,t_koyuu_meisi).
first(n_period_begin,t_meisi_hi).
first(n_period_begin,t_meisi_hun).
first(n_period_begin,t_meisi_tsuki).
first(n_period_begin,t_meisi_youbi).
first(n_period_begin,t_meisi_zi).
first(n_period_begin,t_myoji_first).
first(n_period_begin,t_myoji_last).
first(n_period_begin,t_n_keisiki).
first(n_period_begin,t_namae_first).
first(n_period_begin,t_namae_last).
first(n_period_begin,t_num_bouyomi).
first(n_period_begin,t_num_byaku).
first(n_period_begin,t_num_byaq).
first(n_period_begin,t_num_go).
first(n_period_begin,t_num_hachi).
first(n_period_begin,t_num_haq).
first(n_period_begin,t_num_hito).
first(n_period_begin,t_num_huta).
first(n_period_begin,t_num_hutsu).
first(n_period_begin,t_num_hyaku).
first(n_period_begin,t_num_hyaq).
first(n_period_begin,t_num_ichi).
first(n_period_begin,t_num_iq).
first(n_period_begin,t_num_itsu).
first(n_period_begin,t_num_kokono).
first(n_period_begin,t_num_ku).
first(n_period_begin,t_num_kyuu).
first(n_period_begin,t_num_miq).
first(n_period_begin,t_num_mui).
first(n_period_begin,t_num_muq).
first(n_period_begin,t_num_nana).
first(n_period_begin,t_num_nano).
first(n_period_begin,t_num_ni).
first(n_period_begin,t_num_one).
first(n_period_begin,t_num_pyaku).
first(n_period_begin,t_num_pyaq).
first(n_period_begin,t_num_roku).
first(n_period_begin,t_num_roq).
first(n_period_begin,t_num_san).
first(n_period_begin,t_num_sen).
first(n_period_begin,t_num_shi).
first(n_period_begin,t_num_shichi).
first(n_period_begin,t_num_ten).
first(n_period_begin,t_num_tou).
first(n_period_begin,t_num_yaq).
first(n_period_begin,t_num_yo).
first(n_period_begin,t_num_yon).
first(n_period_begin,t_num_yoq).
first(n_period_begin,t_num_you).
first(n_period_begin,t_num_zen).
first(n_period_begin,t_num_zyuq).
first(n_period_begin,t_num_zyuu).
first(n_period_begin,t_prefix_go).
first(n_period_begin,t_prefix_hutu_hutu).
first(n_period_begin,t_prefix_o).
first(n_period_begin,t_prefix_quant_quant).
first(n_period_begin,t_rentai).
first(n_period_begin,t_sahen_dousi_katei_2FH_ga_ni).
first(n_period_begin,t_sahen_dousi_katei_2FH_ga_o).
first(n_period_begin,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_period_begin,t_sahen_dousi_mizen_2FH_ga_o).
first(n_period_begin,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_period_begin,t_sahen_dousi_rentai_2FH_ga_o).
first(n_period_begin,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_period_begin,t_sahen_dousi_renyo_2FH_ga_o).
first(n_period_begin,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_period_begin,t_sahen_dousi_syusi_2FH_ga_o).
first(n_period_begin,t_sahen_meisi_2FH_ga).
first(n_period_begin,t_sahen_meisi_2FH_ga_ni).
first(n_period_begin,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_period_begin,t_sahen_meisi_2FH_ga_ni_o).
first(n_period_begin,t_sahen_meisi_2FH_ga_o).
first(n_period_begin,t_sahen_meisi_2FH_ga_to).
first(n_period_begin,t_sahen_meisi_pol_2FH_ga).
first(n_period_begin,t_sahen_meisi_pol_2FH_ga_ni).
first(n_period_begin,t_sahen_meisi_pol_2FH_ga_o).
first(n_period_begin,t_sahen_meisi_pol_2FH_ga_to).
first(n_period_begin,t_suuryousi).
first(n_period_begin,t_teido_hukusi).
first(n_period_begin,t_tsuzuri).
first(n_period_begin,t_vstem_1_2FH_ga).
first(n_period_begin,t_vstem_1_2FH_ga_de).
first(n_period_begin,t_vstem_1_2FH_ga_ni).
first(n_period_begin,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_period_begin,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_period_begin,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_period_begin,t_vstem_1_2FH_ga_ni_o).
first(n_period_begin,t_vstem_1_2FH_ga_o).
first(n_period_begin,t_vstem_1_2FH_ga_quote).
first(n_period_begin,t_vstem_1_2FH_ga_to).
first(n_period_begin,t_vstem_5_b_2FH_ga).
first(n_period_begin,t_vstem_5_b_2FH_ga_ni).
first(n_period_begin,t_vstem_5_b_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_b_2FH_ga_o).
first(n_period_begin,t_vstem_5_b_2FH_ga_to).
first(n_period_begin,t_vstem_5_g_2FH_ga).
first(n_period_begin,t_vstem_5_g_2FH_ga_ni).
first(n_period_begin,t_vstem_5_g_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_g_2FH_ga_o).
first(n_period_begin,t_vstem_5_k_2FH_ga).
first(n_period_begin,t_vstem_5_k_2FH_ga_ni).
first(n_period_begin,t_vstem_5_k_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_k_2FH_ga_o).
first(n_period_begin,t_vstem_5_k_2FH_ga_to).
first(n_period_begin,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_period_begin,t_vstem_5_m_2FH_ga).
first(n_period_begin,t_vstem_5_m_2FH_ga_ni).
first(n_period_begin,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_period_begin,t_vstem_5_m_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_m_2FH_ga_o).
first(n_period_begin,t_vstem_5_m_2FH_ga_to).
first(n_period_begin,t_vstem_5_r_2FH_ga).
first(n_period_begin,t_vstem_5_r_2FH_ga_ni).
first(n_period_begin,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_period_begin,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_period_begin,t_vstem_5_r_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_r_2FH_ga_o).
first(n_period_begin,t_vstem_5_r_2FH_ga_to).
first(n_period_begin,t_vstem_5_r_i_2FH_ga).
first(n_period_begin,t_vstem_5_r_i_2FH_ga_o).
first(n_period_begin,t_vstem_5_r_i_2FH_ga_quote).
first(n_period_begin,t_vstem_5_s_2FH_ga).
first(n_period_begin,t_vstem_5_s_2FH_ga_ni).
first(n_period_begin,t_vstem_5_s_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_s_2FH_ga_o).
first(n_period_begin,t_vstem_5_s_2FH_ga_quote).
first(n_period_begin,t_vstem_5_s_2FH_ga_to).
first(n_period_begin,t_vstem_5_t_2FH_ga).
first(n_period_begin,t_vstem_5_t_2FH_ga_ni).
first(n_period_begin,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_period_begin,t_vstem_5_t_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_t_2FH_ga_o).
first(n_period_begin,t_vstem_5_t_2FH_ga_to).
first(n_period_begin,t_vstem_5_w_2FH_ga).
first(n_period_begin,t_vstem_5_w_2FH_ga_de).
first(n_period_begin,t_vstem_5_w_2FH_ga_ni).
first(n_period_begin,t_vstem_5_w_2FH_ga_ni_o).
first(n_period_begin,t_vstem_5_w_2FH_ga_o).
first(n_period_begin,t_vstem_5_w_2FH_ga_quote).
first(n_period_begin,t_vstem_5_w_2FH_ga_to).
first(n_period_begin,t_vstem_masu_2FH_ga).
first(n_period_begin,t_vstem_sahen_2FH_ga_ni).
first(n_period_begin,t_wh_daimeisi).
first(n_period_begin,t_wh_daimeisi_nan).
first(n_period_begin,t_wh_hukusi).
first(n_period_begin,t_zikan_meisi).
first(n_period_begin,t_zikan_meisi_ippai).
first(n_period_begin,t_zikantai).
first(n_period_end,t_meisi_hi).
first(n_period_end,t_meisi_tsuki).
first(n_period_kara,n_capacity).
first(n_period_kara,n_visitor_name).
first(n_period_kara,t_adj_meisi).
first(n_period_kara,t_adj_renyo_2FH_ga).
first(n_period_kara,t_adj_renyo_2FH_ga_de).
first(n_period_kara,t_adjstem_2FH_ga).
first(n_period_kara,t_adjstem_2FH_ga_de).
first(n_period_kara,t_adjstem_spe_2FH_ga_de).
first(n_period_kara,t_daimeisi).
first(n_period_kara,t_daimeisi_domo).
first(n_period_kara,t_daimeisi_exp).
first(n_period_kara,t_hukusi).
first(n_period_kara,t_hukusi_desu).
first(n_period_kara,t_hutu_meisi).
first(n_period_kara,t_hutu_meisi_post).
first(n_period_kara,t_kahen_dousi_katei_2FH_ga_ni).
first(n_period_kara,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_period_kara,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_period_kara,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_period_kara,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_period_kara,t_kdo_2FH_ga).
first(n_period_kara,t_kdo_2FH_ga_de).
first(n_period_kara,t_kdo_2FH_ga_to).
first(n_period_kara,t_koyuu_meisi).
first(n_period_kara,t_meisi_hi).
first(n_period_kara,t_meisi_hun).
first(n_period_kara,t_meisi_tsuki).
first(n_period_kara,t_meisi_youbi).
first(n_period_kara,t_meisi_zi).
first(n_period_kara,t_myoji_first).
first(n_period_kara,t_myoji_last).
first(n_period_kara,t_n_keisiki).
first(n_period_kara,t_namae_first).
first(n_period_kara,t_namae_last).
first(n_period_kara,t_num_bouyomi).
first(n_period_kara,t_num_byaku).
first(n_period_kara,t_num_byaq).
first(n_period_kara,t_num_go).
first(n_period_kara,t_num_hachi).
first(n_period_kara,t_num_haq).
first(n_period_kara,t_num_hito).
first(n_period_kara,t_num_huta).
first(n_period_kara,t_num_hutsu).
first(n_period_kara,t_num_hyaku).
first(n_period_kara,t_num_hyaq).
first(n_period_kara,t_num_ichi).
first(n_period_kara,t_num_iq).
first(n_period_kara,t_num_itsu).
first(n_period_kara,t_num_kokono).
first(n_period_kara,t_num_ku).
first(n_period_kara,t_num_kyuu).
first(n_period_kara,t_num_miq).
first(n_period_kara,t_num_mui).
first(n_period_kara,t_num_muq).
first(n_period_kara,t_num_nana).
first(n_period_kara,t_num_nano).
first(n_period_kara,t_num_ni).
first(n_period_kara,t_num_one).
first(n_period_kara,t_num_pyaku).
first(n_period_kara,t_num_pyaq).
first(n_period_kara,t_num_roku).
first(n_period_kara,t_num_roq).
first(n_period_kara,t_num_san).
first(n_period_kara,t_num_sen).
first(n_period_kara,t_num_shi).
first(n_period_kara,t_num_shichi).
first(n_period_kara,t_num_ten).
first(n_period_kara,t_num_tou).
first(n_period_kara,t_num_yaq).
first(n_period_kara,t_num_yo).
first(n_period_kara,t_num_yon).
first(n_period_kara,t_num_yoq).
first(n_period_kara,t_num_you).
first(n_period_kara,t_num_zen).
first(n_period_kara,t_num_zyuq).
first(n_period_kara,t_num_zyuu).
first(n_period_kara,t_prefix_go).
first(n_period_kara,t_prefix_hutu_hutu).
first(n_period_kara,t_prefix_o).
first(n_period_kara,t_prefix_quant_quant).
first(n_period_kara,t_rentai).
first(n_period_kara,t_sahen_dousi_katei_2FH_ga_ni).
first(n_period_kara,t_sahen_dousi_katei_2FH_ga_o).
first(n_period_kara,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_period_kara,t_sahen_dousi_mizen_2FH_ga_o).
first(n_period_kara,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_period_kara,t_sahen_dousi_rentai_2FH_ga_o).
first(n_period_kara,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_period_kara,t_sahen_dousi_renyo_2FH_ga_o).
first(n_period_kara,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_period_kara,t_sahen_dousi_syusi_2FH_ga_o).
first(n_period_kara,t_sahen_meisi_2FH_ga).
first(n_period_kara,t_sahen_meisi_2FH_ga_ni).
first(n_period_kara,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_period_kara,t_sahen_meisi_2FH_ga_ni_o).
first(n_period_kara,t_sahen_meisi_2FH_ga_o).
first(n_period_kara,t_sahen_meisi_2FH_ga_to).
first(n_period_kara,t_sahen_meisi_pol_2FH_ga).
first(n_period_kara,t_sahen_meisi_pol_2FH_ga_ni).
first(n_period_kara,t_sahen_meisi_pol_2FH_ga_o).
first(n_period_kara,t_sahen_meisi_pol_2FH_ga_to).
first(n_period_kara,t_suuryousi).
first(n_period_kara,t_teido_hukusi).
first(n_period_kara,t_tsuzuri).
first(n_period_kara,t_vstem_1_2FH_ga).
first(n_period_kara,t_vstem_1_2FH_ga_de).
first(n_period_kara,t_vstem_1_2FH_ga_ni).
first(n_period_kara,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_period_kara,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_period_kara,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_period_kara,t_vstem_1_2FH_ga_ni_o).
first(n_period_kara,t_vstem_1_2FH_ga_o).
first(n_period_kara,t_vstem_1_2FH_ga_quote).
first(n_period_kara,t_vstem_1_2FH_ga_to).
first(n_period_kara,t_vstem_5_b_2FH_ga).
first(n_period_kara,t_vstem_5_b_2FH_ga_ni).
first(n_period_kara,t_vstem_5_b_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_b_2FH_ga_o).
first(n_period_kara,t_vstem_5_b_2FH_ga_to).
first(n_period_kara,t_vstem_5_g_2FH_ga).
first(n_period_kara,t_vstem_5_g_2FH_ga_ni).
first(n_period_kara,t_vstem_5_g_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_g_2FH_ga_o).
first(n_period_kara,t_vstem_5_k_2FH_ga).
first(n_period_kara,t_vstem_5_k_2FH_ga_ni).
first(n_period_kara,t_vstem_5_k_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_k_2FH_ga_o).
first(n_period_kara,t_vstem_5_k_2FH_ga_to).
first(n_period_kara,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_period_kara,t_vstem_5_m_2FH_ga).
first(n_period_kara,t_vstem_5_m_2FH_ga_ni).
first(n_period_kara,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_period_kara,t_vstem_5_m_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_m_2FH_ga_o).
first(n_period_kara,t_vstem_5_m_2FH_ga_to).
first(n_period_kara,t_vstem_5_r_2FH_ga).
first(n_period_kara,t_vstem_5_r_2FH_ga_ni).
first(n_period_kara,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_period_kara,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_period_kara,t_vstem_5_r_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_r_2FH_ga_o).
first(n_period_kara,t_vstem_5_r_2FH_ga_to).
first(n_period_kara,t_vstem_5_r_i_2FH_ga).
first(n_period_kara,t_vstem_5_r_i_2FH_ga_o).
first(n_period_kara,t_vstem_5_r_i_2FH_ga_quote).
first(n_period_kara,t_vstem_5_s_2FH_ga).
first(n_period_kara,t_vstem_5_s_2FH_ga_ni).
first(n_period_kara,t_vstem_5_s_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_s_2FH_ga_o).
first(n_period_kara,t_vstem_5_s_2FH_ga_quote).
first(n_period_kara,t_vstem_5_s_2FH_ga_to).
first(n_period_kara,t_vstem_5_t_2FH_ga).
first(n_period_kara,t_vstem_5_t_2FH_ga_ni).
first(n_period_kara,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_period_kara,t_vstem_5_t_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_t_2FH_ga_o).
first(n_period_kara,t_vstem_5_t_2FH_ga_to).
first(n_period_kara,t_vstem_5_w_2FH_ga).
first(n_period_kara,t_vstem_5_w_2FH_ga_de).
first(n_period_kara,t_vstem_5_w_2FH_ga_ni).
first(n_period_kara,t_vstem_5_w_2FH_ga_ni_o).
first(n_period_kara,t_vstem_5_w_2FH_ga_o).
first(n_period_kara,t_vstem_5_w_2FH_ga_quote).
first(n_period_kara,t_vstem_5_w_2FH_ga_to).
first(n_period_kara,t_vstem_masu_2FH_ga).
first(n_period_kara,t_vstem_sahen_2FH_ga_ni).
first(n_period_kara,t_wh_daimeisi).
first(n_period_kara,t_wh_daimeisi_nan).
first(n_period_kara,t_wh_hukusi).
first(n_period_kara,t_zikan_meisi).
first(n_period_kara,t_zikan_meisi_ippai).
first(n_period_kara,t_zikantai).
first(n_period_made,t_meisi_hi).
first(n_period_made,t_meisi_tsuki).
first(n_period_to,n_capacity).
first(n_period_to,n_visitor_name).
first(n_period_to,t_adj_meisi).
first(n_period_to,t_adj_renyo_2FH_ga).
first(n_period_to,t_adj_renyo_2FH_ga_de).
first(n_period_to,t_adjstem_2FH_ga).
first(n_period_to,t_adjstem_2FH_ga_de).
first(n_period_to,t_adjstem_spe_2FH_ga_de).
first(n_period_to,t_daimeisi).
first(n_period_to,t_daimeisi_domo).
first(n_period_to,t_daimeisi_exp).
first(n_period_to,t_hukusi).
first(n_period_to,t_hukusi_desu).
first(n_period_to,t_hutu_meisi).
first(n_period_to,t_hutu_meisi_post).
first(n_period_to,t_kahen_dousi_katei_2FH_ga_ni).
first(n_period_to,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_period_to,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_period_to,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_period_to,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_period_to,t_kdo_2FH_ga).
first(n_period_to,t_kdo_2FH_ga_de).
first(n_period_to,t_kdo_2FH_ga_to).
first(n_period_to,t_koyuu_meisi).
first(n_period_to,t_meisi_hi).
first(n_period_to,t_meisi_hun).
first(n_period_to,t_meisi_tsuki).
first(n_period_to,t_meisi_youbi).
first(n_period_to,t_meisi_zi).
first(n_period_to,t_myoji_first).
first(n_period_to,t_myoji_last).
first(n_period_to,t_n_keisiki).
first(n_period_to,t_namae_first).
first(n_period_to,t_namae_last).
first(n_period_to,t_num_bouyomi).
first(n_period_to,t_num_byaku).
first(n_period_to,t_num_byaq).
first(n_period_to,t_num_go).
first(n_period_to,t_num_hachi).
first(n_period_to,t_num_haq).
first(n_period_to,t_num_hito).
first(n_period_to,t_num_huta).
first(n_period_to,t_num_hutsu).
first(n_period_to,t_num_hyaku).
first(n_period_to,t_num_hyaq).
first(n_period_to,t_num_ichi).
first(n_period_to,t_num_iq).
first(n_period_to,t_num_itsu).
first(n_period_to,t_num_kokono).
first(n_period_to,t_num_ku).
first(n_period_to,t_num_kyuu).
first(n_period_to,t_num_miq).
first(n_period_to,t_num_mui).
first(n_period_to,t_num_muq).
first(n_period_to,t_num_nana).
first(n_period_to,t_num_nano).
first(n_period_to,t_num_ni).
first(n_period_to,t_num_one).
first(n_period_to,t_num_pyaku).
first(n_period_to,t_num_pyaq).
first(n_period_to,t_num_roku).
first(n_period_to,t_num_roq).
first(n_period_to,t_num_san).
first(n_period_to,t_num_sen).
first(n_period_to,t_num_shi).
first(n_period_to,t_num_shichi).
first(n_period_to,t_num_ten).
first(n_period_to,t_num_tou).
first(n_period_to,t_num_yaq).
first(n_period_to,t_num_yo).
first(n_period_to,t_num_yon).
first(n_period_to,t_num_yoq).
first(n_period_to,t_num_you).
first(n_period_to,t_num_zen).
first(n_period_to,t_num_zyuq).
first(n_period_to,t_num_zyuu).
first(n_period_to,t_prefix_go).
first(n_period_to,t_prefix_hutu_hutu).
first(n_period_to,t_prefix_o).
first(n_period_to,t_prefix_quant_quant).
first(n_period_to,t_rentai).
first(n_period_to,t_sahen_dousi_katei_2FH_ga_ni).
first(n_period_to,t_sahen_dousi_katei_2FH_ga_o).
first(n_period_to,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_period_to,t_sahen_dousi_mizen_2FH_ga_o).
first(n_period_to,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_period_to,t_sahen_dousi_rentai_2FH_ga_o).
first(n_period_to,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_period_to,t_sahen_dousi_renyo_2FH_ga_o).
first(n_period_to,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_period_to,t_sahen_dousi_syusi_2FH_ga_o).
first(n_period_to,t_sahen_meisi_2FH_ga).
first(n_period_to,t_sahen_meisi_2FH_ga_ni).
first(n_period_to,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_period_to,t_sahen_meisi_2FH_ga_ni_o).
first(n_period_to,t_sahen_meisi_2FH_ga_o).
first(n_period_to,t_sahen_meisi_2FH_ga_to).
first(n_period_to,t_sahen_meisi_pol_2FH_ga).
first(n_period_to,t_sahen_meisi_pol_2FH_ga_ni).
first(n_period_to,t_sahen_meisi_pol_2FH_ga_o).
first(n_period_to,t_sahen_meisi_pol_2FH_ga_to).
first(n_period_to,t_suuryousi).
first(n_period_to,t_teido_hukusi).
first(n_period_to,t_tsuzuri).
first(n_period_to,t_vstem_1_2FH_ga).
first(n_period_to,t_vstem_1_2FH_ga_de).
first(n_period_to,t_vstem_1_2FH_ga_ni).
first(n_period_to,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_period_to,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_period_to,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_period_to,t_vstem_1_2FH_ga_ni_o).
first(n_period_to,t_vstem_1_2FH_ga_o).
first(n_period_to,t_vstem_1_2FH_ga_quote).
first(n_period_to,t_vstem_1_2FH_ga_to).
first(n_period_to,t_vstem_5_b_2FH_ga).
first(n_period_to,t_vstem_5_b_2FH_ga_ni).
first(n_period_to,t_vstem_5_b_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_b_2FH_ga_o).
first(n_period_to,t_vstem_5_b_2FH_ga_to).
first(n_period_to,t_vstem_5_g_2FH_ga).
first(n_period_to,t_vstem_5_g_2FH_ga_ni).
first(n_period_to,t_vstem_5_g_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_g_2FH_ga_o).
first(n_period_to,t_vstem_5_k_2FH_ga).
first(n_period_to,t_vstem_5_k_2FH_ga_ni).
first(n_period_to,t_vstem_5_k_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_k_2FH_ga_o).
first(n_period_to,t_vstem_5_k_2FH_ga_to).
first(n_period_to,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_period_to,t_vstem_5_m_2FH_ga).
first(n_period_to,t_vstem_5_m_2FH_ga_ni).
first(n_period_to,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_period_to,t_vstem_5_m_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_m_2FH_ga_o).
first(n_period_to,t_vstem_5_m_2FH_ga_to).
first(n_period_to,t_vstem_5_r_2FH_ga).
first(n_period_to,t_vstem_5_r_2FH_ga_ni).
first(n_period_to,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_period_to,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_period_to,t_vstem_5_r_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_r_2FH_ga_o).
first(n_period_to,t_vstem_5_r_2FH_ga_to).
first(n_period_to,t_vstem_5_r_i_2FH_ga).
first(n_period_to,t_vstem_5_r_i_2FH_ga_o).
first(n_period_to,t_vstem_5_r_i_2FH_ga_quote).
first(n_period_to,t_vstem_5_s_2FH_ga).
first(n_period_to,t_vstem_5_s_2FH_ga_ni).
first(n_period_to,t_vstem_5_s_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_s_2FH_ga_o).
first(n_period_to,t_vstem_5_s_2FH_ga_quote).
first(n_period_to,t_vstem_5_s_2FH_ga_to).
first(n_period_to,t_vstem_5_t_2FH_ga).
first(n_period_to,t_vstem_5_t_2FH_ga_ni).
first(n_period_to,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_period_to,t_vstem_5_t_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_t_2FH_ga_o).
first(n_period_to,t_vstem_5_t_2FH_ga_to).
first(n_period_to,t_vstem_5_w_2FH_ga).
first(n_period_to,t_vstem_5_w_2FH_ga_de).
first(n_period_to,t_vstem_5_w_2FH_ga_ni).
first(n_period_to,t_vstem_5_w_2FH_ga_ni_o).
first(n_period_to,t_vstem_5_w_2FH_ga_o).
first(n_period_to,t_vstem_5_w_2FH_ga_quote).
first(n_period_to,t_vstem_5_w_2FH_ga_to).
first(n_period_to,t_vstem_masu_2FH_ga).
first(n_period_to,t_vstem_sahen_2FH_ga_ni).
first(n_period_to,t_wh_daimeisi).
first(n_period_to,t_wh_daimeisi_nan).
first(n_period_to,t_wh_hukusi).
first(n_period_to,t_zikan_meisi).
first(n_period_to,t_zikan_meisi_ippai).
first(n_period_to,t_zikantai).
first(n_pp,n_capacity).
first(n_pp,n_visitor_name).
first(n_pp,t_adj_meisi).
first(n_pp,t_adj_renyo_2FH_ga).
first(n_pp,t_adj_renyo_2FH_ga_de).
first(n_pp,t_adjstem_2FH_ga).
first(n_pp,t_adjstem_2FH_ga_de).
first(n_pp,t_adjstem_spe_2FH_ga_de).
first(n_pp,t_daimeisi).
first(n_pp,t_daimeisi_domo).
first(n_pp,t_daimeisi_exp).
first(n_pp,t_hukusi).
first(n_pp,t_hukusi_desu).
first(n_pp,t_hutu_meisi).
first(n_pp,t_hutu_meisi_post).
first(n_pp,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp,t_kdo_2FH_ga).
first(n_pp,t_kdo_2FH_ga_de).
first(n_pp,t_kdo_2FH_ga_to).
first(n_pp,t_koyuu_meisi).
first(n_pp,t_meisi_hi).
first(n_pp,t_meisi_hun).
first(n_pp,t_meisi_tsuki).
first(n_pp,t_meisi_youbi).
first(n_pp,t_meisi_zi).
first(n_pp,t_myoji_first).
first(n_pp,t_myoji_last).
first(n_pp,t_n_keisiki).
first(n_pp,t_namae_first).
first(n_pp,t_namae_last).
first(n_pp,t_num_bouyomi).
first(n_pp,t_num_byaku).
first(n_pp,t_num_byaq).
first(n_pp,t_num_go).
first(n_pp,t_num_hachi).
first(n_pp,t_num_haq).
first(n_pp,t_num_hito).
first(n_pp,t_num_huta).
first(n_pp,t_num_hutsu).
first(n_pp,t_num_hyaku).
first(n_pp,t_num_hyaq).
first(n_pp,t_num_ichi).
first(n_pp,t_num_iq).
first(n_pp,t_num_itsu).
first(n_pp,t_num_kokono).
first(n_pp,t_num_ku).
first(n_pp,t_num_kyuu).
first(n_pp,t_num_miq).
first(n_pp,t_num_mui).
first(n_pp,t_num_muq).
first(n_pp,t_num_nana).
first(n_pp,t_num_nano).
first(n_pp,t_num_ni).
first(n_pp,t_num_one).
first(n_pp,t_num_pyaku).
first(n_pp,t_num_pyaq).
first(n_pp,t_num_roku).
first(n_pp,t_num_roq).
first(n_pp,t_num_san).
first(n_pp,t_num_sen).
first(n_pp,t_num_shi).
first(n_pp,t_num_shichi).
first(n_pp,t_num_ten).
first(n_pp,t_num_tou).
first(n_pp,t_num_yaq).
first(n_pp,t_num_yo).
first(n_pp,t_num_yon).
first(n_pp,t_num_yoq).
first(n_pp,t_num_you).
first(n_pp,t_num_zen).
first(n_pp,t_num_zyuq).
first(n_pp,t_num_zyuu).
first(n_pp,t_prefix_go).
first(n_pp,t_prefix_hutu_hutu).
first(n_pp,t_prefix_o).
first(n_pp,t_prefix_quant_quant).
first(n_pp,t_rentai).
first(n_pp,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp,t_sahen_meisi_2FH_ga).
first(n_pp,t_sahen_meisi_2FH_ga_ni).
first(n_pp,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp,t_sahen_meisi_2FH_ga_o).
first(n_pp,t_sahen_meisi_2FH_ga_to).
first(n_pp,t_sahen_meisi_pol_2FH_ga).
first(n_pp,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp,t_suuryousi).
first(n_pp,t_teido_hukusi).
first(n_pp,t_tsuzuri).
first(n_pp,t_vstem_1_2FH_ga).
first(n_pp,t_vstem_1_2FH_ga_de).
first(n_pp,t_vstem_1_2FH_ga_ni).
first(n_pp,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp,t_vstem_1_2FH_ga_ni_o).
first(n_pp,t_vstem_1_2FH_ga_o).
first(n_pp,t_vstem_1_2FH_ga_quote).
first(n_pp,t_vstem_1_2FH_ga_to).
first(n_pp,t_vstem_5_b_2FH_ga).
first(n_pp,t_vstem_5_b_2FH_ga_ni).
first(n_pp,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp,t_vstem_5_b_2FH_ga_o).
first(n_pp,t_vstem_5_b_2FH_ga_to).
first(n_pp,t_vstem_5_g_2FH_ga).
first(n_pp,t_vstem_5_g_2FH_ga_ni).
first(n_pp,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp,t_vstem_5_g_2FH_ga_o).
first(n_pp,t_vstem_5_k_2FH_ga).
first(n_pp,t_vstem_5_k_2FH_ga_ni).
first(n_pp,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp,t_vstem_5_k_2FH_ga_o).
first(n_pp,t_vstem_5_k_2FH_ga_to).
first(n_pp,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp,t_vstem_5_m_2FH_ga).
first(n_pp,t_vstem_5_m_2FH_ga_ni).
first(n_pp,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp,t_vstem_5_m_2FH_ga_o).
first(n_pp,t_vstem_5_m_2FH_ga_to).
first(n_pp,t_vstem_5_r_2FH_ga).
first(n_pp,t_vstem_5_r_2FH_ga_ni).
first(n_pp,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp,t_vstem_5_r_2FH_ga_o).
first(n_pp,t_vstem_5_r_2FH_ga_to).
first(n_pp,t_vstem_5_r_i_2FH_ga).
first(n_pp,t_vstem_5_r_i_2FH_ga_o).
first(n_pp,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp,t_vstem_5_s_2FH_ga).
first(n_pp,t_vstem_5_s_2FH_ga_ni).
first(n_pp,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp,t_vstem_5_s_2FH_ga_o).
first(n_pp,t_vstem_5_s_2FH_ga_quote).
first(n_pp,t_vstem_5_s_2FH_ga_to).
first(n_pp,t_vstem_5_t_2FH_ga).
first(n_pp,t_vstem_5_t_2FH_ga_ni).
first(n_pp,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp,t_vstem_5_t_2FH_ga_o).
first(n_pp,t_vstem_5_t_2FH_ga_to).
first(n_pp,t_vstem_5_w_2FH_ga).
first(n_pp,t_vstem_5_w_2FH_ga_de).
first(n_pp,t_vstem_5_w_2FH_ga_ni).
first(n_pp,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp,t_vstem_5_w_2FH_ga_o).
first(n_pp,t_vstem_5_w_2FH_ga_quote).
first(n_pp,t_vstem_5_w_2FH_ga_to).
first(n_pp,t_vstem_masu_2FH_ga).
first(n_pp,t_vstem_sahen_2FH_ga_ni).
first(n_pp,t_wh_daimeisi).
first(n_pp,t_wh_daimeisi_nan).
first(n_pp,t_wh_hukusi).
first(n_pp,t_zikan_meisi).
first(n_pp,t_zikan_meisi_ippai).
first(n_pp,t_zikantai).
first(n_pp_de,n_capacity).
first(n_pp_de,n_visitor_name).
first(n_pp_de,t_adj_meisi).
first(n_pp_de,t_adj_renyo_2FH_ga).
first(n_pp_de,t_adj_renyo_2FH_ga_de).
first(n_pp_de,t_adjstem_2FH_ga).
first(n_pp_de,t_adjstem_2FH_ga_de).
first(n_pp_de,t_adjstem_spe_2FH_ga_de).
first(n_pp_de,t_daimeisi).
first(n_pp_de,t_daimeisi_domo).
first(n_pp_de,t_daimeisi_exp).
first(n_pp_de,t_hukusi).
first(n_pp_de,t_hukusi_desu).
first(n_pp_de,t_hutu_meisi).
first(n_pp_de,t_hutu_meisi_post).
first(n_pp_de,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp_de,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp_de,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp_de,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp_de,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp_de,t_kdo_2FH_ga).
first(n_pp_de,t_kdo_2FH_ga_de).
first(n_pp_de,t_kdo_2FH_ga_to).
first(n_pp_de,t_koyuu_meisi).
first(n_pp_de,t_meisi_hi).
first(n_pp_de,t_meisi_hun).
first(n_pp_de,t_meisi_tsuki).
first(n_pp_de,t_meisi_youbi).
first(n_pp_de,t_meisi_zi).
first(n_pp_de,t_myoji_first).
first(n_pp_de,t_myoji_last).
first(n_pp_de,t_n_keisiki).
first(n_pp_de,t_namae_first).
first(n_pp_de,t_namae_last).
first(n_pp_de,t_num_bouyomi).
first(n_pp_de,t_num_byaku).
first(n_pp_de,t_num_byaq).
first(n_pp_de,t_num_go).
first(n_pp_de,t_num_hachi).
first(n_pp_de,t_num_haq).
first(n_pp_de,t_num_hito).
first(n_pp_de,t_num_huta).
first(n_pp_de,t_num_hutsu).
first(n_pp_de,t_num_hyaku).
first(n_pp_de,t_num_hyaq).
first(n_pp_de,t_num_ichi).
first(n_pp_de,t_num_iq).
first(n_pp_de,t_num_itsu).
first(n_pp_de,t_num_kokono).
first(n_pp_de,t_num_ku).
first(n_pp_de,t_num_kyuu).
first(n_pp_de,t_num_miq).
first(n_pp_de,t_num_mui).
first(n_pp_de,t_num_muq).
first(n_pp_de,t_num_nana).
first(n_pp_de,t_num_nano).
first(n_pp_de,t_num_ni).
first(n_pp_de,t_num_one).
first(n_pp_de,t_num_pyaku).
first(n_pp_de,t_num_pyaq).
first(n_pp_de,t_num_roku).
first(n_pp_de,t_num_roq).
first(n_pp_de,t_num_san).
first(n_pp_de,t_num_sen).
first(n_pp_de,t_num_shi).
first(n_pp_de,t_num_shichi).
first(n_pp_de,t_num_ten).
first(n_pp_de,t_num_tou).
first(n_pp_de,t_num_yaq).
first(n_pp_de,t_num_yo).
first(n_pp_de,t_num_yon).
first(n_pp_de,t_num_yoq).
first(n_pp_de,t_num_you).
first(n_pp_de,t_num_zen).
first(n_pp_de,t_num_zyuq).
first(n_pp_de,t_num_zyuu).
first(n_pp_de,t_prefix_go).
first(n_pp_de,t_prefix_hutu_hutu).
first(n_pp_de,t_prefix_o).
first(n_pp_de,t_prefix_quant_quant).
first(n_pp_de,t_rentai).
first(n_pp_de,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp_de,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp_de,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp_de,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp_de,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp_de,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp_de,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp_de,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp_de,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp_de,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp_de,t_sahen_meisi_2FH_ga).
first(n_pp_de,t_sahen_meisi_2FH_ga_ni).
first(n_pp_de,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp_de,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp_de,t_sahen_meisi_2FH_ga_o).
first(n_pp_de,t_sahen_meisi_2FH_ga_to).
first(n_pp_de,t_sahen_meisi_pol_2FH_ga).
first(n_pp_de,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp_de,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp_de,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp_de,t_suuryousi).
first(n_pp_de,t_teido_hukusi).
first(n_pp_de,t_tsuzuri).
first(n_pp_de,t_vstem_1_2FH_ga).
first(n_pp_de,t_vstem_1_2FH_ga_de).
first(n_pp_de,t_vstem_1_2FH_ga_ni).
first(n_pp_de,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp_de,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp_de,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp_de,t_vstem_1_2FH_ga_ni_o).
first(n_pp_de,t_vstem_1_2FH_ga_o).
first(n_pp_de,t_vstem_1_2FH_ga_quote).
first(n_pp_de,t_vstem_1_2FH_ga_to).
first(n_pp_de,t_vstem_5_b_2FH_ga).
first(n_pp_de,t_vstem_5_b_2FH_ga_ni).
first(n_pp_de,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_b_2FH_ga_o).
first(n_pp_de,t_vstem_5_b_2FH_ga_to).
first(n_pp_de,t_vstem_5_g_2FH_ga).
first(n_pp_de,t_vstem_5_g_2FH_ga_ni).
first(n_pp_de,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_g_2FH_ga_o).
first(n_pp_de,t_vstem_5_k_2FH_ga).
first(n_pp_de,t_vstem_5_k_2FH_ga_ni).
first(n_pp_de,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_k_2FH_ga_o).
first(n_pp_de,t_vstem_5_k_2FH_ga_to).
first(n_pp_de,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp_de,t_vstem_5_m_2FH_ga).
first(n_pp_de,t_vstem_5_m_2FH_ga_ni).
first(n_pp_de,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp_de,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_m_2FH_ga_o).
first(n_pp_de,t_vstem_5_m_2FH_ga_to).
first(n_pp_de,t_vstem_5_r_2FH_ga).
first(n_pp_de,t_vstem_5_r_2FH_ga_ni).
first(n_pp_de,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp_de,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp_de,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_r_2FH_ga_o).
first(n_pp_de,t_vstem_5_r_2FH_ga_to).
first(n_pp_de,t_vstem_5_r_i_2FH_ga).
first(n_pp_de,t_vstem_5_r_i_2FH_ga_o).
first(n_pp_de,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp_de,t_vstem_5_s_2FH_ga).
first(n_pp_de,t_vstem_5_s_2FH_ga_ni).
first(n_pp_de,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_s_2FH_ga_o).
first(n_pp_de,t_vstem_5_s_2FH_ga_quote).
first(n_pp_de,t_vstem_5_s_2FH_ga_to).
first(n_pp_de,t_vstem_5_t_2FH_ga).
first(n_pp_de,t_vstem_5_t_2FH_ga_ni).
first(n_pp_de,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp_de,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_t_2FH_ga_o).
first(n_pp_de,t_vstem_5_t_2FH_ga_to).
first(n_pp_de,t_vstem_5_w_2FH_ga).
first(n_pp_de,t_vstem_5_w_2FH_ga_de).
first(n_pp_de,t_vstem_5_w_2FH_ga_ni).
first(n_pp_de,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp_de,t_vstem_5_w_2FH_ga_o).
first(n_pp_de,t_vstem_5_w_2FH_ga_quote).
first(n_pp_de,t_vstem_5_w_2FH_ga_to).
first(n_pp_de,t_vstem_masu_2FH_ga).
first(n_pp_de,t_vstem_sahen_2FH_ga_ni).
first(n_pp_de,t_wh_daimeisi).
first(n_pp_de,t_wh_daimeisi_nan).
first(n_pp_de,t_wh_hukusi).
first(n_pp_de,t_zikan_meisi).
first(n_pp_de,t_zikan_meisi_ippai).
first(n_pp_de,t_zikantai).
first(n_pp_e,n_capacity).
first(n_pp_e,n_visitor_name).
first(n_pp_e,t_adj_meisi).
first(n_pp_e,t_adj_renyo_2FH_ga).
first(n_pp_e,t_adj_renyo_2FH_ga_de).
first(n_pp_e,t_adjstem_2FH_ga).
first(n_pp_e,t_adjstem_2FH_ga_de).
first(n_pp_e,t_adjstem_spe_2FH_ga_de).
first(n_pp_e,t_daimeisi).
first(n_pp_e,t_daimeisi_domo).
first(n_pp_e,t_daimeisi_exp).
first(n_pp_e,t_hukusi).
first(n_pp_e,t_hukusi_desu).
first(n_pp_e,t_hutu_meisi).
first(n_pp_e,t_hutu_meisi_post).
first(n_pp_e,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp_e,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp_e,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp_e,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp_e,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp_e,t_kdo_2FH_ga).
first(n_pp_e,t_kdo_2FH_ga_de).
first(n_pp_e,t_kdo_2FH_ga_to).
first(n_pp_e,t_koyuu_meisi).
first(n_pp_e,t_meisi_hi).
first(n_pp_e,t_meisi_hun).
first(n_pp_e,t_meisi_tsuki).
first(n_pp_e,t_meisi_youbi).
first(n_pp_e,t_meisi_zi).
first(n_pp_e,t_myoji_first).
first(n_pp_e,t_myoji_last).
first(n_pp_e,t_n_keisiki).
first(n_pp_e,t_namae_first).
first(n_pp_e,t_namae_last).
first(n_pp_e,t_num_bouyomi).
first(n_pp_e,t_num_byaku).
first(n_pp_e,t_num_byaq).
first(n_pp_e,t_num_go).
first(n_pp_e,t_num_hachi).
first(n_pp_e,t_num_haq).
first(n_pp_e,t_num_hito).
first(n_pp_e,t_num_huta).
first(n_pp_e,t_num_hutsu).
first(n_pp_e,t_num_hyaku).
first(n_pp_e,t_num_hyaq).
first(n_pp_e,t_num_ichi).
first(n_pp_e,t_num_iq).
first(n_pp_e,t_num_itsu).
first(n_pp_e,t_num_kokono).
first(n_pp_e,t_num_ku).
first(n_pp_e,t_num_kyuu).
first(n_pp_e,t_num_miq).
first(n_pp_e,t_num_mui).
first(n_pp_e,t_num_muq).
first(n_pp_e,t_num_nana).
first(n_pp_e,t_num_nano).
first(n_pp_e,t_num_ni).
first(n_pp_e,t_num_one).
first(n_pp_e,t_num_pyaku).
first(n_pp_e,t_num_pyaq).
first(n_pp_e,t_num_roku).
first(n_pp_e,t_num_roq).
first(n_pp_e,t_num_san).
first(n_pp_e,t_num_sen).
first(n_pp_e,t_num_shi).
first(n_pp_e,t_num_shichi).
first(n_pp_e,t_num_ten).
first(n_pp_e,t_num_tou).
first(n_pp_e,t_num_yaq).
first(n_pp_e,t_num_yo).
first(n_pp_e,t_num_yon).
first(n_pp_e,t_num_yoq).
first(n_pp_e,t_num_you).
first(n_pp_e,t_num_zen).
first(n_pp_e,t_num_zyuq).
first(n_pp_e,t_num_zyuu).
first(n_pp_e,t_prefix_go).
first(n_pp_e,t_prefix_hutu_hutu).
first(n_pp_e,t_prefix_o).
first(n_pp_e,t_prefix_quant_quant).
first(n_pp_e,t_rentai).
first(n_pp_e,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp_e,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp_e,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp_e,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp_e,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp_e,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp_e,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp_e,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp_e,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp_e,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp_e,t_sahen_meisi_2FH_ga).
first(n_pp_e,t_sahen_meisi_2FH_ga_ni).
first(n_pp_e,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp_e,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp_e,t_sahen_meisi_2FH_ga_o).
first(n_pp_e,t_sahen_meisi_2FH_ga_to).
first(n_pp_e,t_sahen_meisi_pol_2FH_ga).
first(n_pp_e,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp_e,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp_e,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp_e,t_suuryousi).
first(n_pp_e,t_teido_hukusi).
first(n_pp_e,t_tsuzuri).
first(n_pp_e,t_vstem_1_2FH_ga).
first(n_pp_e,t_vstem_1_2FH_ga_de).
first(n_pp_e,t_vstem_1_2FH_ga_ni).
first(n_pp_e,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp_e,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp_e,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp_e,t_vstem_1_2FH_ga_ni_o).
first(n_pp_e,t_vstem_1_2FH_ga_o).
first(n_pp_e,t_vstem_1_2FH_ga_quote).
first(n_pp_e,t_vstem_1_2FH_ga_to).
first(n_pp_e,t_vstem_5_b_2FH_ga).
first(n_pp_e,t_vstem_5_b_2FH_ga_ni).
first(n_pp_e,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_b_2FH_ga_o).
first(n_pp_e,t_vstem_5_b_2FH_ga_to).
first(n_pp_e,t_vstem_5_g_2FH_ga).
first(n_pp_e,t_vstem_5_g_2FH_ga_ni).
first(n_pp_e,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_g_2FH_ga_o).
first(n_pp_e,t_vstem_5_k_2FH_ga).
first(n_pp_e,t_vstem_5_k_2FH_ga_ni).
first(n_pp_e,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_k_2FH_ga_o).
first(n_pp_e,t_vstem_5_k_2FH_ga_to).
first(n_pp_e,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp_e,t_vstem_5_m_2FH_ga).
first(n_pp_e,t_vstem_5_m_2FH_ga_ni).
first(n_pp_e,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp_e,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_m_2FH_ga_o).
first(n_pp_e,t_vstem_5_m_2FH_ga_to).
first(n_pp_e,t_vstem_5_r_2FH_ga).
first(n_pp_e,t_vstem_5_r_2FH_ga_ni).
first(n_pp_e,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp_e,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp_e,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_r_2FH_ga_o).
first(n_pp_e,t_vstem_5_r_2FH_ga_to).
first(n_pp_e,t_vstem_5_r_i_2FH_ga).
first(n_pp_e,t_vstem_5_r_i_2FH_ga_o).
first(n_pp_e,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp_e,t_vstem_5_s_2FH_ga).
first(n_pp_e,t_vstem_5_s_2FH_ga_ni).
first(n_pp_e,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_s_2FH_ga_o).
first(n_pp_e,t_vstem_5_s_2FH_ga_quote).
first(n_pp_e,t_vstem_5_s_2FH_ga_to).
first(n_pp_e,t_vstem_5_t_2FH_ga).
first(n_pp_e,t_vstem_5_t_2FH_ga_ni).
first(n_pp_e,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp_e,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_t_2FH_ga_o).
first(n_pp_e,t_vstem_5_t_2FH_ga_to).
first(n_pp_e,t_vstem_5_w_2FH_ga).
first(n_pp_e,t_vstem_5_w_2FH_ga_de).
first(n_pp_e,t_vstem_5_w_2FH_ga_ni).
first(n_pp_e,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp_e,t_vstem_5_w_2FH_ga_o).
first(n_pp_e,t_vstem_5_w_2FH_ga_quote).
first(n_pp_e,t_vstem_5_w_2FH_ga_to).
first(n_pp_e,t_vstem_masu_2FH_ga).
first(n_pp_e,t_vstem_sahen_2FH_ga_ni).
first(n_pp_e,t_wh_daimeisi).
first(n_pp_e,t_wh_daimeisi_nan).
first(n_pp_e,t_wh_hukusi).
first(n_pp_e,t_zikan_meisi).
first(n_pp_e,t_zikan_meisi_ippai).
first(n_pp_e,t_zikantai).
first(n_pp_ga,n_capacity).
first(n_pp_ga,n_visitor_name).
first(n_pp_ga,t_adj_meisi).
first(n_pp_ga,t_adj_renyo_2FH_ga).
first(n_pp_ga,t_adj_renyo_2FH_ga_de).
first(n_pp_ga,t_adjstem_2FH_ga).
first(n_pp_ga,t_adjstem_2FH_ga_de).
first(n_pp_ga,t_adjstem_spe_2FH_ga_de).
first(n_pp_ga,t_daimeisi).
first(n_pp_ga,t_daimeisi_domo).
first(n_pp_ga,t_daimeisi_exp).
first(n_pp_ga,t_hukusi).
first(n_pp_ga,t_hukusi_desu).
first(n_pp_ga,t_hutu_meisi).
first(n_pp_ga,t_hutu_meisi_post).
first(n_pp_ga,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp_ga,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp_ga,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp_ga,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp_ga,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp_ga,t_kdo_2FH_ga).
first(n_pp_ga,t_kdo_2FH_ga_de).
first(n_pp_ga,t_kdo_2FH_ga_to).
first(n_pp_ga,t_koyuu_meisi).
first(n_pp_ga,t_meisi_hi).
first(n_pp_ga,t_meisi_hun).
first(n_pp_ga,t_meisi_tsuki).
first(n_pp_ga,t_meisi_youbi).
first(n_pp_ga,t_meisi_zi).
first(n_pp_ga,t_myoji_first).
first(n_pp_ga,t_myoji_last).
first(n_pp_ga,t_n_keisiki).
first(n_pp_ga,t_namae_first).
first(n_pp_ga,t_namae_last).
first(n_pp_ga,t_num_bouyomi).
first(n_pp_ga,t_num_byaku).
first(n_pp_ga,t_num_byaq).
first(n_pp_ga,t_num_go).
first(n_pp_ga,t_num_hachi).
first(n_pp_ga,t_num_haq).
first(n_pp_ga,t_num_hito).
first(n_pp_ga,t_num_huta).
first(n_pp_ga,t_num_hutsu).
first(n_pp_ga,t_num_hyaku).
first(n_pp_ga,t_num_hyaq).
first(n_pp_ga,t_num_ichi).
first(n_pp_ga,t_num_iq).
first(n_pp_ga,t_num_itsu).
first(n_pp_ga,t_num_kokono).
first(n_pp_ga,t_num_ku).
first(n_pp_ga,t_num_kyuu).
first(n_pp_ga,t_num_miq).
first(n_pp_ga,t_num_mui).
first(n_pp_ga,t_num_muq).
first(n_pp_ga,t_num_nana).
first(n_pp_ga,t_num_nano).
first(n_pp_ga,t_num_ni).
first(n_pp_ga,t_num_one).
first(n_pp_ga,t_num_pyaku).
first(n_pp_ga,t_num_pyaq).
first(n_pp_ga,t_num_roku).
first(n_pp_ga,t_num_roq).
first(n_pp_ga,t_num_san).
first(n_pp_ga,t_num_sen).
first(n_pp_ga,t_num_shi).
first(n_pp_ga,t_num_shichi).
first(n_pp_ga,t_num_ten).
first(n_pp_ga,t_num_tou).
first(n_pp_ga,t_num_yaq).
first(n_pp_ga,t_num_yo).
first(n_pp_ga,t_num_yon).
first(n_pp_ga,t_num_yoq).
first(n_pp_ga,t_num_you).
first(n_pp_ga,t_num_zen).
first(n_pp_ga,t_num_zyuq).
first(n_pp_ga,t_num_zyuu).
first(n_pp_ga,t_prefix_go).
first(n_pp_ga,t_prefix_hutu_hutu).
first(n_pp_ga,t_prefix_o).
first(n_pp_ga,t_prefix_quant_quant).
first(n_pp_ga,t_rentai).
first(n_pp_ga,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp_ga,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp_ga,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp_ga,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp_ga,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp_ga,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp_ga,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp_ga,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp_ga,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp_ga,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp_ga,t_sahen_meisi_2FH_ga).
first(n_pp_ga,t_sahen_meisi_2FH_ga_ni).
first(n_pp_ga,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp_ga,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp_ga,t_sahen_meisi_2FH_ga_o).
first(n_pp_ga,t_sahen_meisi_2FH_ga_to).
first(n_pp_ga,t_sahen_meisi_pol_2FH_ga).
first(n_pp_ga,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp_ga,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp_ga,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp_ga,t_suuryousi).
first(n_pp_ga,t_teido_hukusi).
first(n_pp_ga,t_tsuzuri).
first(n_pp_ga,t_vstem_1_2FH_ga).
first(n_pp_ga,t_vstem_1_2FH_ga_de).
first(n_pp_ga,t_vstem_1_2FH_ga_ni).
first(n_pp_ga,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp_ga,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp_ga,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp_ga,t_vstem_1_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_1_2FH_ga_o).
first(n_pp_ga,t_vstem_1_2FH_ga_quote).
first(n_pp_ga,t_vstem_1_2FH_ga_to).
first(n_pp_ga,t_vstem_5_b_2FH_ga).
first(n_pp_ga,t_vstem_5_b_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_b_2FH_ga_o).
first(n_pp_ga,t_vstem_5_b_2FH_ga_to).
first(n_pp_ga,t_vstem_5_g_2FH_ga).
first(n_pp_ga,t_vstem_5_g_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_g_2FH_ga_o).
first(n_pp_ga,t_vstem_5_k_2FH_ga).
first(n_pp_ga,t_vstem_5_k_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_k_2FH_ga_o).
first(n_pp_ga,t_vstem_5_k_2FH_ga_to).
first(n_pp_ga,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp_ga,t_vstem_5_m_2FH_ga).
first(n_pp_ga,t_vstem_5_m_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp_ga,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_m_2FH_ga_o).
first(n_pp_ga,t_vstem_5_m_2FH_ga_to).
first(n_pp_ga,t_vstem_5_r_2FH_ga).
first(n_pp_ga,t_vstem_5_r_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp_ga,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp_ga,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_r_2FH_ga_o).
first(n_pp_ga,t_vstem_5_r_2FH_ga_to).
first(n_pp_ga,t_vstem_5_r_i_2FH_ga).
first(n_pp_ga,t_vstem_5_r_i_2FH_ga_o).
first(n_pp_ga,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp_ga,t_vstem_5_s_2FH_ga).
first(n_pp_ga,t_vstem_5_s_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_s_2FH_ga_o).
first(n_pp_ga,t_vstem_5_s_2FH_ga_quote).
first(n_pp_ga,t_vstem_5_s_2FH_ga_to).
first(n_pp_ga,t_vstem_5_t_2FH_ga).
first(n_pp_ga,t_vstem_5_t_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp_ga,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_t_2FH_ga_o).
first(n_pp_ga,t_vstem_5_t_2FH_ga_to).
first(n_pp_ga,t_vstem_5_w_2FH_ga).
first(n_pp_ga,t_vstem_5_w_2FH_ga_de).
first(n_pp_ga,t_vstem_5_w_2FH_ga_ni).
first(n_pp_ga,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp_ga,t_vstem_5_w_2FH_ga_o).
first(n_pp_ga,t_vstem_5_w_2FH_ga_quote).
first(n_pp_ga,t_vstem_5_w_2FH_ga_to).
first(n_pp_ga,t_vstem_masu_2FH_ga).
first(n_pp_ga,t_vstem_sahen_2FH_ga_ni).
first(n_pp_ga,t_wh_daimeisi).
first(n_pp_ga,t_wh_daimeisi_nan).
first(n_pp_ga,t_wh_hukusi).
first(n_pp_ga,t_zikan_meisi).
first(n_pp_ga,t_zikan_meisi_ippai).
first(n_pp_ga,t_zikantai).
first(n_pp_ni,n_capacity).
first(n_pp_ni,n_visitor_name).
first(n_pp_ni,t_adj_meisi).
first(n_pp_ni,t_adj_renyo_2FH_ga).
first(n_pp_ni,t_adj_renyo_2FH_ga_de).
first(n_pp_ni,t_adjstem_2FH_ga).
first(n_pp_ni,t_adjstem_2FH_ga_de).
first(n_pp_ni,t_adjstem_spe_2FH_ga_de).
first(n_pp_ni,t_daimeisi).
first(n_pp_ni,t_daimeisi_domo).
first(n_pp_ni,t_daimeisi_exp).
first(n_pp_ni,t_hukusi).
first(n_pp_ni,t_hukusi_desu).
first(n_pp_ni,t_hutu_meisi).
first(n_pp_ni,t_hutu_meisi_post).
first(n_pp_ni,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp_ni,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp_ni,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp_ni,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp_ni,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp_ni,t_kdo_2FH_ga).
first(n_pp_ni,t_kdo_2FH_ga_de).
first(n_pp_ni,t_kdo_2FH_ga_to).
first(n_pp_ni,t_koyuu_meisi).
first(n_pp_ni,t_meisi_hi).
first(n_pp_ni,t_meisi_hun).
first(n_pp_ni,t_meisi_tsuki).
first(n_pp_ni,t_meisi_youbi).
first(n_pp_ni,t_meisi_zi).
first(n_pp_ni,t_myoji_first).
first(n_pp_ni,t_myoji_last).
first(n_pp_ni,t_n_keisiki).
first(n_pp_ni,t_namae_first).
first(n_pp_ni,t_namae_last).
first(n_pp_ni,t_num_bouyomi).
first(n_pp_ni,t_num_byaku).
first(n_pp_ni,t_num_byaq).
first(n_pp_ni,t_num_go).
first(n_pp_ni,t_num_hachi).
first(n_pp_ni,t_num_haq).
first(n_pp_ni,t_num_hito).
first(n_pp_ni,t_num_huta).
first(n_pp_ni,t_num_hutsu).
first(n_pp_ni,t_num_hyaku).
first(n_pp_ni,t_num_hyaq).
first(n_pp_ni,t_num_ichi).
first(n_pp_ni,t_num_iq).
first(n_pp_ni,t_num_itsu).
first(n_pp_ni,t_num_kokono).
first(n_pp_ni,t_num_ku).
first(n_pp_ni,t_num_kyuu).
first(n_pp_ni,t_num_miq).
first(n_pp_ni,t_num_mui).
first(n_pp_ni,t_num_muq).
first(n_pp_ni,t_num_nana).
first(n_pp_ni,t_num_nano).
first(n_pp_ni,t_num_ni).
first(n_pp_ni,t_num_one).
first(n_pp_ni,t_num_pyaku).
first(n_pp_ni,t_num_pyaq).
first(n_pp_ni,t_num_roku).
first(n_pp_ni,t_num_roq).
first(n_pp_ni,t_num_san).
first(n_pp_ni,t_num_sen).
first(n_pp_ni,t_num_shi).
first(n_pp_ni,t_num_shichi).
first(n_pp_ni,t_num_ten).
first(n_pp_ni,t_num_tou).
first(n_pp_ni,t_num_yaq).
first(n_pp_ni,t_num_yo).
first(n_pp_ni,t_num_yon).
first(n_pp_ni,t_num_yoq).
first(n_pp_ni,t_num_you).
first(n_pp_ni,t_num_zen).
first(n_pp_ni,t_num_zyuq).
first(n_pp_ni,t_num_zyuu).
first(n_pp_ni,t_prefix_go).
first(n_pp_ni,t_prefix_hutu_hutu).
first(n_pp_ni,t_prefix_o).
first(n_pp_ni,t_prefix_quant_quant).
first(n_pp_ni,t_rentai).
first(n_pp_ni,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp_ni,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp_ni,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp_ni,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp_ni,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp_ni,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp_ni,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp_ni,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp_ni,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp_ni,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp_ni,t_sahen_meisi_2FH_ga).
first(n_pp_ni,t_sahen_meisi_2FH_ga_ni).
first(n_pp_ni,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp_ni,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp_ni,t_sahen_meisi_2FH_ga_o).
first(n_pp_ni,t_sahen_meisi_2FH_ga_to).
first(n_pp_ni,t_sahen_meisi_pol_2FH_ga).
first(n_pp_ni,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp_ni,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp_ni,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp_ni,t_suuryousi).
first(n_pp_ni,t_teido_hukusi).
first(n_pp_ni,t_tsuzuri).
first(n_pp_ni,t_vstem_1_2FH_ga).
first(n_pp_ni,t_vstem_1_2FH_ga_de).
first(n_pp_ni,t_vstem_1_2FH_ga_ni).
first(n_pp_ni,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp_ni,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp_ni,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp_ni,t_vstem_1_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_1_2FH_ga_o).
first(n_pp_ni,t_vstem_1_2FH_ga_quote).
first(n_pp_ni,t_vstem_1_2FH_ga_to).
first(n_pp_ni,t_vstem_5_b_2FH_ga).
first(n_pp_ni,t_vstem_5_b_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_b_2FH_ga_o).
first(n_pp_ni,t_vstem_5_b_2FH_ga_to).
first(n_pp_ni,t_vstem_5_g_2FH_ga).
first(n_pp_ni,t_vstem_5_g_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_g_2FH_ga_o).
first(n_pp_ni,t_vstem_5_k_2FH_ga).
first(n_pp_ni,t_vstem_5_k_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_k_2FH_ga_o).
first(n_pp_ni,t_vstem_5_k_2FH_ga_to).
first(n_pp_ni,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp_ni,t_vstem_5_m_2FH_ga).
first(n_pp_ni,t_vstem_5_m_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp_ni,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_m_2FH_ga_o).
first(n_pp_ni,t_vstem_5_m_2FH_ga_to).
first(n_pp_ni,t_vstem_5_r_2FH_ga).
first(n_pp_ni,t_vstem_5_r_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp_ni,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp_ni,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_r_2FH_ga_o).
first(n_pp_ni,t_vstem_5_r_2FH_ga_to).
first(n_pp_ni,t_vstem_5_r_i_2FH_ga).
first(n_pp_ni,t_vstem_5_r_i_2FH_ga_o).
first(n_pp_ni,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp_ni,t_vstem_5_s_2FH_ga).
first(n_pp_ni,t_vstem_5_s_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_s_2FH_ga_o).
first(n_pp_ni,t_vstem_5_s_2FH_ga_quote).
first(n_pp_ni,t_vstem_5_s_2FH_ga_to).
first(n_pp_ni,t_vstem_5_t_2FH_ga).
first(n_pp_ni,t_vstem_5_t_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp_ni,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_t_2FH_ga_o).
first(n_pp_ni,t_vstem_5_t_2FH_ga_to).
first(n_pp_ni,t_vstem_5_w_2FH_ga).
first(n_pp_ni,t_vstem_5_w_2FH_ga_de).
first(n_pp_ni,t_vstem_5_w_2FH_ga_ni).
first(n_pp_ni,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp_ni,t_vstem_5_w_2FH_ga_o).
first(n_pp_ni,t_vstem_5_w_2FH_ga_quote).
first(n_pp_ni,t_vstem_5_w_2FH_ga_to).
first(n_pp_ni,t_vstem_masu_2FH_ga).
first(n_pp_ni,t_vstem_sahen_2FH_ga_ni).
first(n_pp_ni,t_wh_daimeisi).
first(n_pp_ni,t_wh_daimeisi_nan).
first(n_pp_ni,t_wh_hukusi).
first(n_pp_ni,t_zikan_meisi).
first(n_pp_ni,t_zikan_meisi_ippai).
first(n_pp_ni,t_zikantai).
first(n_pp_o,n_capacity).
first(n_pp_o,n_visitor_name).
first(n_pp_o,t_adj_meisi).
first(n_pp_o,t_adj_renyo_2FH_ga).
first(n_pp_o,t_adj_renyo_2FH_ga_de).
first(n_pp_o,t_adjstem_2FH_ga).
first(n_pp_o,t_adjstem_2FH_ga_de).
first(n_pp_o,t_adjstem_spe_2FH_ga_de).
first(n_pp_o,t_daimeisi).
first(n_pp_o,t_daimeisi_domo).
first(n_pp_o,t_daimeisi_exp).
first(n_pp_o,t_hukusi).
first(n_pp_o,t_hukusi_desu).
first(n_pp_o,t_hutu_meisi).
first(n_pp_o,t_hutu_meisi_post).
first(n_pp_o,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp_o,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp_o,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp_o,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp_o,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp_o,t_kdo_2FH_ga).
first(n_pp_o,t_kdo_2FH_ga_de).
first(n_pp_o,t_kdo_2FH_ga_to).
first(n_pp_o,t_koyuu_meisi).
first(n_pp_o,t_meisi_hi).
first(n_pp_o,t_meisi_hun).
first(n_pp_o,t_meisi_tsuki).
first(n_pp_o,t_meisi_youbi).
first(n_pp_o,t_meisi_zi).
first(n_pp_o,t_myoji_first).
first(n_pp_o,t_myoji_last).
first(n_pp_o,t_n_keisiki).
first(n_pp_o,t_namae_first).
first(n_pp_o,t_namae_last).
first(n_pp_o,t_num_bouyomi).
first(n_pp_o,t_num_byaku).
first(n_pp_o,t_num_byaq).
first(n_pp_o,t_num_go).
first(n_pp_o,t_num_hachi).
first(n_pp_o,t_num_haq).
first(n_pp_o,t_num_hito).
first(n_pp_o,t_num_huta).
first(n_pp_o,t_num_hutsu).
first(n_pp_o,t_num_hyaku).
first(n_pp_o,t_num_hyaq).
first(n_pp_o,t_num_ichi).
first(n_pp_o,t_num_iq).
first(n_pp_o,t_num_itsu).
first(n_pp_o,t_num_kokono).
first(n_pp_o,t_num_ku).
first(n_pp_o,t_num_kyuu).
first(n_pp_o,t_num_miq).
first(n_pp_o,t_num_mui).
first(n_pp_o,t_num_muq).
first(n_pp_o,t_num_nana).
first(n_pp_o,t_num_nano).
first(n_pp_o,t_num_ni).
first(n_pp_o,t_num_one).
first(n_pp_o,t_num_pyaku).
first(n_pp_o,t_num_pyaq).
first(n_pp_o,t_num_roku).
first(n_pp_o,t_num_roq).
first(n_pp_o,t_num_san).
first(n_pp_o,t_num_sen).
first(n_pp_o,t_num_shi).
first(n_pp_o,t_num_shichi).
first(n_pp_o,t_num_ten).
first(n_pp_o,t_num_tou).
first(n_pp_o,t_num_yaq).
first(n_pp_o,t_num_yo).
first(n_pp_o,t_num_yon).
first(n_pp_o,t_num_yoq).
first(n_pp_o,t_num_you).
first(n_pp_o,t_num_zen).
first(n_pp_o,t_num_zyuq).
first(n_pp_o,t_num_zyuu).
first(n_pp_o,t_prefix_go).
first(n_pp_o,t_prefix_hutu_hutu).
first(n_pp_o,t_prefix_o).
first(n_pp_o,t_prefix_quant_quant).
first(n_pp_o,t_rentai).
first(n_pp_o,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp_o,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp_o,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp_o,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp_o,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp_o,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp_o,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp_o,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp_o,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp_o,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp_o,t_sahen_meisi_2FH_ga).
first(n_pp_o,t_sahen_meisi_2FH_ga_ni).
first(n_pp_o,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp_o,t_sahen_meisi_2FH_ga_o).
first(n_pp_o,t_sahen_meisi_2FH_ga_to).
first(n_pp_o,t_sahen_meisi_pol_2FH_ga).
first(n_pp_o,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp_o,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp_o,t_suuryousi).
first(n_pp_o,t_teido_hukusi).
first(n_pp_o,t_tsuzuri).
first(n_pp_o,t_vstem_1_2FH_ga).
first(n_pp_o,t_vstem_1_2FH_ga_de).
first(n_pp_o,t_vstem_1_2FH_ga_ni).
first(n_pp_o,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp_o,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp_o,t_vstem_1_2FH_ga_ni_o).
first(n_pp_o,t_vstem_1_2FH_ga_o).
first(n_pp_o,t_vstem_1_2FH_ga_quote).
first(n_pp_o,t_vstem_1_2FH_ga_to).
first(n_pp_o,t_vstem_5_b_2FH_ga).
first(n_pp_o,t_vstem_5_b_2FH_ga_ni).
first(n_pp_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_b_2FH_ga_o).
first(n_pp_o,t_vstem_5_b_2FH_ga_to).
first(n_pp_o,t_vstem_5_g_2FH_ga).
first(n_pp_o,t_vstem_5_g_2FH_ga_ni).
first(n_pp_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_g_2FH_ga_o).
first(n_pp_o,t_vstem_5_k_2FH_ga).
first(n_pp_o,t_vstem_5_k_2FH_ga_ni).
first(n_pp_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_k_2FH_ga_o).
first(n_pp_o,t_vstem_5_k_2FH_ga_to).
first(n_pp_o,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp_o,t_vstem_5_m_2FH_ga).
first(n_pp_o,t_vstem_5_m_2FH_ga_ni).
first(n_pp_o,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_m_2FH_ga_o).
first(n_pp_o,t_vstem_5_m_2FH_ga_to).
first(n_pp_o,t_vstem_5_r_2FH_ga).
first(n_pp_o,t_vstem_5_r_2FH_ga_ni).
first(n_pp_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp_o,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_r_2FH_ga_o).
first(n_pp_o,t_vstem_5_r_2FH_ga_to).
first(n_pp_o,t_vstem_5_r_i_2FH_ga).
first(n_pp_o,t_vstem_5_r_i_2FH_ga_o).
first(n_pp_o,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp_o,t_vstem_5_s_2FH_ga).
first(n_pp_o,t_vstem_5_s_2FH_ga_ni).
first(n_pp_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_s_2FH_ga_o).
first(n_pp_o,t_vstem_5_s_2FH_ga_quote).
first(n_pp_o,t_vstem_5_s_2FH_ga_to).
first(n_pp_o,t_vstem_5_t_2FH_ga).
first(n_pp_o,t_vstem_5_t_2FH_ga_ni).
first(n_pp_o,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_t_2FH_ga_o).
first(n_pp_o,t_vstem_5_t_2FH_ga_to).
first(n_pp_o,t_vstem_5_w_2FH_ga).
first(n_pp_o,t_vstem_5_w_2FH_ga_de).
first(n_pp_o,t_vstem_5_w_2FH_ga_ni).
first(n_pp_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp_o,t_vstem_5_w_2FH_ga_o).
first(n_pp_o,t_vstem_5_w_2FH_ga_quote).
first(n_pp_o,t_vstem_5_w_2FH_ga_to).
first(n_pp_o,t_vstem_masu_2FH_ga).
first(n_pp_o,t_vstem_sahen_2FH_ga_ni).
first(n_pp_o,t_wh_daimeisi).
first(n_pp_o,t_wh_daimeisi_nan).
first(n_pp_o,t_wh_hukusi).
first(n_pp_o,t_zikan_meisi).
first(n_pp_o,t_zikan_meisi_ippai).
first(n_pp_o,t_zikantai).
first(n_pp_quote,n_capacity).
first(n_pp_quote,n_visitor_name).
first(n_pp_quote,t_adj_meisi).
first(n_pp_quote,t_adj_renyo_2FH_ga).
first(n_pp_quote,t_adj_renyo_2FH_ga_de).
first(n_pp_quote,t_adjstem_2FH_ga).
first(n_pp_quote,t_adjstem_2FH_ga_de).
first(n_pp_quote,t_adjstem_spe_2FH_ga_de).
first(n_pp_quote,t_daimeisi).
first(n_pp_quote,t_daimeisi_domo).
first(n_pp_quote,t_daimeisi_exp).
first(n_pp_quote,t_hukusi).
first(n_pp_quote,t_hukusi_desu).
first(n_pp_quote,t_hutu_meisi).
first(n_pp_quote,t_hutu_meisi_post).
first(n_pp_quote,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp_quote,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp_quote,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp_quote,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp_quote,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp_quote,t_kdo_2FH_ga).
first(n_pp_quote,t_kdo_2FH_ga_de).
first(n_pp_quote,t_kdo_2FH_ga_to).
first(n_pp_quote,t_koyuu_meisi).
first(n_pp_quote,t_meisi_hi).
first(n_pp_quote,t_meisi_hun).
first(n_pp_quote,t_meisi_tsuki).
first(n_pp_quote,t_meisi_youbi).
first(n_pp_quote,t_meisi_zi).
first(n_pp_quote,t_myoji_first).
first(n_pp_quote,t_myoji_last).
first(n_pp_quote,t_n_keisiki).
first(n_pp_quote,t_namae_first).
first(n_pp_quote,t_namae_last).
first(n_pp_quote,t_num_bouyomi).
first(n_pp_quote,t_num_byaku).
first(n_pp_quote,t_num_byaq).
first(n_pp_quote,t_num_go).
first(n_pp_quote,t_num_hachi).
first(n_pp_quote,t_num_haq).
first(n_pp_quote,t_num_hito).
first(n_pp_quote,t_num_huta).
first(n_pp_quote,t_num_hutsu).
first(n_pp_quote,t_num_hyaku).
first(n_pp_quote,t_num_hyaq).
first(n_pp_quote,t_num_ichi).
first(n_pp_quote,t_num_iq).
first(n_pp_quote,t_num_itsu).
first(n_pp_quote,t_num_kokono).
first(n_pp_quote,t_num_ku).
first(n_pp_quote,t_num_kyuu).
first(n_pp_quote,t_num_miq).
first(n_pp_quote,t_num_mui).
first(n_pp_quote,t_num_muq).
first(n_pp_quote,t_num_nana).
first(n_pp_quote,t_num_nano).
first(n_pp_quote,t_num_ni).
first(n_pp_quote,t_num_one).
first(n_pp_quote,t_num_pyaku).
first(n_pp_quote,t_num_pyaq).
first(n_pp_quote,t_num_roku).
first(n_pp_quote,t_num_roq).
first(n_pp_quote,t_num_san).
first(n_pp_quote,t_num_sen).
first(n_pp_quote,t_num_shi).
first(n_pp_quote,t_num_shichi).
first(n_pp_quote,t_num_ten).
first(n_pp_quote,t_num_tou).
first(n_pp_quote,t_num_yaq).
first(n_pp_quote,t_num_yo).
first(n_pp_quote,t_num_yon).
first(n_pp_quote,t_num_yoq).
first(n_pp_quote,t_num_you).
first(n_pp_quote,t_num_zen).
first(n_pp_quote,t_num_zyuq).
first(n_pp_quote,t_num_zyuu).
first(n_pp_quote,t_prefix_go).
first(n_pp_quote,t_prefix_hutu_hutu).
first(n_pp_quote,t_prefix_o).
first(n_pp_quote,t_prefix_quant_quant).
first(n_pp_quote,t_rentai).
first(n_pp_quote,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp_quote,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp_quote,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp_quote,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp_quote,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp_quote,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp_quote,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp_quote,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp_quote,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp_quote,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp_quote,t_sahen_meisi_2FH_ga).
first(n_pp_quote,t_sahen_meisi_2FH_ga_ni).
first(n_pp_quote,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp_quote,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp_quote,t_sahen_meisi_2FH_ga_o).
first(n_pp_quote,t_sahen_meisi_2FH_ga_to).
first(n_pp_quote,t_sahen_meisi_pol_2FH_ga).
first(n_pp_quote,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp_quote,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp_quote,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp_quote,t_suuryousi).
first(n_pp_quote,t_teido_hukusi).
first(n_pp_quote,t_tsuzuri).
first(n_pp_quote,t_vstem_1_2FH_ga).
first(n_pp_quote,t_vstem_1_2FH_ga_de).
first(n_pp_quote,t_vstem_1_2FH_ga_ni).
first(n_pp_quote,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp_quote,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp_quote,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp_quote,t_vstem_1_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_1_2FH_ga_o).
first(n_pp_quote,t_vstem_1_2FH_ga_quote).
first(n_pp_quote,t_vstem_1_2FH_ga_to).
first(n_pp_quote,t_vstem_5_b_2FH_ga).
first(n_pp_quote,t_vstem_5_b_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_b_2FH_ga_o).
first(n_pp_quote,t_vstem_5_b_2FH_ga_to).
first(n_pp_quote,t_vstem_5_g_2FH_ga).
first(n_pp_quote,t_vstem_5_g_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_g_2FH_ga_o).
first(n_pp_quote,t_vstem_5_k_2FH_ga).
first(n_pp_quote,t_vstem_5_k_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_k_2FH_ga_o).
first(n_pp_quote,t_vstem_5_k_2FH_ga_to).
first(n_pp_quote,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp_quote,t_vstem_5_m_2FH_ga).
first(n_pp_quote,t_vstem_5_m_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp_quote,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_m_2FH_ga_o).
first(n_pp_quote,t_vstem_5_m_2FH_ga_to).
first(n_pp_quote,t_vstem_5_r_2FH_ga).
first(n_pp_quote,t_vstem_5_r_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp_quote,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp_quote,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_r_2FH_ga_o).
first(n_pp_quote,t_vstem_5_r_2FH_ga_to).
first(n_pp_quote,t_vstem_5_r_i_2FH_ga).
first(n_pp_quote,t_vstem_5_r_i_2FH_ga_o).
first(n_pp_quote,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp_quote,t_vstem_5_s_2FH_ga).
first(n_pp_quote,t_vstem_5_s_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_s_2FH_ga_o).
first(n_pp_quote,t_vstem_5_s_2FH_ga_quote).
first(n_pp_quote,t_vstem_5_s_2FH_ga_to).
first(n_pp_quote,t_vstem_5_t_2FH_ga).
first(n_pp_quote,t_vstem_5_t_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp_quote,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_t_2FH_ga_o).
first(n_pp_quote,t_vstem_5_t_2FH_ga_to).
first(n_pp_quote,t_vstem_5_w_2FH_ga).
first(n_pp_quote,t_vstem_5_w_2FH_ga_de).
first(n_pp_quote,t_vstem_5_w_2FH_ga_ni).
first(n_pp_quote,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp_quote,t_vstem_5_w_2FH_ga_o).
first(n_pp_quote,t_vstem_5_w_2FH_ga_quote).
first(n_pp_quote,t_vstem_5_w_2FH_ga_to).
first(n_pp_quote,t_vstem_masu_2FH_ga).
first(n_pp_quote,t_vstem_sahen_2FH_ga_ni).
first(n_pp_quote,t_wh_daimeisi).
first(n_pp_quote,t_wh_daimeisi_nan).
first(n_pp_quote,t_wh_hukusi).
first(n_pp_quote,t_zikan_meisi).
first(n_pp_quote,t_zikan_meisi_ippai).
first(n_pp_quote,t_zikantai).
first(n_pp_to,n_capacity).
first(n_pp_to,n_visitor_name).
first(n_pp_to,t_adj_meisi).
first(n_pp_to,t_adj_renyo_2FH_ga).
first(n_pp_to,t_adj_renyo_2FH_ga_de).
first(n_pp_to,t_adjstem_2FH_ga).
first(n_pp_to,t_adjstem_2FH_ga_de).
first(n_pp_to,t_adjstem_spe_2FH_ga_de).
first(n_pp_to,t_daimeisi).
first(n_pp_to,t_daimeisi_domo).
first(n_pp_to,t_daimeisi_exp).
first(n_pp_to,t_hukusi).
first(n_pp_to,t_hukusi_desu).
first(n_pp_to,t_hutu_meisi).
first(n_pp_to,t_hutu_meisi_post).
first(n_pp_to,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pp_to,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pp_to,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pp_to,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pp_to,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pp_to,t_kdo_2FH_ga).
first(n_pp_to,t_kdo_2FH_ga_de).
first(n_pp_to,t_kdo_2FH_ga_to).
first(n_pp_to,t_koyuu_meisi).
first(n_pp_to,t_meisi_hi).
first(n_pp_to,t_meisi_hun).
first(n_pp_to,t_meisi_tsuki).
first(n_pp_to,t_meisi_youbi).
first(n_pp_to,t_meisi_zi).
first(n_pp_to,t_myoji_first).
first(n_pp_to,t_myoji_last).
first(n_pp_to,t_n_keisiki).
first(n_pp_to,t_namae_first).
first(n_pp_to,t_namae_last).
first(n_pp_to,t_num_bouyomi).
first(n_pp_to,t_num_byaku).
first(n_pp_to,t_num_byaq).
first(n_pp_to,t_num_go).
first(n_pp_to,t_num_hachi).
first(n_pp_to,t_num_haq).
first(n_pp_to,t_num_hito).
first(n_pp_to,t_num_huta).
first(n_pp_to,t_num_hutsu).
first(n_pp_to,t_num_hyaku).
first(n_pp_to,t_num_hyaq).
first(n_pp_to,t_num_ichi).
first(n_pp_to,t_num_iq).
first(n_pp_to,t_num_itsu).
first(n_pp_to,t_num_kokono).
first(n_pp_to,t_num_ku).
first(n_pp_to,t_num_kyuu).
first(n_pp_to,t_num_miq).
first(n_pp_to,t_num_mui).
first(n_pp_to,t_num_muq).
first(n_pp_to,t_num_nana).
first(n_pp_to,t_num_nano).
first(n_pp_to,t_num_ni).
first(n_pp_to,t_num_one).
first(n_pp_to,t_num_pyaku).
first(n_pp_to,t_num_pyaq).
first(n_pp_to,t_num_roku).
first(n_pp_to,t_num_roq).
first(n_pp_to,t_num_san).
first(n_pp_to,t_num_sen).
first(n_pp_to,t_num_shi).
first(n_pp_to,t_num_shichi).
first(n_pp_to,t_num_ten).
first(n_pp_to,t_num_tou).
first(n_pp_to,t_num_yaq).
first(n_pp_to,t_num_yo).
first(n_pp_to,t_num_yon).
first(n_pp_to,t_num_yoq).
first(n_pp_to,t_num_you).
first(n_pp_to,t_num_zen).
first(n_pp_to,t_num_zyuq).
first(n_pp_to,t_num_zyuu).
first(n_pp_to,t_prefix_go).
first(n_pp_to,t_prefix_hutu_hutu).
first(n_pp_to,t_prefix_o).
first(n_pp_to,t_prefix_quant_quant).
first(n_pp_to,t_rentai).
first(n_pp_to,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pp_to,t_sahen_dousi_katei_2FH_ga_o).
first(n_pp_to,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pp_to,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pp_to,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pp_to,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pp_to,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pp_to,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pp_to,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pp_to,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pp_to,t_sahen_meisi_2FH_ga).
first(n_pp_to,t_sahen_meisi_2FH_ga_ni).
first(n_pp_to,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pp_to,t_sahen_meisi_2FH_ga_ni_o).
first(n_pp_to,t_sahen_meisi_2FH_ga_o).
first(n_pp_to,t_sahen_meisi_2FH_ga_to).
first(n_pp_to,t_sahen_meisi_pol_2FH_ga).
first(n_pp_to,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pp_to,t_sahen_meisi_pol_2FH_ga_o).
first(n_pp_to,t_sahen_meisi_pol_2FH_ga_to).
first(n_pp_to,t_suuryousi).
first(n_pp_to,t_teido_hukusi).
first(n_pp_to,t_tsuzuri).
first(n_pp_to,t_vstem_1_2FH_ga).
first(n_pp_to,t_vstem_1_2FH_ga_de).
first(n_pp_to,t_vstem_1_2FH_ga_ni).
first(n_pp_to,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pp_to,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pp_to,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pp_to,t_vstem_1_2FH_ga_ni_o).
first(n_pp_to,t_vstem_1_2FH_ga_o).
first(n_pp_to,t_vstem_1_2FH_ga_quote).
first(n_pp_to,t_vstem_1_2FH_ga_to).
first(n_pp_to,t_vstem_5_b_2FH_ga).
first(n_pp_to,t_vstem_5_b_2FH_ga_ni).
first(n_pp_to,t_vstem_5_b_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_b_2FH_ga_o).
first(n_pp_to,t_vstem_5_b_2FH_ga_to).
first(n_pp_to,t_vstem_5_g_2FH_ga).
first(n_pp_to,t_vstem_5_g_2FH_ga_ni).
first(n_pp_to,t_vstem_5_g_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_g_2FH_ga_o).
first(n_pp_to,t_vstem_5_k_2FH_ga).
first(n_pp_to,t_vstem_5_k_2FH_ga_ni).
first(n_pp_to,t_vstem_5_k_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_k_2FH_ga_o).
first(n_pp_to,t_vstem_5_k_2FH_ga_to).
first(n_pp_to,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pp_to,t_vstem_5_m_2FH_ga).
first(n_pp_to,t_vstem_5_m_2FH_ga_ni).
first(n_pp_to,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pp_to,t_vstem_5_m_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_m_2FH_ga_o).
first(n_pp_to,t_vstem_5_m_2FH_ga_to).
first(n_pp_to,t_vstem_5_r_2FH_ga).
first(n_pp_to,t_vstem_5_r_2FH_ga_ni).
first(n_pp_to,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pp_to,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pp_to,t_vstem_5_r_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_r_2FH_ga_o).
first(n_pp_to,t_vstem_5_r_2FH_ga_to).
first(n_pp_to,t_vstem_5_r_i_2FH_ga).
first(n_pp_to,t_vstem_5_r_i_2FH_ga_o).
first(n_pp_to,t_vstem_5_r_i_2FH_ga_quote).
first(n_pp_to,t_vstem_5_s_2FH_ga).
first(n_pp_to,t_vstem_5_s_2FH_ga_ni).
first(n_pp_to,t_vstem_5_s_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_s_2FH_ga_o).
first(n_pp_to,t_vstem_5_s_2FH_ga_quote).
first(n_pp_to,t_vstem_5_s_2FH_ga_to).
first(n_pp_to,t_vstem_5_t_2FH_ga).
first(n_pp_to,t_vstem_5_t_2FH_ga_ni).
first(n_pp_to,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pp_to,t_vstem_5_t_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_t_2FH_ga_o).
first(n_pp_to,t_vstem_5_t_2FH_ga_to).
first(n_pp_to,t_vstem_5_w_2FH_ga).
first(n_pp_to,t_vstem_5_w_2FH_ga_de).
first(n_pp_to,t_vstem_5_w_2FH_ga_ni).
first(n_pp_to,t_vstem_5_w_2FH_ga_ni_o).
first(n_pp_to,t_vstem_5_w_2FH_ga_o).
first(n_pp_to,t_vstem_5_w_2FH_ga_quote).
first(n_pp_to,t_vstem_5_w_2FH_ga_to).
first(n_pp_to,t_vstem_masu_2FH_ga).
first(n_pp_to,t_vstem_sahen_2FH_ga_ni).
first(n_pp_to,t_wh_daimeisi).
first(n_pp_to,t_wh_daimeisi_nan).
first(n_pp_to,t_wh_hukusi).
first(n_pp_to,t_zikan_meisi).
first(n_pp_to,t_zikan_meisi_ippai).
first(n_pp_to,t_zikantai).
first(n_prefix,t_prefix_go).
first(n_prefix,t_prefix_hutu_hutu).
first(n_prefix,t_prefix_o).
first(n_prefix,t_prefix_quant_quant).
first(n_pro,t_daimeisi).
first(n_pro_domo,n_capacity).
first(n_pro_domo,n_visitor_name).
first(n_pro_domo,t_adj_meisi).
first(n_pro_domo,t_adj_renyo_2FH_ga).
first(n_pro_domo,t_adj_renyo_2FH_ga_de).
first(n_pro_domo,t_adjstem_2FH_ga).
first(n_pro_domo,t_adjstem_2FH_ga_de).
first(n_pro_domo,t_adjstem_spe_2FH_ga_de).
first(n_pro_domo,t_daimeisi).
first(n_pro_domo,t_daimeisi_domo).
first(n_pro_domo,t_daimeisi_exp).
first(n_pro_domo,t_hukusi).
first(n_pro_domo,t_hukusi_desu).
first(n_pro_domo,t_hutu_meisi).
first(n_pro_domo,t_hutu_meisi_post).
first(n_pro_domo,t_kahen_dousi_katei_2FH_ga_ni).
first(n_pro_domo,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_pro_domo,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_pro_domo,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_pro_domo,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_pro_domo,t_kdo_2FH_ga).
first(n_pro_domo,t_kdo_2FH_ga_de).
first(n_pro_domo,t_kdo_2FH_ga_to).
first(n_pro_domo,t_koyuu_meisi).
first(n_pro_domo,t_meisi_hi).
first(n_pro_domo,t_meisi_hun).
first(n_pro_domo,t_meisi_tsuki).
first(n_pro_domo,t_meisi_youbi).
first(n_pro_domo,t_meisi_zi).
first(n_pro_domo,t_myoji_first).
first(n_pro_domo,t_myoji_last).
first(n_pro_domo,t_n_keisiki).
first(n_pro_domo,t_namae_first).
first(n_pro_domo,t_namae_last).
first(n_pro_domo,t_num_bouyomi).
first(n_pro_domo,t_num_byaku).
first(n_pro_domo,t_num_byaq).
first(n_pro_domo,t_num_go).
first(n_pro_domo,t_num_hachi).
first(n_pro_domo,t_num_haq).
first(n_pro_domo,t_num_hito).
first(n_pro_domo,t_num_huta).
first(n_pro_domo,t_num_hutsu).
first(n_pro_domo,t_num_hyaku).
first(n_pro_domo,t_num_hyaq).
first(n_pro_domo,t_num_ichi).
first(n_pro_domo,t_num_iq).
first(n_pro_domo,t_num_itsu).
first(n_pro_domo,t_num_kokono).
first(n_pro_domo,t_num_ku).
first(n_pro_domo,t_num_kyuu).
first(n_pro_domo,t_num_miq).
first(n_pro_domo,t_num_mui).
first(n_pro_domo,t_num_muq).
first(n_pro_domo,t_num_nana).
first(n_pro_domo,t_num_nano).
first(n_pro_domo,t_num_ni).
first(n_pro_domo,t_num_one).
first(n_pro_domo,t_num_pyaku).
first(n_pro_domo,t_num_pyaq).
first(n_pro_domo,t_num_roku).
first(n_pro_domo,t_num_roq).
first(n_pro_domo,t_num_san).
first(n_pro_domo,t_num_sen).
first(n_pro_domo,t_num_shi).
first(n_pro_domo,t_num_shichi).
first(n_pro_domo,t_num_ten).
first(n_pro_domo,t_num_tou).
first(n_pro_domo,t_num_yaq).
first(n_pro_domo,t_num_yo).
first(n_pro_domo,t_num_yon).
first(n_pro_domo,t_num_yoq).
first(n_pro_domo,t_num_you).
first(n_pro_domo,t_num_zen).
first(n_pro_domo,t_num_zyuq).
first(n_pro_domo,t_num_zyuu).
first(n_pro_domo,t_prefix_go).
first(n_pro_domo,t_prefix_hutu_hutu).
first(n_pro_domo,t_prefix_o).
first(n_pro_domo,t_prefix_quant_quant).
first(n_pro_domo,t_rentai).
first(n_pro_domo,t_sahen_dousi_katei_2FH_ga_ni).
first(n_pro_domo,t_sahen_dousi_katei_2FH_ga_o).
first(n_pro_domo,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_pro_domo,t_sahen_dousi_mizen_2FH_ga_o).
first(n_pro_domo,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_pro_domo,t_sahen_dousi_rentai_2FH_ga_o).
first(n_pro_domo,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_pro_domo,t_sahen_dousi_renyo_2FH_ga_o).
first(n_pro_domo,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_pro_domo,t_sahen_dousi_syusi_2FH_ga_o).
first(n_pro_domo,t_sahen_meisi_2FH_ga).
first(n_pro_domo,t_sahen_meisi_2FH_ga_ni).
first(n_pro_domo,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_pro_domo,t_sahen_meisi_2FH_ga_ni_o).
first(n_pro_domo,t_sahen_meisi_2FH_ga_o).
first(n_pro_domo,t_sahen_meisi_2FH_ga_to).
first(n_pro_domo,t_sahen_meisi_pol_2FH_ga).
first(n_pro_domo,t_sahen_meisi_pol_2FH_ga_ni).
first(n_pro_domo,t_sahen_meisi_pol_2FH_ga_o).
first(n_pro_domo,t_sahen_meisi_pol_2FH_ga_to).
first(n_pro_domo,t_suuryousi).
first(n_pro_domo,t_teido_hukusi).
first(n_pro_domo,t_tsuzuri).
first(n_pro_domo,t_vstem_1_2FH_ga).
first(n_pro_domo,t_vstem_1_2FH_ga_de).
first(n_pro_domo,t_vstem_1_2FH_ga_ni).
first(n_pro_domo,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_pro_domo,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_pro_domo,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_pro_domo,t_vstem_1_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_1_2FH_ga_o).
first(n_pro_domo,t_vstem_1_2FH_ga_quote).
first(n_pro_domo,t_vstem_1_2FH_ga_to).
first(n_pro_domo,t_vstem_5_b_2FH_ga).
first(n_pro_domo,t_vstem_5_b_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_b_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_b_2FH_ga_o).
first(n_pro_domo,t_vstem_5_b_2FH_ga_to).
first(n_pro_domo,t_vstem_5_g_2FH_ga).
first(n_pro_domo,t_vstem_5_g_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_g_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_g_2FH_ga_o).
first(n_pro_domo,t_vstem_5_k_2FH_ga).
first(n_pro_domo,t_vstem_5_k_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_k_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_k_2FH_ga_o).
first(n_pro_domo,t_vstem_5_k_2FH_ga_to).
first(n_pro_domo,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_pro_domo,t_vstem_5_m_2FH_ga).
first(n_pro_domo,t_vstem_5_m_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_pro_domo,t_vstem_5_m_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_m_2FH_ga_o).
first(n_pro_domo,t_vstem_5_m_2FH_ga_to).
first(n_pro_domo,t_vstem_5_r_2FH_ga).
first(n_pro_domo,t_vstem_5_r_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_pro_domo,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_pro_domo,t_vstem_5_r_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_r_2FH_ga_o).
first(n_pro_domo,t_vstem_5_r_2FH_ga_to).
first(n_pro_domo,t_vstem_5_r_i_2FH_ga).
first(n_pro_domo,t_vstem_5_r_i_2FH_ga_o).
first(n_pro_domo,t_vstem_5_r_i_2FH_ga_quote).
first(n_pro_domo,t_vstem_5_s_2FH_ga).
first(n_pro_domo,t_vstem_5_s_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_s_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_s_2FH_ga_o).
first(n_pro_domo,t_vstem_5_s_2FH_ga_quote).
first(n_pro_domo,t_vstem_5_s_2FH_ga_to).
first(n_pro_domo,t_vstem_5_t_2FH_ga).
first(n_pro_domo,t_vstem_5_t_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_pro_domo,t_vstem_5_t_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_t_2FH_ga_o).
first(n_pro_domo,t_vstem_5_t_2FH_ga_to).
first(n_pro_domo,t_vstem_5_w_2FH_ga).
first(n_pro_domo,t_vstem_5_w_2FH_ga_de).
first(n_pro_domo,t_vstem_5_w_2FH_ga_ni).
first(n_pro_domo,t_vstem_5_w_2FH_ga_ni_o).
first(n_pro_domo,t_vstem_5_w_2FH_ga_o).
first(n_pro_domo,t_vstem_5_w_2FH_ga_quote).
first(n_pro_domo,t_vstem_5_w_2FH_ga_to).
first(n_pro_domo,t_vstem_masu_2FH_ga).
first(n_pro_domo,t_vstem_sahen_2FH_ga_ni).
first(n_pro_domo,t_wh_daimeisi).
first(n_pro_domo,t_wh_daimeisi_nan).
first(n_pro_domo,t_wh_hukusi).
first(n_pro_domo,t_zikan_meisi).
first(n_pro_domo,t_zikan_meisi_ippai).
first(n_pro_domo,t_zikantai).
first(n_pro_exp,t_daimeisi_exp).
first(n_renyo_cl,n_capacity).
first(n_renyo_cl,n_visitor_name).
first(n_renyo_cl,t_adj_meisi).
first(n_renyo_cl,t_adj_renyo_2FH_ga).
first(n_renyo_cl,t_adj_renyo_2FH_ga_de).
first(n_renyo_cl,t_adjstem_2FH_ga).
first(n_renyo_cl,t_adjstem_2FH_ga_de).
first(n_renyo_cl,t_adjstem_spe_2FH_ga_de).
first(n_renyo_cl,t_daimeisi).
first(n_renyo_cl,t_daimeisi_domo).
first(n_renyo_cl,t_daimeisi_exp).
first(n_renyo_cl,t_hukusi).
first(n_renyo_cl,t_hukusi_desu).
first(n_renyo_cl,t_hutu_meisi).
first(n_renyo_cl,t_hutu_meisi_post).
first(n_renyo_cl,t_kahen_dousi_katei_2FH_ga_ni).
first(n_renyo_cl,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_renyo_cl,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_renyo_cl,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_renyo_cl,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_renyo_cl,t_kdo_2FH_ga).
first(n_renyo_cl,t_kdo_2FH_ga_de).
first(n_renyo_cl,t_kdo_2FH_ga_to).
first(n_renyo_cl,t_koyuu_meisi).
first(n_renyo_cl,t_meisi_hi).
first(n_renyo_cl,t_meisi_hun).
first(n_renyo_cl,t_meisi_tsuki).
first(n_renyo_cl,t_meisi_youbi).
first(n_renyo_cl,t_meisi_zi).
first(n_renyo_cl,t_myoji_first).
first(n_renyo_cl,t_myoji_last).
first(n_renyo_cl,t_n_keisiki).
first(n_renyo_cl,t_namae_first).
first(n_renyo_cl,t_namae_last).
first(n_renyo_cl,t_num_bouyomi).
first(n_renyo_cl,t_num_byaku).
first(n_renyo_cl,t_num_byaq).
first(n_renyo_cl,t_num_go).
first(n_renyo_cl,t_num_hachi).
first(n_renyo_cl,t_num_haq).
first(n_renyo_cl,t_num_hito).
first(n_renyo_cl,t_num_huta).
first(n_renyo_cl,t_num_hutsu).
first(n_renyo_cl,t_num_hyaku).
first(n_renyo_cl,t_num_hyaq).
first(n_renyo_cl,t_num_ichi).
first(n_renyo_cl,t_num_iq).
first(n_renyo_cl,t_num_itsu).
first(n_renyo_cl,t_num_kokono).
first(n_renyo_cl,t_num_ku).
first(n_renyo_cl,t_num_kyuu).
first(n_renyo_cl,t_num_miq).
first(n_renyo_cl,t_num_mui).
first(n_renyo_cl,t_num_muq).
first(n_renyo_cl,t_num_nana).
first(n_renyo_cl,t_num_nano).
first(n_renyo_cl,t_num_ni).
first(n_renyo_cl,t_num_one).
first(n_renyo_cl,t_num_pyaku).
first(n_renyo_cl,t_num_pyaq).
first(n_renyo_cl,t_num_roku).
first(n_renyo_cl,t_num_roq).
first(n_renyo_cl,t_num_san).
first(n_renyo_cl,t_num_sen).
first(n_renyo_cl,t_num_shi).
first(n_renyo_cl,t_num_shichi).
first(n_renyo_cl,t_num_ten).
first(n_renyo_cl,t_num_tou).
first(n_renyo_cl,t_num_yaq).
first(n_renyo_cl,t_num_yo).
first(n_renyo_cl,t_num_yon).
first(n_renyo_cl,t_num_yoq).
first(n_renyo_cl,t_num_you).
first(n_renyo_cl,t_num_zen).
first(n_renyo_cl,t_num_zyuq).
first(n_renyo_cl,t_num_zyuu).
first(n_renyo_cl,t_prefix_go).
first(n_renyo_cl,t_prefix_hutu_hutu).
first(n_renyo_cl,t_prefix_o).
first(n_renyo_cl,t_prefix_quant_quant).
first(n_renyo_cl,t_rentai).
first(n_renyo_cl,t_sahen_dousi_katei_2FH_ga_ni).
first(n_renyo_cl,t_sahen_dousi_katei_2FH_ga_o).
first(n_renyo_cl,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_renyo_cl,t_sahen_dousi_mizen_2FH_ga_o).
first(n_renyo_cl,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_renyo_cl,t_sahen_dousi_rentai_2FH_ga_o).
first(n_renyo_cl,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_renyo_cl,t_sahen_dousi_renyo_2FH_ga_o).
first(n_renyo_cl,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_renyo_cl,t_sahen_dousi_syusi_2FH_ga_o).
first(n_renyo_cl,t_sahen_meisi_2FH_ga).
first(n_renyo_cl,t_sahen_meisi_2FH_ga_ni).
first(n_renyo_cl,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_renyo_cl,t_sahen_meisi_2FH_ga_ni_o).
first(n_renyo_cl,t_sahen_meisi_2FH_ga_o).
first(n_renyo_cl,t_sahen_meisi_2FH_ga_to).
first(n_renyo_cl,t_sahen_meisi_pol_2FH_ga).
first(n_renyo_cl,t_sahen_meisi_pol_2FH_ga_ni).
first(n_renyo_cl,t_sahen_meisi_pol_2FH_ga_o).
first(n_renyo_cl,t_sahen_meisi_pol_2FH_ga_to).
first(n_renyo_cl,t_suuryousi).
first(n_renyo_cl,t_teido_hukusi).
first(n_renyo_cl,t_tsuzuri).
first(n_renyo_cl,t_vstem_1_2FH_ga).
first(n_renyo_cl,t_vstem_1_2FH_ga_de).
first(n_renyo_cl,t_vstem_1_2FH_ga_ni).
first(n_renyo_cl,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_renyo_cl,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_renyo_cl,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_renyo_cl,t_vstem_1_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_1_2FH_ga_o).
first(n_renyo_cl,t_vstem_1_2FH_ga_quote).
first(n_renyo_cl,t_vstem_1_2FH_ga_to).
first(n_renyo_cl,t_vstem_5_b_2FH_ga).
first(n_renyo_cl,t_vstem_5_b_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_b_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_b_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_b_2FH_ga_to).
first(n_renyo_cl,t_vstem_5_g_2FH_ga).
first(n_renyo_cl,t_vstem_5_g_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_g_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_g_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_k_2FH_ga).
first(n_renyo_cl,t_vstem_5_k_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_k_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_k_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_k_2FH_ga_to).
first(n_renyo_cl,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_renyo_cl,t_vstem_5_m_2FH_ga).
first(n_renyo_cl,t_vstem_5_m_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_renyo_cl,t_vstem_5_m_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_m_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_m_2FH_ga_to).
first(n_renyo_cl,t_vstem_5_r_2FH_ga).
first(n_renyo_cl,t_vstem_5_r_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_renyo_cl,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_renyo_cl,t_vstem_5_r_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_r_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_r_2FH_ga_to).
first(n_renyo_cl,t_vstem_5_r_i_2FH_ga).
first(n_renyo_cl,t_vstem_5_r_i_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_r_i_2FH_ga_quote).
first(n_renyo_cl,t_vstem_5_s_2FH_ga).
first(n_renyo_cl,t_vstem_5_s_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_s_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_s_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_s_2FH_ga_quote).
first(n_renyo_cl,t_vstem_5_s_2FH_ga_to).
first(n_renyo_cl,t_vstem_5_t_2FH_ga).
first(n_renyo_cl,t_vstem_5_t_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_renyo_cl,t_vstem_5_t_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_t_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_t_2FH_ga_to).
first(n_renyo_cl,t_vstem_5_w_2FH_ga).
first(n_renyo_cl,t_vstem_5_w_2FH_ga_de).
first(n_renyo_cl,t_vstem_5_w_2FH_ga_ni).
first(n_renyo_cl,t_vstem_5_w_2FH_ga_ni_o).
first(n_renyo_cl,t_vstem_5_w_2FH_ga_o).
first(n_renyo_cl,t_vstem_5_w_2FH_ga_quote).
first(n_renyo_cl,t_vstem_5_w_2FH_ga_to).
first(n_renyo_cl,t_vstem_masu_2FH_ga).
first(n_renyo_cl,t_vstem_sahen_2FH_ga_ni).
first(n_renyo_cl,t_wh_daimeisi).
first(n_renyo_cl,t_wh_daimeisi_nan).
first(n_renyo_cl,t_wh_hukusi).
first(n_renyo_cl,t_zikan_meisi).
first(n_renyo_cl,t_zikan_meisi_ippai).
first(n_renyo_cl,t_zikantai).
first(n_reservation,n_capacity).
first(n_reservation,n_visitor_name).
first(n_reservation,t_adj_meisi).
first(n_reservation,t_adj_renyo_2FH_ga).
first(n_reservation,t_adj_renyo_2FH_ga_de).
first(n_reservation,t_adjstem_2FH_ga).
first(n_reservation,t_adjstem_2FH_ga_de).
first(n_reservation,t_adjstem_spe_2FH_ga_de).
first(n_reservation,t_daimeisi).
first(n_reservation,t_daimeisi_domo).
first(n_reservation,t_daimeisi_exp).
first(n_reservation,t_hukusi).
first(n_reservation,t_hukusi_desu).
first(n_reservation,t_hutu_meisi).
first(n_reservation,t_hutu_meisi_post).
first(n_reservation,t_kahen_dousi_katei_2FH_ga_ni).
first(n_reservation,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_reservation,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_reservation,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_reservation,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_reservation,t_kdo_2FH_ga).
first(n_reservation,t_kdo_2FH_ga_de).
first(n_reservation,t_kdo_2FH_ga_to).
first(n_reservation,t_koyuu_meisi).
first(n_reservation,t_meisi_hi).
first(n_reservation,t_meisi_hun).
first(n_reservation,t_meisi_tsuki).
first(n_reservation,t_meisi_youbi).
first(n_reservation,t_meisi_zi).
first(n_reservation,t_myoji_first).
first(n_reservation,t_myoji_last).
first(n_reservation,t_n_keisiki).
first(n_reservation,t_namae_first).
first(n_reservation,t_namae_last).
first(n_reservation,t_num_bouyomi).
first(n_reservation,t_num_byaku).
first(n_reservation,t_num_byaq).
first(n_reservation,t_num_go).
first(n_reservation,t_num_hachi).
first(n_reservation,t_num_haq).
first(n_reservation,t_num_hito).
first(n_reservation,t_num_huta).
first(n_reservation,t_num_hutsu).
first(n_reservation,t_num_hyaku).
first(n_reservation,t_num_hyaq).
first(n_reservation,t_num_ichi).
first(n_reservation,t_num_iq).
first(n_reservation,t_num_itsu).
first(n_reservation,t_num_kokono).
first(n_reservation,t_num_ku).
first(n_reservation,t_num_kyuu).
first(n_reservation,t_num_miq).
first(n_reservation,t_num_mui).
first(n_reservation,t_num_muq).
first(n_reservation,t_num_nana).
first(n_reservation,t_num_nano).
first(n_reservation,t_num_ni).
first(n_reservation,t_num_one).
first(n_reservation,t_num_pyaku).
first(n_reservation,t_num_pyaq).
first(n_reservation,t_num_roku).
first(n_reservation,t_num_roq).
first(n_reservation,t_num_san).
first(n_reservation,t_num_sen).
first(n_reservation,t_num_shi).
first(n_reservation,t_num_shichi).
first(n_reservation,t_num_ten).
first(n_reservation,t_num_tou).
first(n_reservation,t_num_yaq).
first(n_reservation,t_num_yo).
first(n_reservation,t_num_yon).
first(n_reservation,t_num_yoq).
first(n_reservation,t_num_you).
first(n_reservation,t_num_zen).
first(n_reservation,t_num_zyuq).
first(n_reservation,t_num_zyuu).
first(n_reservation,t_prefix_go).
first(n_reservation,t_prefix_hutu_hutu).
first(n_reservation,t_prefix_o).
first(n_reservation,t_prefix_quant_quant).
first(n_reservation,t_rentai).
first(n_reservation,t_sahen_dousi_katei_2FH_ga_ni).
first(n_reservation,t_sahen_dousi_katei_2FH_ga_o).
first(n_reservation,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_reservation,t_sahen_dousi_mizen_2FH_ga_o).
first(n_reservation,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_reservation,t_sahen_dousi_rentai_2FH_ga_o).
first(n_reservation,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_reservation,t_sahen_dousi_renyo_2FH_ga_o).
first(n_reservation,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_reservation,t_sahen_dousi_syusi_2FH_ga_o).
first(n_reservation,t_sahen_meisi_2FH_ga).
first(n_reservation,t_sahen_meisi_2FH_ga_ni).
first(n_reservation,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_reservation,t_sahen_meisi_2FH_ga_ni_o).
first(n_reservation,t_sahen_meisi_2FH_ga_o).
first(n_reservation,t_sahen_meisi_2FH_ga_to).
first(n_reservation,t_sahen_meisi_pol_2FH_ga).
first(n_reservation,t_sahen_meisi_pol_2FH_ga_ni).
first(n_reservation,t_sahen_meisi_pol_2FH_ga_o).
first(n_reservation,t_sahen_meisi_pol_2FH_ga_to).
first(n_reservation,t_suuryousi).
first(n_reservation,t_teido_hukusi).
first(n_reservation,t_tsuzuri).
first(n_reservation,t_vstem_1_2FH_ga).
first(n_reservation,t_vstem_1_2FH_ga_de).
first(n_reservation,t_vstem_1_2FH_ga_ni).
first(n_reservation,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_reservation,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_reservation,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_reservation,t_vstem_1_2FH_ga_ni_o).
first(n_reservation,t_vstem_1_2FH_ga_o).
first(n_reservation,t_vstem_1_2FH_ga_quote).
first(n_reservation,t_vstem_1_2FH_ga_to).
first(n_reservation,t_vstem_5_b_2FH_ga).
first(n_reservation,t_vstem_5_b_2FH_ga_ni).
first(n_reservation,t_vstem_5_b_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_b_2FH_ga_o).
first(n_reservation,t_vstem_5_b_2FH_ga_to).
first(n_reservation,t_vstem_5_g_2FH_ga).
first(n_reservation,t_vstem_5_g_2FH_ga_ni).
first(n_reservation,t_vstem_5_g_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_g_2FH_ga_o).
first(n_reservation,t_vstem_5_k_2FH_ga).
first(n_reservation,t_vstem_5_k_2FH_ga_ni).
first(n_reservation,t_vstem_5_k_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_k_2FH_ga_o).
first(n_reservation,t_vstem_5_k_2FH_ga_to).
first(n_reservation,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_reservation,t_vstem_5_m_2FH_ga).
first(n_reservation,t_vstem_5_m_2FH_ga_ni).
first(n_reservation,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_reservation,t_vstem_5_m_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_m_2FH_ga_o).
first(n_reservation,t_vstem_5_m_2FH_ga_to).
first(n_reservation,t_vstem_5_r_2FH_ga).
first(n_reservation,t_vstem_5_r_2FH_ga_ni).
first(n_reservation,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_reservation,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_reservation,t_vstem_5_r_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_r_2FH_ga_o).
first(n_reservation,t_vstem_5_r_2FH_ga_to).
first(n_reservation,t_vstem_5_r_i_2FH_ga).
first(n_reservation,t_vstem_5_r_i_2FH_ga_o).
first(n_reservation,t_vstem_5_r_i_2FH_ga_quote).
first(n_reservation,t_vstem_5_s_2FH_ga).
first(n_reservation,t_vstem_5_s_2FH_ga_ni).
first(n_reservation,t_vstem_5_s_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_s_2FH_ga_o).
first(n_reservation,t_vstem_5_s_2FH_ga_quote).
first(n_reservation,t_vstem_5_s_2FH_ga_to).
first(n_reservation,t_vstem_5_t_2FH_ga).
first(n_reservation,t_vstem_5_t_2FH_ga_ni).
first(n_reservation,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_reservation,t_vstem_5_t_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_t_2FH_ga_o).
first(n_reservation,t_vstem_5_t_2FH_ga_to).
first(n_reservation,t_vstem_5_w_2FH_ga).
first(n_reservation,t_vstem_5_w_2FH_ga_de).
first(n_reservation,t_vstem_5_w_2FH_ga_ni).
first(n_reservation,t_vstem_5_w_2FH_ga_ni_o).
first(n_reservation,t_vstem_5_w_2FH_ga_o).
first(n_reservation,t_vstem_5_w_2FH_ga_quote).
first(n_reservation,t_vstem_5_w_2FH_ga_to).
first(n_reservation,t_vstem_masu_2FH_ga).
first(n_reservation,t_vstem_sahen_2FH_ga_ni).
first(n_reservation,t_wh_daimeisi).
first(n_reservation,t_wh_daimeisi_nan).
first(n_reservation,t_wh_hukusi).
first(n_reservation,t_zikan_meisi).
first(n_reservation,t_zikan_meisi_ippai).
first(n_reservation,t_zikantai).
first(n_sent,n_capacity).
first(n_sent,n_n_name_jap_honor).
first(n_sent,n_n_name_others_honor).
first(n_sent,n_visitor_name).
first(n_sent,t_adj_meisi).
first(n_sent,t_adj_renyo_2FH_ga).
first(n_sent,t_adj_renyo_2FH_ga_de).
first(n_sent,t_adjstem_2FH_ga).
first(n_sent,t_adjstem_2FH_ga_de).
first(n_sent,t_adjstem_spe_2FH_ga_de).
first(n_sent,t_bun_hukusi).
first(n_sent,t_conj).
first(n_sent,t_daimeisi).
first(n_sent,t_daimeisi_domo).
first(n_sent,t_daimeisi_exp).
first(n_sent,t_hukusi).
first(n_sent,t_hukusi_desu).
first(n_sent,t_hutu_meisi).
first(n_sent,t_hutu_meisi_post).
first(n_sent,t_interj_hesit).
first(n_sent,t_interj_post).
first(n_sent,t_interj_pre).
first(n_sent,t_kahen_dousi_katei_2FH_ga_ni).
first(n_sent,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_sent,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_sent,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_sent,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_sent,t_kdo_2FH_ga).
first(n_sent,t_kdo_2FH_ga_de).
first(n_sent,t_kdo_2FH_ga_to).
first(n_sent,t_koyuu_meisi).
first(n_sent,t_meisi_hi).
first(n_sent,t_meisi_hun).
first(n_sent,t_meisi_tsuki).
first(n_sent,t_meisi_youbi).
first(n_sent,t_meisi_zi).
first(n_sent,t_myoji_first).
first(n_sent,t_myoji_last).
first(n_sent,t_n_keisiki).
first(n_sent,t_namae_first).
first(n_sent,t_namae_last).
first(n_sent,t_num_bouyomi).
first(n_sent,t_num_byaku).
first(n_sent,t_num_byaq).
first(n_sent,t_num_go).
first(n_sent,t_num_hachi).
first(n_sent,t_num_haq).
first(n_sent,t_num_hito).
first(n_sent,t_num_huta).
first(n_sent,t_num_hutsu).
first(n_sent,t_num_hyaku).
first(n_sent,t_num_hyaq).
first(n_sent,t_num_ichi).
first(n_sent,t_num_iq).
first(n_sent,t_num_itsu).
first(n_sent,t_num_kokono).
first(n_sent,t_num_ku).
first(n_sent,t_num_kyuu).
first(n_sent,t_num_miq).
first(n_sent,t_num_mui).
first(n_sent,t_num_muq).
first(n_sent,t_num_nana).
first(n_sent,t_num_nano).
first(n_sent,t_num_ni).
first(n_sent,t_num_one).
first(n_sent,t_num_pyaku).
first(n_sent,t_num_pyaq).
first(n_sent,t_num_roku).
first(n_sent,t_num_roq).
first(n_sent,t_num_san).
first(n_sent,t_num_sen).
first(n_sent,t_num_shi).
first(n_sent,t_num_shichi).
first(n_sent,t_num_ten).
first(n_sent,t_num_tou).
first(n_sent,t_num_yaq).
first(n_sent,t_num_yo).
first(n_sent,t_num_yon).
first(n_sent,t_num_yoq).
first(n_sent,t_num_you).
first(n_sent,t_num_zen).
first(n_sent,t_num_zyuq).
first(n_sent,t_num_zyuu).
first(n_sent,t_prefix_go).
first(n_sent,t_prefix_hutu_hutu).
first(n_sent,t_prefix_o).
first(n_sent,t_prefix_quant_quant).
first(n_sent,t_rentai).
first(n_sent,t_sahen_dousi_katei_2FH_ga_ni).
first(n_sent,t_sahen_dousi_katei_2FH_ga_o).
first(n_sent,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_sent,t_sahen_dousi_mizen_2FH_ga_o).
first(n_sent,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_sent,t_sahen_dousi_rentai_2FH_ga_o).
first(n_sent,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_sent,t_sahen_dousi_renyo_2FH_ga_o).
first(n_sent,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_sent,t_sahen_dousi_syusi_2FH_ga_o).
first(n_sent,t_sahen_meisi_2FH_ga).
first(n_sent,t_sahen_meisi_2FH_ga_ni).
first(n_sent,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_sent,t_sahen_meisi_2FH_ga_ni_o).
first(n_sent,t_sahen_meisi_2FH_ga_o).
first(n_sent,t_sahen_meisi_2FH_ga_to).
first(n_sent,t_sahen_meisi_pol_2FH_ga).
first(n_sent,t_sahen_meisi_pol_2FH_ga_ni).
first(n_sent,t_sahen_meisi_pol_2FH_ga_o).
first(n_sent,t_sahen_meisi_pol_2FH_ga_to).
first(n_sent,t_suuryousi).
first(n_sent,t_teido_hukusi).
first(n_sent,t_tsuzuri).
first(n_sent,t_vstem_1_2FH_ga).
first(n_sent,t_vstem_1_2FH_ga_de).
first(n_sent,t_vstem_1_2FH_ga_ni).
first(n_sent,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_sent,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_sent,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_sent,t_vstem_1_2FH_ga_ni_o).
first(n_sent,t_vstem_1_2FH_ga_o).
first(n_sent,t_vstem_1_2FH_ga_quote).
first(n_sent,t_vstem_1_2FH_ga_to).
first(n_sent,t_vstem_5_b_2FH_ga).
first(n_sent,t_vstem_5_b_2FH_ga_ni).
first(n_sent,t_vstem_5_b_2FH_ga_ni_o).
first(n_sent,t_vstem_5_b_2FH_ga_o).
first(n_sent,t_vstem_5_b_2FH_ga_to).
first(n_sent,t_vstem_5_g_2FH_ga).
first(n_sent,t_vstem_5_g_2FH_ga_ni).
first(n_sent,t_vstem_5_g_2FH_ga_ni_o).
first(n_sent,t_vstem_5_g_2FH_ga_o).
first(n_sent,t_vstem_5_k_2FH_ga).
first(n_sent,t_vstem_5_k_2FH_ga_ni).
first(n_sent,t_vstem_5_k_2FH_ga_ni_o).
first(n_sent,t_vstem_5_k_2FH_ga_o).
first(n_sent,t_vstem_5_k_2FH_ga_to).
first(n_sent,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_sent,t_vstem_5_m_2FH_ga).
first(n_sent,t_vstem_5_m_2FH_ga_ni).
first(n_sent,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_sent,t_vstem_5_m_2FH_ga_ni_o).
first(n_sent,t_vstem_5_m_2FH_ga_o).
first(n_sent,t_vstem_5_m_2FH_ga_to).
first(n_sent,t_vstem_5_r_2FH_ga).
first(n_sent,t_vstem_5_r_2FH_ga_ni).
first(n_sent,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_sent,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_sent,t_vstem_5_r_2FH_ga_ni_o).
first(n_sent,t_vstem_5_r_2FH_ga_o).
first(n_sent,t_vstem_5_r_2FH_ga_to).
first(n_sent,t_vstem_5_r_i_2FH_ga).
first(n_sent,t_vstem_5_r_i_2FH_ga_o).
first(n_sent,t_vstem_5_r_i_2FH_ga_quote).
first(n_sent,t_vstem_5_s_2FH_ga).
first(n_sent,t_vstem_5_s_2FH_ga_ni).
first(n_sent,t_vstem_5_s_2FH_ga_ni_o).
first(n_sent,t_vstem_5_s_2FH_ga_o).
first(n_sent,t_vstem_5_s_2FH_ga_quote).
first(n_sent,t_vstem_5_s_2FH_ga_to).
first(n_sent,t_vstem_5_t_2FH_ga).
first(n_sent,t_vstem_5_t_2FH_ga_ni).
first(n_sent,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_sent,t_vstem_5_t_2FH_ga_ni_o).
first(n_sent,t_vstem_5_t_2FH_ga_o).
first(n_sent,t_vstem_5_t_2FH_ga_to).
first(n_sent,t_vstem_5_w_2FH_ga).
first(n_sent,t_vstem_5_w_2FH_ga_de).
first(n_sent,t_vstem_5_w_2FH_ga_ni).
first(n_sent,t_vstem_5_w_2FH_ga_ni_o).
first(n_sent,t_vstem_5_w_2FH_ga_o).
first(n_sent,t_vstem_5_w_2FH_ga_quote).
first(n_sent,t_vstem_5_w_2FH_ga_to).
first(n_sent,t_vstem_masu_2FH_ga).
first(n_sent,t_vstem_sahen_2FH_ga_ni).
first(n_sent,t_wh_daimeisi).
first(n_sent,t_wh_daimeisi_nan).
first(n_sent,t_wh_hukusi).
first(n_sent,t_zikan_meisi).
first(n_sent,t_zikan_meisi_ippai).
first(n_sent,t_zikantai).
first(n_specific_date,t_meisi_hi).
first(n_specific_date,t_meisi_tsuki).
first(n_stay,n_capacity).
first(n_stay,n_visitor_name).
first(n_stay,t_adj_meisi).
first(n_stay,t_adj_renyo_2FH_ga).
first(n_stay,t_adj_renyo_2FH_ga_de).
first(n_stay,t_adjstem_2FH_ga).
first(n_stay,t_adjstem_2FH_ga_de).
first(n_stay,t_adjstem_spe_2FH_ga_de).
first(n_stay,t_daimeisi).
first(n_stay,t_daimeisi_domo).
first(n_stay,t_daimeisi_exp).
first(n_stay,t_hukusi).
first(n_stay,t_hukusi_desu).
first(n_stay,t_hutu_meisi).
first(n_stay,t_hutu_meisi_post).
first(n_stay,t_kahen_dousi_katei_2FH_ga_ni).
first(n_stay,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_stay,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_stay,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_stay,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_stay,t_kdo_2FH_ga).
first(n_stay,t_kdo_2FH_ga_de).
first(n_stay,t_kdo_2FH_ga_to).
first(n_stay,t_koyuu_meisi).
first(n_stay,t_meisi_hi).
first(n_stay,t_meisi_hun).
first(n_stay,t_meisi_tsuki).
first(n_stay,t_meisi_youbi).
first(n_stay,t_meisi_zi).
first(n_stay,t_myoji_first).
first(n_stay,t_myoji_last).
first(n_stay,t_n_keisiki).
first(n_stay,t_namae_first).
first(n_stay,t_namae_last).
first(n_stay,t_num_bouyomi).
first(n_stay,t_num_byaku).
first(n_stay,t_num_byaq).
first(n_stay,t_num_go).
first(n_stay,t_num_hachi).
first(n_stay,t_num_haq).
first(n_stay,t_num_hito).
first(n_stay,t_num_huta).
first(n_stay,t_num_hutsu).
first(n_stay,t_num_hyaku).
first(n_stay,t_num_hyaq).
first(n_stay,t_num_ichi).
first(n_stay,t_num_iq).
first(n_stay,t_num_itsu).
first(n_stay,t_num_kokono).
first(n_stay,t_num_ku).
first(n_stay,t_num_kyuu).
first(n_stay,t_num_miq).
first(n_stay,t_num_mui).
first(n_stay,t_num_muq).
first(n_stay,t_num_nana).
first(n_stay,t_num_nano).
first(n_stay,t_num_ni).
first(n_stay,t_num_one).
first(n_stay,t_num_pyaku).
first(n_stay,t_num_pyaq).
first(n_stay,t_num_roku).
first(n_stay,t_num_roq).
first(n_stay,t_num_san).
first(n_stay,t_num_sen).
first(n_stay,t_num_shi).
first(n_stay,t_num_shichi).
first(n_stay,t_num_ten).
first(n_stay,t_num_tou).
first(n_stay,t_num_yaq).
first(n_stay,t_num_yo).
first(n_stay,t_num_yon).
first(n_stay,t_num_yoq).
first(n_stay,t_num_you).
first(n_stay,t_num_zen).
first(n_stay,t_num_zyuq).
first(n_stay,t_num_zyuu).
first(n_stay,t_prefix_go).
first(n_stay,t_prefix_hutu_hutu).
first(n_stay,t_prefix_o).
first(n_stay,t_prefix_quant_quant).
first(n_stay,t_rentai).
first(n_stay,t_sahen_dousi_katei_2FH_ga_ni).
first(n_stay,t_sahen_dousi_katei_2FH_ga_o).
first(n_stay,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_stay,t_sahen_dousi_mizen_2FH_ga_o).
first(n_stay,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_stay,t_sahen_dousi_rentai_2FH_ga_o).
first(n_stay,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_stay,t_sahen_dousi_renyo_2FH_ga_o).
first(n_stay,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_stay,t_sahen_dousi_syusi_2FH_ga_o).
first(n_stay,t_sahen_meisi_2FH_ga).
first(n_stay,t_sahen_meisi_2FH_ga_ni).
first(n_stay,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_stay,t_sahen_meisi_2FH_ga_ni_o).
first(n_stay,t_sahen_meisi_2FH_ga_o).
first(n_stay,t_sahen_meisi_2FH_ga_to).
first(n_stay,t_sahen_meisi_pol_2FH_ga).
first(n_stay,t_sahen_meisi_pol_2FH_ga_ni).
first(n_stay,t_sahen_meisi_pol_2FH_ga_o).
first(n_stay,t_sahen_meisi_pol_2FH_ga_to).
first(n_stay,t_suuryousi).
first(n_stay,t_teido_hukusi).
first(n_stay,t_tsuzuri).
first(n_stay,t_vstem_1_2FH_ga).
first(n_stay,t_vstem_1_2FH_ga_de).
first(n_stay,t_vstem_1_2FH_ga_ni).
first(n_stay,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_stay,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_stay,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_stay,t_vstem_1_2FH_ga_ni_o).
first(n_stay,t_vstem_1_2FH_ga_o).
first(n_stay,t_vstem_1_2FH_ga_quote).
first(n_stay,t_vstem_1_2FH_ga_to).
first(n_stay,t_vstem_5_b_2FH_ga).
first(n_stay,t_vstem_5_b_2FH_ga_ni).
first(n_stay,t_vstem_5_b_2FH_ga_ni_o).
first(n_stay,t_vstem_5_b_2FH_ga_o).
first(n_stay,t_vstem_5_b_2FH_ga_to).
first(n_stay,t_vstem_5_g_2FH_ga).
first(n_stay,t_vstem_5_g_2FH_ga_ni).
first(n_stay,t_vstem_5_g_2FH_ga_ni_o).
first(n_stay,t_vstem_5_g_2FH_ga_o).
first(n_stay,t_vstem_5_k_2FH_ga).
first(n_stay,t_vstem_5_k_2FH_ga_ni).
first(n_stay,t_vstem_5_k_2FH_ga_ni_o).
first(n_stay,t_vstem_5_k_2FH_ga_o).
first(n_stay,t_vstem_5_k_2FH_ga_to).
first(n_stay,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_stay,t_vstem_5_m_2FH_ga).
first(n_stay,t_vstem_5_m_2FH_ga_ni).
first(n_stay,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_stay,t_vstem_5_m_2FH_ga_ni_o).
first(n_stay,t_vstem_5_m_2FH_ga_o).
first(n_stay,t_vstem_5_m_2FH_ga_to).
first(n_stay,t_vstem_5_r_2FH_ga).
first(n_stay,t_vstem_5_r_2FH_ga_ni).
first(n_stay,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_stay,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_stay,t_vstem_5_r_2FH_ga_ni_o).
first(n_stay,t_vstem_5_r_2FH_ga_o).
first(n_stay,t_vstem_5_r_2FH_ga_to).
first(n_stay,t_vstem_5_r_i_2FH_ga).
first(n_stay,t_vstem_5_r_i_2FH_ga_o).
first(n_stay,t_vstem_5_r_i_2FH_ga_quote).
first(n_stay,t_vstem_5_s_2FH_ga).
first(n_stay,t_vstem_5_s_2FH_ga_ni).
first(n_stay,t_vstem_5_s_2FH_ga_ni_o).
first(n_stay,t_vstem_5_s_2FH_ga_o).
first(n_stay,t_vstem_5_s_2FH_ga_quote).
first(n_stay,t_vstem_5_s_2FH_ga_to).
first(n_stay,t_vstem_5_t_2FH_ga).
first(n_stay,t_vstem_5_t_2FH_ga_ni).
first(n_stay,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_stay,t_vstem_5_t_2FH_ga_ni_o).
first(n_stay,t_vstem_5_t_2FH_ga_o).
first(n_stay,t_vstem_5_t_2FH_ga_to).
first(n_stay,t_vstem_5_w_2FH_ga).
first(n_stay,t_vstem_5_w_2FH_ga_de).
first(n_stay,t_vstem_5_w_2FH_ga_ni).
first(n_stay,t_vstem_5_w_2FH_ga_ni_o).
first(n_stay,t_vstem_5_w_2FH_ga_o).
first(n_stay,t_vstem_5_w_2FH_ga_quote).
first(n_stay,t_vstem_5_w_2FH_ga_to).
first(n_stay,t_vstem_masu_2FH_ga).
first(n_stay,t_vstem_sahen_2FH_ga_ni).
first(n_stay,t_wh_daimeisi).
first(n_stay,t_wh_daimeisi_nan).
first(n_stay,t_wh_hukusi).
first(n_stay,t_zikan_meisi).
first(n_stay,t_zikan_meisi_ippai).
first(n_stay,t_zikantai).
first(n_stay_date,n_capacity).
first(n_stay_date,n_visitor_name).
first(n_stay_date,t_adj_meisi).
first(n_stay_date,t_adj_renyo_2FH_ga).
first(n_stay_date,t_adj_renyo_2FH_ga_de).
first(n_stay_date,t_adjstem_2FH_ga).
first(n_stay_date,t_adjstem_2FH_ga_de).
first(n_stay_date,t_adjstem_spe_2FH_ga_de).
first(n_stay_date,t_daimeisi).
first(n_stay_date,t_daimeisi_domo).
first(n_stay_date,t_daimeisi_exp).
first(n_stay_date,t_hukusi).
first(n_stay_date,t_hukusi_desu).
first(n_stay_date,t_hutu_meisi).
first(n_stay_date,t_hutu_meisi_post).
first(n_stay_date,t_kahen_dousi_katei_2FH_ga_ni).
first(n_stay_date,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_stay_date,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_stay_date,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_stay_date,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_stay_date,t_kdo_2FH_ga).
first(n_stay_date,t_kdo_2FH_ga_de).
first(n_stay_date,t_kdo_2FH_ga_to).
first(n_stay_date,t_koyuu_meisi).
first(n_stay_date,t_meisi_hi).
first(n_stay_date,t_meisi_hun).
first(n_stay_date,t_meisi_tsuki).
first(n_stay_date,t_meisi_youbi).
first(n_stay_date,t_meisi_zi).
first(n_stay_date,t_myoji_first).
first(n_stay_date,t_myoji_last).
first(n_stay_date,t_n_keisiki).
first(n_stay_date,t_namae_first).
first(n_stay_date,t_namae_last).
first(n_stay_date,t_num_bouyomi).
first(n_stay_date,t_num_byaku).
first(n_stay_date,t_num_byaq).
first(n_stay_date,t_num_go).
first(n_stay_date,t_num_hachi).
first(n_stay_date,t_num_haq).
first(n_stay_date,t_num_hito).
first(n_stay_date,t_num_huta).
first(n_stay_date,t_num_hutsu).
first(n_stay_date,t_num_hyaku).
first(n_stay_date,t_num_hyaq).
first(n_stay_date,t_num_ichi).
first(n_stay_date,t_num_iq).
first(n_stay_date,t_num_itsu).
first(n_stay_date,t_num_kokono).
first(n_stay_date,t_num_ku).
first(n_stay_date,t_num_kyuu).
first(n_stay_date,t_num_miq).
first(n_stay_date,t_num_mui).
first(n_stay_date,t_num_muq).
first(n_stay_date,t_num_nana).
first(n_stay_date,t_num_nano).
first(n_stay_date,t_num_ni).
first(n_stay_date,t_num_one).
first(n_stay_date,t_num_pyaku).
first(n_stay_date,t_num_pyaq).
first(n_stay_date,t_num_roku).
first(n_stay_date,t_num_roq).
first(n_stay_date,t_num_san).
first(n_stay_date,t_num_sen).
first(n_stay_date,t_num_shi).
first(n_stay_date,t_num_shichi).
first(n_stay_date,t_num_ten).
first(n_stay_date,t_num_tou).
first(n_stay_date,t_num_yaq).
first(n_stay_date,t_num_yo).
first(n_stay_date,t_num_yon).
first(n_stay_date,t_num_yoq).
first(n_stay_date,t_num_you).
first(n_stay_date,t_num_zen).
first(n_stay_date,t_num_zyuq).
first(n_stay_date,t_num_zyuu).
first(n_stay_date,t_prefix_go).
first(n_stay_date,t_prefix_hutu_hutu).
first(n_stay_date,t_prefix_o).
first(n_stay_date,t_prefix_quant_quant).
first(n_stay_date,t_rentai).
first(n_stay_date,t_sahen_dousi_katei_2FH_ga_ni).
first(n_stay_date,t_sahen_dousi_katei_2FH_ga_o).
first(n_stay_date,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_stay_date,t_sahen_dousi_mizen_2FH_ga_o).
first(n_stay_date,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_stay_date,t_sahen_dousi_rentai_2FH_ga_o).
first(n_stay_date,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_stay_date,t_sahen_dousi_renyo_2FH_ga_o).
first(n_stay_date,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_stay_date,t_sahen_dousi_syusi_2FH_ga_o).
first(n_stay_date,t_sahen_meisi_2FH_ga).
first(n_stay_date,t_sahen_meisi_2FH_ga_ni).
first(n_stay_date,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_stay_date,t_sahen_meisi_2FH_ga_ni_o).
first(n_stay_date,t_sahen_meisi_2FH_ga_o).
first(n_stay_date,t_sahen_meisi_2FH_ga_to).
first(n_stay_date,t_sahen_meisi_pol_2FH_ga).
first(n_stay_date,t_sahen_meisi_pol_2FH_ga_ni).
first(n_stay_date,t_sahen_meisi_pol_2FH_ga_o).
first(n_stay_date,t_sahen_meisi_pol_2FH_ga_to).
first(n_stay_date,t_suuryousi).
first(n_stay_date,t_teido_hukusi).
first(n_stay_date,t_tsuzuri).
first(n_stay_date,t_vstem_1_2FH_ga).
first(n_stay_date,t_vstem_1_2FH_ga_de).
first(n_stay_date,t_vstem_1_2FH_ga_ni).
first(n_stay_date,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_stay_date,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_stay_date,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_stay_date,t_vstem_1_2FH_ga_ni_o).
first(n_stay_date,t_vstem_1_2FH_ga_o).
first(n_stay_date,t_vstem_1_2FH_ga_quote).
first(n_stay_date,t_vstem_1_2FH_ga_to).
first(n_stay_date,t_vstem_5_b_2FH_ga).
first(n_stay_date,t_vstem_5_b_2FH_ga_ni).
first(n_stay_date,t_vstem_5_b_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_b_2FH_ga_o).
first(n_stay_date,t_vstem_5_b_2FH_ga_to).
first(n_stay_date,t_vstem_5_g_2FH_ga).
first(n_stay_date,t_vstem_5_g_2FH_ga_ni).
first(n_stay_date,t_vstem_5_g_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_g_2FH_ga_o).
first(n_stay_date,t_vstem_5_k_2FH_ga).
first(n_stay_date,t_vstem_5_k_2FH_ga_ni).
first(n_stay_date,t_vstem_5_k_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_k_2FH_ga_o).
first(n_stay_date,t_vstem_5_k_2FH_ga_to).
first(n_stay_date,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_stay_date,t_vstem_5_m_2FH_ga).
first(n_stay_date,t_vstem_5_m_2FH_ga_ni).
first(n_stay_date,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_stay_date,t_vstem_5_m_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_m_2FH_ga_o).
first(n_stay_date,t_vstem_5_m_2FH_ga_to).
first(n_stay_date,t_vstem_5_r_2FH_ga).
first(n_stay_date,t_vstem_5_r_2FH_ga_ni).
first(n_stay_date,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_stay_date,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_stay_date,t_vstem_5_r_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_r_2FH_ga_o).
first(n_stay_date,t_vstem_5_r_2FH_ga_to).
first(n_stay_date,t_vstem_5_r_i_2FH_ga).
first(n_stay_date,t_vstem_5_r_i_2FH_ga_o).
first(n_stay_date,t_vstem_5_r_i_2FH_ga_quote).
first(n_stay_date,t_vstem_5_s_2FH_ga).
first(n_stay_date,t_vstem_5_s_2FH_ga_ni).
first(n_stay_date,t_vstem_5_s_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_s_2FH_ga_o).
first(n_stay_date,t_vstem_5_s_2FH_ga_quote).
first(n_stay_date,t_vstem_5_s_2FH_ga_to).
first(n_stay_date,t_vstem_5_t_2FH_ga).
first(n_stay_date,t_vstem_5_t_2FH_ga_ni).
first(n_stay_date,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_stay_date,t_vstem_5_t_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_t_2FH_ga_o).
first(n_stay_date,t_vstem_5_t_2FH_ga_to).
first(n_stay_date,t_vstem_5_w_2FH_ga).
first(n_stay_date,t_vstem_5_w_2FH_ga_de).
first(n_stay_date,t_vstem_5_w_2FH_ga_ni).
first(n_stay_date,t_vstem_5_w_2FH_ga_ni_o).
first(n_stay_date,t_vstem_5_w_2FH_ga_o).
first(n_stay_date,t_vstem_5_w_2FH_ga_quote).
first(n_stay_date,t_vstem_5_w_2FH_ga_to).
first(n_stay_date,t_vstem_masu_2FH_ga).
first(n_stay_date,t_vstem_sahen_2FH_ga_ni).
first(n_stay_date,t_wh_daimeisi).
first(n_stay_date,t_wh_daimeisi_nan).
first(n_stay_date,t_wh_hukusi).
first(n_stay_date,t_zikan_meisi).
first(n_stay_date,t_zikan_meisi_ippai).
first(n_stay_date,t_zikantai).
first(n_stay_day,t_num_byaku).
first(n_stay_day,t_num_byaq).
first(n_stay_day,t_num_go).
first(n_stay_day,t_num_hachi).
first(n_stay_day,t_num_haq).
first(n_stay_day,t_num_hito).
first(n_stay_day,t_num_huta).
first(n_stay_day,t_num_hutsu).
first(n_stay_day,t_num_hyaku).
first(n_stay_day,t_num_hyaq).
first(n_stay_day,t_num_ichi).
first(n_stay_day,t_num_iq).
first(n_stay_day,t_num_itsu).
first(n_stay_day,t_num_kokono).
first(n_stay_day,t_num_ku).
first(n_stay_day,t_num_kyuu).
first(n_stay_day,t_num_miq).
first(n_stay_day,t_num_mui).
first(n_stay_day,t_num_muq).
first(n_stay_day,t_num_nana).
first(n_stay_day,t_num_nano).
first(n_stay_day,t_num_ni).
first(n_stay_day,t_num_one).
first(n_stay_day,t_num_pyaku).
first(n_stay_day,t_num_pyaq).
first(n_stay_day,t_num_roku).
first(n_stay_day,t_num_roq).
first(n_stay_day,t_num_san).
first(n_stay_day,t_num_sen).
first(n_stay_day,t_num_shi).
first(n_stay_day,t_num_shichi).
first(n_stay_day,t_num_ten).
first(n_stay_day,t_num_tou).
first(n_stay_day,t_num_yaq).
first(n_stay_day,t_num_yo).
first(n_stay_day,t_num_yon).
first(n_stay_day,t_num_yoq).
first(n_stay_day,t_num_you).
first(n_stay_day,t_num_zen).
first(n_stay_day,t_num_zyuq).
first(n_stay_day,t_num_zyuu).
first(n_stay_day,t_prefix_go).
first(n_stay_day,t_prefix_hutu_hutu).
first(n_stay_day,t_prefix_o).
first(n_stay_day,t_prefix_quant_quant).
first(n_stay_period,n_capacity).
first(n_stay_period,n_visitor_name).
first(n_stay_period,t_adj_meisi).
first(n_stay_period,t_adj_renyo_2FH_ga).
first(n_stay_period,t_adj_renyo_2FH_ga_de).
first(n_stay_period,t_adjstem_2FH_ga).
first(n_stay_period,t_adjstem_2FH_ga_de).
first(n_stay_period,t_adjstem_spe_2FH_ga_de).
first(n_stay_period,t_daimeisi).
first(n_stay_period,t_daimeisi_domo).
first(n_stay_period,t_daimeisi_exp).
first(n_stay_period,t_hukusi).
first(n_stay_period,t_hukusi_desu).
first(n_stay_period,t_hutu_meisi).
first(n_stay_period,t_hutu_meisi_post).
first(n_stay_period,t_kahen_dousi_katei_2FH_ga_ni).
first(n_stay_period,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_stay_period,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_stay_period,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_stay_period,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_stay_period,t_kdo_2FH_ga).
first(n_stay_period,t_kdo_2FH_ga_de).
first(n_stay_period,t_kdo_2FH_ga_to).
first(n_stay_period,t_koyuu_meisi).
first(n_stay_period,t_meisi_hi).
first(n_stay_period,t_meisi_hun).
first(n_stay_period,t_meisi_tsuki).
first(n_stay_period,t_meisi_youbi).
first(n_stay_period,t_meisi_zi).
first(n_stay_period,t_myoji_first).
first(n_stay_period,t_myoji_last).
first(n_stay_period,t_n_keisiki).
first(n_stay_period,t_namae_first).
first(n_stay_period,t_namae_last).
first(n_stay_period,t_num_bouyomi).
first(n_stay_period,t_num_byaku).
first(n_stay_period,t_num_byaq).
first(n_stay_period,t_num_go).
first(n_stay_period,t_num_hachi).
first(n_stay_period,t_num_haq).
first(n_stay_period,t_num_hito).
first(n_stay_period,t_num_huta).
first(n_stay_period,t_num_hutsu).
first(n_stay_period,t_num_hyaku).
first(n_stay_period,t_num_hyaq).
first(n_stay_period,t_num_ichi).
first(n_stay_period,t_num_iq).
first(n_stay_period,t_num_itsu).
first(n_stay_period,t_num_kokono).
first(n_stay_period,t_num_ku).
first(n_stay_period,t_num_kyuu).
first(n_stay_period,t_num_miq).
first(n_stay_period,t_num_mui).
first(n_stay_period,t_num_muq).
first(n_stay_period,t_num_nana).
first(n_stay_period,t_num_nano).
first(n_stay_period,t_num_ni).
first(n_stay_period,t_num_one).
first(n_stay_period,t_num_pyaku).
first(n_stay_period,t_num_pyaq).
first(n_stay_period,t_num_roku).
first(n_stay_period,t_num_roq).
first(n_stay_period,t_num_san).
first(n_stay_period,t_num_sen).
first(n_stay_period,t_num_shi).
first(n_stay_period,t_num_shichi).
first(n_stay_period,t_num_ten).
first(n_stay_period,t_num_tou).
first(n_stay_period,t_num_yaq).
first(n_stay_period,t_num_yo).
first(n_stay_period,t_num_yon).
first(n_stay_period,t_num_yoq).
first(n_stay_period,t_num_you).
first(n_stay_period,t_num_zen).
first(n_stay_period,t_num_zyuq).
first(n_stay_period,t_num_zyuu).
first(n_stay_period,t_prefix_go).
first(n_stay_period,t_prefix_hutu_hutu).
first(n_stay_period,t_prefix_o).
first(n_stay_period,t_prefix_quant_quant).
first(n_stay_period,t_rentai).
first(n_stay_period,t_sahen_dousi_katei_2FH_ga_ni).
first(n_stay_period,t_sahen_dousi_katei_2FH_ga_o).
first(n_stay_period,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_stay_period,t_sahen_dousi_mizen_2FH_ga_o).
first(n_stay_period,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_stay_period,t_sahen_dousi_rentai_2FH_ga_o).
first(n_stay_period,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_stay_period,t_sahen_dousi_renyo_2FH_ga_o).
first(n_stay_period,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_stay_period,t_sahen_dousi_syusi_2FH_ga_o).
first(n_stay_period,t_sahen_meisi_2FH_ga).
first(n_stay_period,t_sahen_meisi_2FH_ga_ni).
first(n_stay_period,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_stay_period,t_sahen_meisi_2FH_ga_ni_o).
first(n_stay_period,t_sahen_meisi_2FH_ga_o).
first(n_stay_period,t_sahen_meisi_2FH_ga_to).
first(n_stay_period,t_sahen_meisi_pol_2FH_ga).
first(n_stay_period,t_sahen_meisi_pol_2FH_ga_ni).
first(n_stay_period,t_sahen_meisi_pol_2FH_ga_o).
first(n_stay_period,t_sahen_meisi_pol_2FH_ga_to).
first(n_stay_period,t_suuryousi).
first(n_stay_period,t_teido_hukusi).
first(n_stay_period,t_tsuzuri).
first(n_stay_period,t_vstem_1_2FH_ga).
first(n_stay_period,t_vstem_1_2FH_ga_de).
first(n_stay_period,t_vstem_1_2FH_ga_ni).
first(n_stay_period,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_stay_period,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_stay_period,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_stay_period,t_vstem_1_2FH_ga_ni_o).
first(n_stay_period,t_vstem_1_2FH_ga_o).
first(n_stay_period,t_vstem_1_2FH_ga_quote).
first(n_stay_period,t_vstem_1_2FH_ga_to).
first(n_stay_period,t_vstem_5_b_2FH_ga).
first(n_stay_period,t_vstem_5_b_2FH_ga_ni).
first(n_stay_period,t_vstem_5_b_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_b_2FH_ga_o).
first(n_stay_period,t_vstem_5_b_2FH_ga_to).
first(n_stay_period,t_vstem_5_g_2FH_ga).
first(n_stay_period,t_vstem_5_g_2FH_ga_ni).
first(n_stay_period,t_vstem_5_g_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_g_2FH_ga_o).
first(n_stay_period,t_vstem_5_k_2FH_ga).
first(n_stay_period,t_vstem_5_k_2FH_ga_ni).
first(n_stay_period,t_vstem_5_k_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_k_2FH_ga_o).
first(n_stay_period,t_vstem_5_k_2FH_ga_to).
first(n_stay_period,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_stay_period,t_vstem_5_m_2FH_ga).
first(n_stay_period,t_vstem_5_m_2FH_ga_ni).
first(n_stay_period,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_stay_period,t_vstem_5_m_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_m_2FH_ga_o).
first(n_stay_period,t_vstem_5_m_2FH_ga_to).
first(n_stay_period,t_vstem_5_r_2FH_ga).
first(n_stay_period,t_vstem_5_r_2FH_ga_ni).
first(n_stay_period,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_stay_period,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_stay_period,t_vstem_5_r_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_r_2FH_ga_o).
first(n_stay_period,t_vstem_5_r_2FH_ga_to).
first(n_stay_period,t_vstem_5_r_i_2FH_ga).
first(n_stay_period,t_vstem_5_r_i_2FH_ga_o).
first(n_stay_period,t_vstem_5_r_i_2FH_ga_quote).
first(n_stay_period,t_vstem_5_s_2FH_ga).
first(n_stay_period,t_vstem_5_s_2FH_ga_ni).
first(n_stay_period,t_vstem_5_s_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_s_2FH_ga_o).
first(n_stay_period,t_vstem_5_s_2FH_ga_quote).
first(n_stay_period,t_vstem_5_s_2FH_ga_to).
first(n_stay_period,t_vstem_5_t_2FH_ga).
first(n_stay_period,t_vstem_5_t_2FH_ga_ni).
first(n_stay_period,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_stay_period,t_vstem_5_t_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_t_2FH_ga_o).
first(n_stay_period,t_vstem_5_t_2FH_ga_to).
first(n_stay_period,t_vstem_5_w_2FH_ga).
first(n_stay_period,t_vstem_5_w_2FH_ga_de).
first(n_stay_period,t_vstem_5_w_2FH_ga_ni).
first(n_stay_period,t_vstem_5_w_2FH_ga_ni_o).
first(n_stay_period,t_vstem_5_w_2FH_ga_o).
first(n_stay_period,t_vstem_5_w_2FH_ga_quote).
first(n_stay_period,t_vstem_5_w_2FH_ga_to).
first(n_stay_period,t_vstem_masu_2FH_ga).
first(n_stay_period,t_vstem_sahen_2FH_ga_ni).
first(n_stay_period,t_wh_daimeisi).
first(n_stay_period,t_wh_daimeisi_nan).
first(n_stay_period,t_wh_hukusi).
first(n_stay_period,t_zikan_meisi).
first(n_stay_period,t_zikan_meisi_ippai).
first(n_stay_period,t_zikantai).
first(n_suffix_unit,t_suffix_doru).
first(n_suffix_unit,t_suffix_en).
first(n_suffix_unit,t_suffix_num_b).
first(n_suffix_unit,t_suffix_num_d).
first(n_suffix_unit,t_suffix_num_g).
first(n_suffix_unit,t_suffix_num_h).
first(n_suffix_unit,t_suffix_num_i).
first(n_suffix_unit,t_suffix_num_k).
first(n_suffix_unit,t_suffix_num_ka).
first(n_suffix_unit,t_suffix_num_m).
first(n_suffix_unit,t_suffix_num_n).
first(n_suffix_unit,t_suffix_num_p).
first(n_suffix_unit,t_suffix_num_r).
first(n_suffix_unit,t_suffix_num_ri).
first(n_suffix_unit,t_suffix_num_s).
first(n_suffix_unit,t_suffix_num_t).
first(n_suffix_unit,t_suffix_num_tsu).
first(n_suffix_unit,t_suffix_num_w).
first(n_suffix_unit,t_suffix_num_y).
first(n_suffix_unit,t_suffix_num_z).
first(n_suffix_unit,t_suffix_sento).
first(n_tag_slot,t_zikantai).
first(n_v_kahen_2FH_,n_capacity).
first(n_v_kahen_2FH_,n_visitor_name).
first(n_v_kahen_2FH_,t_adj_meisi).
first(n_v_kahen_2FH_,t_adj_renyo_2FH_ga).
first(n_v_kahen_2FH_,t_adj_renyo_2FH_ga_de).
first(n_v_kahen_2FH_,t_adjstem_2FH_ga).
first(n_v_kahen_2FH_,t_adjstem_2FH_ga_de).
first(n_v_kahen_2FH_,t_adjstem_spe_2FH_ga_de).
first(n_v_kahen_2FH_,t_daimeisi).
first(n_v_kahen_2FH_,t_daimeisi_domo).
first(n_v_kahen_2FH_,t_daimeisi_exp).
first(n_v_kahen_2FH_,t_hukusi).
first(n_v_kahen_2FH_,t_hukusi_desu).
first(n_v_kahen_2FH_,t_hutu_meisi).
first(n_v_kahen_2FH_,t_hutu_meisi_post).
first(n_v_kahen_2FH_,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_,t_kdo_2FH_ga).
first(n_v_kahen_2FH_,t_kdo_2FH_ga_de).
first(n_v_kahen_2FH_,t_kdo_2FH_ga_to).
first(n_v_kahen_2FH_,t_koyuu_meisi).
first(n_v_kahen_2FH_,t_meisi_hi).
first(n_v_kahen_2FH_,t_meisi_hun).
first(n_v_kahen_2FH_,t_meisi_tsuki).
first(n_v_kahen_2FH_,t_meisi_youbi).
first(n_v_kahen_2FH_,t_meisi_zi).
first(n_v_kahen_2FH_,t_myoji_first).
first(n_v_kahen_2FH_,t_myoji_last).
first(n_v_kahen_2FH_,t_n_keisiki).
first(n_v_kahen_2FH_,t_namae_first).
first(n_v_kahen_2FH_,t_namae_last).
first(n_v_kahen_2FH_,t_num_bouyomi).
first(n_v_kahen_2FH_,t_num_byaku).
first(n_v_kahen_2FH_,t_num_byaq).
first(n_v_kahen_2FH_,t_num_go).
first(n_v_kahen_2FH_,t_num_hachi).
first(n_v_kahen_2FH_,t_num_haq).
first(n_v_kahen_2FH_,t_num_hito).
first(n_v_kahen_2FH_,t_num_huta).
first(n_v_kahen_2FH_,t_num_hutsu).
first(n_v_kahen_2FH_,t_num_hyaku).
first(n_v_kahen_2FH_,t_num_hyaq).
first(n_v_kahen_2FH_,t_num_ichi).
first(n_v_kahen_2FH_,t_num_iq).
first(n_v_kahen_2FH_,t_num_itsu).
first(n_v_kahen_2FH_,t_num_kokono).
first(n_v_kahen_2FH_,t_num_ku).
first(n_v_kahen_2FH_,t_num_kyuu).
first(n_v_kahen_2FH_,t_num_miq).
first(n_v_kahen_2FH_,t_num_mui).
first(n_v_kahen_2FH_,t_num_muq).
first(n_v_kahen_2FH_,t_num_nana).
first(n_v_kahen_2FH_,t_num_nano).
first(n_v_kahen_2FH_,t_num_ni).
first(n_v_kahen_2FH_,t_num_one).
first(n_v_kahen_2FH_,t_num_pyaku).
first(n_v_kahen_2FH_,t_num_pyaq).
first(n_v_kahen_2FH_,t_num_roku).
first(n_v_kahen_2FH_,t_num_roq).
first(n_v_kahen_2FH_,t_num_san).
first(n_v_kahen_2FH_,t_num_sen).
first(n_v_kahen_2FH_,t_num_shi).
first(n_v_kahen_2FH_,t_num_shichi).
first(n_v_kahen_2FH_,t_num_ten).
first(n_v_kahen_2FH_,t_num_tou).
first(n_v_kahen_2FH_,t_num_yaq).
first(n_v_kahen_2FH_,t_num_yo).
first(n_v_kahen_2FH_,t_num_yon).
first(n_v_kahen_2FH_,t_num_yoq).
first(n_v_kahen_2FH_,t_num_you).
first(n_v_kahen_2FH_,t_num_zen).
first(n_v_kahen_2FH_,t_num_zyuq).
first(n_v_kahen_2FH_,t_num_zyuu).
first(n_v_kahen_2FH_,t_prefix_go).
first(n_v_kahen_2FH_,t_prefix_hutu_hutu).
first(n_v_kahen_2FH_,t_prefix_o).
first(n_v_kahen_2FH_,t_prefix_quant_quant).
first(n_v_kahen_2FH_,t_rentai).
first(n_v_kahen_2FH_,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_kahen_2FH_,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_kahen_2FH_,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_kahen_2FH_,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_kahen_2FH_,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_kahen_2FH_,t_sahen_meisi_2FH_ga).
first(n_v_kahen_2FH_,t_sahen_meisi_2FH_ga_ni).
first(n_v_kahen_2FH_,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_sahen_meisi_2FH_ga_o).
first(n_v_kahen_2FH_,t_sahen_meisi_2FH_ga_to).
first(n_v_kahen_2FH_,t_sahen_meisi_pol_2FH_ga).
first(n_v_kahen_2FH_,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_kahen_2FH_,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_kahen_2FH_,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_kahen_2FH_,t_suuryousi).
first(n_v_kahen_2FH_,t_teido_hukusi).
first(n_v_kahen_2FH_,t_tsuzuri).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_de).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_quote).
first(n_v_kahen_2FH_,t_vstem_1_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_5_b_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_b_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_b_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_b_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_5_g_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_g_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_g_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_k_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_k_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_k_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_k_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_,t_vstem_5_m_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_m_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_m_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_m_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_5_r_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_r_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_r_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_r_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_5_r_i_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_r_i_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_kahen_2FH_,t_vstem_5_s_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_s_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_s_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_s_2FH_ga_quote).
first(n_v_kahen_2FH_,t_vstem_5_s_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_5_t_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_t_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_t_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_t_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_5_w_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_5_w_2FH_ga_de).
first(n_v_kahen_2FH_,t_vstem_5_w_2FH_ga_ni).
first(n_v_kahen_2FH_,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_kahen_2FH_,t_vstem_5_w_2FH_ga_o).
first(n_v_kahen_2FH_,t_vstem_5_w_2FH_ga_quote).
first(n_v_kahen_2FH_,t_vstem_5_w_2FH_ga_to).
first(n_v_kahen_2FH_,t_vstem_masu_2FH_ga).
first(n_v_kahen_2FH_,t_vstem_sahen_2FH_ga_ni).
first(n_v_kahen_2FH_,t_wh_daimeisi).
first(n_v_kahen_2FH_,t_wh_daimeisi_nan).
first(n_v_kahen_2FH_,t_wh_hukusi).
first(n_v_kahen_2FH_,t_zikan_meisi).
first(n_v_kahen_2FH_,t_zikan_meisi_ippai).
first(n_v_kahen_2FH_,t_zikantai).
first(n_v_kahen_2FH_ga,n_capacity).
first(n_v_kahen_2FH_ga,n_visitor_name).
first(n_v_kahen_2FH_ga,t_adj_meisi).
first(n_v_kahen_2FH_ga,t_adj_renyo_2FH_ga).
first(n_v_kahen_2FH_ga,t_adj_renyo_2FH_ga_de).
first(n_v_kahen_2FH_ga,t_adjstem_2FH_ga).
first(n_v_kahen_2FH_ga,t_adjstem_2FH_ga_de).
first(n_v_kahen_2FH_ga,t_adjstem_spe_2FH_ga_de).
first(n_v_kahen_2FH_ga,t_daimeisi).
first(n_v_kahen_2FH_ga,t_daimeisi_domo).
first(n_v_kahen_2FH_ga,t_daimeisi_exp).
first(n_v_kahen_2FH_ga,t_hukusi).
first(n_v_kahen_2FH_ga,t_hukusi_desu).
first(n_v_kahen_2FH_ga,t_hutu_meisi).
first(n_v_kahen_2FH_ga,t_hutu_meisi_post).
first(n_v_kahen_2FH_ga,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_kdo_2FH_ga).
first(n_v_kahen_2FH_ga,t_kdo_2FH_ga_de).
first(n_v_kahen_2FH_ga,t_kdo_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_koyuu_meisi).
first(n_v_kahen_2FH_ga,t_meisi_hi).
first(n_v_kahen_2FH_ga,t_meisi_hun).
first(n_v_kahen_2FH_ga,t_meisi_tsuki).
first(n_v_kahen_2FH_ga,t_meisi_youbi).
first(n_v_kahen_2FH_ga,t_meisi_zi).
first(n_v_kahen_2FH_ga,t_myoji_first).
first(n_v_kahen_2FH_ga,t_myoji_last).
first(n_v_kahen_2FH_ga,t_n_keisiki).
first(n_v_kahen_2FH_ga,t_namae_first).
first(n_v_kahen_2FH_ga,t_namae_last).
first(n_v_kahen_2FH_ga,t_num_bouyomi).
first(n_v_kahen_2FH_ga,t_num_byaku).
first(n_v_kahen_2FH_ga,t_num_byaq).
first(n_v_kahen_2FH_ga,t_num_go).
first(n_v_kahen_2FH_ga,t_num_hachi).
first(n_v_kahen_2FH_ga,t_num_haq).
first(n_v_kahen_2FH_ga,t_num_hito).
first(n_v_kahen_2FH_ga,t_num_huta).
first(n_v_kahen_2FH_ga,t_num_hutsu).
first(n_v_kahen_2FH_ga,t_num_hyaku).
first(n_v_kahen_2FH_ga,t_num_hyaq).
first(n_v_kahen_2FH_ga,t_num_ichi).
first(n_v_kahen_2FH_ga,t_num_iq).
first(n_v_kahen_2FH_ga,t_num_itsu).
first(n_v_kahen_2FH_ga,t_num_kokono).
first(n_v_kahen_2FH_ga,t_num_ku).
first(n_v_kahen_2FH_ga,t_num_kyuu).
first(n_v_kahen_2FH_ga,t_num_miq).
first(n_v_kahen_2FH_ga,t_num_mui).
first(n_v_kahen_2FH_ga,t_num_muq).
first(n_v_kahen_2FH_ga,t_num_nana).
first(n_v_kahen_2FH_ga,t_num_nano).
first(n_v_kahen_2FH_ga,t_num_ni).
first(n_v_kahen_2FH_ga,t_num_one).
first(n_v_kahen_2FH_ga,t_num_pyaku).
first(n_v_kahen_2FH_ga,t_num_pyaq).
first(n_v_kahen_2FH_ga,t_num_roku).
first(n_v_kahen_2FH_ga,t_num_roq).
first(n_v_kahen_2FH_ga,t_num_san).
first(n_v_kahen_2FH_ga,t_num_sen).
first(n_v_kahen_2FH_ga,t_num_shi).
first(n_v_kahen_2FH_ga,t_num_shichi).
first(n_v_kahen_2FH_ga,t_num_ten).
first(n_v_kahen_2FH_ga,t_num_tou).
first(n_v_kahen_2FH_ga,t_num_yaq).
first(n_v_kahen_2FH_ga,t_num_yo).
first(n_v_kahen_2FH_ga,t_num_yon).
first(n_v_kahen_2FH_ga,t_num_yoq).
first(n_v_kahen_2FH_ga,t_num_you).
first(n_v_kahen_2FH_ga,t_num_zen).
first(n_v_kahen_2FH_ga,t_num_zyuq).
first(n_v_kahen_2FH_ga,t_num_zyuu).
first(n_v_kahen_2FH_ga,t_prefix_go).
first(n_v_kahen_2FH_ga,t_prefix_hutu_hutu).
first(n_v_kahen_2FH_ga,t_prefix_o).
first(n_v_kahen_2FH_ga,t_prefix_quant_quant).
first(n_v_kahen_2FH_ga,t_rentai).
first(n_v_kahen_2FH_ga,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_sahen_meisi_2FH_ga).
first(n_v_kahen_2FH_ga,t_sahen_meisi_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_sahen_meisi_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_sahen_meisi_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_sahen_meisi_pol_2FH_ga).
first(n_v_kahen_2FH_ga,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_suuryousi).
first(n_v_kahen_2FH_ga,t_teido_hukusi).
first(n_v_kahen_2FH_ga,t_tsuzuri).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_de).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_quote).
first(n_v_kahen_2FH_ga,t_vstem_1_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_5_b_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_b_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_b_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_b_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_5_g_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_g_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_g_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_k_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_k_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_k_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_k_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga,t_vstem_5_m_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_m_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_m_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_m_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_5_r_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_r_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_ga,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_ga,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_r_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_r_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_5_r_i_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_r_i_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_kahen_2FH_ga,t_vstem_5_s_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_s_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_s_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_s_2FH_ga_quote).
first(n_v_kahen_2FH_ga,t_vstem_5_s_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_5_t_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_t_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_t_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_t_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_5_w_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_5_w_2FH_ga_de).
first(n_v_kahen_2FH_ga,t_vstem_5_w_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga,t_vstem_5_w_2FH_ga_o).
first(n_v_kahen_2FH_ga,t_vstem_5_w_2FH_ga_quote).
first(n_v_kahen_2FH_ga,t_vstem_5_w_2FH_ga_to).
first(n_v_kahen_2FH_ga,t_vstem_masu_2FH_ga).
first(n_v_kahen_2FH_ga,t_vstem_sahen_2FH_ga_ni).
first(n_v_kahen_2FH_ga,t_wh_daimeisi).
first(n_v_kahen_2FH_ga,t_wh_daimeisi_nan).
first(n_v_kahen_2FH_ga,t_wh_hukusi).
first(n_v_kahen_2FH_ga,t_zikan_meisi).
first(n_v_kahen_2FH_ga,t_zikan_meisi_ippai).
first(n_v_kahen_2FH_ga,t_zikantai).
first(n_v_kahen_2FH_ga_ni,n_capacity).
first(n_v_kahen_2FH_ga_ni,n_visitor_name).
first(n_v_kahen_2FH_ga_ni,t_adj_meisi).
first(n_v_kahen_2FH_ga_ni,t_adj_renyo_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_adj_renyo_2FH_ga_de).
first(n_v_kahen_2FH_ga_ni,t_adjstem_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_adjstem_2FH_ga_de).
first(n_v_kahen_2FH_ga_ni,t_adjstem_spe_2FH_ga_de).
first(n_v_kahen_2FH_ga_ni,t_daimeisi).
first(n_v_kahen_2FH_ga_ni,t_daimeisi_domo).
first(n_v_kahen_2FH_ga_ni,t_daimeisi_exp).
first(n_v_kahen_2FH_ga_ni,t_hukusi).
first(n_v_kahen_2FH_ga_ni,t_hukusi_desu).
first(n_v_kahen_2FH_ga_ni,t_hutu_meisi).
first(n_v_kahen_2FH_ga_ni,t_hutu_meisi_post).
first(n_v_kahen_2FH_ga_ni,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_kdo_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_kdo_2FH_ga_de).
first(n_v_kahen_2FH_ga_ni,t_kdo_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_koyuu_meisi).
first(n_v_kahen_2FH_ga_ni,t_meisi_hi).
first(n_v_kahen_2FH_ga_ni,t_meisi_hun).
first(n_v_kahen_2FH_ga_ni,t_meisi_tsuki).
first(n_v_kahen_2FH_ga_ni,t_meisi_youbi).
first(n_v_kahen_2FH_ga_ni,t_meisi_zi).
first(n_v_kahen_2FH_ga_ni,t_myoji_first).
first(n_v_kahen_2FH_ga_ni,t_myoji_last).
first(n_v_kahen_2FH_ga_ni,t_n_keisiki).
first(n_v_kahen_2FH_ga_ni,t_namae_first).
first(n_v_kahen_2FH_ga_ni,t_namae_last).
first(n_v_kahen_2FH_ga_ni,t_num_bouyomi).
first(n_v_kahen_2FH_ga_ni,t_num_byaku).
first(n_v_kahen_2FH_ga_ni,t_num_byaq).
first(n_v_kahen_2FH_ga_ni,t_num_go).
first(n_v_kahen_2FH_ga_ni,t_num_hachi).
first(n_v_kahen_2FH_ga_ni,t_num_haq).
first(n_v_kahen_2FH_ga_ni,t_num_hito).
first(n_v_kahen_2FH_ga_ni,t_num_huta).
first(n_v_kahen_2FH_ga_ni,t_num_hutsu).
first(n_v_kahen_2FH_ga_ni,t_num_hyaku).
first(n_v_kahen_2FH_ga_ni,t_num_hyaq).
first(n_v_kahen_2FH_ga_ni,t_num_ichi).
first(n_v_kahen_2FH_ga_ni,t_num_iq).
first(n_v_kahen_2FH_ga_ni,t_num_itsu).
first(n_v_kahen_2FH_ga_ni,t_num_kokono).
first(n_v_kahen_2FH_ga_ni,t_num_ku).
first(n_v_kahen_2FH_ga_ni,t_num_kyuu).
first(n_v_kahen_2FH_ga_ni,t_num_miq).
first(n_v_kahen_2FH_ga_ni,t_num_mui).
first(n_v_kahen_2FH_ga_ni,t_num_muq).
first(n_v_kahen_2FH_ga_ni,t_num_nana).
first(n_v_kahen_2FH_ga_ni,t_num_nano).
first(n_v_kahen_2FH_ga_ni,t_num_ni).
first(n_v_kahen_2FH_ga_ni,t_num_one).
first(n_v_kahen_2FH_ga_ni,t_num_pyaku).
first(n_v_kahen_2FH_ga_ni,t_num_pyaq).
first(n_v_kahen_2FH_ga_ni,t_num_roku).
first(n_v_kahen_2FH_ga_ni,t_num_roq).
first(n_v_kahen_2FH_ga_ni,t_num_san).
first(n_v_kahen_2FH_ga_ni,t_num_sen).
first(n_v_kahen_2FH_ga_ni,t_num_shi).
first(n_v_kahen_2FH_ga_ni,t_num_shichi).
first(n_v_kahen_2FH_ga_ni,t_num_ten).
first(n_v_kahen_2FH_ga_ni,t_num_tou).
first(n_v_kahen_2FH_ga_ni,t_num_yaq).
first(n_v_kahen_2FH_ga_ni,t_num_yo).
first(n_v_kahen_2FH_ga_ni,t_num_yon).
first(n_v_kahen_2FH_ga_ni,t_num_yoq).
first(n_v_kahen_2FH_ga_ni,t_num_you).
first(n_v_kahen_2FH_ga_ni,t_num_zen).
first(n_v_kahen_2FH_ga_ni,t_num_zyuq).
first(n_v_kahen_2FH_ga_ni,t_num_zyuu).
first(n_v_kahen_2FH_ga_ni,t_prefix_go).
first(n_v_kahen_2FH_ga_ni,t_prefix_hutu_hutu).
first(n_v_kahen_2FH_ga_ni,t_prefix_o).
first(n_v_kahen_2FH_ga_ni,t_prefix_quant_quant).
first(n_v_kahen_2FH_ga_ni,t_rentai).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_suuryousi).
first(n_v_kahen_2FH_ga_ni,t_teido_hukusi).
first(n_v_kahen_2FH_ga_ni,t_tsuzuri).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_de).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_quote).
first(n_v_kahen_2FH_ga_ni,t_vstem_1_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_b_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_g_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_k_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_m_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_s_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_quote).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_t_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_w_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_de).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_o).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_quote).
first(n_v_kahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_to).
first(n_v_kahen_2FH_ga_ni,t_vstem_masu_2FH_ga).
first(n_v_kahen_2FH_ga_ni,t_vstem_sahen_2FH_ga_ni).
first(n_v_kahen_2FH_ga_ni,t_wh_daimeisi).
first(n_v_kahen_2FH_ga_ni,t_wh_daimeisi_nan).
first(n_v_kahen_2FH_ga_ni,t_wh_hukusi).
first(n_v_kahen_2FH_ga_ni,t_zikan_meisi).
first(n_v_kahen_2FH_ga_ni,t_zikan_meisi_ippai).
first(n_v_kahen_2FH_ga_ni,t_zikantai).
first(n_v_kahen_2FH_ni,n_capacity).
first(n_v_kahen_2FH_ni,n_visitor_name).
first(n_v_kahen_2FH_ni,t_adj_meisi).
first(n_v_kahen_2FH_ni,t_adj_renyo_2FH_ga).
first(n_v_kahen_2FH_ni,t_adj_renyo_2FH_ga_de).
first(n_v_kahen_2FH_ni,t_adjstem_2FH_ga).
first(n_v_kahen_2FH_ni,t_adjstem_2FH_ga_de).
first(n_v_kahen_2FH_ni,t_adjstem_spe_2FH_ga_de).
first(n_v_kahen_2FH_ni,t_daimeisi).
first(n_v_kahen_2FH_ni,t_daimeisi_domo).
first(n_v_kahen_2FH_ni,t_daimeisi_exp).
first(n_v_kahen_2FH_ni,t_hukusi).
first(n_v_kahen_2FH_ni,t_hukusi_desu).
first(n_v_kahen_2FH_ni,t_hutu_meisi).
first(n_v_kahen_2FH_ni,t_hutu_meisi_post).
first(n_v_kahen_2FH_ni,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_kdo_2FH_ga).
first(n_v_kahen_2FH_ni,t_kdo_2FH_ga_de).
first(n_v_kahen_2FH_ni,t_kdo_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_koyuu_meisi).
first(n_v_kahen_2FH_ni,t_meisi_hi).
first(n_v_kahen_2FH_ni,t_meisi_hun).
first(n_v_kahen_2FH_ni,t_meisi_tsuki).
first(n_v_kahen_2FH_ni,t_meisi_youbi).
first(n_v_kahen_2FH_ni,t_meisi_zi).
first(n_v_kahen_2FH_ni,t_myoji_first).
first(n_v_kahen_2FH_ni,t_myoji_last).
first(n_v_kahen_2FH_ni,t_n_keisiki).
first(n_v_kahen_2FH_ni,t_namae_first).
first(n_v_kahen_2FH_ni,t_namae_last).
first(n_v_kahen_2FH_ni,t_num_bouyomi).
first(n_v_kahen_2FH_ni,t_num_byaku).
first(n_v_kahen_2FH_ni,t_num_byaq).
first(n_v_kahen_2FH_ni,t_num_go).
first(n_v_kahen_2FH_ni,t_num_hachi).
first(n_v_kahen_2FH_ni,t_num_haq).
first(n_v_kahen_2FH_ni,t_num_hito).
first(n_v_kahen_2FH_ni,t_num_huta).
first(n_v_kahen_2FH_ni,t_num_hutsu).
first(n_v_kahen_2FH_ni,t_num_hyaku).
first(n_v_kahen_2FH_ni,t_num_hyaq).
first(n_v_kahen_2FH_ni,t_num_ichi).
first(n_v_kahen_2FH_ni,t_num_iq).
first(n_v_kahen_2FH_ni,t_num_itsu).
first(n_v_kahen_2FH_ni,t_num_kokono).
first(n_v_kahen_2FH_ni,t_num_ku).
first(n_v_kahen_2FH_ni,t_num_kyuu).
first(n_v_kahen_2FH_ni,t_num_miq).
first(n_v_kahen_2FH_ni,t_num_mui).
first(n_v_kahen_2FH_ni,t_num_muq).
first(n_v_kahen_2FH_ni,t_num_nana).
first(n_v_kahen_2FH_ni,t_num_nano).
first(n_v_kahen_2FH_ni,t_num_ni).
first(n_v_kahen_2FH_ni,t_num_one).
first(n_v_kahen_2FH_ni,t_num_pyaku).
first(n_v_kahen_2FH_ni,t_num_pyaq).
first(n_v_kahen_2FH_ni,t_num_roku).
first(n_v_kahen_2FH_ni,t_num_roq).
first(n_v_kahen_2FH_ni,t_num_san).
first(n_v_kahen_2FH_ni,t_num_sen).
first(n_v_kahen_2FH_ni,t_num_shi).
first(n_v_kahen_2FH_ni,t_num_shichi).
first(n_v_kahen_2FH_ni,t_num_ten).
first(n_v_kahen_2FH_ni,t_num_tou).
first(n_v_kahen_2FH_ni,t_num_yaq).
first(n_v_kahen_2FH_ni,t_num_yo).
first(n_v_kahen_2FH_ni,t_num_yon).
first(n_v_kahen_2FH_ni,t_num_yoq).
first(n_v_kahen_2FH_ni,t_num_you).
first(n_v_kahen_2FH_ni,t_num_zen).
first(n_v_kahen_2FH_ni,t_num_zyuq).
first(n_v_kahen_2FH_ni,t_num_zyuu).
first(n_v_kahen_2FH_ni,t_prefix_go).
first(n_v_kahen_2FH_ni,t_prefix_hutu_hutu).
first(n_v_kahen_2FH_ni,t_prefix_o).
first(n_v_kahen_2FH_ni,t_prefix_quant_quant).
first(n_v_kahen_2FH_ni,t_rentai).
first(n_v_kahen_2FH_ni,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_sahen_meisi_2FH_ga).
first(n_v_kahen_2FH_ni,t_sahen_meisi_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ni,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_sahen_meisi_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_sahen_meisi_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_sahen_meisi_pol_2FH_ga).
first(n_v_kahen_2FH_ni,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_suuryousi).
first(n_v_kahen_2FH_ni,t_teido_hukusi).
first(n_v_kahen_2FH_ni,t_tsuzuri).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_de).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_quote).
first(n_v_kahen_2FH_ni,t_vstem_1_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_5_b_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_b_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_b_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_b_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_5_g_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_g_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_g_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_k_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_k_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_k_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_k_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ni,t_vstem_5_m_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_m_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ni,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_m_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_m_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_5_r_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_r_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_kahen_2FH_ni,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_kahen_2FH_ni,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_r_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_r_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_5_r_i_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_r_i_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_kahen_2FH_ni,t_vstem_5_s_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_s_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_s_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_s_2FH_ga_quote).
first(n_v_kahen_2FH_ni,t_vstem_5_s_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_5_t_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_t_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_kahen_2FH_ni,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_t_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_t_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_5_w_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_5_w_2FH_ga_de).
first(n_v_kahen_2FH_ni,t_vstem_5_w_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_kahen_2FH_ni,t_vstem_5_w_2FH_ga_o).
first(n_v_kahen_2FH_ni,t_vstem_5_w_2FH_ga_quote).
first(n_v_kahen_2FH_ni,t_vstem_5_w_2FH_ga_to).
first(n_v_kahen_2FH_ni,t_vstem_masu_2FH_ga).
first(n_v_kahen_2FH_ni,t_vstem_sahen_2FH_ga_ni).
first(n_v_kahen_2FH_ni,t_wh_daimeisi).
first(n_v_kahen_2FH_ni,t_wh_daimeisi_nan).
first(n_v_kahen_2FH_ni,t_wh_hukusi).
first(n_v_kahen_2FH_ni,t_zikan_meisi).
first(n_v_kahen_2FH_ni,t_zikan_meisi_ippai).
first(n_v_kahen_2FH_ni,t_zikantai).
first(n_v_sahen_2FH_,n_capacity).
first(n_v_sahen_2FH_,n_visitor_name).
first(n_v_sahen_2FH_,t_adj_meisi).
first(n_v_sahen_2FH_,t_adj_renyo_2FH_ga).
first(n_v_sahen_2FH_,t_adj_renyo_2FH_ga_de).
first(n_v_sahen_2FH_,t_adjstem_2FH_ga).
first(n_v_sahen_2FH_,t_adjstem_2FH_ga_de).
first(n_v_sahen_2FH_,t_adjstem_spe_2FH_ga_de).
first(n_v_sahen_2FH_,t_daimeisi).
first(n_v_sahen_2FH_,t_daimeisi_domo).
first(n_v_sahen_2FH_,t_daimeisi_exp).
first(n_v_sahen_2FH_,t_hukusi).
first(n_v_sahen_2FH_,t_hukusi_desu).
first(n_v_sahen_2FH_,t_hutu_meisi).
first(n_v_sahen_2FH_,t_hutu_meisi_post).
first(n_v_sahen_2FH_,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_,t_kdo_2FH_ga).
first(n_v_sahen_2FH_,t_kdo_2FH_ga_de).
first(n_v_sahen_2FH_,t_kdo_2FH_ga_to).
first(n_v_sahen_2FH_,t_koyuu_meisi).
first(n_v_sahen_2FH_,t_meisi_hi).
first(n_v_sahen_2FH_,t_meisi_hun).
first(n_v_sahen_2FH_,t_meisi_tsuki).
first(n_v_sahen_2FH_,t_meisi_youbi).
first(n_v_sahen_2FH_,t_meisi_zi).
first(n_v_sahen_2FH_,t_myoji_first).
first(n_v_sahen_2FH_,t_myoji_last).
first(n_v_sahen_2FH_,t_n_keisiki).
first(n_v_sahen_2FH_,t_namae_first).
first(n_v_sahen_2FH_,t_namae_last).
first(n_v_sahen_2FH_,t_num_bouyomi).
first(n_v_sahen_2FH_,t_num_byaku).
first(n_v_sahen_2FH_,t_num_byaq).
first(n_v_sahen_2FH_,t_num_go).
first(n_v_sahen_2FH_,t_num_hachi).
first(n_v_sahen_2FH_,t_num_haq).
first(n_v_sahen_2FH_,t_num_hito).
first(n_v_sahen_2FH_,t_num_huta).
first(n_v_sahen_2FH_,t_num_hutsu).
first(n_v_sahen_2FH_,t_num_hyaku).
first(n_v_sahen_2FH_,t_num_hyaq).
first(n_v_sahen_2FH_,t_num_ichi).
first(n_v_sahen_2FH_,t_num_iq).
first(n_v_sahen_2FH_,t_num_itsu).
first(n_v_sahen_2FH_,t_num_kokono).
first(n_v_sahen_2FH_,t_num_ku).
first(n_v_sahen_2FH_,t_num_kyuu).
first(n_v_sahen_2FH_,t_num_miq).
first(n_v_sahen_2FH_,t_num_mui).
first(n_v_sahen_2FH_,t_num_muq).
first(n_v_sahen_2FH_,t_num_nana).
first(n_v_sahen_2FH_,t_num_nano).
first(n_v_sahen_2FH_,t_num_ni).
first(n_v_sahen_2FH_,t_num_one).
first(n_v_sahen_2FH_,t_num_pyaku).
first(n_v_sahen_2FH_,t_num_pyaq).
first(n_v_sahen_2FH_,t_num_roku).
first(n_v_sahen_2FH_,t_num_roq).
first(n_v_sahen_2FH_,t_num_san).
first(n_v_sahen_2FH_,t_num_sen).
first(n_v_sahen_2FH_,t_num_shi).
first(n_v_sahen_2FH_,t_num_shichi).
first(n_v_sahen_2FH_,t_num_ten).
first(n_v_sahen_2FH_,t_num_tou).
first(n_v_sahen_2FH_,t_num_yaq).
first(n_v_sahen_2FH_,t_num_yo).
first(n_v_sahen_2FH_,t_num_yon).
first(n_v_sahen_2FH_,t_num_yoq).
first(n_v_sahen_2FH_,t_num_you).
first(n_v_sahen_2FH_,t_num_zen).
first(n_v_sahen_2FH_,t_num_zyuq).
first(n_v_sahen_2FH_,t_num_zyuu).
first(n_v_sahen_2FH_,t_prefix_go).
first(n_v_sahen_2FH_,t_prefix_hutu_hutu).
first(n_v_sahen_2FH_,t_prefix_o).
first(n_v_sahen_2FH_,t_prefix_quant_quant).
first(n_v_sahen_2FH_,t_rentai).
first(n_v_sahen_2FH_,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_sahen_2FH_,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_sahen_2FH_,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_sahen_2FH_,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_sahen_2FH_,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_sahen_2FH_,t_sahen_meisi_2FH_ga).
first(n_v_sahen_2FH_,t_sahen_meisi_2FH_ga_ni).
first(n_v_sahen_2FH_,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_sahen_meisi_2FH_ga_o).
first(n_v_sahen_2FH_,t_sahen_meisi_2FH_ga_to).
first(n_v_sahen_2FH_,t_sahen_meisi_pol_2FH_ga).
first(n_v_sahen_2FH_,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_sahen_2FH_,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_sahen_2FH_,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_sahen_2FH_,t_suuryousi).
first(n_v_sahen_2FH_,t_teido_hukusi).
first(n_v_sahen_2FH_,t_tsuzuri).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_de).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_quote).
first(n_v_sahen_2FH_,t_vstem_1_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_5_b_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_b_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_b_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_b_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_5_g_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_g_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_g_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_k_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_k_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_k_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_k_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_,t_vstem_5_m_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_m_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_m_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_m_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_5_r_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_r_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_r_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_r_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_5_r_i_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_r_i_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_sahen_2FH_,t_vstem_5_s_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_s_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_s_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_s_2FH_ga_quote).
first(n_v_sahen_2FH_,t_vstem_5_s_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_5_t_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_t_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_t_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_t_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_5_w_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_5_w_2FH_ga_de).
first(n_v_sahen_2FH_,t_vstem_5_w_2FH_ga_ni).
first(n_v_sahen_2FH_,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_sahen_2FH_,t_vstem_5_w_2FH_ga_o).
first(n_v_sahen_2FH_,t_vstem_5_w_2FH_ga_quote).
first(n_v_sahen_2FH_,t_vstem_5_w_2FH_ga_to).
first(n_v_sahen_2FH_,t_vstem_masu_2FH_ga).
first(n_v_sahen_2FH_,t_vstem_sahen_2FH_ga_ni).
first(n_v_sahen_2FH_,t_wh_daimeisi).
first(n_v_sahen_2FH_,t_wh_daimeisi_nan).
first(n_v_sahen_2FH_,t_wh_hukusi).
first(n_v_sahen_2FH_,t_zikan_meisi).
first(n_v_sahen_2FH_,t_zikan_meisi_ippai).
first(n_v_sahen_2FH_,t_zikantai).
first(n_v_sahen_2FH_ga,n_capacity).
first(n_v_sahen_2FH_ga,n_visitor_name).
first(n_v_sahen_2FH_ga,t_adj_meisi).
first(n_v_sahen_2FH_ga,t_adj_renyo_2FH_ga).
first(n_v_sahen_2FH_ga,t_adj_renyo_2FH_ga_de).
first(n_v_sahen_2FH_ga,t_adjstem_2FH_ga).
first(n_v_sahen_2FH_ga,t_adjstem_2FH_ga_de).
first(n_v_sahen_2FH_ga,t_adjstem_spe_2FH_ga_de).
first(n_v_sahen_2FH_ga,t_daimeisi).
first(n_v_sahen_2FH_ga,t_daimeisi_domo).
first(n_v_sahen_2FH_ga,t_daimeisi_exp).
first(n_v_sahen_2FH_ga,t_hukusi).
first(n_v_sahen_2FH_ga,t_hukusi_desu).
first(n_v_sahen_2FH_ga,t_hutu_meisi).
first(n_v_sahen_2FH_ga,t_hutu_meisi_post).
first(n_v_sahen_2FH_ga,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_kdo_2FH_ga).
first(n_v_sahen_2FH_ga,t_kdo_2FH_ga_de).
first(n_v_sahen_2FH_ga,t_kdo_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_koyuu_meisi).
first(n_v_sahen_2FH_ga,t_meisi_hi).
first(n_v_sahen_2FH_ga,t_meisi_hun).
first(n_v_sahen_2FH_ga,t_meisi_tsuki).
first(n_v_sahen_2FH_ga,t_meisi_youbi).
first(n_v_sahen_2FH_ga,t_meisi_zi).
first(n_v_sahen_2FH_ga,t_myoji_first).
first(n_v_sahen_2FH_ga,t_myoji_last).
first(n_v_sahen_2FH_ga,t_n_keisiki).
first(n_v_sahen_2FH_ga,t_namae_first).
first(n_v_sahen_2FH_ga,t_namae_last).
first(n_v_sahen_2FH_ga,t_num_bouyomi).
first(n_v_sahen_2FH_ga,t_num_byaku).
first(n_v_sahen_2FH_ga,t_num_byaq).
first(n_v_sahen_2FH_ga,t_num_go).
first(n_v_sahen_2FH_ga,t_num_hachi).
first(n_v_sahen_2FH_ga,t_num_haq).
first(n_v_sahen_2FH_ga,t_num_hito).
first(n_v_sahen_2FH_ga,t_num_huta).
first(n_v_sahen_2FH_ga,t_num_hutsu).
first(n_v_sahen_2FH_ga,t_num_hyaku).
first(n_v_sahen_2FH_ga,t_num_hyaq).
first(n_v_sahen_2FH_ga,t_num_ichi).
first(n_v_sahen_2FH_ga,t_num_iq).
first(n_v_sahen_2FH_ga,t_num_itsu).
first(n_v_sahen_2FH_ga,t_num_kokono).
first(n_v_sahen_2FH_ga,t_num_ku).
first(n_v_sahen_2FH_ga,t_num_kyuu).
first(n_v_sahen_2FH_ga,t_num_miq).
first(n_v_sahen_2FH_ga,t_num_mui).
first(n_v_sahen_2FH_ga,t_num_muq).
first(n_v_sahen_2FH_ga,t_num_nana).
first(n_v_sahen_2FH_ga,t_num_nano).
first(n_v_sahen_2FH_ga,t_num_ni).
first(n_v_sahen_2FH_ga,t_num_one).
first(n_v_sahen_2FH_ga,t_num_pyaku).
first(n_v_sahen_2FH_ga,t_num_pyaq).
first(n_v_sahen_2FH_ga,t_num_roku).
first(n_v_sahen_2FH_ga,t_num_roq).
first(n_v_sahen_2FH_ga,t_num_san).
first(n_v_sahen_2FH_ga,t_num_sen).
first(n_v_sahen_2FH_ga,t_num_shi).
first(n_v_sahen_2FH_ga,t_num_shichi).
first(n_v_sahen_2FH_ga,t_num_ten).
first(n_v_sahen_2FH_ga,t_num_tou).
first(n_v_sahen_2FH_ga,t_num_yaq).
first(n_v_sahen_2FH_ga,t_num_yo).
first(n_v_sahen_2FH_ga,t_num_yon).
first(n_v_sahen_2FH_ga,t_num_yoq).
first(n_v_sahen_2FH_ga,t_num_you).
first(n_v_sahen_2FH_ga,t_num_zen).
first(n_v_sahen_2FH_ga,t_num_zyuq).
first(n_v_sahen_2FH_ga,t_num_zyuu).
first(n_v_sahen_2FH_ga,t_prefix_go).
first(n_v_sahen_2FH_ga,t_prefix_hutu_hutu).
first(n_v_sahen_2FH_ga,t_prefix_o).
first(n_v_sahen_2FH_ga,t_prefix_quant_quant).
first(n_v_sahen_2FH_ga,t_rentai).
first(n_v_sahen_2FH_ga,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_sahen_meisi_2FH_ga).
first(n_v_sahen_2FH_ga,t_sahen_meisi_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_sahen_meisi_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_sahen_meisi_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_sahen_meisi_pol_2FH_ga).
first(n_v_sahen_2FH_ga,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_suuryousi).
first(n_v_sahen_2FH_ga,t_teido_hukusi).
first(n_v_sahen_2FH_ga,t_tsuzuri).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_de).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_quote).
first(n_v_sahen_2FH_ga,t_vstem_1_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_5_b_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_b_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_b_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_b_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_5_g_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_g_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_g_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_k_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_k_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_k_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_k_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga,t_vstem_5_m_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_m_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_m_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_m_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_5_r_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_r_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_ga,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_ga,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_r_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_r_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_5_r_i_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_r_i_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_sahen_2FH_ga,t_vstem_5_s_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_s_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_s_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_s_2FH_ga_quote).
first(n_v_sahen_2FH_ga,t_vstem_5_s_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_5_t_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_t_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_t_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_t_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_5_w_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_5_w_2FH_ga_de).
first(n_v_sahen_2FH_ga,t_vstem_5_w_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga,t_vstem_5_w_2FH_ga_o).
first(n_v_sahen_2FH_ga,t_vstem_5_w_2FH_ga_quote).
first(n_v_sahen_2FH_ga,t_vstem_5_w_2FH_ga_to).
first(n_v_sahen_2FH_ga,t_vstem_masu_2FH_ga).
first(n_v_sahen_2FH_ga,t_vstem_sahen_2FH_ga_ni).
first(n_v_sahen_2FH_ga,t_wh_daimeisi).
first(n_v_sahen_2FH_ga,t_wh_daimeisi_nan).
first(n_v_sahen_2FH_ga,t_wh_hukusi).
first(n_v_sahen_2FH_ga,t_zikan_meisi).
first(n_v_sahen_2FH_ga,t_zikan_meisi_ippai).
first(n_v_sahen_2FH_ga,t_zikantai).
first(n_v_sahen_2FH_ga_ni,n_capacity).
first(n_v_sahen_2FH_ga_ni,n_visitor_name).
first(n_v_sahen_2FH_ga_ni,t_adj_meisi).
first(n_v_sahen_2FH_ga_ni,t_adj_renyo_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_adj_renyo_2FH_ga_de).
first(n_v_sahen_2FH_ga_ni,t_adjstem_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_adjstem_2FH_ga_de).
first(n_v_sahen_2FH_ga_ni,t_adjstem_spe_2FH_ga_de).
first(n_v_sahen_2FH_ga_ni,t_daimeisi).
first(n_v_sahen_2FH_ga_ni,t_daimeisi_domo).
first(n_v_sahen_2FH_ga_ni,t_daimeisi_exp).
first(n_v_sahen_2FH_ga_ni,t_hukusi).
first(n_v_sahen_2FH_ga_ni,t_hukusi_desu).
first(n_v_sahen_2FH_ga_ni,t_hutu_meisi).
first(n_v_sahen_2FH_ga_ni,t_hutu_meisi_post).
first(n_v_sahen_2FH_ga_ni,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_kdo_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_kdo_2FH_ga_de).
first(n_v_sahen_2FH_ga_ni,t_kdo_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_koyuu_meisi).
first(n_v_sahen_2FH_ga_ni,t_meisi_hi).
first(n_v_sahen_2FH_ga_ni,t_meisi_hun).
first(n_v_sahen_2FH_ga_ni,t_meisi_tsuki).
first(n_v_sahen_2FH_ga_ni,t_meisi_youbi).
first(n_v_sahen_2FH_ga_ni,t_meisi_zi).
first(n_v_sahen_2FH_ga_ni,t_myoji_first).
first(n_v_sahen_2FH_ga_ni,t_myoji_last).
first(n_v_sahen_2FH_ga_ni,t_n_keisiki).
first(n_v_sahen_2FH_ga_ni,t_namae_first).
first(n_v_sahen_2FH_ga_ni,t_namae_last).
first(n_v_sahen_2FH_ga_ni,t_num_bouyomi).
first(n_v_sahen_2FH_ga_ni,t_num_byaku).
first(n_v_sahen_2FH_ga_ni,t_num_byaq).
first(n_v_sahen_2FH_ga_ni,t_num_go).
first(n_v_sahen_2FH_ga_ni,t_num_hachi).
first(n_v_sahen_2FH_ga_ni,t_num_haq).
first(n_v_sahen_2FH_ga_ni,t_num_hito).
first(n_v_sahen_2FH_ga_ni,t_num_huta).
first(n_v_sahen_2FH_ga_ni,t_num_hutsu).
first(n_v_sahen_2FH_ga_ni,t_num_hyaku).
first(n_v_sahen_2FH_ga_ni,t_num_hyaq).
first(n_v_sahen_2FH_ga_ni,t_num_ichi).
first(n_v_sahen_2FH_ga_ni,t_num_iq).
first(n_v_sahen_2FH_ga_ni,t_num_itsu).
first(n_v_sahen_2FH_ga_ni,t_num_kokono).
first(n_v_sahen_2FH_ga_ni,t_num_ku).
first(n_v_sahen_2FH_ga_ni,t_num_kyuu).
first(n_v_sahen_2FH_ga_ni,t_num_miq).
first(n_v_sahen_2FH_ga_ni,t_num_mui).
first(n_v_sahen_2FH_ga_ni,t_num_muq).
first(n_v_sahen_2FH_ga_ni,t_num_nana).
first(n_v_sahen_2FH_ga_ni,t_num_nano).
first(n_v_sahen_2FH_ga_ni,t_num_ni).
first(n_v_sahen_2FH_ga_ni,t_num_one).
first(n_v_sahen_2FH_ga_ni,t_num_pyaku).
first(n_v_sahen_2FH_ga_ni,t_num_pyaq).
first(n_v_sahen_2FH_ga_ni,t_num_roku).
first(n_v_sahen_2FH_ga_ni,t_num_roq).
first(n_v_sahen_2FH_ga_ni,t_num_san).
first(n_v_sahen_2FH_ga_ni,t_num_sen).
first(n_v_sahen_2FH_ga_ni,t_num_shi).
first(n_v_sahen_2FH_ga_ni,t_num_shichi).
first(n_v_sahen_2FH_ga_ni,t_num_ten).
first(n_v_sahen_2FH_ga_ni,t_num_tou).
first(n_v_sahen_2FH_ga_ni,t_num_yaq).
first(n_v_sahen_2FH_ga_ni,t_num_yo).
first(n_v_sahen_2FH_ga_ni,t_num_yon).
first(n_v_sahen_2FH_ga_ni,t_num_yoq).
first(n_v_sahen_2FH_ga_ni,t_num_you).
first(n_v_sahen_2FH_ga_ni,t_num_zen).
first(n_v_sahen_2FH_ga_ni,t_num_zyuq).
first(n_v_sahen_2FH_ga_ni,t_num_zyuu).
first(n_v_sahen_2FH_ga_ni,t_prefix_go).
first(n_v_sahen_2FH_ga_ni,t_prefix_hutu_hutu).
first(n_v_sahen_2FH_ga_ni,t_prefix_o).
first(n_v_sahen_2FH_ga_ni,t_prefix_quant_quant).
first(n_v_sahen_2FH_ga_ni,t_rentai).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_suuryousi).
first(n_v_sahen_2FH_ga_ni,t_teido_hukusi).
first(n_v_sahen_2FH_ga_ni,t_tsuzuri).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_de).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_quote).
first(n_v_sahen_2FH_ga_ni,t_vstem_1_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_b_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_g_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_k_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_m_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_quote).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_s_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_t_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_de).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_o).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_quote).
first(n_v_sahen_2FH_ga_ni,t_vstem_5_w_2FH_ga_to).
first(n_v_sahen_2FH_ga_ni,t_vstem_masu_2FH_ga).
first(n_v_sahen_2FH_ga_ni,t_vstem_sahen_2FH_ga_ni).
first(n_v_sahen_2FH_ga_ni,t_wh_daimeisi).
first(n_v_sahen_2FH_ga_ni,t_wh_daimeisi_nan).
first(n_v_sahen_2FH_ga_ni,t_wh_hukusi).
first(n_v_sahen_2FH_ga_ni,t_zikan_meisi).
first(n_v_sahen_2FH_ga_ni,t_zikan_meisi_ippai).
first(n_v_sahen_2FH_ga_ni,t_zikantai).
first(n_v_sahen_2FH_ga_o,n_capacity).
first(n_v_sahen_2FH_ga_o,n_visitor_name).
first(n_v_sahen_2FH_ga_o,t_adj_meisi).
first(n_v_sahen_2FH_ga_o,t_adj_renyo_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_adj_renyo_2FH_ga_de).
first(n_v_sahen_2FH_ga_o,t_adjstem_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_adjstem_2FH_ga_de).
first(n_v_sahen_2FH_ga_o,t_adjstem_spe_2FH_ga_de).
first(n_v_sahen_2FH_ga_o,t_daimeisi).
first(n_v_sahen_2FH_ga_o,t_daimeisi_domo).
first(n_v_sahen_2FH_ga_o,t_daimeisi_exp).
first(n_v_sahen_2FH_ga_o,t_hukusi).
first(n_v_sahen_2FH_ga_o,t_hukusi_desu).
first(n_v_sahen_2FH_ga_o,t_hutu_meisi).
first(n_v_sahen_2FH_ga_o,t_hutu_meisi_post).
first(n_v_sahen_2FH_ga_o,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_kdo_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_kdo_2FH_ga_de).
first(n_v_sahen_2FH_ga_o,t_kdo_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_koyuu_meisi).
first(n_v_sahen_2FH_ga_o,t_meisi_hi).
first(n_v_sahen_2FH_ga_o,t_meisi_hun).
first(n_v_sahen_2FH_ga_o,t_meisi_tsuki).
first(n_v_sahen_2FH_ga_o,t_meisi_youbi).
first(n_v_sahen_2FH_ga_o,t_meisi_zi).
first(n_v_sahen_2FH_ga_o,t_myoji_first).
first(n_v_sahen_2FH_ga_o,t_myoji_last).
first(n_v_sahen_2FH_ga_o,t_n_keisiki).
first(n_v_sahen_2FH_ga_o,t_namae_first).
first(n_v_sahen_2FH_ga_o,t_namae_last).
first(n_v_sahen_2FH_ga_o,t_num_bouyomi).
first(n_v_sahen_2FH_ga_o,t_num_byaku).
first(n_v_sahen_2FH_ga_o,t_num_byaq).
first(n_v_sahen_2FH_ga_o,t_num_go).
first(n_v_sahen_2FH_ga_o,t_num_hachi).
first(n_v_sahen_2FH_ga_o,t_num_haq).
first(n_v_sahen_2FH_ga_o,t_num_hito).
first(n_v_sahen_2FH_ga_o,t_num_huta).
first(n_v_sahen_2FH_ga_o,t_num_hutsu).
first(n_v_sahen_2FH_ga_o,t_num_hyaku).
first(n_v_sahen_2FH_ga_o,t_num_hyaq).
first(n_v_sahen_2FH_ga_o,t_num_ichi).
first(n_v_sahen_2FH_ga_o,t_num_iq).
first(n_v_sahen_2FH_ga_o,t_num_itsu).
first(n_v_sahen_2FH_ga_o,t_num_kokono).
first(n_v_sahen_2FH_ga_o,t_num_ku).
first(n_v_sahen_2FH_ga_o,t_num_kyuu).
first(n_v_sahen_2FH_ga_o,t_num_miq).
first(n_v_sahen_2FH_ga_o,t_num_mui).
first(n_v_sahen_2FH_ga_o,t_num_muq).
first(n_v_sahen_2FH_ga_o,t_num_nana).
first(n_v_sahen_2FH_ga_o,t_num_nano).
first(n_v_sahen_2FH_ga_o,t_num_ni).
first(n_v_sahen_2FH_ga_o,t_num_one).
first(n_v_sahen_2FH_ga_o,t_num_pyaku).
first(n_v_sahen_2FH_ga_o,t_num_pyaq).
first(n_v_sahen_2FH_ga_o,t_num_roku).
first(n_v_sahen_2FH_ga_o,t_num_roq).
first(n_v_sahen_2FH_ga_o,t_num_san).
first(n_v_sahen_2FH_ga_o,t_num_sen).
first(n_v_sahen_2FH_ga_o,t_num_shi).
first(n_v_sahen_2FH_ga_o,t_num_shichi).
first(n_v_sahen_2FH_ga_o,t_num_ten).
first(n_v_sahen_2FH_ga_o,t_num_tou).
first(n_v_sahen_2FH_ga_o,t_num_yaq).
first(n_v_sahen_2FH_ga_o,t_num_yo).
first(n_v_sahen_2FH_ga_o,t_num_yon).
first(n_v_sahen_2FH_ga_o,t_num_yoq).
first(n_v_sahen_2FH_ga_o,t_num_you).
first(n_v_sahen_2FH_ga_o,t_num_zen).
first(n_v_sahen_2FH_ga_o,t_num_zyuq).
first(n_v_sahen_2FH_ga_o,t_num_zyuu).
first(n_v_sahen_2FH_ga_o,t_prefix_go).
first(n_v_sahen_2FH_ga_o,t_prefix_hutu_hutu).
first(n_v_sahen_2FH_ga_o,t_prefix_o).
first(n_v_sahen_2FH_ga_o,t_prefix_quant_quant).
first(n_v_sahen_2FH_ga_o,t_rentai).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_pol_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_suuryousi).
first(n_v_sahen_2FH_ga_o,t_teido_hukusi).
first(n_v_sahen_2FH_ga_o,t_tsuzuri).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_de).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_quote).
first(n_v_sahen_2FH_ga_o,t_vstem_1_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_b_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_b_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_b_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_b_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_g_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_g_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_g_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_k_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_k_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_k_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_k_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_o,t_vstem_5_m_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_m_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_m_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_m_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_i_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_i_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_sahen_2FH_ga_o,t_vstem_5_s_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_s_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_s_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_s_2FH_ga_quote).
first(n_v_sahen_2FH_ga_o,t_vstem_5_s_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_t_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_t_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_ga_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_t_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_t_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_5_w_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_5_w_2FH_ga_de).
first(n_v_sahen_2FH_ga_o,t_vstem_5_w_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_w_2FH_ga_o).
first(n_v_sahen_2FH_ga_o,t_vstem_5_w_2FH_ga_quote).
first(n_v_sahen_2FH_ga_o,t_vstem_5_w_2FH_ga_to).
first(n_v_sahen_2FH_ga_o,t_vstem_masu_2FH_ga).
first(n_v_sahen_2FH_ga_o,t_vstem_sahen_2FH_ga_ni).
first(n_v_sahen_2FH_ga_o,t_wh_daimeisi).
first(n_v_sahen_2FH_ga_o,t_wh_daimeisi_nan).
first(n_v_sahen_2FH_ga_o,t_wh_hukusi).
first(n_v_sahen_2FH_ga_o,t_zikan_meisi).
first(n_v_sahen_2FH_ga_o,t_zikan_meisi_ippai).
first(n_v_sahen_2FH_ga_o,t_zikantai).
first(n_v_sahen_2FH_o,n_capacity).
first(n_v_sahen_2FH_o,n_visitor_name).
first(n_v_sahen_2FH_o,t_adj_meisi).
first(n_v_sahen_2FH_o,t_adj_renyo_2FH_ga).
first(n_v_sahen_2FH_o,t_adj_renyo_2FH_ga_de).
first(n_v_sahen_2FH_o,t_adjstem_2FH_ga).
first(n_v_sahen_2FH_o,t_adjstem_2FH_ga_de).
first(n_v_sahen_2FH_o,t_adjstem_spe_2FH_ga_de).
first(n_v_sahen_2FH_o,t_daimeisi).
first(n_v_sahen_2FH_o,t_daimeisi_domo).
first(n_v_sahen_2FH_o,t_daimeisi_exp).
first(n_v_sahen_2FH_o,t_hukusi).
first(n_v_sahen_2FH_o,t_hukusi_desu).
first(n_v_sahen_2FH_o,t_hutu_meisi).
first(n_v_sahen_2FH_o,t_hutu_meisi_post).
first(n_v_sahen_2FH_o,t_kahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_kdo_2FH_ga).
first(n_v_sahen_2FH_o,t_kdo_2FH_ga_de).
first(n_v_sahen_2FH_o,t_kdo_2FH_ga_to).
first(n_v_sahen_2FH_o,t_koyuu_meisi).
first(n_v_sahen_2FH_o,t_meisi_hi).
first(n_v_sahen_2FH_o,t_meisi_hun).
first(n_v_sahen_2FH_o,t_meisi_tsuki).
first(n_v_sahen_2FH_o,t_meisi_youbi).
first(n_v_sahen_2FH_o,t_meisi_zi).
first(n_v_sahen_2FH_o,t_myoji_first).
first(n_v_sahen_2FH_o,t_myoji_last).
first(n_v_sahen_2FH_o,t_n_keisiki).
first(n_v_sahen_2FH_o,t_namae_first).
first(n_v_sahen_2FH_o,t_namae_last).
first(n_v_sahen_2FH_o,t_num_bouyomi).
first(n_v_sahen_2FH_o,t_num_byaku).
first(n_v_sahen_2FH_o,t_num_byaq).
first(n_v_sahen_2FH_o,t_num_go).
first(n_v_sahen_2FH_o,t_num_hachi).
first(n_v_sahen_2FH_o,t_num_haq).
first(n_v_sahen_2FH_o,t_num_hito).
first(n_v_sahen_2FH_o,t_num_huta).
first(n_v_sahen_2FH_o,t_num_hutsu).
first(n_v_sahen_2FH_o,t_num_hyaku).
first(n_v_sahen_2FH_o,t_num_hyaq).
first(n_v_sahen_2FH_o,t_num_ichi).
first(n_v_sahen_2FH_o,t_num_iq).
first(n_v_sahen_2FH_o,t_num_itsu).
first(n_v_sahen_2FH_o,t_num_kokono).
first(n_v_sahen_2FH_o,t_num_ku).
first(n_v_sahen_2FH_o,t_num_kyuu).
first(n_v_sahen_2FH_o,t_num_miq).
first(n_v_sahen_2FH_o,t_num_mui).
first(n_v_sahen_2FH_o,t_num_muq).
first(n_v_sahen_2FH_o,t_num_nana).
first(n_v_sahen_2FH_o,t_num_nano).
first(n_v_sahen_2FH_o,t_num_ni).
first(n_v_sahen_2FH_o,t_num_one).
first(n_v_sahen_2FH_o,t_num_pyaku).
first(n_v_sahen_2FH_o,t_num_pyaq).
first(n_v_sahen_2FH_o,t_num_roku).
first(n_v_sahen_2FH_o,t_num_roq).
first(n_v_sahen_2FH_o,t_num_san).
first(n_v_sahen_2FH_o,t_num_sen).
first(n_v_sahen_2FH_o,t_num_shi).
first(n_v_sahen_2FH_o,t_num_shichi).
first(n_v_sahen_2FH_o,t_num_ten).
first(n_v_sahen_2FH_o,t_num_tou).
first(n_v_sahen_2FH_o,t_num_yaq).
first(n_v_sahen_2FH_o,t_num_yo).
first(n_v_sahen_2FH_o,t_num_yon).
first(n_v_sahen_2FH_o,t_num_yoq).
first(n_v_sahen_2FH_o,t_num_you).
first(n_v_sahen_2FH_o,t_num_zen).
first(n_v_sahen_2FH_o,t_num_zyuq).
first(n_v_sahen_2FH_o,t_num_zyuu).
first(n_v_sahen_2FH_o,t_prefix_go).
first(n_v_sahen_2FH_o,t_prefix_hutu_hutu).
first(n_v_sahen_2FH_o,t_prefix_o).
first(n_v_sahen_2FH_o,t_prefix_quant_quant).
first(n_v_sahen_2FH_o,t_rentai).
first(n_v_sahen_2FH_o,t_sahen_dousi_katei_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_sahen_dousi_katei_2FH_ga_o).
first(n_v_sahen_2FH_o,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_sahen_dousi_mizen_2FH_ga_o).
first(n_v_sahen_2FH_o,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_sahen_dousi_rentai_2FH_ga_o).
first(n_v_sahen_2FH_o,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_sahen_dousi_renyo_2FH_ga_o).
first(n_v_sahen_2FH_o,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_sahen_dousi_syusi_2FH_ga_o).
first(n_v_sahen_2FH_o,t_sahen_meisi_2FH_ga).
first(n_v_sahen_2FH_o,t_sahen_meisi_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_sahen_meisi_2FH_ga_o).
first(n_v_sahen_2FH_o,t_sahen_meisi_2FH_ga_to).
first(n_v_sahen_2FH_o,t_sahen_meisi_pol_2FH_ga).
first(n_v_sahen_2FH_o,t_sahen_meisi_pol_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_v_sahen_2FH_o,t_sahen_meisi_pol_2FH_ga_to).
first(n_v_sahen_2FH_o,t_suuryousi).
first(n_v_sahen_2FH_o,t_teido_hukusi).
first(n_v_sahen_2FH_o,t_tsuzuri).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_de).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_quote).
first(n_v_sahen_2FH_o,t_vstem_1_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_5_b_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_b_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_b_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_b_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_5_g_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_g_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_g_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_k_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_k_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_k_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_k_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_o,t_vstem_5_m_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_m_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_m_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_m_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_5_r_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_r_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_v_sahen_2FH_o,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_v_sahen_2FH_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_r_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_r_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_5_r_i_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_r_i_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_r_i_2FH_ga_quote).
first(n_v_sahen_2FH_o,t_vstem_5_s_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_s_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_s_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_s_2FH_ga_quote).
first(n_v_sahen_2FH_o,t_vstem_5_s_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_5_t_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_t_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_v_sahen_2FH_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_t_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_t_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_5_w_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_5_w_2FH_ga_de).
first(n_v_sahen_2FH_o,t_vstem_5_w_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_v_sahen_2FH_o,t_vstem_5_w_2FH_ga_o).
first(n_v_sahen_2FH_o,t_vstem_5_w_2FH_ga_quote).
first(n_v_sahen_2FH_o,t_vstem_5_w_2FH_ga_to).
first(n_v_sahen_2FH_o,t_vstem_masu_2FH_ga).
first(n_v_sahen_2FH_o,t_vstem_sahen_2FH_ga_ni).
first(n_v_sahen_2FH_o,t_wh_daimeisi).
first(n_v_sahen_2FH_o,t_wh_daimeisi_nan).
first(n_v_sahen_2FH_o,t_wh_hukusi).
first(n_v_sahen_2FH_o,t_zikan_meisi).
first(n_v_sahen_2FH_o,t_zikan_meisi_ippai).
first(n_v_sahen_2FH_o,t_zikantai).
first(n_vaux,n_capacity).
first(n_vaux,n_visitor_name).
first(n_vaux,t_adj_meisi).
first(n_vaux,t_adj_renyo_2FH_ga).
first(n_vaux,t_adj_renyo_2FH_ga_de).
first(n_vaux,t_adjstem_2FH_ga).
first(n_vaux,t_adjstem_2FH_ga_de).
first(n_vaux,t_adjstem_spe_2FH_ga_de).
first(n_vaux,t_daimeisi).
first(n_vaux,t_daimeisi_domo).
first(n_vaux,t_daimeisi_exp).
first(n_vaux,t_hukusi).
first(n_vaux,t_hukusi_desu).
first(n_vaux,t_hutu_meisi).
first(n_vaux,t_hutu_meisi_post).
first(n_vaux,t_kahen_dousi_katei_2FH_ga_ni).
first(n_vaux,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_vaux,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_vaux,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_vaux,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_vaux,t_kdo_2FH_ga).
first(n_vaux,t_kdo_2FH_ga_de).
first(n_vaux,t_kdo_2FH_ga_to).
first(n_vaux,t_koyuu_meisi).
first(n_vaux,t_meisi_hi).
first(n_vaux,t_meisi_hun).
first(n_vaux,t_meisi_tsuki).
first(n_vaux,t_meisi_youbi).
first(n_vaux,t_meisi_zi).
first(n_vaux,t_myoji_first).
first(n_vaux,t_myoji_last).
first(n_vaux,t_n_keisiki).
first(n_vaux,t_namae_first).
first(n_vaux,t_namae_last).
first(n_vaux,t_num_bouyomi).
first(n_vaux,t_num_byaku).
first(n_vaux,t_num_byaq).
first(n_vaux,t_num_go).
first(n_vaux,t_num_hachi).
first(n_vaux,t_num_haq).
first(n_vaux,t_num_hito).
first(n_vaux,t_num_huta).
first(n_vaux,t_num_hutsu).
first(n_vaux,t_num_hyaku).
first(n_vaux,t_num_hyaq).
first(n_vaux,t_num_ichi).
first(n_vaux,t_num_iq).
first(n_vaux,t_num_itsu).
first(n_vaux,t_num_kokono).
first(n_vaux,t_num_ku).
first(n_vaux,t_num_kyuu).
first(n_vaux,t_num_miq).
first(n_vaux,t_num_mui).
first(n_vaux,t_num_muq).
first(n_vaux,t_num_nana).
first(n_vaux,t_num_nano).
first(n_vaux,t_num_ni).
first(n_vaux,t_num_one).
first(n_vaux,t_num_pyaku).
first(n_vaux,t_num_pyaq).
first(n_vaux,t_num_roku).
first(n_vaux,t_num_roq).
first(n_vaux,t_num_san).
first(n_vaux,t_num_sen).
first(n_vaux,t_num_shi).
first(n_vaux,t_num_shichi).
first(n_vaux,t_num_ten).
first(n_vaux,t_num_tou).
first(n_vaux,t_num_yaq).
first(n_vaux,t_num_yo).
first(n_vaux,t_num_yon).
first(n_vaux,t_num_yoq).
first(n_vaux,t_num_you).
first(n_vaux,t_num_zen).
first(n_vaux,t_num_zyuq).
first(n_vaux,t_num_zyuu).
first(n_vaux,t_prefix_go).
first(n_vaux,t_prefix_hutu_hutu).
first(n_vaux,t_prefix_o).
first(n_vaux,t_prefix_quant_quant).
first(n_vaux,t_rentai).
first(n_vaux,t_sahen_dousi_katei_2FH_ga_ni).
first(n_vaux,t_sahen_dousi_katei_2FH_ga_o).
first(n_vaux,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_vaux,t_sahen_dousi_mizen_2FH_ga_o).
first(n_vaux,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_vaux,t_sahen_dousi_rentai_2FH_ga_o).
first(n_vaux,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_vaux,t_sahen_dousi_renyo_2FH_ga_o).
first(n_vaux,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_vaux,t_sahen_dousi_syusi_2FH_ga_o).
first(n_vaux,t_sahen_meisi_2FH_ga).
first(n_vaux,t_sahen_meisi_2FH_ga_ni).
first(n_vaux,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_vaux,t_sahen_meisi_2FH_ga_ni_o).
first(n_vaux,t_sahen_meisi_2FH_ga_o).
first(n_vaux,t_sahen_meisi_2FH_ga_to).
first(n_vaux,t_sahen_meisi_pol_2FH_ga).
first(n_vaux,t_sahen_meisi_pol_2FH_ga_ni).
first(n_vaux,t_sahen_meisi_pol_2FH_ga_o).
first(n_vaux,t_sahen_meisi_pol_2FH_ga_to).
first(n_vaux,t_suuryousi).
first(n_vaux,t_teido_hukusi).
first(n_vaux,t_tsuzuri).
first(n_vaux,t_vstem_1_2FH_ga).
first(n_vaux,t_vstem_1_2FH_ga_de).
first(n_vaux,t_vstem_1_2FH_ga_ni).
first(n_vaux,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_vaux,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_vaux,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_vaux,t_vstem_1_2FH_ga_ni_o).
first(n_vaux,t_vstem_1_2FH_ga_o).
first(n_vaux,t_vstem_1_2FH_ga_quote).
first(n_vaux,t_vstem_1_2FH_ga_to).
first(n_vaux,t_vstem_5_b_2FH_ga).
first(n_vaux,t_vstem_5_b_2FH_ga_ni).
first(n_vaux,t_vstem_5_b_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_b_2FH_ga_o).
first(n_vaux,t_vstem_5_b_2FH_ga_to).
first(n_vaux,t_vstem_5_g_2FH_ga).
first(n_vaux,t_vstem_5_g_2FH_ga_ni).
first(n_vaux,t_vstem_5_g_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_g_2FH_ga_o).
first(n_vaux,t_vstem_5_k_2FH_ga).
first(n_vaux,t_vstem_5_k_2FH_ga_ni).
first(n_vaux,t_vstem_5_k_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_k_2FH_ga_o).
first(n_vaux,t_vstem_5_k_2FH_ga_to).
first(n_vaux,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_vaux,t_vstem_5_m_2FH_ga).
first(n_vaux,t_vstem_5_m_2FH_ga_ni).
first(n_vaux,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_vaux,t_vstem_5_m_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_m_2FH_ga_o).
first(n_vaux,t_vstem_5_m_2FH_ga_to).
first(n_vaux,t_vstem_5_r_2FH_ga).
first(n_vaux,t_vstem_5_r_2FH_ga_ni).
first(n_vaux,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_vaux,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_vaux,t_vstem_5_r_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_r_2FH_ga_o).
first(n_vaux,t_vstem_5_r_2FH_ga_to).
first(n_vaux,t_vstem_5_r_i_2FH_ga).
first(n_vaux,t_vstem_5_r_i_2FH_ga_o).
first(n_vaux,t_vstem_5_r_i_2FH_ga_quote).
first(n_vaux,t_vstem_5_s_2FH_ga).
first(n_vaux,t_vstem_5_s_2FH_ga_ni).
first(n_vaux,t_vstem_5_s_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_s_2FH_ga_o).
first(n_vaux,t_vstem_5_s_2FH_ga_quote).
first(n_vaux,t_vstem_5_s_2FH_ga_to).
first(n_vaux,t_vstem_5_t_2FH_ga).
first(n_vaux,t_vstem_5_t_2FH_ga_ni).
first(n_vaux,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_vaux,t_vstem_5_t_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_t_2FH_ga_o).
first(n_vaux,t_vstem_5_t_2FH_ga_to).
first(n_vaux,t_vstem_5_w_2FH_ga).
first(n_vaux,t_vstem_5_w_2FH_ga_de).
first(n_vaux,t_vstem_5_w_2FH_ga_ni).
first(n_vaux,t_vstem_5_w_2FH_ga_ni_o).
first(n_vaux,t_vstem_5_w_2FH_ga_o).
first(n_vaux,t_vstem_5_w_2FH_ga_quote).
first(n_vaux,t_vstem_5_w_2FH_ga_to).
first(n_vaux,t_vstem_masu_2FH_ga).
first(n_vaux,t_vstem_sahen_2FH_ga_ni).
first(n_vaux,t_wh_daimeisi).
first(n_vaux,t_wh_daimeisi_nan).
first(n_vaux,t_wh_hukusi).
first(n_vaux,t_zikan_meisi).
first(n_vaux,t_zikan_meisi_ippai).
first(n_vaux,t_zikantai).
first(n_verb,n_capacity).
first(n_verb,n_visitor_name).
first(n_verb,t_adj_meisi).
first(n_verb,t_adj_renyo_2FH_ga).
first(n_verb,t_adj_renyo_2FH_ga_de).
first(n_verb,t_adjstem_2FH_ga).
first(n_verb,t_adjstem_2FH_ga_de).
first(n_verb,t_adjstem_spe_2FH_ga_de).
first(n_verb,t_daimeisi).
first(n_verb,t_daimeisi_domo).
first(n_verb,t_daimeisi_exp).
first(n_verb,t_hukusi).
first(n_verb,t_hukusi_desu).
first(n_verb,t_hutu_meisi).
first(n_verb,t_hutu_meisi_post).
first(n_verb,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb,t_kdo_2FH_ga).
first(n_verb,t_kdo_2FH_ga_de).
first(n_verb,t_kdo_2FH_ga_to).
first(n_verb,t_koyuu_meisi).
first(n_verb,t_meisi_hi).
first(n_verb,t_meisi_hun).
first(n_verb,t_meisi_tsuki).
first(n_verb,t_meisi_youbi).
first(n_verb,t_meisi_zi).
first(n_verb,t_myoji_first).
first(n_verb,t_myoji_last).
first(n_verb,t_n_keisiki).
first(n_verb,t_namae_first).
first(n_verb,t_namae_last).
first(n_verb,t_num_bouyomi).
first(n_verb,t_num_byaku).
first(n_verb,t_num_byaq).
first(n_verb,t_num_go).
first(n_verb,t_num_hachi).
first(n_verb,t_num_haq).
first(n_verb,t_num_hito).
first(n_verb,t_num_huta).
first(n_verb,t_num_hutsu).
first(n_verb,t_num_hyaku).
first(n_verb,t_num_hyaq).
first(n_verb,t_num_ichi).
first(n_verb,t_num_iq).
first(n_verb,t_num_itsu).
first(n_verb,t_num_kokono).
first(n_verb,t_num_ku).
first(n_verb,t_num_kyuu).
first(n_verb,t_num_miq).
first(n_verb,t_num_mui).
first(n_verb,t_num_muq).
first(n_verb,t_num_nana).
first(n_verb,t_num_nano).
first(n_verb,t_num_ni).
first(n_verb,t_num_one).
first(n_verb,t_num_pyaku).
first(n_verb,t_num_pyaq).
first(n_verb,t_num_roku).
first(n_verb,t_num_roq).
first(n_verb,t_num_san).
first(n_verb,t_num_sen).
first(n_verb,t_num_shi).
first(n_verb,t_num_shichi).
first(n_verb,t_num_ten).
first(n_verb,t_num_tou).
first(n_verb,t_num_yaq).
first(n_verb,t_num_yo).
first(n_verb,t_num_yon).
first(n_verb,t_num_yoq).
first(n_verb,t_num_you).
first(n_verb,t_num_zen).
first(n_verb,t_num_zyuq).
first(n_verb,t_num_zyuu).
first(n_verb,t_prefix_go).
first(n_verb,t_prefix_hutu_hutu).
first(n_verb,t_prefix_o).
first(n_verb,t_prefix_quant_quant).
first(n_verb,t_rentai).
first(n_verb,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb,t_sahen_meisi_2FH_ga).
first(n_verb,t_sahen_meisi_2FH_ga_ni).
first(n_verb,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb,t_sahen_meisi_2FH_ga_o).
first(n_verb,t_sahen_meisi_2FH_ga_to).
first(n_verb,t_sahen_meisi_pol_2FH_ga).
first(n_verb,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb,t_suuryousi).
first(n_verb,t_teido_hukusi).
first(n_verb,t_tsuzuri).
first(n_verb,t_vstem_1_2FH_ga).
first(n_verb,t_vstem_1_2FH_ga_de).
first(n_verb,t_vstem_1_2FH_ga_ni).
first(n_verb,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb,t_vstem_1_2FH_ga_ni_o).
first(n_verb,t_vstem_1_2FH_ga_o).
first(n_verb,t_vstem_1_2FH_ga_quote).
first(n_verb,t_vstem_1_2FH_ga_to).
first(n_verb,t_vstem_5_b_2FH_ga).
first(n_verb,t_vstem_5_b_2FH_ga_ni).
first(n_verb,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb,t_vstem_5_b_2FH_ga_o).
first(n_verb,t_vstem_5_b_2FH_ga_to).
first(n_verb,t_vstem_5_g_2FH_ga).
first(n_verb,t_vstem_5_g_2FH_ga_ni).
first(n_verb,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb,t_vstem_5_g_2FH_ga_o).
first(n_verb,t_vstem_5_k_2FH_ga).
first(n_verb,t_vstem_5_k_2FH_ga_ni).
first(n_verb,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb,t_vstem_5_k_2FH_ga_o).
first(n_verb,t_vstem_5_k_2FH_ga_to).
first(n_verb,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb,t_vstem_5_m_2FH_ga).
first(n_verb,t_vstem_5_m_2FH_ga_ni).
first(n_verb,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb,t_vstem_5_m_2FH_ga_o).
first(n_verb,t_vstem_5_m_2FH_ga_to).
first(n_verb,t_vstem_5_r_2FH_ga).
first(n_verb,t_vstem_5_r_2FH_ga_ni).
first(n_verb,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb,t_vstem_5_r_2FH_ga_o).
first(n_verb,t_vstem_5_r_2FH_ga_to).
first(n_verb,t_vstem_5_r_i_2FH_ga).
first(n_verb,t_vstem_5_r_i_2FH_ga_o).
first(n_verb,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb,t_vstem_5_s_2FH_ga).
first(n_verb,t_vstem_5_s_2FH_ga_ni).
first(n_verb,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb,t_vstem_5_s_2FH_ga_o).
first(n_verb,t_vstem_5_s_2FH_ga_quote).
first(n_verb,t_vstem_5_s_2FH_ga_to).
first(n_verb,t_vstem_5_t_2FH_ga).
first(n_verb,t_vstem_5_t_2FH_ga_ni).
first(n_verb,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb,t_vstem_5_t_2FH_ga_o).
first(n_verb,t_vstem_5_t_2FH_ga_to).
first(n_verb,t_vstem_5_w_2FH_ga).
first(n_verb,t_vstem_5_w_2FH_ga_de).
first(n_verb,t_vstem_5_w_2FH_ga_ni).
first(n_verb,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb,t_vstem_5_w_2FH_ga_o).
first(n_verb,t_vstem_5_w_2FH_ga_quote).
first(n_verb,t_vstem_5_w_2FH_ga_to).
first(n_verb,t_vstem_masu_2FH_ga).
first(n_verb,t_vstem_sahen_2FH_ga_ni).
first(n_verb,t_wh_daimeisi).
first(n_verb,t_wh_daimeisi_nan).
first(n_verb,t_wh_hukusi).
first(n_verb,t_zikan_meisi).
first(n_verb,t_zikan_meisi_ippai).
first(n_verb,t_zikantai).
first(n_verb_2FH_,n_capacity).
first(n_verb_2FH_,n_visitor_name).
first(n_verb_2FH_,t_adj_meisi).
first(n_verb_2FH_,t_adj_renyo_2FH_ga).
first(n_verb_2FH_,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_,t_adjstem_2FH_ga).
first(n_verb_2FH_,t_adjstem_2FH_ga_de).
first(n_verb_2FH_,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_,t_daimeisi).
first(n_verb_2FH_,t_daimeisi_domo).
first(n_verb_2FH_,t_daimeisi_exp).
first(n_verb_2FH_,t_hukusi).
first(n_verb_2FH_,t_hukusi_desu).
first(n_verb_2FH_,t_hutu_meisi).
first(n_verb_2FH_,t_hutu_meisi_post).
first(n_verb_2FH_,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_,t_kdo_2FH_ga).
first(n_verb_2FH_,t_kdo_2FH_ga_de).
first(n_verb_2FH_,t_kdo_2FH_ga_to).
first(n_verb_2FH_,t_koyuu_meisi).
first(n_verb_2FH_,t_meisi_hi).
first(n_verb_2FH_,t_meisi_hun).
first(n_verb_2FH_,t_meisi_tsuki).
first(n_verb_2FH_,t_meisi_youbi).
first(n_verb_2FH_,t_meisi_zi).
first(n_verb_2FH_,t_myoji_first).
first(n_verb_2FH_,t_myoji_last).
first(n_verb_2FH_,t_n_keisiki).
first(n_verb_2FH_,t_namae_first).
first(n_verb_2FH_,t_namae_last).
first(n_verb_2FH_,t_num_bouyomi).
first(n_verb_2FH_,t_num_byaku).
first(n_verb_2FH_,t_num_byaq).
first(n_verb_2FH_,t_num_go).
first(n_verb_2FH_,t_num_hachi).
first(n_verb_2FH_,t_num_haq).
first(n_verb_2FH_,t_num_hito).
first(n_verb_2FH_,t_num_huta).
first(n_verb_2FH_,t_num_hutsu).
first(n_verb_2FH_,t_num_hyaku).
first(n_verb_2FH_,t_num_hyaq).
first(n_verb_2FH_,t_num_ichi).
first(n_verb_2FH_,t_num_iq).
first(n_verb_2FH_,t_num_itsu).
first(n_verb_2FH_,t_num_kokono).
first(n_verb_2FH_,t_num_ku).
first(n_verb_2FH_,t_num_kyuu).
first(n_verb_2FH_,t_num_miq).
first(n_verb_2FH_,t_num_mui).
first(n_verb_2FH_,t_num_muq).
first(n_verb_2FH_,t_num_nana).
first(n_verb_2FH_,t_num_nano).
first(n_verb_2FH_,t_num_ni).
first(n_verb_2FH_,t_num_one).
first(n_verb_2FH_,t_num_pyaku).
first(n_verb_2FH_,t_num_pyaq).
first(n_verb_2FH_,t_num_roku).
first(n_verb_2FH_,t_num_roq).
first(n_verb_2FH_,t_num_san).
first(n_verb_2FH_,t_num_sen).
first(n_verb_2FH_,t_num_shi).
first(n_verb_2FH_,t_num_shichi).
first(n_verb_2FH_,t_num_ten).
first(n_verb_2FH_,t_num_tou).
first(n_verb_2FH_,t_num_yaq).
first(n_verb_2FH_,t_num_yo).
first(n_verb_2FH_,t_num_yon).
first(n_verb_2FH_,t_num_yoq).
first(n_verb_2FH_,t_num_you).
first(n_verb_2FH_,t_num_zen).
first(n_verb_2FH_,t_num_zyuq).
first(n_verb_2FH_,t_num_zyuu).
first(n_verb_2FH_,t_prefix_go).
first(n_verb_2FH_,t_prefix_hutu_hutu).
first(n_verb_2FH_,t_prefix_o).
first(n_verb_2FH_,t_prefix_quant_quant).
first(n_verb_2FH_,t_rentai).
first(n_verb_2FH_,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_,t_suuryousi).
first(n_verb_2FH_,t_teido_hukusi).
first(n_verb_2FH_,t_tsuzuri).
first(n_verb_2FH_,t_vstem_1_2FH_ga).
first(n_verb_2FH_,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_,t_vstem_masu_2FH_ga).
first(n_verb_2FH_,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_,t_wh_daimeisi).
first(n_verb_2FH_,t_wh_daimeisi_nan).
first(n_verb_2FH_,t_wh_hukusi).
first(n_verb_2FH_,t_zikan_meisi).
first(n_verb_2FH_,t_zikan_meisi_ippai).
first(n_verb_2FH_,t_zikantai).
first(n_verb_2FH_de,n_capacity).
first(n_verb_2FH_de,n_visitor_name).
first(n_verb_2FH_de,t_adj_meisi).
first(n_verb_2FH_de,t_adj_renyo_2FH_ga).
first(n_verb_2FH_de,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_de,t_adjstem_2FH_ga).
first(n_verb_2FH_de,t_adjstem_2FH_ga_de).
first(n_verb_2FH_de,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_de,t_daimeisi).
first(n_verb_2FH_de,t_daimeisi_domo).
first(n_verb_2FH_de,t_daimeisi_exp).
first(n_verb_2FH_de,t_hukusi).
first(n_verb_2FH_de,t_hukusi_desu).
first(n_verb_2FH_de,t_hutu_meisi).
first(n_verb_2FH_de,t_hutu_meisi_post).
first(n_verb_2FH_de,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_de,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_de,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_de,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_de,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_de,t_kdo_2FH_ga).
first(n_verb_2FH_de,t_kdo_2FH_ga_de).
first(n_verb_2FH_de,t_kdo_2FH_ga_to).
first(n_verb_2FH_de,t_koyuu_meisi).
first(n_verb_2FH_de,t_meisi_hi).
first(n_verb_2FH_de,t_meisi_hun).
first(n_verb_2FH_de,t_meisi_tsuki).
first(n_verb_2FH_de,t_meisi_youbi).
first(n_verb_2FH_de,t_meisi_zi).
first(n_verb_2FH_de,t_myoji_first).
first(n_verb_2FH_de,t_myoji_last).
first(n_verb_2FH_de,t_n_keisiki).
first(n_verb_2FH_de,t_namae_first).
first(n_verb_2FH_de,t_namae_last).
first(n_verb_2FH_de,t_num_bouyomi).
first(n_verb_2FH_de,t_num_byaku).
first(n_verb_2FH_de,t_num_byaq).
first(n_verb_2FH_de,t_num_go).
first(n_verb_2FH_de,t_num_hachi).
first(n_verb_2FH_de,t_num_haq).
first(n_verb_2FH_de,t_num_hito).
first(n_verb_2FH_de,t_num_huta).
first(n_verb_2FH_de,t_num_hutsu).
first(n_verb_2FH_de,t_num_hyaku).
first(n_verb_2FH_de,t_num_hyaq).
first(n_verb_2FH_de,t_num_ichi).
first(n_verb_2FH_de,t_num_iq).
first(n_verb_2FH_de,t_num_itsu).
first(n_verb_2FH_de,t_num_kokono).
first(n_verb_2FH_de,t_num_ku).
first(n_verb_2FH_de,t_num_kyuu).
first(n_verb_2FH_de,t_num_miq).
first(n_verb_2FH_de,t_num_mui).
first(n_verb_2FH_de,t_num_muq).
first(n_verb_2FH_de,t_num_nana).
first(n_verb_2FH_de,t_num_nano).
first(n_verb_2FH_de,t_num_ni).
first(n_verb_2FH_de,t_num_one).
first(n_verb_2FH_de,t_num_pyaku).
first(n_verb_2FH_de,t_num_pyaq).
first(n_verb_2FH_de,t_num_roku).
first(n_verb_2FH_de,t_num_roq).
first(n_verb_2FH_de,t_num_san).
first(n_verb_2FH_de,t_num_sen).
first(n_verb_2FH_de,t_num_shi).
first(n_verb_2FH_de,t_num_shichi).
first(n_verb_2FH_de,t_num_ten).
first(n_verb_2FH_de,t_num_tou).
first(n_verb_2FH_de,t_num_yaq).
first(n_verb_2FH_de,t_num_yo).
first(n_verb_2FH_de,t_num_yon).
first(n_verb_2FH_de,t_num_yoq).
first(n_verb_2FH_de,t_num_you).
first(n_verb_2FH_de,t_num_zen).
first(n_verb_2FH_de,t_num_zyuq).
first(n_verb_2FH_de,t_num_zyuu).
first(n_verb_2FH_de,t_prefix_go).
first(n_verb_2FH_de,t_prefix_hutu_hutu).
first(n_verb_2FH_de,t_prefix_o).
first(n_verb_2FH_de,t_prefix_quant_quant).
first(n_verb_2FH_de,t_rentai).
first(n_verb_2FH_de,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_de,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_de,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_de,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_de,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_de,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_de,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_de,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_de,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_de,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_de,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_de,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_de,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_de,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_de,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_de,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_de,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_de,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_de,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_de,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_de,t_suuryousi).
first(n_verb_2FH_de,t_teido_hukusi).
first(n_verb_2FH_de,t_tsuzuri).
first(n_verb_2FH_de,t_vstem_1_2FH_ga).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_de,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_de,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_de,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_de,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_de,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_de,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_de,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_de,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_de,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_de,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_de,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_de,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_de,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_de,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_de,t_vstem_masu_2FH_ga).
first(n_verb_2FH_de,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_de,t_wh_daimeisi).
first(n_verb_2FH_de,t_wh_daimeisi_nan).
first(n_verb_2FH_de,t_wh_hukusi).
first(n_verb_2FH_de,t_zikan_meisi).
first(n_verb_2FH_de,t_zikan_meisi_ippai).
first(n_verb_2FH_de,t_zikantai).
first(n_verb_2FH_ga,n_capacity).
first(n_verb_2FH_ga,n_visitor_name).
first(n_verb_2FH_ga,t_adj_meisi).
first(n_verb_2FH_ga,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga,t_adjstem_2FH_ga).
first(n_verb_2FH_ga,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga,t_daimeisi).
first(n_verb_2FH_ga,t_daimeisi_domo).
first(n_verb_2FH_ga,t_daimeisi_exp).
first(n_verb_2FH_ga,t_hukusi).
first(n_verb_2FH_ga,t_hukusi_desu).
first(n_verb_2FH_ga,t_hutu_meisi).
first(n_verb_2FH_ga,t_hutu_meisi_post).
first(n_verb_2FH_ga,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga,t_kdo_2FH_ga).
first(n_verb_2FH_ga,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga,t_koyuu_meisi).
first(n_verb_2FH_ga,t_meisi_hi).
first(n_verb_2FH_ga,t_meisi_hun).
first(n_verb_2FH_ga,t_meisi_tsuki).
first(n_verb_2FH_ga,t_meisi_youbi).
first(n_verb_2FH_ga,t_meisi_zi).
first(n_verb_2FH_ga,t_myoji_first).
first(n_verb_2FH_ga,t_myoji_last).
first(n_verb_2FH_ga,t_n_keisiki).
first(n_verb_2FH_ga,t_namae_first).
first(n_verb_2FH_ga,t_namae_last).
first(n_verb_2FH_ga,t_num_bouyomi).
first(n_verb_2FH_ga,t_num_byaku).
first(n_verb_2FH_ga,t_num_byaq).
first(n_verb_2FH_ga,t_num_go).
first(n_verb_2FH_ga,t_num_hachi).
first(n_verb_2FH_ga,t_num_haq).
first(n_verb_2FH_ga,t_num_hito).
first(n_verb_2FH_ga,t_num_huta).
first(n_verb_2FH_ga,t_num_hutsu).
first(n_verb_2FH_ga,t_num_hyaku).
first(n_verb_2FH_ga,t_num_hyaq).
first(n_verb_2FH_ga,t_num_ichi).
first(n_verb_2FH_ga,t_num_iq).
first(n_verb_2FH_ga,t_num_itsu).
first(n_verb_2FH_ga,t_num_kokono).
first(n_verb_2FH_ga,t_num_ku).
first(n_verb_2FH_ga,t_num_kyuu).
first(n_verb_2FH_ga,t_num_miq).
first(n_verb_2FH_ga,t_num_mui).
first(n_verb_2FH_ga,t_num_muq).
first(n_verb_2FH_ga,t_num_nana).
first(n_verb_2FH_ga,t_num_nano).
first(n_verb_2FH_ga,t_num_ni).
first(n_verb_2FH_ga,t_num_one).
first(n_verb_2FH_ga,t_num_pyaku).
first(n_verb_2FH_ga,t_num_pyaq).
first(n_verb_2FH_ga,t_num_roku).
first(n_verb_2FH_ga,t_num_roq).
first(n_verb_2FH_ga,t_num_san).
first(n_verb_2FH_ga,t_num_sen).
first(n_verb_2FH_ga,t_num_shi).
first(n_verb_2FH_ga,t_num_shichi).
first(n_verb_2FH_ga,t_num_ten).
first(n_verb_2FH_ga,t_num_tou).
first(n_verb_2FH_ga,t_num_yaq).
first(n_verb_2FH_ga,t_num_yo).
first(n_verb_2FH_ga,t_num_yon).
first(n_verb_2FH_ga,t_num_yoq).
first(n_verb_2FH_ga,t_num_you).
first(n_verb_2FH_ga,t_num_zen).
first(n_verb_2FH_ga,t_num_zyuq).
first(n_verb_2FH_ga,t_num_zyuu).
first(n_verb_2FH_ga,t_prefix_go).
first(n_verb_2FH_ga,t_prefix_hutu_hutu).
first(n_verb_2FH_ga,t_prefix_o).
first(n_verb_2FH_ga,t_prefix_quant_quant).
first(n_verb_2FH_ga,t_rentai).
first(n_verb_2FH_ga,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga,t_suuryousi).
first(n_verb_2FH_ga,t_teido_hukusi).
first(n_verb_2FH_ga,t_tsuzuri).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga,t_wh_daimeisi).
first(n_verb_2FH_ga,t_wh_daimeisi_nan).
first(n_verb_2FH_ga,t_wh_hukusi).
first(n_verb_2FH_ga,t_zikan_meisi).
first(n_verb_2FH_ga,t_zikan_meisi_ippai).
first(n_verb_2FH_ga,t_zikantai).
first(n_verb_2FH_ga_de,n_capacity).
first(n_verb_2FH_ga_de,n_visitor_name).
first(n_verb_2FH_ga_de,t_adj_meisi).
first(n_verb_2FH_ga_de,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_de,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_de,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_de,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_de,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_de,t_daimeisi).
first(n_verb_2FH_ga_de,t_daimeisi_domo).
first(n_verb_2FH_ga_de,t_daimeisi_exp).
first(n_verb_2FH_ga_de,t_hukusi).
first(n_verb_2FH_ga_de,t_hukusi_desu).
first(n_verb_2FH_ga_de,t_hutu_meisi).
first(n_verb_2FH_ga_de,t_hutu_meisi_post).
first(n_verb_2FH_ga_de,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_kdo_2FH_ga).
first(n_verb_2FH_ga_de,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_de,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_de,t_koyuu_meisi).
first(n_verb_2FH_ga_de,t_meisi_hi).
first(n_verb_2FH_ga_de,t_meisi_hun).
first(n_verb_2FH_ga_de,t_meisi_tsuki).
first(n_verb_2FH_ga_de,t_meisi_youbi).
first(n_verb_2FH_ga_de,t_meisi_zi).
first(n_verb_2FH_ga_de,t_myoji_first).
first(n_verb_2FH_ga_de,t_myoji_last).
first(n_verb_2FH_ga_de,t_n_keisiki).
first(n_verb_2FH_ga_de,t_namae_first).
first(n_verb_2FH_ga_de,t_namae_last).
first(n_verb_2FH_ga_de,t_num_bouyomi).
first(n_verb_2FH_ga_de,t_num_byaku).
first(n_verb_2FH_ga_de,t_num_byaq).
first(n_verb_2FH_ga_de,t_num_go).
first(n_verb_2FH_ga_de,t_num_hachi).
first(n_verb_2FH_ga_de,t_num_haq).
first(n_verb_2FH_ga_de,t_num_hito).
first(n_verb_2FH_ga_de,t_num_huta).
first(n_verb_2FH_ga_de,t_num_hutsu).
first(n_verb_2FH_ga_de,t_num_hyaku).
first(n_verb_2FH_ga_de,t_num_hyaq).
first(n_verb_2FH_ga_de,t_num_ichi).
first(n_verb_2FH_ga_de,t_num_iq).
first(n_verb_2FH_ga_de,t_num_itsu).
first(n_verb_2FH_ga_de,t_num_kokono).
first(n_verb_2FH_ga_de,t_num_ku).
first(n_verb_2FH_ga_de,t_num_kyuu).
first(n_verb_2FH_ga_de,t_num_miq).
first(n_verb_2FH_ga_de,t_num_mui).
first(n_verb_2FH_ga_de,t_num_muq).
first(n_verb_2FH_ga_de,t_num_nana).
first(n_verb_2FH_ga_de,t_num_nano).
first(n_verb_2FH_ga_de,t_num_ni).
first(n_verb_2FH_ga_de,t_num_one).
first(n_verb_2FH_ga_de,t_num_pyaku).
first(n_verb_2FH_ga_de,t_num_pyaq).
first(n_verb_2FH_ga_de,t_num_roku).
first(n_verb_2FH_ga_de,t_num_roq).
first(n_verb_2FH_ga_de,t_num_san).
first(n_verb_2FH_ga_de,t_num_sen).
first(n_verb_2FH_ga_de,t_num_shi).
first(n_verb_2FH_ga_de,t_num_shichi).
first(n_verb_2FH_ga_de,t_num_ten).
first(n_verb_2FH_ga_de,t_num_tou).
first(n_verb_2FH_ga_de,t_num_yaq).
first(n_verb_2FH_ga_de,t_num_yo).
first(n_verb_2FH_ga_de,t_num_yon).
first(n_verb_2FH_ga_de,t_num_yoq).
first(n_verb_2FH_ga_de,t_num_you).
first(n_verb_2FH_ga_de,t_num_zen).
first(n_verb_2FH_ga_de,t_num_zyuq).
first(n_verb_2FH_ga_de,t_num_zyuu).
first(n_verb_2FH_ga_de,t_prefix_go).
first(n_verb_2FH_ga_de,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_de,t_prefix_o).
first(n_verb_2FH_ga_de,t_prefix_quant_quant).
first(n_verb_2FH_ga_de,t_rentai).
first(n_verb_2FH_ga_de,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_de,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_de,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_de,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_de,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_de,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_de,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_de,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_de,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_de,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_de,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_de,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_de,t_suuryousi).
first(n_verb_2FH_ga_de,t_teido_hukusi).
first(n_verb_2FH_ga_de,t_tsuzuri).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_de,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_de,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_de,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_de,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_de,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_de,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_de,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_de,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_de,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_de,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_de,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_de,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_de,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_de,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_de,t_wh_daimeisi).
first(n_verb_2FH_ga_de,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_de,t_wh_hukusi).
first(n_verb_2FH_ga_de,t_zikan_meisi).
first(n_verb_2FH_ga_de,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_de,t_zikantai).
first(n_verb_2FH_ga_ni,n_capacity).
first(n_verb_2FH_ga_ni,n_visitor_name).
first(n_verb_2FH_ga_ni,t_adj_meisi).
first(n_verb_2FH_ga_ni,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_ni,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_ni,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_ni,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_ni,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_ni,t_daimeisi).
first(n_verb_2FH_ga_ni,t_daimeisi_domo).
first(n_verb_2FH_ga_ni,t_daimeisi_exp).
first(n_verb_2FH_ga_ni,t_hukusi).
first(n_verb_2FH_ga_ni,t_hukusi_desu).
first(n_verb_2FH_ga_ni,t_hutu_meisi).
first(n_verb_2FH_ga_ni,t_hutu_meisi_post).
first(n_verb_2FH_ga_ni,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_kdo_2FH_ga).
first(n_verb_2FH_ga_ni,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_ni,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_koyuu_meisi).
first(n_verb_2FH_ga_ni,t_meisi_hi).
first(n_verb_2FH_ga_ni,t_meisi_hun).
first(n_verb_2FH_ga_ni,t_meisi_tsuki).
first(n_verb_2FH_ga_ni,t_meisi_youbi).
first(n_verb_2FH_ga_ni,t_meisi_zi).
first(n_verb_2FH_ga_ni,t_myoji_first).
first(n_verb_2FH_ga_ni,t_myoji_last).
first(n_verb_2FH_ga_ni,t_n_keisiki).
first(n_verb_2FH_ga_ni,t_namae_first).
first(n_verb_2FH_ga_ni,t_namae_last).
first(n_verb_2FH_ga_ni,t_num_bouyomi).
first(n_verb_2FH_ga_ni,t_num_byaku).
first(n_verb_2FH_ga_ni,t_num_byaq).
first(n_verb_2FH_ga_ni,t_num_go).
first(n_verb_2FH_ga_ni,t_num_hachi).
first(n_verb_2FH_ga_ni,t_num_haq).
first(n_verb_2FH_ga_ni,t_num_hito).
first(n_verb_2FH_ga_ni,t_num_huta).
first(n_verb_2FH_ga_ni,t_num_hutsu).
first(n_verb_2FH_ga_ni,t_num_hyaku).
first(n_verb_2FH_ga_ni,t_num_hyaq).
first(n_verb_2FH_ga_ni,t_num_ichi).
first(n_verb_2FH_ga_ni,t_num_iq).
first(n_verb_2FH_ga_ni,t_num_itsu).
first(n_verb_2FH_ga_ni,t_num_kokono).
first(n_verb_2FH_ga_ni,t_num_ku).
first(n_verb_2FH_ga_ni,t_num_kyuu).
first(n_verb_2FH_ga_ni,t_num_miq).
first(n_verb_2FH_ga_ni,t_num_mui).
first(n_verb_2FH_ga_ni,t_num_muq).
first(n_verb_2FH_ga_ni,t_num_nana).
first(n_verb_2FH_ga_ni,t_num_nano).
first(n_verb_2FH_ga_ni,t_num_ni).
first(n_verb_2FH_ga_ni,t_num_one).
first(n_verb_2FH_ga_ni,t_num_pyaku).
first(n_verb_2FH_ga_ni,t_num_pyaq).
first(n_verb_2FH_ga_ni,t_num_roku).
first(n_verb_2FH_ga_ni,t_num_roq).
first(n_verb_2FH_ga_ni,t_num_san).
first(n_verb_2FH_ga_ni,t_num_sen).
first(n_verb_2FH_ga_ni,t_num_shi).
first(n_verb_2FH_ga_ni,t_num_shichi).
first(n_verb_2FH_ga_ni,t_num_ten).
first(n_verb_2FH_ga_ni,t_num_tou).
first(n_verb_2FH_ga_ni,t_num_yaq).
first(n_verb_2FH_ga_ni,t_num_yo).
first(n_verb_2FH_ga_ni,t_num_yon).
first(n_verb_2FH_ga_ni,t_num_yoq).
first(n_verb_2FH_ga_ni,t_num_you).
first(n_verb_2FH_ga_ni,t_num_zen).
first(n_verb_2FH_ga_ni,t_num_zyuq).
first(n_verb_2FH_ga_ni,t_num_zyuu).
first(n_verb_2FH_ga_ni,t_prefix_go).
first(n_verb_2FH_ga_ni,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_ni,t_prefix_o).
first(n_verb_2FH_ga_ni,t_prefix_quant_quant).
first(n_verb_2FH_ga_ni,t_rentai).
first(n_verb_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_suuryousi).
first(n_verb_2FH_ga_ni,t_teido_hukusi).
first(n_verb_2FH_ga_ni,t_tsuzuri).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_ni,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_ni,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_ni,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_ni,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_ni,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_ni,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_ni,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_ni,t_wh_daimeisi).
first(n_verb_2FH_ga_ni,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_ni,t_wh_hukusi).
first(n_verb_2FH_ga_ni,t_zikan_meisi).
first(n_verb_2FH_ga_ni,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_ni,t_zikantai).
first(n_verb_2FH_ga_ni_5EH_e,n_capacity).
first(n_verb_2FH_ga_ni_5EH_e,n_visitor_name).
first(n_verb_2FH_ga_ni_5EH_e,t_adj_meisi).
first(n_verb_2FH_ga_ni_5EH_e,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e,t_daimeisi).
first(n_verb_2FH_ga_ni_5EH_e,t_daimeisi_domo).
first(n_verb_2FH_ga_ni_5EH_e,t_daimeisi_exp).
first(n_verb_2FH_ga_ni_5EH_e,t_hukusi).
first(n_verb_2FH_ga_ni_5EH_e,t_hukusi_desu).
first(n_verb_2FH_ga_ni_5EH_e,t_hutu_meisi).
first(n_verb_2FH_ga_ni_5EH_e,t_hutu_meisi_post).
first(n_verb_2FH_ga_ni_5EH_e,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_kdo_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_koyuu_meisi).
first(n_verb_2FH_ga_ni_5EH_e,t_meisi_hi).
first(n_verb_2FH_ga_ni_5EH_e,t_meisi_hun).
first(n_verb_2FH_ga_ni_5EH_e,t_meisi_tsuki).
first(n_verb_2FH_ga_ni_5EH_e,t_meisi_youbi).
first(n_verb_2FH_ga_ni_5EH_e,t_meisi_zi).
first(n_verb_2FH_ga_ni_5EH_e,t_myoji_first).
first(n_verb_2FH_ga_ni_5EH_e,t_myoji_last).
first(n_verb_2FH_ga_ni_5EH_e,t_n_keisiki).
first(n_verb_2FH_ga_ni_5EH_e,t_namae_first).
first(n_verb_2FH_ga_ni_5EH_e,t_namae_last).
first(n_verb_2FH_ga_ni_5EH_e,t_num_bouyomi).
first(n_verb_2FH_ga_ni_5EH_e,t_num_byaku).
first(n_verb_2FH_ga_ni_5EH_e,t_num_byaq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_go).
first(n_verb_2FH_ga_ni_5EH_e,t_num_hachi).
first(n_verb_2FH_ga_ni_5EH_e,t_num_haq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_hito).
first(n_verb_2FH_ga_ni_5EH_e,t_num_huta).
first(n_verb_2FH_ga_ni_5EH_e,t_num_hutsu).
first(n_verb_2FH_ga_ni_5EH_e,t_num_hyaku).
first(n_verb_2FH_ga_ni_5EH_e,t_num_hyaq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_ichi).
first(n_verb_2FH_ga_ni_5EH_e,t_num_iq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_itsu).
first(n_verb_2FH_ga_ni_5EH_e,t_num_kokono).
first(n_verb_2FH_ga_ni_5EH_e,t_num_ku).
first(n_verb_2FH_ga_ni_5EH_e,t_num_kyuu).
first(n_verb_2FH_ga_ni_5EH_e,t_num_miq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_mui).
first(n_verb_2FH_ga_ni_5EH_e,t_num_muq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_nana).
first(n_verb_2FH_ga_ni_5EH_e,t_num_nano).
first(n_verb_2FH_ga_ni_5EH_e,t_num_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_num_one).
first(n_verb_2FH_ga_ni_5EH_e,t_num_pyaku).
first(n_verb_2FH_ga_ni_5EH_e,t_num_pyaq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_roku).
first(n_verb_2FH_ga_ni_5EH_e,t_num_roq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_san).
first(n_verb_2FH_ga_ni_5EH_e,t_num_sen).
first(n_verb_2FH_ga_ni_5EH_e,t_num_shi).
first(n_verb_2FH_ga_ni_5EH_e,t_num_shichi).
first(n_verb_2FH_ga_ni_5EH_e,t_num_ten).
first(n_verb_2FH_ga_ni_5EH_e,t_num_tou).
first(n_verb_2FH_ga_ni_5EH_e,t_num_yaq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_yo).
first(n_verb_2FH_ga_ni_5EH_e,t_num_yon).
first(n_verb_2FH_ga_ni_5EH_e,t_num_yoq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_you).
first(n_verb_2FH_ga_ni_5EH_e,t_num_zen).
first(n_verb_2FH_ga_ni_5EH_e,t_num_zyuq).
first(n_verb_2FH_ga_ni_5EH_e,t_num_zyuu).
first(n_verb_2FH_ga_ni_5EH_e,t_prefix_go).
first(n_verb_2FH_ga_ni_5EH_e,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_ni_5EH_e,t_prefix_o).
first(n_verb_2FH_ga_ni_5EH_e,t_prefix_quant_quant).
first(n_verb_2FH_ga_ni_5EH_e,t_rentai).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_suuryousi).
first(n_verb_2FH_ga_ni_5EH_e,t_teido_hukusi).
first(n_verb_2FH_ga_ni_5EH_e,t_tsuzuri).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e,t_wh_daimeisi).
first(n_verb_2FH_ga_ni_5EH_e,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_ni_5EH_e,t_wh_hukusi).
first(n_verb_2FH_ga_ni_5EH_e,t_zikan_meisi).
first(n_verb_2FH_ga_ni_5EH_e,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_ni_5EH_e,t_zikantai).
first(n_verb_2FH_ga_ni_5EH_e_o,n_capacity).
first(n_verb_2FH_ga_ni_5EH_e_o,n_visitor_name).
first(n_verb_2FH_ga_ni_5EH_e_o,t_adj_meisi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e_o,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e_o,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e_o,t_daimeisi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_daimeisi_domo).
first(n_verb_2FH_ga_ni_5EH_e_o,t_daimeisi_exp).
first(n_verb_2FH_ga_ni_5EH_e_o,t_hukusi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_hukusi_desu).
first(n_verb_2FH_ga_ni_5EH_e_o,t_hutu_meisi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_hutu_meisi_post).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kdo_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e_o,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_koyuu_meisi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_meisi_hi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_meisi_hun).
first(n_verb_2FH_ga_ni_5EH_e_o,t_meisi_tsuki).
first(n_verb_2FH_ga_ni_5EH_e_o,t_meisi_youbi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_meisi_zi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_myoji_first).
first(n_verb_2FH_ga_ni_5EH_e_o,t_myoji_last).
first(n_verb_2FH_ga_ni_5EH_e_o,t_n_keisiki).
first(n_verb_2FH_ga_ni_5EH_e_o,t_namae_first).
first(n_verb_2FH_ga_ni_5EH_e_o,t_namae_last).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_bouyomi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_byaku).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_byaq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_go).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_hachi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_haq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_hito).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_huta).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_hutsu).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_hyaku).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_hyaq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_ichi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_iq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_itsu).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_kokono).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_ku).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_kyuu).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_miq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_mui).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_muq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_nana).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_nano).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_one).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_pyaku).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_pyaq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_roku).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_roq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_san).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_sen).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_shi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_shichi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_ten).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_tou).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_yaq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_yo).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_yon).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_yoq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_you).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_zen).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_zyuq).
first(n_verb_2FH_ga_ni_5EH_e_o,t_num_zyuu).
first(n_verb_2FH_ga_ni_5EH_e_o,t_prefix_go).
first(n_verb_2FH_ga_ni_5EH_e_o,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_ni_5EH_e_o,t_prefix_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_prefix_quant_quant).
first(n_verb_2FH_ga_ni_5EH_e_o,t_rentai).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_suuryousi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_teido_hukusi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_tsuzuri).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_e_o,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_e_o,t_wh_daimeisi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_ni_5EH_e_o,t_wh_hukusi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_zikan_meisi).
first(n_verb_2FH_ga_ni_5EH_e_o,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_ni_5EH_e_o,t_zikantai).
first(n_verb_2FH_ga_ni_5EH_to,n_capacity).
first(n_verb_2FH_ga_ni_5EH_to,n_visitor_name).
first(n_verb_2FH_ga_ni_5EH_to,t_adj_meisi).
first(n_verb_2FH_ga_ni_5EH_to,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_to,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_to,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_to,t_daimeisi).
first(n_verb_2FH_ga_ni_5EH_to,t_daimeisi_domo).
first(n_verb_2FH_ga_ni_5EH_to,t_daimeisi_exp).
first(n_verb_2FH_ga_ni_5EH_to,t_hukusi).
first(n_verb_2FH_ga_ni_5EH_to,t_hukusi_desu).
first(n_verb_2FH_ga_ni_5EH_to,t_hutu_meisi).
first(n_verb_2FH_ga_ni_5EH_to,t_hutu_meisi_post).
first(n_verb_2FH_ga_ni_5EH_to,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_kdo_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_to,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_koyuu_meisi).
first(n_verb_2FH_ga_ni_5EH_to,t_meisi_hi).
first(n_verb_2FH_ga_ni_5EH_to,t_meisi_hun).
first(n_verb_2FH_ga_ni_5EH_to,t_meisi_tsuki).
first(n_verb_2FH_ga_ni_5EH_to,t_meisi_youbi).
first(n_verb_2FH_ga_ni_5EH_to,t_meisi_zi).
first(n_verb_2FH_ga_ni_5EH_to,t_myoji_first).
first(n_verb_2FH_ga_ni_5EH_to,t_myoji_last).
first(n_verb_2FH_ga_ni_5EH_to,t_n_keisiki).
first(n_verb_2FH_ga_ni_5EH_to,t_namae_first).
first(n_verb_2FH_ga_ni_5EH_to,t_namae_last).
first(n_verb_2FH_ga_ni_5EH_to,t_num_bouyomi).
first(n_verb_2FH_ga_ni_5EH_to,t_num_byaku).
first(n_verb_2FH_ga_ni_5EH_to,t_num_byaq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_go).
first(n_verb_2FH_ga_ni_5EH_to,t_num_hachi).
first(n_verb_2FH_ga_ni_5EH_to,t_num_haq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_hito).
first(n_verb_2FH_ga_ni_5EH_to,t_num_huta).
first(n_verb_2FH_ga_ni_5EH_to,t_num_hutsu).
first(n_verb_2FH_ga_ni_5EH_to,t_num_hyaku).
first(n_verb_2FH_ga_ni_5EH_to,t_num_hyaq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_ichi).
first(n_verb_2FH_ga_ni_5EH_to,t_num_iq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_itsu).
first(n_verb_2FH_ga_ni_5EH_to,t_num_kokono).
first(n_verb_2FH_ga_ni_5EH_to,t_num_ku).
first(n_verb_2FH_ga_ni_5EH_to,t_num_kyuu).
first(n_verb_2FH_ga_ni_5EH_to,t_num_miq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_mui).
first(n_verb_2FH_ga_ni_5EH_to,t_num_muq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_nana).
first(n_verb_2FH_ga_ni_5EH_to,t_num_nano).
first(n_verb_2FH_ga_ni_5EH_to,t_num_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_num_one).
first(n_verb_2FH_ga_ni_5EH_to,t_num_pyaku).
first(n_verb_2FH_ga_ni_5EH_to,t_num_pyaq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_roku).
first(n_verb_2FH_ga_ni_5EH_to,t_num_roq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_san).
first(n_verb_2FH_ga_ni_5EH_to,t_num_sen).
first(n_verb_2FH_ga_ni_5EH_to,t_num_shi).
first(n_verb_2FH_ga_ni_5EH_to,t_num_shichi).
first(n_verb_2FH_ga_ni_5EH_to,t_num_ten).
first(n_verb_2FH_ga_ni_5EH_to,t_num_tou).
first(n_verb_2FH_ga_ni_5EH_to,t_num_yaq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_yo).
first(n_verb_2FH_ga_ni_5EH_to,t_num_yon).
first(n_verb_2FH_ga_ni_5EH_to,t_num_yoq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_you).
first(n_verb_2FH_ga_ni_5EH_to,t_num_zen).
first(n_verb_2FH_ga_ni_5EH_to,t_num_zyuq).
first(n_verb_2FH_ga_ni_5EH_to,t_num_zyuu).
first(n_verb_2FH_ga_ni_5EH_to,t_prefix_go).
first(n_verb_2FH_ga_ni_5EH_to,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_ni_5EH_to,t_prefix_o).
first(n_verb_2FH_ga_ni_5EH_to,t_prefix_quant_quant).
first(n_verb_2FH_ga_ni_5EH_to,t_rentai).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_suuryousi).
first(n_verb_2FH_ga_ni_5EH_to,t_teido_hukusi).
first(n_verb_2FH_ga_ni_5EH_to,t_tsuzuri).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_ni_5EH_to,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_5EH_to,t_wh_daimeisi).
first(n_verb_2FH_ga_ni_5EH_to,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_ni_5EH_to,t_wh_hukusi).
first(n_verb_2FH_ga_ni_5EH_to,t_zikan_meisi).
first(n_verb_2FH_ga_ni_5EH_to,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_ni_5EH_to,t_zikantai).
first(n_verb_2FH_ga_ni_o,n_capacity).
first(n_verb_2FH_ga_ni_o,n_visitor_name).
first(n_verb_2FH_ga_ni_o,t_adj_meisi).
first(n_verb_2FH_ga_ni_o,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_ni_o,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_ni_o,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_ni_o,t_daimeisi).
first(n_verb_2FH_ga_ni_o,t_daimeisi_domo).
first(n_verb_2FH_ga_ni_o,t_daimeisi_exp).
first(n_verb_2FH_ga_ni_o,t_hukusi).
first(n_verb_2FH_ga_ni_o,t_hukusi_desu).
first(n_verb_2FH_ga_ni_o,t_hutu_meisi).
first(n_verb_2FH_ga_ni_o,t_hutu_meisi_post).
first(n_verb_2FH_ga_ni_o,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_kdo_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_ni_o,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_koyuu_meisi).
first(n_verb_2FH_ga_ni_o,t_meisi_hi).
first(n_verb_2FH_ga_ni_o,t_meisi_hun).
first(n_verb_2FH_ga_ni_o,t_meisi_tsuki).
first(n_verb_2FH_ga_ni_o,t_meisi_youbi).
first(n_verb_2FH_ga_ni_o,t_meisi_zi).
first(n_verb_2FH_ga_ni_o,t_myoji_first).
first(n_verb_2FH_ga_ni_o,t_myoji_last).
first(n_verb_2FH_ga_ni_o,t_n_keisiki).
first(n_verb_2FH_ga_ni_o,t_namae_first).
first(n_verb_2FH_ga_ni_o,t_namae_last).
first(n_verb_2FH_ga_ni_o,t_num_bouyomi).
first(n_verb_2FH_ga_ni_o,t_num_byaku).
first(n_verb_2FH_ga_ni_o,t_num_byaq).
first(n_verb_2FH_ga_ni_o,t_num_go).
first(n_verb_2FH_ga_ni_o,t_num_hachi).
first(n_verb_2FH_ga_ni_o,t_num_haq).
first(n_verb_2FH_ga_ni_o,t_num_hito).
first(n_verb_2FH_ga_ni_o,t_num_huta).
first(n_verb_2FH_ga_ni_o,t_num_hutsu).
first(n_verb_2FH_ga_ni_o,t_num_hyaku).
first(n_verb_2FH_ga_ni_o,t_num_hyaq).
first(n_verb_2FH_ga_ni_o,t_num_ichi).
first(n_verb_2FH_ga_ni_o,t_num_iq).
first(n_verb_2FH_ga_ni_o,t_num_itsu).
first(n_verb_2FH_ga_ni_o,t_num_kokono).
first(n_verb_2FH_ga_ni_o,t_num_ku).
first(n_verb_2FH_ga_ni_o,t_num_kyuu).
first(n_verb_2FH_ga_ni_o,t_num_miq).
first(n_verb_2FH_ga_ni_o,t_num_mui).
first(n_verb_2FH_ga_ni_o,t_num_muq).
first(n_verb_2FH_ga_ni_o,t_num_nana).
first(n_verb_2FH_ga_ni_o,t_num_nano).
first(n_verb_2FH_ga_ni_o,t_num_ni).
first(n_verb_2FH_ga_ni_o,t_num_one).
first(n_verb_2FH_ga_ni_o,t_num_pyaku).
first(n_verb_2FH_ga_ni_o,t_num_pyaq).
first(n_verb_2FH_ga_ni_o,t_num_roku).
first(n_verb_2FH_ga_ni_o,t_num_roq).
first(n_verb_2FH_ga_ni_o,t_num_san).
first(n_verb_2FH_ga_ni_o,t_num_sen).
first(n_verb_2FH_ga_ni_o,t_num_shi).
first(n_verb_2FH_ga_ni_o,t_num_shichi).
first(n_verb_2FH_ga_ni_o,t_num_ten).
first(n_verb_2FH_ga_ni_o,t_num_tou).
first(n_verb_2FH_ga_ni_o,t_num_yaq).
first(n_verb_2FH_ga_ni_o,t_num_yo).
first(n_verb_2FH_ga_ni_o,t_num_yon).
first(n_verb_2FH_ga_ni_o,t_num_yoq).
first(n_verb_2FH_ga_ni_o,t_num_you).
first(n_verb_2FH_ga_ni_o,t_num_zen).
first(n_verb_2FH_ga_ni_o,t_num_zyuq).
first(n_verb_2FH_ga_ni_o,t_num_zyuu).
first(n_verb_2FH_ga_ni_o,t_prefix_go).
first(n_verb_2FH_ga_ni_o,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_ni_o,t_prefix_o).
first(n_verb_2FH_ga_ni_o,t_prefix_quant_quant).
first(n_verb_2FH_ga_ni_o,t_rentai).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_suuryousi).
first(n_verb_2FH_ga_ni_o,t_teido_hukusi).
first(n_verb_2FH_ga_ni_o,t_tsuzuri).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_ni_o,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_o,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_ni_o,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_ni_o,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_ni_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_ni_o,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_ni_o,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_ni_o,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_ni_o,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_ni_o,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_ni_o,t_wh_daimeisi).
first(n_verb_2FH_ga_ni_o,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_ni_o,t_wh_hukusi).
first(n_verb_2FH_ga_ni_o,t_zikan_meisi).
first(n_verb_2FH_ga_ni_o,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_ni_o,t_zikantai).
first(n_verb_2FH_ga_o,n_capacity).
first(n_verb_2FH_ga_o,n_visitor_name).
first(n_verb_2FH_ga_o,t_adj_meisi).
first(n_verb_2FH_ga_o,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_o,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_o,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_o,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_o,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_o,t_daimeisi).
first(n_verb_2FH_ga_o,t_daimeisi_domo).
first(n_verb_2FH_ga_o,t_daimeisi_exp).
first(n_verb_2FH_ga_o,t_hukusi).
first(n_verb_2FH_ga_o,t_hukusi_desu).
first(n_verb_2FH_ga_o,t_hutu_meisi).
first(n_verb_2FH_ga_o,t_hutu_meisi_post).
first(n_verb_2FH_ga_o,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_kdo_2FH_ga).
first(n_verb_2FH_ga_o,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_o,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_o,t_koyuu_meisi).
first(n_verb_2FH_ga_o,t_meisi_hi).
first(n_verb_2FH_ga_o,t_meisi_hun).
first(n_verb_2FH_ga_o,t_meisi_tsuki).
first(n_verb_2FH_ga_o,t_meisi_youbi).
first(n_verb_2FH_ga_o,t_meisi_zi).
first(n_verb_2FH_ga_o,t_myoji_first).
first(n_verb_2FH_ga_o,t_myoji_last).
first(n_verb_2FH_ga_o,t_n_keisiki).
first(n_verb_2FH_ga_o,t_namae_first).
first(n_verb_2FH_ga_o,t_namae_last).
first(n_verb_2FH_ga_o,t_num_bouyomi).
first(n_verb_2FH_ga_o,t_num_byaku).
first(n_verb_2FH_ga_o,t_num_byaq).
first(n_verb_2FH_ga_o,t_num_go).
first(n_verb_2FH_ga_o,t_num_hachi).
first(n_verb_2FH_ga_o,t_num_haq).
first(n_verb_2FH_ga_o,t_num_hito).
first(n_verb_2FH_ga_o,t_num_huta).
first(n_verb_2FH_ga_o,t_num_hutsu).
first(n_verb_2FH_ga_o,t_num_hyaku).
first(n_verb_2FH_ga_o,t_num_hyaq).
first(n_verb_2FH_ga_o,t_num_ichi).
first(n_verb_2FH_ga_o,t_num_iq).
first(n_verb_2FH_ga_o,t_num_itsu).
first(n_verb_2FH_ga_o,t_num_kokono).
first(n_verb_2FH_ga_o,t_num_ku).
first(n_verb_2FH_ga_o,t_num_kyuu).
first(n_verb_2FH_ga_o,t_num_miq).
first(n_verb_2FH_ga_o,t_num_mui).
first(n_verb_2FH_ga_o,t_num_muq).
first(n_verb_2FH_ga_o,t_num_nana).
first(n_verb_2FH_ga_o,t_num_nano).
first(n_verb_2FH_ga_o,t_num_ni).
first(n_verb_2FH_ga_o,t_num_one).
first(n_verb_2FH_ga_o,t_num_pyaku).
first(n_verb_2FH_ga_o,t_num_pyaq).
first(n_verb_2FH_ga_o,t_num_roku).
first(n_verb_2FH_ga_o,t_num_roq).
first(n_verb_2FH_ga_o,t_num_san).
first(n_verb_2FH_ga_o,t_num_sen).
first(n_verb_2FH_ga_o,t_num_shi).
first(n_verb_2FH_ga_o,t_num_shichi).
first(n_verb_2FH_ga_o,t_num_ten).
first(n_verb_2FH_ga_o,t_num_tou).
first(n_verb_2FH_ga_o,t_num_yaq).
first(n_verb_2FH_ga_o,t_num_yo).
first(n_verb_2FH_ga_o,t_num_yon).
first(n_verb_2FH_ga_o,t_num_yoq).
first(n_verb_2FH_ga_o,t_num_you).
first(n_verb_2FH_ga_o,t_num_zen).
first(n_verb_2FH_ga_o,t_num_zyuq).
first(n_verb_2FH_ga_o,t_num_zyuu).
first(n_verb_2FH_ga_o,t_prefix_go).
first(n_verb_2FH_ga_o,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_o,t_prefix_o).
first(n_verb_2FH_ga_o,t_prefix_quant_quant).
first(n_verb_2FH_ga_o,t_rentai).
first(n_verb_2FH_ga_o,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_o,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_o,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_o,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_o,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_o,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_o,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_o,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_o,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_o,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_o,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_o,t_suuryousi).
first(n_verb_2FH_ga_o,t_teido_hukusi).
first(n_verb_2FH_ga_o,t_tsuzuri).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_o,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_o,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_o,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_o,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_o,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_o,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_o,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_o,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_o,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_o,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_o,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_o,t_wh_daimeisi).
first(n_verb_2FH_ga_o,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_o,t_wh_hukusi).
first(n_verb_2FH_ga_o,t_zikan_meisi).
first(n_verb_2FH_ga_o,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_o,t_zikantai).
first(n_verb_2FH_ga_quote,n_capacity).
first(n_verb_2FH_ga_quote,n_visitor_name).
first(n_verb_2FH_ga_quote,t_adj_meisi).
first(n_verb_2FH_ga_quote,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_quote,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_quote,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_quote,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_quote,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_quote,t_daimeisi).
first(n_verb_2FH_ga_quote,t_daimeisi_domo).
first(n_verb_2FH_ga_quote,t_daimeisi_exp).
first(n_verb_2FH_ga_quote,t_hukusi).
first(n_verb_2FH_ga_quote,t_hukusi_desu).
first(n_verb_2FH_ga_quote,t_hutu_meisi).
first(n_verb_2FH_ga_quote,t_hutu_meisi_post).
first(n_verb_2FH_ga_quote,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_kdo_2FH_ga).
first(n_verb_2FH_ga_quote,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_quote,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_koyuu_meisi).
first(n_verb_2FH_ga_quote,t_meisi_hi).
first(n_verb_2FH_ga_quote,t_meisi_hun).
first(n_verb_2FH_ga_quote,t_meisi_tsuki).
first(n_verb_2FH_ga_quote,t_meisi_youbi).
first(n_verb_2FH_ga_quote,t_meisi_zi).
first(n_verb_2FH_ga_quote,t_myoji_first).
first(n_verb_2FH_ga_quote,t_myoji_last).
first(n_verb_2FH_ga_quote,t_n_keisiki).
first(n_verb_2FH_ga_quote,t_namae_first).
first(n_verb_2FH_ga_quote,t_namae_last).
first(n_verb_2FH_ga_quote,t_num_bouyomi).
first(n_verb_2FH_ga_quote,t_num_byaku).
first(n_verb_2FH_ga_quote,t_num_byaq).
first(n_verb_2FH_ga_quote,t_num_go).
first(n_verb_2FH_ga_quote,t_num_hachi).
first(n_verb_2FH_ga_quote,t_num_haq).
first(n_verb_2FH_ga_quote,t_num_hito).
first(n_verb_2FH_ga_quote,t_num_huta).
first(n_verb_2FH_ga_quote,t_num_hutsu).
first(n_verb_2FH_ga_quote,t_num_hyaku).
first(n_verb_2FH_ga_quote,t_num_hyaq).
first(n_verb_2FH_ga_quote,t_num_ichi).
first(n_verb_2FH_ga_quote,t_num_iq).
first(n_verb_2FH_ga_quote,t_num_itsu).
first(n_verb_2FH_ga_quote,t_num_kokono).
first(n_verb_2FH_ga_quote,t_num_ku).
first(n_verb_2FH_ga_quote,t_num_kyuu).
first(n_verb_2FH_ga_quote,t_num_miq).
first(n_verb_2FH_ga_quote,t_num_mui).
first(n_verb_2FH_ga_quote,t_num_muq).
first(n_verb_2FH_ga_quote,t_num_nana).
first(n_verb_2FH_ga_quote,t_num_nano).
first(n_verb_2FH_ga_quote,t_num_ni).
first(n_verb_2FH_ga_quote,t_num_one).
first(n_verb_2FH_ga_quote,t_num_pyaku).
first(n_verb_2FH_ga_quote,t_num_pyaq).
first(n_verb_2FH_ga_quote,t_num_roku).
first(n_verb_2FH_ga_quote,t_num_roq).
first(n_verb_2FH_ga_quote,t_num_san).
first(n_verb_2FH_ga_quote,t_num_sen).
first(n_verb_2FH_ga_quote,t_num_shi).
first(n_verb_2FH_ga_quote,t_num_shichi).
first(n_verb_2FH_ga_quote,t_num_ten).
first(n_verb_2FH_ga_quote,t_num_tou).
first(n_verb_2FH_ga_quote,t_num_yaq).
first(n_verb_2FH_ga_quote,t_num_yo).
first(n_verb_2FH_ga_quote,t_num_yon).
first(n_verb_2FH_ga_quote,t_num_yoq).
first(n_verb_2FH_ga_quote,t_num_you).
first(n_verb_2FH_ga_quote,t_num_zen).
first(n_verb_2FH_ga_quote,t_num_zyuq).
first(n_verb_2FH_ga_quote,t_num_zyuu).
first(n_verb_2FH_ga_quote,t_prefix_go).
first(n_verb_2FH_ga_quote,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_quote,t_prefix_o).
first(n_verb_2FH_ga_quote,t_prefix_quant_quant).
first(n_verb_2FH_ga_quote,t_rentai).
first(n_verb_2FH_ga_quote,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_quote,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_quote,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_quote,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_suuryousi).
first(n_verb_2FH_ga_quote,t_teido_hukusi).
first(n_verb_2FH_ga_quote,t_tsuzuri).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_quote,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_quote,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_quote,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_quote,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_quote,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_quote,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_quote,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_quote,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_quote,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_quote,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_quote,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_quote,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_quote,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_quote,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_quote,t_wh_daimeisi).
first(n_verb_2FH_ga_quote,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_quote,t_wh_hukusi).
first(n_verb_2FH_ga_quote,t_zikan_meisi).
first(n_verb_2FH_ga_quote,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_quote,t_zikantai).
first(n_verb_2FH_ga_to,n_capacity).
first(n_verb_2FH_ga_to,n_visitor_name).
first(n_verb_2FH_ga_to,t_adj_meisi).
first(n_verb_2FH_ga_to,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ga_to,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ga_to,t_adjstem_2FH_ga).
first(n_verb_2FH_ga_to,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ga_to,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ga_to,t_daimeisi).
first(n_verb_2FH_ga_to,t_daimeisi_domo).
first(n_verb_2FH_ga_to,t_daimeisi_exp).
first(n_verb_2FH_ga_to,t_hukusi).
first(n_verb_2FH_ga_to,t_hukusi_desu).
first(n_verb_2FH_ga_to,t_hutu_meisi).
first(n_verb_2FH_ga_to,t_hutu_meisi_post).
first(n_verb_2FH_ga_to,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_kdo_2FH_ga).
first(n_verb_2FH_ga_to,t_kdo_2FH_ga_de).
first(n_verb_2FH_ga_to,t_kdo_2FH_ga_to).
first(n_verb_2FH_ga_to,t_koyuu_meisi).
first(n_verb_2FH_ga_to,t_meisi_hi).
first(n_verb_2FH_ga_to,t_meisi_hun).
first(n_verb_2FH_ga_to,t_meisi_tsuki).
first(n_verb_2FH_ga_to,t_meisi_youbi).
first(n_verb_2FH_ga_to,t_meisi_zi).
first(n_verb_2FH_ga_to,t_myoji_first).
first(n_verb_2FH_ga_to,t_myoji_last).
first(n_verb_2FH_ga_to,t_n_keisiki).
first(n_verb_2FH_ga_to,t_namae_first).
first(n_verb_2FH_ga_to,t_namae_last).
first(n_verb_2FH_ga_to,t_num_bouyomi).
first(n_verb_2FH_ga_to,t_num_byaku).
first(n_verb_2FH_ga_to,t_num_byaq).
first(n_verb_2FH_ga_to,t_num_go).
first(n_verb_2FH_ga_to,t_num_hachi).
first(n_verb_2FH_ga_to,t_num_haq).
first(n_verb_2FH_ga_to,t_num_hito).
first(n_verb_2FH_ga_to,t_num_huta).
first(n_verb_2FH_ga_to,t_num_hutsu).
first(n_verb_2FH_ga_to,t_num_hyaku).
first(n_verb_2FH_ga_to,t_num_hyaq).
first(n_verb_2FH_ga_to,t_num_ichi).
first(n_verb_2FH_ga_to,t_num_iq).
first(n_verb_2FH_ga_to,t_num_itsu).
first(n_verb_2FH_ga_to,t_num_kokono).
first(n_verb_2FH_ga_to,t_num_ku).
first(n_verb_2FH_ga_to,t_num_kyuu).
first(n_verb_2FH_ga_to,t_num_miq).
first(n_verb_2FH_ga_to,t_num_mui).
first(n_verb_2FH_ga_to,t_num_muq).
first(n_verb_2FH_ga_to,t_num_nana).
first(n_verb_2FH_ga_to,t_num_nano).
first(n_verb_2FH_ga_to,t_num_ni).
first(n_verb_2FH_ga_to,t_num_one).
first(n_verb_2FH_ga_to,t_num_pyaku).
first(n_verb_2FH_ga_to,t_num_pyaq).
first(n_verb_2FH_ga_to,t_num_roku).
first(n_verb_2FH_ga_to,t_num_roq).
first(n_verb_2FH_ga_to,t_num_san).
first(n_verb_2FH_ga_to,t_num_sen).
first(n_verb_2FH_ga_to,t_num_shi).
first(n_verb_2FH_ga_to,t_num_shichi).
first(n_verb_2FH_ga_to,t_num_ten).
first(n_verb_2FH_ga_to,t_num_tou).
first(n_verb_2FH_ga_to,t_num_yaq).
first(n_verb_2FH_ga_to,t_num_yo).
first(n_verb_2FH_ga_to,t_num_yon).
first(n_verb_2FH_ga_to,t_num_yoq).
first(n_verb_2FH_ga_to,t_num_you).
first(n_verb_2FH_ga_to,t_num_zen).
first(n_verb_2FH_ga_to,t_num_zyuq).
first(n_verb_2FH_ga_to,t_num_zyuu).
first(n_verb_2FH_ga_to,t_prefix_go).
first(n_verb_2FH_ga_to,t_prefix_hutu_hutu).
first(n_verb_2FH_ga_to,t_prefix_o).
first(n_verb_2FH_ga_to,t_prefix_quant_quant).
first(n_verb_2FH_ga_to,t_rentai).
first(n_verb_2FH_ga_to,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ga_to,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ga_to,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ga_to,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ga_to,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ga_to,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ga_to,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_to,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ga_to,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ga_to,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ga_to,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ga_to,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ga_to,t_suuryousi).
first(n_verb_2FH_ga_to,t_teido_hukusi).
first(n_verb_2FH_ga_to,t_tsuzuri).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ga_to,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_to,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_to,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ga_to,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ga_to,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ga_to,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ga_to,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ga_to,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ga_to,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ga_to,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ga_to,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ga_to,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ga_to,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ga_to,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ga_to,t_wh_daimeisi).
first(n_verb_2FH_ga_to,t_wh_daimeisi_nan).
first(n_verb_2FH_ga_to,t_wh_hukusi).
first(n_verb_2FH_ga_to,t_zikan_meisi).
first(n_verb_2FH_ga_to,t_zikan_meisi_ippai).
first(n_verb_2FH_ga_to,t_zikantai).
first(n_verb_2FH_ni,n_capacity).
first(n_verb_2FH_ni,n_visitor_name).
first(n_verb_2FH_ni,t_adj_meisi).
first(n_verb_2FH_ni,t_adj_renyo_2FH_ga).
first(n_verb_2FH_ni,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_ni,t_adjstem_2FH_ga).
first(n_verb_2FH_ni,t_adjstem_2FH_ga_de).
first(n_verb_2FH_ni,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_ni,t_daimeisi).
first(n_verb_2FH_ni,t_daimeisi_domo).
first(n_verb_2FH_ni,t_daimeisi_exp).
first(n_verb_2FH_ni,t_hukusi).
first(n_verb_2FH_ni,t_hukusi_desu).
first(n_verb_2FH_ni,t_hutu_meisi).
first(n_verb_2FH_ni,t_hutu_meisi_post).
first(n_verb_2FH_ni,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ni,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ni,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ni,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ni,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ni,t_kdo_2FH_ga).
first(n_verb_2FH_ni,t_kdo_2FH_ga_de).
first(n_verb_2FH_ni,t_kdo_2FH_ga_to).
first(n_verb_2FH_ni,t_koyuu_meisi).
first(n_verb_2FH_ni,t_meisi_hi).
first(n_verb_2FH_ni,t_meisi_hun).
first(n_verb_2FH_ni,t_meisi_tsuki).
first(n_verb_2FH_ni,t_meisi_youbi).
first(n_verb_2FH_ni,t_meisi_zi).
first(n_verb_2FH_ni,t_myoji_first).
first(n_verb_2FH_ni,t_myoji_last).
first(n_verb_2FH_ni,t_n_keisiki).
first(n_verb_2FH_ni,t_namae_first).
first(n_verb_2FH_ni,t_namae_last).
first(n_verb_2FH_ni,t_num_bouyomi).
first(n_verb_2FH_ni,t_num_byaku).
first(n_verb_2FH_ni,t_num_byaq).
first(n_verb_2FH_ni,t_num_go).
first(n_verb_2FH_ni,t_num_hachi).
first(n_verb_2FH_ni,t_num_haq).
first(n_verb_2FH_ni,t_num_hito).
first(n_verb_2FH_ni,t_num_huta).
first(n_verb_2FH_ni,t_num_hutsu).
first(n_verb_2FH_ni,t_num_hyaku).
first(n_verb_2FH_ni,t_num_hyaq).
first(n_verb_2FH_ni,t_num_ichi).
first(n_verb_2FH_ni,t_num_iq).
first(n_verb_2FH_ni,t_num_itsu).
first(n_verb_2FH_ni,t_num_kokono).
first(n_verb_2FH_ni,t_num_ku).
first(n_verb_2FH_ni,t_num_kyuu).
first(n_verb_2FH_ni,t_num_miq).
first(n_verb_2FH_ni,t_num_mui).
first(n_verb_2FH_ni,t_num_muq).
first(n_verb_2FH_ni,t_num_nana).
first(n_verb_2FH_ni,t_num_nano).
first(n_verb_2FH_ni,t_num_ni).
first(n_verb_2FH_ni,t_num_one).
first(n_verb_2FH_ni,t_num_pyaku).
first(n_verb_2FH_ni,t_num_pyaq).
first(n_verb_2FH_ni,t_num_roku).
first(n_verb_2FH_ni,t_num_roq).
first(n_verb_2FH_ni,t_num_san).
first(n_verb_2FH_ni,t_num_sen).
first(n_verb_2FH_ni,t_num_shi).
first(n_verb_2FH_ni,t_num_shichi).
first(n_verb_2FH_ni,t_num_ten).
first(n_verb_2FH_ni,t_num_tou).
first(n_verb_2FH_ni,t_num_yaq).
first(n_verb_2FH_ni,t_num_yo).
first(n_verb_2FH_ni,t_num_yon).
first(n_verb_2FH_ni,t_num_yoq).
first(n_verb_2FH_ni,t_num_you).
first(n_verb_2FH_ni,t_num_zen).
first(n_verb_2FH_ni,t_num_zyuq).
first(n_verb_2FH_ni,t_num_zyuu).
first(n_verb_2FH_ni,t_prefix_go).
first(n_verb_2FH_ni,t_prefix_hutu_hutu).
first(n_verb_2FH_ni,t_prefix_o).
first(n_verb_2FH_ni,t_prefix_quant_quant).
first(n_verb_2FH_ni,t_rentai).
first(n_verb_2FH_ni,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_ni,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_ni,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_ni,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_ni,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_ni,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_ni,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_ni,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_ni,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_ni,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_ni,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_ni,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_ni,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ni,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_ni,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_ni,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_ni,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_ni,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_ni,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_ni,t_suuryousi).
first(n_verb_2FH_ni,t_teido_hukusi).
first(n_verb_2FH_ni,t_tsuzuri).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_ni,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ni,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ni,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_ni,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_ni,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_ni,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_ni,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_ni,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_ni,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_ni,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_ni,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_ni,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_ni,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_ni,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_ni,t_vstem_masu_2FH_ga).
first(n_verb_2FH_ni,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_ni,t_wh_daimeisi).
first(n_verb_2FH_ni,t_wh_daimeisi_nan).
first(n_verb_2FH_ni,t_wh_hukusi).
first(n_verb_2FH_ni,t_zikan_meisi).
first(n_verb_2FH_ni,t_zikan_meisi_ippai).
first(n_verb_2FH_ni,t_zikantai).
first(n_verb_2FH_o,n_capacity).
first(n_verb_2FH_o,n_visitor_name).
first(n_verb_2FH_o,t_adj_meisi).
first(n_verb_2FH_o,t_adj_renyo_2FH_ga).
first(n_verb_2FH_o,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_o,t_adjstem_2FH_ga).
first(n_verb_2FH_o,t_adjstem_2FH_ga_de).
first(n_verb_2FH_o,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_o,t_daimeisi).
first(n_verb_2FH_o,t_daimeisi_domo).
first(n_verb_2FH_o,t_daimeisi_exp).
first(n_verb_2FH_o,t_hukusi).
first(n_verb_2FH_o,t_hukusi_desu).
first(n_verb_2FH_o,t_hutu_meisi).
first(n_verb_2FH_o,t_hutu_meisi_post).
first(n_verb_2FH_o,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_o,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_o,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_o,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_o,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_o,t_kdo_2FH_ga).
first(n_verb_2FH_o,t_kdo_2FH_ga_de).
first(n_verb_2FH_o,t_kdo_2FH_ga_to).
first(n_verb_2FH_o,t_koyuu_meisi).
first(n_verb_2FH_o,t_meisi_hi).
first(n_verb_2FH_o,t_meisi_hun).
first(n_verb_2FH_o,t_meisi_tsuki).
first(n_verb_2FH_o,t_meisi_youbi).
first(n_verb_2FH_o,t_meisi_zi).
first(n_verb_2FH_o,t_myoji_first).
first(n_verb_2FH_o,t_myoji_last).
first(n_verb_2FH_o,t_n_keisiki).
first(n_verb_2FH_o,t_namae_first).
first(n_verb_2FH_o,t_namae_last).
first(n_verb_2FH_o,t_num_bouyomi).
first(n_verb_2FH_o,t_num_byaku).
first(n_verb_2FH_o,t_num_byaq).
first(n_verb_2FH_o,t_num_go).
first(n_verb_2FH_o,t_num_hachi).
first(n_verb_2FH_o,t_num_haq).
first(n_verb_2FH_o,t_num_hito).
first(n_verb_2FH_o,t_num_huta).
first(n_verb_2FH_o,t_num_hutsu).
first(n_verb_2FH_o,t_num_hyaku).
first(n_verb_2FH_o,t_num_hyaq).
first(n_verb_2FH_o,t_num_ichi).
first(n_verb_2FH_o,t_num_iq).
first(n_verb_2FH_o,t_num_itsu).
first(n_verb_2FH_o,t_num_kokono).
first(n_verb_2FH_o,t_num_ku).
first(n_verb_2FH_o,t_num_kyuu).
first(n_verb_2FH_o,t_num_miq).
first(n_verb_2FH_o,t_num_mui).
first(n_verb_2FH_o,t_num_muq).
first(n_verb_2FH_o,t_num_nana).
first(n_verb_2FH_o,t_num_nano).
first(n_verb_2FH_o,t_num_ni).
first(n_verb_2FH_o,t_num_one).
first(n_verb_2FH_o,t_num_pyaku).
first(n_verb_2FH_o,t_num_pyaq).
first(n_verb_2FH_o,t_num_roku).
first(n_verb_2FH_o,t_num_roq).
first(n_verb_2FH_o,t_num_san).
first(n_verb_2FH_o,t_num_sen).
first(n_verb_2FH_o,t_num_shi).
first(n_verb_2FH_o,t_num_shichi).
first(n_verb_2FH_o,t_num_ten).
first(n_verb_2FH_o,t_num_tou).
first(n_verb_2FH_o,t_num_yaq).
first(n_verb_2FH_o,t_num_yo).
first(n_verb_2FH_o,t_num_yon).
first(n_verb_2FH_o,t_num_yoq).
first(n_verb_2FH_o,t_num_you).
first(n_verb_2FH_o,t_num_zen).
first(n_verb_2FH_o,t_num_zyuq).
first(n_verb_2FH_o,t_num_zyuu).
first(n_verb_2FH_o,t_prefix_go).
first(n_verb_2FH_o,t_prefix_hutu_hutu).
first(n_verb_2FH_o,t_prefix_o).
first(n_verb_2FH_o,t_prefix_quant_quant).
first(n_verb_2FH_o,t_rentai).
first(n_verb_2FH_o,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_o,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_o,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_o,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_o,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_o,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_o,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_o,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_o,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_o,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_o,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_o,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_o,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_o,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_o,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_o,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_o,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_o,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_o,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_o,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_o,t_suuryousi).
first(n_verb_2FH_o,t_teido_hukusi).
first(n_verb_2FH_o,t_tsuzuri).
first(n_verb_2FH_o,t_vstem_1_2FH_ga).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_o,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_o,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_o,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_o,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_o,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_o,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_o,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_o,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_o,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_o,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_o,t_vstem_masu_2FH_ga).
first(n_verb_2FH_o,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_o,t_wh_daimeisi).
first(n_verb_2FH_o,t_wh_daimeisi_nan).
first(n_verb_2FH_o,t_wh_hukusi).
first(n_verb_2FH_o,t_zikan_meisi).
first(n_verb_2FH_o,t_zikan_meisi_ippai).
first(n_verb_2FH_o,t_zikantai).
first(n_verb_2FH_to,n_capacity).
first(n_verb_2FH_to,n_visitor_name).
first(n_verb_2FH_to,t_adj_meisi).
first(n_verb_2FH_to,t_adj_renyo_2FH_ga).
first(n_verb_2FH_to,t_adj_renyo_2FH_ga_de).
first(n_verb_2FH_to,t_adjstem_2FH_ga).
first(n_verb_2FH_to,t_adjstem_2FH_ga_de).
first(n_verb_2FH_to,t_adjstem_spe_2FH_ga_de).
first(n_verb_2FH_to,t_daimeisi).
first(n_verb_2FH_to,t_daimeisi_domo).
first(n_verb_2FH_to,t_daimeisi_exp).
first(n_verb_2FH_to,t_hukusi).
first(n_verb_2FH_to,t_hukusi_desu).
first(n_verb_2FH_to,t_hutu_meisi).
first(n_verb_2FH_to,t_hutu_meisi_post).
first(n_verb_2FH_to,t_kahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_to,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_to,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_to,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_to,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_to,t_kdo_2FH_ga).
first(n_verb_2FH_to,t_kdo_2FH_ga_de).
first(n_verb_2FH_to,t_kdo_2FH_ga_to).
first(n_verb_2FH_to,t_koyuu_meisi).
first(n_verb_2FH_to,t_meisi_hi).
first(n_verb_2FH_to,t_meisi_hun).
first(n_verb_2FH_to,t_meisi_tsuki).
first(n_verb_2FH_to,t_meisi_youbi).
first(n_verb_2FH_to,t_meisi_zi).
first(n_verb_2FH_to,t_myoji_first).
first(n_verb_2FH_to,t_myoji_last).
first(n_verb_2FH_to,t_n_keisiki).
first(n_verb_2FH_to,t_namae_first).
first(n_verb_2FH_to,t_namae_last).
first(n_verb_2FH_to,t_num_bouyomi).
first(n_verb_2FH_to,t_num_byaku).
first(n_verb_2FH_to,t_num_byaq).
first(n_verb_2FH_to,t_num_go).
first(n_verb_2FH_to,t_num_hachi).
first(n_verb_2FH_to,t_num_haq).
first(n_verb_2FH_to,t_num_hito).
first(n_verb_2FH_to,t_num_huta).
first(n_verb_2FH_to,t_num_hutsu).
first(n_verb_2FH_to,t_num_hyaku).
first(n_verb_2FH_to,t_num_hyaq).
first(n_verb_2FH_to,t_num_ichi).
first(n_verb_2FH_to,t_num_iq).
first(n_verb_2FH_to,t_num_itsu).
first(n_verb_2FH_to,t_num_kokono).
first(n_verb_2FH_to,t_num_ku).
first(n_verb_2FH_to,t_num_kyuu).
first(n_verb_2FH_to,t_num_miq).
first(n_verb_2FH_to,t_num_mui).
first(n_verb_2FH_to,t_num_muq).
first(n_verb_2FH_to,t_num_nana).
first(n_verb_2FH_to,t_num_nano).
first(n_verb_2FH_to,t_num_ni).
first(n_verb_2FH_to,t_num_one).
first(n_verb_2FH_to,t_num_pyaku).
first(n_verb_2FH_to,t_num_pyaq).
first(n_verb_2FH_to,t_num_roku).
first(n_verb_2FH_to,t_num_roq).
first(n_verb_2FH_to,t_num_san).
first(n_verb_2FH_to,t_num_sen).
first(n_verb_2FH_to,t_num_shi).
first(n_verb_2FH_to,t_num_shichi).
first(n_verb_2FH_to,t_num_ten).
first(n_verb_2FH_to,t_num_tou).
first(n_verb_2FH_to,t_num_yaq).
first(n_verb_2FH_to,t_num_yo).
first(n_verb_2FH_to,t_num_yon).
first(n_verb_2FH_to,t_num_yoq).
first(n_verb_2FH_to,t_num_you).
first(n_verb_2FH_to,t_num_zen).
first(n_verb_2FH_to,t_num_zyuq).
first(n_verb_2FH_to,t_num_zyuu).
first(n_verb_2FH_to,t_prefix_go).
first(n_verb_2FH_to,t_prefix_hutu_hutu).
first(n_verb_2FH_to,t_prefix_o).
first(n_verb_2FH_to,t_prefix_quant_quant).
first(n_verb_2FH_to,t_rentai).
first(n_verb_2FH_to,t_sahen_dousi_katei_2FH_ga_ni).
first(n_verb_2FH_to,t_sahen_dousi_katei_2FH_ga_o).
first(n_verb_2FH_to,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_verb_2FH_to,t_sahen_dousi_mizen_2FH_ga_o).
first(n_verb_2FH_to,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_verb_2FH_to,t_sahen_dousi_rentai_2FH_ga_o).
first(n_verb_2FH_to,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_verb_2FH_to,t_sahen_dousi_renyo_2FH_ga_o).
first(n_verb_2FH_to,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_verb_2FH_to,t_sahen_dousi_syusi_2FH_ga_o).
first(n_verb_2FH_to,t_sahen_meisi_2FH_ga).
first(n_verb_2FH_to,t_sahen_meisi_2FH_ga_ni).
first(n_verb_2FH_to,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_verb_2FH_to,t_sahen_meisi_2FH_ga_ni_o).
first(n_verb_2FH_to,t_sahen_meisi_2FH_ga_o).
first(n_verb_2FH_to,t_sahen_meisi_2FH_ga_to).
first(n_verb_2FH_to,t_sahen_meisi_pol_2FH_ga).
first(n_verb_2FH_to,t_sahen_meisi_pol_2FH_ga_ni).
first(n_verb_2FH_to,t_sahen_meisi_pol_2FH_ga_o).
first(n_verb_2FH_to,t_sahen_meisi_pol_2FH_ga_to).
first(n_verb_2FH_to,t_suuryousi).
first(n_verb_2FH_to,t_teido_hukusi).
first(n_verb_2FH_to,t_tsuzuri).
first(n_verb_2FH_to,t_vstem_1_2FH_ga).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_de).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_quote).
first(n_verb_2FH_to,t_vstem_1_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_5_b_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_b_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_b_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_b_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_b_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_5_g_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_g_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_g_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_g_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_k_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_k_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_k_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_k_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_k_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_verb_2FH_to,t_vstem_5_m_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_m_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_verb_2FH_to,t_vstem_5_m_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_m_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_m_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_5_r_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_r_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_verb_2FH_to,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_verb_2FH_to,t_vstem_5_r_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_r_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_r_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_5_r_i_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_r_i_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_r_i_2FH_ga_quote).
first(n_verb_2FH_to,t_vstem_5_s_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_s_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_s_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_s_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_s_2FH_ga_quote).
first(n_verb_2FH_to,t_vstem_5_s_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_5_t_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_t_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_verb_2FH_to,t_vstem_5_t_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_t_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_t_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_5_w_2FH_ga).
first(n_verb_2FH_to,t_vstem_5_w_2FH_ga_de).
first(n_verb_2FH_to,t_vstem_5_w_2FH_ga_ni).
first(n_verb_2FH_to,t_vstem_5_w_2FH_ga_ni_o).
first(n_verb_2FH_to,t_vstem_5_w_2FH_ga_o).
first(n_verb_2FH_to,t_vstem_5_w_2FH_ga_quote).
first(n_verb_2FH_to,t_vstem_5_w_2FH_ga_to).
first(n_verb_2FH_to,t_vstem_masu_2FH_ga).
first(n_verb_2FH_to,t_vstem_sahen_2FH_ga_ni).
first(n_verb_2FH_to,t_wh_daimeisi).
first(n_verb_2FH_to,t_wh_daimeisi_nan).
first(n_verb_2FH_to,t_wh_hukusi).
first(n_verb_2FH_to,t_zikan_meisi).
first(n_verb_2FH_to,t_zikan_meisi_ippai).
first(n_verb_2FH_to,t_zikantai).
first(n_vstem1_2FH_ga,t_vstem_1_2FH_ga).
first(n_vstem1_2FH_ga_de,t_vstem_1_2FH_ga_de).
first(n_vstem1_2FH_ga_ni,t_vstem_1_2FH_ga_ni).
first(n_vstem1_2FH_ga_ni_5EH_e,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_vstem1_2FH_ga_ni_5EH_e_o,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_vstem1_2FH_ga_ni_5EH_to,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_vstem1_2FH_ga_ni_o,t_vstem_1_2FH_ga_ni_o).
first(n_vstem1_2FH_ga_o,t_vstem_1_2FH_ga_o).
first(n_vstem1_2FH_ga_quote,t_vstem_1_2FH_ga_quote).
first(n_vstem1_2FH_ga_to,t_vstem_1_2FH_ga_to).
first(n_vstem5_2FH_ga,t_vstem_5_b_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_g_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_k_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_m_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_r_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_r_i_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_s_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_t_2FH_ga).
first(n_vstem5_2FH_ga,t_vstem_5_w_2FH_ga).
first(n_vstem5_2FH_ga_de,t_vstem_5_w_2FH_ga_de).
first(n_vstem5_2FH_ga_ni,t_vstem_5_b_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni,t_vstem_5_g_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni,t_vstem_5_k_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni,t_vstem_5_m_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni,t_vstem_5_r_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni,t_vstem_5_s_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni,t_vstem_5_t_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni,t_vstem_5_w_2FH_ga_ni).
first(n_vstem5_2FH_ga_ni_5EH_e,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_vstem5_2FH_ga_ni_5EH_e,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_vstem5_2FH_ga_ni_5EH_e,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_vstem5_2FH_ga_ni_5EH_e_o,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_vstem5_2FH_ga_ni_5EH_to,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_b_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_g_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_k_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_m_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_r_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_s_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_t_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_ni_o,t_vstem_5_w_2FH_ga_ni_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_b_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_g_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_k_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_m_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_r_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_r_i_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_s_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_t_2FH_ga_o).
first(n_vstem5_2FH_ga_o,t_vstem_5_w_2FH_ga_o).
first(n_vstem5_2FH_ga_quote,t_vstem_5_r_i_2FH_ga_quote).
first(n_vstem5_2FH_ga_quote,t_vstem_5_s_2FH_ga_quote).
first(n_vstem5_2FH_ga_quote,t_vstem_5_w_2FH_ga_quote).
first(n_vstem5_2FH_ga_to,t_vstem_5_b_2FH_ga_to).
first(n_vstem5_2FH_ga_to,t_vstem_5_k_2FH_ga_to).
first(n_vstem5_2FH_ga_to,t_vstem_5_m_2FH_ga_to).
first(n_vstem5_2FH_ga_to,t_vstem_5_r_2FH_ga_to).
first(n_vstem5_2FH_ga_to,t_vstem_5_s_2FH_ga_to).
first(n_vstem5_2FH_ga_to,t_vstem_5_t_2FH_ga_to).
first(n_vstem5_2FH_ga_to,t_vstem_5_w_2FH_ga_to).
first(n_vstem_spe_2FH_ga,t_vstem_masu_2FH_ga).
first(n_vstem_spe_2FH_ga_ni,t_vstem_sahen_2FH_ga_ni).
first(n_wh_adv,t_wh_hukusi).
first(n_wh_pro,n_capacity).
first(n_wh_pro,n_visitor_name).
first(n_wh_pro,t_adj_meisi).
first(n_wh_pro,t_adj_renyo_2FH_ga).
first(n_wh_pro,t_adj_renyo_2FH_ga_de).
first(n_wh_pro,t_adjstem_2FH_ga).
first(n_wh_pro,t_adjstem_2FH_ga_de).
first(n_wh_pro,t_adjstem_spe_2FH_ga_de).
first(n_wh_pro,t_daimeisi).
first(n_wh_pro,t_daimeisi_domo).
first(n_wh_pro,t_daimeisi_exp).
first(n_wh_pro,t_hukusi).
first(n_wh_pro,t_hukusi_desu).
first(n_wh_pro,t_hutu_meisi).
first(n_wh_pro,t_hutu_meisi_post).
first(n_wh_pro,t_kahen_dousi_katei_2FH_ga_ni).
first(n_wh_pro,t_kahen_dousi_mizen_2FH_ga_ni).
first(n_wh_pro,t_kahen_dousi_rentai_2FH_ga_ni).
first(n_wh_pro,t_kahen_dousi_renyo_2FH_ga_ni).
first(n_wh_pro,t_kahen_dousi_syusi_2FH_ga_ni).
first(n_wh_pro,t_kdo_2FH_ga).
first(n_wh_pro,t_kdo_2FH_ga_de).
first(n_wh_pro,t_kdo_2FH_ga_to).
first(n_wh_pro,t_koyuu_meisi).
first(n_wh_pro,t_meisi_hi).
first(n_wh_pro,t_meisi_hun).
first(n_wh_pro,t_meisi_tsuki).
first(n_wh_pro,t_meisi_youbi).
first(n_wh_pro,t_meisi_zi).
first(n_wh_pro,t_myoji_first).
first(n_wh_pro,t_myoji_last).
first(n_wh_pro,t_n_keisiki).
first(n_wh_pro,t_namae_first).
first(n_wh_pro,t_namae_last).
first(n_wh_pro,t_num_bouyomi).
first(n_wh_pro,t_num_byaku).
first(n_wh_pro,t_num_byaq).
first(n_wh_pro,t_num_go).
first(n_wh_pro,t_num_hachi).
first(n_wh_pro,t_num_haq).
first(n_wh_pro,t_num_hito).
first(n_wh_pro,t_num_huta).
first(n_wh_pro,t_num_hutsu).
first(n_wh_pro,t_num_hyaku).
first(n_wh_pro,t_num_hyaq).
first(n_wh_pro,t_num_ichi).
first(n_wh_pro,t_num_iq).
first(n_wh_pro,t_num_itsu).
first(n_wh_pro,t_num_kokono).
first(n_wh_pro,t_num_ku).
first(n_wh_pro,t_num_kyuu).
first(n_wh_pro,t_num_miq).
first(n_wh_pro,t_num_mui).
first(n_wh_pro,t_num_muq).
first(n_wh_pro,t_num_nana).
first(n_wh_pro,t_num_nano).
first(n_wh_pro,t_num_ni).
first(n_wh_pro,t_num_one).
first(n_wh_pro,t_num_pyaku).
first(n_wh_pro,t_num_pyaq).
first(n_wh_pro,t_num_roku).
first(n_wh_pro,t_num_roq).
first(n_wh_pro,t_num_san).
first(n_wh_pro,t_num_sen).
first(n_wh_pro,t_num_shi).
first(n_wh_pro,t_num_shichi).
first(n_wh_pro,t_num_ten).
first(n_wh_pro,t_num_tou).
first(n_wh_pro,t_num_yaq).
first(n_wh_pro,t_num_yo).
first(n_wh_pro,t_num_yon).
first(n_wh_pro,t_num_yoq).
first(n_wh_pro,t_num_you).
first(n_wh_pro,t_num_zen).
first(n_wh_pro,t_num_zyuq).
first(n_wh_pro,t_num_zyuu).
first(n_wh_pro,t_prefix_go).
first(n_wh_pro,t_prefix_hutu_hutu).
first(n_wh_pro,t_prefix_o).
first(n_wh_pro,t_prefix_quant_quant).
first(n_wh_pro,t_rentai).
first(n_wh_pro,t_sahen_dousi_katei_2FH_ga_ni).
first(n_wh_pro,t_sahen_dousi_katei_2FH_ga_o).
first(n_wh_pro,t_sahen_dousi_mizen_2FH_ga_ni).
first(n_wh_pro,t_sahen_dousi_mizen_2FH_ga_o).
first(n_wh_pro,t_sahen_dousi_rentai_2FH_ga_ni).
first(n_wh_pro,t_sahen_dousi_rentai_2FH_ga_o).
first(n_wh_pro,t_sahen_dousi_renyo_2FH_ga_ni).
first(n_wh_pro,t_sahen_dousi_renyo_2FH_ga_o).
first(n_wh_pro,t_sahen_dousi_syusi_2FH_ga_ni).
first(n_wh_pro,t_sahen_dousi_syusi_2FH_ga_o).
first(n_wh_pro,t_sahen_meisi_2FH_ga).
first(n_wh_pro,t_sahen_meisi_2FH_ga_ni).
first(n_wh_pro,t_sahen_meisi_2FH_ga_ni_5EH_e).
first(n_wh_pro,t_sahen_meisi_2FH_ga_ni_o).
first(n_wh_pro,t_sahen_meisi_2FH_ga_o).
first(n_wh_pro,t_sahen_meisi_2FH_ga_to).
first(n_wh_pro,t_sahen_meisi_pol_2FH_ga).
first(n_wh_pro,t_sahen_meisi_pol_2FH_ga_ni).
first(n_wh_pro,t_sahen_meisi_pol_2FH_ga_o).
first(n_wh_pro,t_sahen_meisi_pol_2FH_ga_to).
first(n_wh_pro,t_suuryousi).
first(n_wh_pro,t_teido_hukusi).
first(n_wh_pro,t_tsuzuri).
first(n_wh_pro,t_vstem_1_2FH_ga).
first(n_wh_pro,t_vstem_1_2FH_ga_de).
first(n_wh_pro,t_vstem_1_2FH_ga_ni).
first(n_wh_pro,t_vstem_1_2FH_ga_ni_5EH_e).
first(n_wh_pro,t_vstem_1_2FH_ga_ni_5EH_e_o).
first(n_wh_pro,t_vstem_1_2FH_ga_ni_5EH_to).
first(n_wh_pro,t_vstem_1_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_1_2FH_ga_o).
first(n_wh_pro,t_vstem_1_2FH_ga_quote).
first(n_wh_pro,t_vstem_1_2FH_ga_to).
first(n_wh_pro,t_vstem_5_b_2FH_ga).
first(n_wh_pro,t_vstem_5_b_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_b_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_b_2FH_ga_o).
first(n_wh_pro,t_vstem_5_b_2FH_ga_to).
first(n_wh_pro,t_vstem_5_g_2FH_ga).
first(n_wh_pro,t_vstem_5_g_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_g_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_g_2FH_ga_o).
first(n_wh_pro,t_vstem_5_k_2FH_ga).
first(n_wh_pro,t_vstem_5_k_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_k_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_k_2FH_ga_o).
first(n_wh_pro,t_vstem_5_k_2FH_ga_to).
first(n_wh_pro,t_vstem_5_k_q_2FH_ga_ni_5EH_e).
first(n_wh_pro,t_vstem_5_m_2FH_ga).
first(n_wh_pro,t_vstem_5_m_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_m_2FH_ga_ni_5EH_e).
first(n_wh_pro,t_vstem_5_m_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_m_2FH_ga_o).
first(n_wh_pro,t_vstem_5_m_2FH_ga_to).
first(n_wh_pro,t_vstem_5_r_2FH_ga).
first(n_wh_pro,t_vstem_5_r_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_r_2FH_ga_ni_5EH_e_o).
first(n_wh_pro,t_vstem_5_r_2FH_ga_ni_5EH_to).
first(n_wh_pro,t_vstem_5_r_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_r_2FH_ga_o).
first(n_wh_pro,t_vstem_5_r_2FH_ga_to).
first(n_wh_pro,t_vstem_5_r_i_2FH_ga).
first(n_wh_pro,t_vstem_5_r_i_2FH_ga_o).
first(n_wh_pro,t_vstem_5_r_i_2FH_ga_quote).
first(n_wh_pro,t_vstem_5_s_2FH_ga).
first(n_wh_pro,t_vstem_5_s_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_s_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_s_2FH_ga_o).
first(n_wh_pro,t_vstem_5_s_2FH_ga_quote).
first(n_wh_pro,t_vstem_5_s_2FH_ga_to).
first(n_wh_pro,t_vstem_5_t_2FH_ga).
first(n_wh_pro,t_vstem_5_t_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_t_2FH_ga_ni_5EH_e).
first(n_wh_pro,t_vstem_5_t_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_t_2FH_ga_o).
first(n_wh_pro,t_vstem_5_t_2FH_ga_to).
first(n_wh_pro,t_vstem_5_w_2FH_ga).
first(n_wh_pro,t_vstem_5_w_2FH_ga_de).
first(n_wh_pro,t_vstem_5_w_2FH_ga_ni).
first(n_wh_pro,t_vstem_5_w_2FH_ga_ni_o).
first(n_wh_pro,t_vstem_5_w_2FH_ga_o).
first(n_wh_pro,t_vstem_5_w_2FH_ga_quote).
first(n_wh_pro,t_vstem_5_w_2FH_ga_to).
first(n_wh_pro,t_vstem_masu_2FH_ga).
first(n_wh_pro,t_vstem_sahen_2FH_ga_ni).
first(n_wh_pro,t_wh_daimeisi).
first(n_wh_pro,t_wh_daimeisi_nan).
first(n_wh_pro,t_wh_hukusi).
first(n_wh_pro,t_zikan_meisi).
first(n_wh_pro,t_zikan_meisi_ippai).
first(n_wh_pro,t_zikantai).
first(n_x_haku,t_num_byaku).
first(n_x_haku,t_num_byaq).
first(n_x_haku,t_num_go).
first(n_x_haku,t_num_hachi).
first(n_x_haku,t_num_haq).
first(n_x_haku,t_num_hito).
first(n_x_haku,t_num_huta).
first(n_x_haku,t_num_hutsu).
first(n_x_haku,t_num_hyaku).
first(n_x_haku,t_num_hyaq).
first(n_x_haku,t_num_ichi).
first(n_x_haku,t_num_iq).
first(n_x_haku,t_num_itsu).
first(n_x_haku,t_num_kokono).
first(n_x_haku,t_num_ku).
first(n_x_haku,t_num_kyuu).
first(n_x_haku,t_num_miq).
first(n_x_haku,t_num_mui).
first(n_x_haku,t_num_muq).
first(n_x_haku,t_num_nana).
first(n_x_haku,t_num_nano).
first(n_x_haku,t_num_ni).
first(n_x_haku,t_num_one).
first(n_x_haku,t_num_pyaku).
first(n_x_haku,t_num_pyaq).
first(n_x_haku,t_num_roku).
first(n_x_haku,t_num_roq).
first(n_x_haku,t_num_san).
first(n_x_haku,t_num_sen).
first(n_x_haku,t_num_shi).
first(n_x_haku,t_num_shichi).
first(n_x_haku,t_num_ten).
first(n_x_haku,t_num_tou).
first(n_x_haku,t_num_yaq).
first(n_x_haku,t_num_yo).
first(n_x_haku,t_num_yon).
first(n_x_haku,t_num_yoq).
first(n_x_haku,t_num_you).
first(n_x_haku,t_num_zen).
first(n_x_haku,t_num_zyuq).
first(n_x_haku,t_num_zyuu).
first(n_x_haku_y_ka,t_num_byaku).
first(n_x_haku_y_ka,t_num_byaq).
first(n_x_haku_y_ka,t_num_go).
first(n_x_haku_y_ka,t_num_hachi).
first(n_x_haku_y_ka,t_num_haq).
first(n_x_haku_y_ka,t_num_hito).
first(n_x_haku_y_ka,t_num_huta).
first(n_x_haku_y_ka,t_num_hutsu).
first(n_x_haku_y_ka,t_num_hyaku).
first(n_x_haku_y_ka,t_num_hyaq).
first(n_x_haku_y_ka,t_num_ichi).
first(n_x_haku_y_ka,t_num_iq).
first(n_x_haku_y_ka,t_num_itsu).
first(n_x_haku_y_ka,t_num_kokono).
first(n_x_haku_y_ka,t_num_ku).
first(n_x_haku_y_ka,t_num_kyuu).
first(n_x_haku_y_ka,t_num_miq).
first(n_x_haku_y_ka,t_num_mui).
first(n_x_haku_y_ka,t_num_muq).
first(n_x_haku_y_ka,t_num_nana).
first(n_x_haku_y_ka,t_num_nano).
first(n_x_haku_y_ka,t_num_ni).
first(n_x_haku_y_ka,t_num_one).
first(n_x_haku_y_ka,t_num_pyaku).
first(n_x_haku_y_ka,t_num_pyaq).
first(n_x_haku_y_ka,t_num_roku).
first(n_x_haku_y_ka,t_num_roq).
first(n_x_haku_y_ka,t_num_san).
first(n_x_haku_y_ka,t_num_sen).
first(n_x_haku_y_ka,t_num_shi).
first(n_x_haku_y_ka,t_num_shichi).
first(n_x_haku_y_ka,t_num_ten).
first(n_x_haku_y_ka,t_num_tou).
first(n_x_haku_y_ka,t_num_yaq).
first(n_x_haku_y_ka,t_num_yo).
first(n_x_haku_y_ka,t_num_yon).
first(n_x_haku_y_ka,t_num_yoq).
first(n_x_haku_y_ka,t_num_you).
first(n_x_haku_y_ka,t_num_zen).
first(n_x_haku_y_ka,t_num_zyuq).
first(n_x_haku_y_ka,t_num_zyuu).
first(n_x_ka_kan,t_num_byaku).
first(n_x_ka_kan,t_num_byaq).
first(n_x_ka_kan,t_num_go).
first(n_x_ka_kan,t_num_hachi).
first(n_x_ka_kan,t_num_haq).
first(n_x_ka_kan,t_num_hito).
first(n_x_ka_kan,t_num_huta).
first(n_x_ka_kan,t_num_hutsu).
first(n_x_ka_kan,t_num_hyaku).
first(n_x_ka_kan,t_num_hyaq).
first(n_x_ka_kan,t_num_ichi).
first(n_x_ka_kan,t_num_iq).
first(n_x_ka_kan,t_num_itsu).
first(n_x_ka_kan,t_num_kokono).
first(n_x_ka_kan,t_num_ku).
first(n_x_ka_kan,t_num_kyuu).
first(n_x_ka_kan,t_num_miq).
first(n_x_ka_kan,t_num_mui).
first(n_x_ka_kan,t_num_muq).
first(n_x_ka_kan,t_num_nana).
first(n_x_ka_kan,t_num_nano).
first(n_x_ka_kan,t_num_ni).
first(n_x_ka_kan,t_num_one).
first(n_x_ka_kan,t_num_pyaku).
first(n_x_ka_kan,t_num_pyaq).
first(n_x_ka_kan,t_num_roku).
first(n_x_ka_kan,t_num_roq).
first(n_x_ka_kan,t_num_san).
first(n_x_ka_kan,t_num_sen).
first(n_x_ka_kan,t_num_shi).
first(n_x_ka_kan,t_num_shichi).
first(n_x_ka_kan,t_num_ten).
first(n_x_ka_kan,t_num_tou).
first(n_x_ka_kan,t_num_yaq).
first(n_x_ka_kan,t_num_yo).
first(n_x_ka_kan,t_num_yon).
first(n_x_ka_kan,t_num_yoq).
first(n_x_ka_kan,t_num_you).
first(n_x_ka_kan,t_num_zen).
first(n_x_ka_kan,t_num_zyuq).
first(n_x_ka_kan,t_num_zyuu).
first(n_y_ka,t_num_byaku).
first(n_y_ka,t_num_byaq).
first(n_y_ka,t_num_go).
first(n_y_ka,t_num_hachi).
first(n_y_ka,t_num_haq).
first(n_y_ka,t_num_hito).
first(n_y_ka,t_num_huta).
first(n_y_ka,t_num_hutsu).
first(n_y_ka,t_num_hyaku).
first(n_y_ka,t_num_hyaq).
first(n_y_ka,t_num_ichi).
first(n_y_ka,t_num_iq).
first(n_y_ka,t_num_itsu).
first(n_y_ka,t_num_kokono).
first(n_y_ka,t_num_ku).
first(n_y_ka,t_num_kyuu).
first(n_y_ka,t_num_miq).
first(n_y_ka,t_num_mui).
first(n_y_ka,t_num_muq).
first(n_y_ka,t_num_nana).
first(n_y_ka,t_num_nano).
first(n_y_ka,t_num_ni).
first(n_y_ka,t_num_one).
first(n_y_ka,t_num_pyaku).
first(n_y_ka,t_num_pyaq).
first(n_y_ka,t_num_roku).
first(n_y_ka,t_num_roq).
first(n_y_ka,t_num_san).
first(n_y_ka,t_num_sen).
first(n_y_ka,t_num_shi).
first(n_y_ka,t_num_shichi).
first(n_y_ka,t_num_ten).
first(n_y_ka,t_num_tou).
first(n_y_ka,t_num_yaq).
first(n_y_ka,t_num_yo).
first(n_y_ka,t_num_yon).
first(n_y_ka,t_num_yoq).
first(n_y_ka,t_num_you).
first(n_y_ka,t_num_zen).
first(n_y_ka,t_num_zyuq).
first(n_y_ka,t_num_zyuu).

fstck(C,X):- X=[Wd|_],first(C,Wd).

msw(I,Rule):-
    values(I,Rules),
    mymember(Rule,Rules).

mymember(X,[X|_]).
mymember(X,[_|Xs]):-mymember(X,Xs).

result([succeed(0), succeed(1), succeed(2), succeed(3), succeed(4),
	succeed(5), succeed(6), succeed(7), succeed(8), succeed(9)]).
